// DOM.cpp : implementation file
//

#include "stdafx.h"
#include "DoM.h"
#include "client3Dlg.h"
#include "Registry.h"

//  Market Depth codes
const static int OPERATION_INSERT = 0;
const static int OPERATION_UPDATE = 1;
const static int OPERATION_DELETE = 2;

const static int SIDE_ASK = 0;
const static int SIDE_BID = 1;

const static int MAX_ROWS = 8;

// CDoM dialog

/*
Eliminate flickering - When updating or filling the list control, 
there is sometimes flickering of list control and/or other controls on dialog. 
To eliminate this flickering, you may try one of the following methods: 
Use CListCtrl::LockWindowUpdate()/CListCtrl::UnlockWindowUpdate() to bracket the updating code. 
Use CListCtrl::SetRedraw(FALSE)/CListCtrl::SetRedraw(TRUE) to bracket the updating code. 
After using one of these methods, you probably should call list.UpdateWindow() to make sure control is updated. 
If one method doesn't completely eliminate flickering in your application, 
try other method to determine which works best. 
*/

IMPLEMENT_DYNAMIC(CDoM, CDialog)
CDoM::CDoM(CWnd* pParent /*=NULL*/)
	: CDialog(CDoM::IDD, pParent)
	, m_bVolCount(FALSE)
	, m_bTickCount(TRUE)
	, m_bS(FALSE)
	, m_bL1(FALSE)
	, m_bL2(FALSE)
	, m_bL3(FALSE)
	, m_bSelected(FALSE)
	, m_nSumTick(0)
	, m_nSumVol(0)
	, m_nSumBid(0)
	, m_nSumAsk(0)
	, m_nRecordBidSize(0)
	, m_nRecordAskSize(0)
	//, m_dRecordTradePrice(0)
	, m_nBidCountLeft(0)
	, m_nAskCountLeft(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pParent = pParent;		// pointer to parent dialog
	m_bMktDepth = FALSE;
}

CDoM::~CDoM()
{
}

void CDoM::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_lstDOM);
	DDX_Control(pDX, IDC_COMBO1, m_cbbActRecord);
	DDX_Control(pDX, IDC_RADIO1, m_chkTick);
	DDX_Control(pDX, IDC_EDIT3, disp2);
	DDX_Control(pDX, IDC_EDIT2, disp1);
	DDX_Control(pDX, IDC_RADIO8, m_chkLmt);
	DDX_Control(pDX, IDC_TEXT, m_edtStatusText);
}

BEGIN_MESSAGE_MAP(CDoM, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON12, OnBnClose)
	ON_WM_TIMER()
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, OnNMRclickList1)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, OnNMDblclkList1)
	ON_NOTIFY(NM_HOVER, IDC_LIST1, OnNMHoverList1)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnNMClickList1)
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedRadio2)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
	ON_BN_CLICKED(IDC_RADIO3, OnBnStop)
	ON_BN_CLICKED(IDC_RADIO8, OnBnLimit)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST1, OnLvnColumnclickList1)
END_MESSAGE_MAP()

// CDoM message handlers

BOOL CDoM::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString title;
    title.Format("Advanced Market Depth for: %s", ((CClient3Dlg*)m_pParent)->cont.symbol);
    SetWindowText(title);

	GetWindowRect(m_dlgRect);

	COLORREF	crBkColor = White; //RGB(210,110,110);
	RECT rect;

	CRect lprect;
	int nLines = 6;
	m_cbbActRecord.GetWindowRect( &lprect ); 
	lprect.bottom = lprect.top + nLines * m_cbbActRecord.GetItemHeight( -1 ) + lprect.Height();
	m_cbbActRecord.SetWindowPos(NULL, 0, 0, lprect.Width(), lprect.Height(), SWP_NOMOVE | SWP_NOZORDER );
	m_cbbActRecord.InsertString(0,"5m");		// data collection over 5, 10 etc minutes
	m_cbbActRecord.InsertString(1,"10m");
	m_cbbActRecord.InsertString(2,"15m");
	m_cbbActRecord.InsertString(3,"20m");
	m_cbbActRecord.InsertString(4,"25m");
	m_cbbActRecord.InsertString(5,"30m");

	m_cbbActRecord.SetCurSel(0);

	m_chkTick.SetCheck(TRUE);

	//  init market depth
	if (m_bMktDepth == FALSE)
	{
		((CClient3Dlg*)m_pParent)->m_tws1.reqMktDepth(
			((CClient3Dlg*)m_pParent)->m_lTickerId,
			((CClient3Dlg*)m_pParent)->cont.symbol,
			((CClient3Dlg*)m_pParent)->cont.secType,
			((CClient3Dlg*)m_pParent)->cont.expiry,
			((CClient3Dlg*)m_pParent)->cont.strike,
			((CClient3Dlg*)m_pParent)->cont.right,
			((CClient3Dlg*)m_pParent)->cont.multiplier,
			((CClient3Dlg*)m_pParent)->cont.exchange,
			((CClient3Dlg*)m_pParent)->cont.currency,
			MAX_ROWS);  // number of rows max
		m_bMktDepth = TRUE;
	}

	//  FULLROWSELECT is required to be able to retrieve row/col numbers in ListCtrl
	m_lstDOM.SetExtendedStyle(	LVS_EX_GRIDLINES | LVS_EX_TRACKSELECT | 
								LVS_EX_ONECLICKACTIVATE | LVS_EX_FULLROWSELECT );
	
	m_lstDOM.GetClientRect(&rect);
	int lw = rect.right - rect.left;
	m_lstDOM.SetBkColor(crBkColor);

	m_lstDOM.InsertColumn(0,"0", LVCFMT_CENTER, 0, -1 );				// skip column 0
	m_lstDOM.InsertColumn(1,"Activity", LVCFMT_CENTER, lw/6, -1 );
	m_lstDOM.InsertColumn(2,"BidBook", LVCFMT_CENTER, lw/6, -1 );
	m_lstDOM.InsertColumn(3,"Ord", LVCFMT_CENTER, lw/12, -1 );
	m_lstDOM.InsertColumn(4,"Price", LVCFMT_CENTER, lw/6, -1 );
	m_lstDOM.InsertColumn(5,"Ord", LVCFMT_CENTER, lw/12, -1 );
	m_lstDOM.InsertColumn(6,"AskBook", LVCFMT_CENTER, lw/6, -1 );
	m_lstDOM.InsertColumn(7,"Sup/Res", LVCFMT_CENTER, lw - 5*lw/6, -1 );

	m_lstDOM.InsertItem(0,"Iup10", White, Blue);						// setup lines
	m_lstDOM.InsertItem(1,"Iup9", White, Blue);
	m_lstDOM.InsertItem(2,"Iup8", White, Blue);
	m_lstDOM.InsertItem(3,"Iup7", White, Blue);
	m_lstDOM.InsertItem(4,"Iup6", White, Blue);
	m_lstDOM.InsertItem(5,"Iup5", White, Blue);
	m_lstDOM.InsertItem(6,"Iup4", White, Blue);
	m_lstDOM.InsertItem(7,"Iup3", White, Blue);
	m_lstDOM.InsertItem(8,"Iup2", White, Blue);
	m_lstDOM.InsertItem(9,"Iup1", White, Blue);

	m_lstDOM.InsertItem(10,"Curr", White, DarkGrey);		// where current price will be displayed

	m_lstDOM.InsertItem(11,"Idn1", White, Red);
	m_lstDOM.InsertItem(12,"Idn2", White, Red);
	m_lstDOM.InsertItem(13,"Idn3", White, Red);
	m_lstDOM.InsertItem(14,"Idn4", White, Red);
	m_lstDOM.InsertItem(15,"Idn5", White, Red);
	m_lstDOM.InsertItem(16,"Idn6", White, Red);
	m_lstDOM.InsertItem(17,"Idn7", White, Red);
	m_lstDOM.InsertItem(18,"Idn8", White, Red);
	m_lstDOM.InsertItem(19,"Idn9", White, Red);
	m_lstDOM.InsertItem(20,"Idn10", White, Red);

	for (int i=0; i<=20; i++)
	{
		m_lstDOM.SetProgress(i,7,FALSE);	// do not show progress text
		for (int j=0;j<7;j++) m_lstDOM.SetItemText(i,j,"",Black,White);
		for (int j=0;j<4;j++) m_dArrMD[i][j] = 0; // clear array
	}
	double t = ((CClient3Dlg*)m_pParent)->m_dSymbolTickSize;
	double b = ((CClient3Dlg*)m_pParent)->m_dLatestBid;
	double a = ((CClient3Dlg*)m_pParent)->m_dLatestAsk;
	for (int j=0;j<10;j++)
	{
		CString strP;
		// ArrMD col2 contains prices (bid and under)
		m_dArrMD[11+j][2] = b - j * t;
		strP.Format("%.3f",m_dArrMD[11+j][2]);
		m_lstDOM.SetItemText(11+j,4, strP, Blue, White); //price
		// ArrMD col[2] contains prices (ask and above)
		m_dArrMD[9-j][2] = a + j * t;
		strP.Format("%.3f",m_dArrMD[9-j][2]);
		m_lstDOM.SetItemText(9-j,4, strP, Red, White);
	}
	
	m_lstDOM.SetProgress(10,1,FALSE);

	for (int i=0; i<81; i++)	// init arrays
	{
		m_dPriceScale[i] = 0.0;
		m_nTickCount[i][0] = 0;
		m_nTickCount[i][1] = -1;
		m_nVolCount[i][0] = 0;
		m_nVolCount[i][1] = -1;
	}

	// BasePrice
	double BasePrice = ((CClient3Dlg*)m_pParent)->m_dLatestTrade;
	m_dPriceScale[40] = BasePrice;
	for (int i=39;i>=0;i--)	
		m_dPriceScale[i] = BasePrice + (40-i) * t;
	for (int i=41;i<81;i++)	
		m_dPriceScale[i] = BasePrice - (i-40) * t;

	CString strP;
	m_dArrMD[10][2] = ((CClient3Dlg*)m_pParent)->m_dLatestTrade;
	strP.Format("%.3f",m_dArrMD[10][2]);
	m_lstDOM.SetItemText(10,4,strP,White,Black);

	m_nTimer1 = SetTimer(1, 1000, 0);	// 1 second timer
	m_nTimer2 = SetTimer(2, 2000, 0);	// 2 seconds timer

	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, FALSE))
	{
		int nL = m_Reg.ReadInt("DOMleft",50);
		int nT = m_Reg.ReadInt("DOMtop",50);
		MoveWindow(nL,nT,m_dlgRect.Width(),m_dlgRect.Height(),TRUE);
		int nRec = m_Reg.ReadInt("DOMrec",1);
		m_cbbActRecord.SetCurSel(nRec-1);
	}

	OnBnLimit();
	m_chkLmt.SetCheck(TRUE);	// default order is LMT
	return TRUE;
}

void CDoM::OnBnClickedButton1() // hide this dialog
{
	this->ShowWindow(SW_HIDE);
}

void CDoM::OnBnClose() // close
{
	KillTimer(1);
	if (m_bMktDepth == TRUE)	// cancel ticker on closing dialog
		((CClient3Dlg*)m_pParent)->m_tws1.cancelMktDepth( m_tickerId);
	m_bMktDepth = FALSE;
	GetWindowRect(m_dlgRect);
	((CClient3Dlg*)m_pParent)->SetFocus();
	DestroyWindow();
}

void CDoM::PostNcDestroy() // close using X
{
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, TRUE))
	{	// record dialog position in registry
		m_Reg.WriteInt("DOMleft", m_dlgRect.left);
		m_Reg.WriteInt("DOMtop",m_dlgRect.top);
	}

	// clear pointer in parent form
	if (m_bMktDepth == TRUE)		// cancel ticker on closing dialog
		((CClient3Dlg*)m_pParent)->m_tws1.cancelMktDepth( m_tickerId);
	m_bMktDepth = FALSE;
	((CClient3Dlg*)m_pParent)->mlDOM = NULL;		
	delete this;	// delete pointer to modeless form
	CDialog::PostNcDestroy();
}

// MktDepth data retrieved in main dialog (message sink) is sent here for display
void CDoM::updateMktDepth( long id, long position, CString marketMaker, 
    long operation, long side, double price, long size)
{
	CString strP;

    if ( position > MAX_ROWS ) return;

	LockWindowUpdate();

	if (operation == OPERATION_DELETE) // delete row
	{
		if (side == SIDE_BID)
		{	// bid info goes to columns 2 and 3
			for (int i=2;i<=3;i++)
			{	// clear from position to row 20
				for (int j = position; j < 11 ; j++) 
				{
					m_dArrMD[10+j][0] = 0;	// reset book size
					m_lstDOM.SetItemText(10+j,i,"",White,White);
				}
			}
			return;  // stop here
		}	// ask info goes to columns 5 and 6
		if (side == SIDE_ASK)
		{
			for (int i=5;i<=6;i++)
			{	// clear from row 0 to position
				for (int j = position; j > 0 ; j--) 
				{
					m_dArrMD[j][0] = 0;	// reset book size
					m_lstDOM.SetItemText(j,i,"",White,White);
				}
			}
			return;	// stop here
		}
	}

	// other operations:  INSERT or UPDATE
	// these 2 operations are not differentiated here since list cells are already created
	if (side == SIDE_BID)
	{	
		m_nSumBid = 0;
		for (int i=0;i<10;i++)
		{
			if (price == m_dArrMD[11+i][2])
			{
				CString strP;
				m_dArrMD[11+i][0] = size;	// fill array (col 0) with bid size
				strP.Format("%d",size);
				m_lstDOM.SetItemText(11+i,2, strP, Blue, White); // display it
				//m_lstDOM.SetItemText(11+i,3,tempP,Black,Blue);
			}
			m_nSumBid += (long)m_dArrMD[11+i][0];
		}
		strP.Format("%d",m_nSumBid);
		disp1.SetWindowText(strP);
	}

	if (side == SIDE_ASK)
	{
		m_nSumAsk = 0;
		for (int i=0;i<10;i++)
		{
			if (price == m_dArrMD[9-i][2])
			{
				CString strP;
				m_dArrMD[9-i][0] = size;	// fill array (col 0) with ask size
				strP.Format("%d",size);
				m_lstDOM.SetItemText(9-i,6, strP, Red, White);
				//m_lstDOM.SetItemText(9-i,5,tempP,Black,Blue);
			}
			m_nSumAsk += (long)m_dArrMD[9-i][0];
		}
		strP.Format("%d",m_nSumAsk);
		disp2.SetWindowText(strP);
	}
	UnlockWindowUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// Private Methods
/////////////////////////////////////////////////////////////////////////////

void CDoM::OnTimer(UINT nIDEvent)
{	
	// the determining variable to display Stop/Limit order on DOM will be Order Qty
	// alternatively stop/limit prices can be used
	static int nCount = 0;
	BOOL bLock = FALSE;
	int nPivot; // the pivot sets a point to link PriceScale to ArrMD arrays
	// update stop/limit orders on grid
	double dEL = (((CClient3Dlg*)m_pParent)->order[0][0].totalQuantity > 0 ?
		((CClient3Dlg*)m_pParent)->order[0][0].lmtPrice : 0);	// limit entry
	double dES = (((CClient3Dlg*)m_pParent)->order[0][0].totalQuantity > 0 ?
		((CClient3Dlg*)m_pParent)->order[0][0].auxPrice : 0);	// stop entry
	// stop price
	double dS = (((CClient3Dlg*)m_pParent)->order[1][0].totalQuantity > 0 ?
		((CClient3Dlg*)m_pParent)->order[1][0].auxPrice : 0);	// or 2 or 3 : same price
	// lmt price 1
	double dL1 =(((CClient3Dlg*)m_pParent)->order[4][0].totalQuantity > 0 ?
		((CClient3Dlg*)m_pParent)->order[4][0].lmtPrice : 0);	// limit exit 1
	// lmt price 2
	double dL2 =(((CClient3Dlg*)m_pParent)->order[5][0].totalQuantity > 0 ? 
		((CClient3Dlg*)m_pParent)->order[5][0].lmtPrice : 0);	// limit exit 2
	// lmt price 3
	double dL3 =(((CClient3Dlg*)m_pParent)->order[6][0].totalQuantity > 0 ? 
		((CClient3Dlg*)m_pParent)->order[6][0].lmtPrice : 0);	// limit exit 3

	long nPos = ((CClient3Dlg*)m_pParent)->m_nPosition1;

	// the following event serves to update position display (stop/limit exit or entry)
	if (nIDEvent == 1)			// 1000 i.e. 1sec (see InitDialog)
	{
		if (dS > 0)	// stop/limits
		{	// try and position stp/lmt prices on list
			bLock = LockWindowUpdate();
			//m_lstDOM.SetRedraw(FALSE);
			for (int i = 0; i<21; i++)	// scan prices
			{
				CString strP;
				m_lstDOM.SetItemText(i,3,"",White,White); // Bid Ord cleared
				m_lstDOM.SetItemText(i,5,"",White,White); // Ask Ord cleared
				if (m_dArrMD[i][2] == dS && nPos != 0)	
				{
					CString strP = "S";	// a S will be inserted in that cell (stop)
					if (i < 10)
						m_lstDOM.SetItemText(i,5,strP,White,Red);
					else
						if (i>10) 
							m_lstDOM.SetItemText(i,3,strP,White,Red);
				} else
				if (m_dArrMD[i][2] == dL1)
				{
					CString strP = "L1"; // a L1 will be inserted in that cell (lmt1)
					if (i < 10)
						m_lstDOM.SetItemText(i,5,strP,White,Blue);
					else
						if (i>10)	m_lstDOM.SetItemText(i,3,strP,White,Blue);
				} else
				if (m_dArrMD[i][2] == dL2)
				{
					CString strP = "L2";	// a L2 will be inserted in that cell (lmt2)
					if (i < 10)
						m_lstDOM.SetItemText(i,5,strP,White,DarkBlue);
					else
						if (i>10)	m_lstDOM.SetItemText(i,3,strP,White,DarkBlue);
				} else
				if (m_dArrMD[i][2] == dL3)
				{
					CString strP = "L3"; // a L3 will be inserted in that cell (lmt3)
					if (i < 10)
						m_lstDOM.SetItemText(i,5,strP,White,DarkerBlue);
					else
						if (i>10)	m_lstDOM.SetItemText(i,3,strP,White,DarkerBlue);
				}
			}
		} else	 // dS == 0
		{
			CString str;
			if (dEL > 0) // limit entry price
			{
				for (int i = 0; i<21; i++)	// scan prices
				{
					if (m_dArrMD[i][2] == dEL)
					{
						str.Format("%.3f",m_dArrMD[i][2]);
						if (i < 10)
							m_lstDOM.SetItemText(i,4,str,White,DarkRed);
						else
							if (i>10)	m_lstDOM.SetItemText(i,4,str,White,DarkBlue);
						break;
					}
				}
			}
			else
			if (dES > 0) // stop entry price
			{
				for (int i = 0; i<21; i++)	// scan prices
				{
					CString str;
					str.Format("%.3f",m_dArrMD[i][2]);
					if (m_dArrMD[i][2] == dES)
					{
						if (i < 10)
							m_lstDOM.SetItemText(i,4,str,White,DarkRed);
						else
							if (i>10)	m_lstDOM.SetItemText(i,4,str,White,DarkBlue);
						break;
					}
				}
			}
			else
			{
				for (int i = 0; i<21; i++)	// scan prices
				{
					m_lstDOM.SetItemText(i,3,"",White,White); // Bid Ord cleared
					m_lstDOM.SetItemText(i,5,"",White,White); // Ask Ord cleared
					//if (i < 10)
					//	m_lstDOM.SetItemText(i,4,str,Red,White);
					//else
					//	if (i>10)	m_lstDOM.SetItemText(i,4,str,Blue,White);
				}
			}
		}
		
		CString str;
		for (int i=0;i<10;i++)
		{
			if (m_nSumBid > 0)
				m_lstDOM.UpdateProgress(11+i,7, (int)(100 * m_dArrMD[11+i][0] / (double)m_nSumBid));
			else
				m_lstDOM.UpdateProgress(11+i,7, 0);
			
			if (m_nSumAsk > 0)
				m_lstDOM.UpdateProgress(9-i,7, (int)(100 * m_dArrMD[9-i][0] / (double)m_nSumAsk));
			else
				m_lstDOM.UpdateProgress(9-i,7, 0);

			str.Format("%.3f",m_dArrMD[i][2]);
			if (m_dArrMD[i][2] == ((CClient3Dlg*)m_pParent)->m_dDayHigh)
				m_lstDOM.SetItemText(i,4,str,Blue,LightGrey);
			else
				if (m_dArrMD[i][2] == ((CClient3Dlg*)m_pParent)->m_dEntryPrice)//m_dRecordTradePrice)
					m_lstDOM.SetItemText(i,4,str,White,Blue);
			
			str.Format("%.3f",m_dArrMD[i+11][2]);
			if (m_dArrMD[i+11][2] == ((CClient3Dlg*)m_pParent)->m_dDayLow)
				m_lstDOM.SetItemText(i+11,4,str,Red,LightGrey);
			else
				if (m_dArrMD[i+11][2] == ((CClient3Dlg*)m_pParent)->m_dEntryPrice)//m_dRecordTradePrice)
					m_lstDOM.SetItemText(i+11,4,str,White,Red);
		}
	}

	if ((nIDEvent == 2) && (m_dArrMD[10][2] > 0)) // ticker must be active
	{	
		int i;
		m_nTimeMult5 = m_cbbActRecord.GetCurSel() + 1;
		CTime m_tTime = CTime::GetCurrentTime();
		CTimeSpan tdiff = m_tTime - m_tTimeRef;
		long t = (long)tdiff.GetTotalSeconds();
		m_nSumTick = m_nSumVol = 0;  // sum all ticks (can be used for averaging)
		
		bLock = LockWindowUpdate();

		if (((CClient3Dlg*)m_pParent)->m_bVerbose == TRUE)
		{
			CString str;
			if (m_nBidCountLeft > 0)
			{
				if (m_nBidCountLeft != nCount)
				{
					str.Format("Bid Left: %i",m_nBidCountLeft);
					((CClient3Dlg*)m_pParent)->AddStatusLine(str,statInfo);
					nCount = m_nBidCountLeft;
				}
			}
			else if (m_nAskCountLeft > 0)
			{
				if (m_nAskCountLeft != nCount)
				{
					str.Format("Ask Left: %i",m_nAskCountLeft);
					((CClient3Dlg*)m_pParent)->AddStatusLine(str,statInfo);
					nCount = m_nAskCountLeft;
				}
			}
			else nCount = 0;
		}

		for (i = 0; i<81; i++)
		{	// erase older records (300 for increments of 5minutes)
			if ((m_nTickCount[i][1] > 0)  && (m_nTickCount[i][1] + m_nTimeMult5 * 300 < t)) 
				m_nTickCount[i][0] = m_nTickCount[i][1] = 0;
			m_nSumTick += m_nTickCount[i][0];
			if ((m_nTickCount[i][1] > 0)  && (m_nVolCount[i][1] + m_nTimeMult5 * 300 < t)) 
				m_nVolCount[i][0]= m_nVolCount[i][1] = 0;
			m_nSumVol += m_nVolCount[i][0];
		}

		// price has gone up significantly: time to shift arrays by 30 (arbitrary)
		if (m_dPriceScale[10] == m_dArrMD[10][2])
		{
			for (i = 10; i<40; i++)	
			{
				m_dPriceScale[i] = 0;
				m_nTickCount[i][0] = 0;
				m_nTickCount[i][1] = 0;
				m_nVolCount[i][0] = 0;
				m_nVolCount[i][1] = 0;
			}
			for (i = 0; i<51; i++)
			{
				m_dPriceScale[i+30] = m_dPriceScale[i];
				m_nTickCount[i+30][0] = m_nTickCount[i][0];
				m_nTickCount[i+30][1] = m_nTickCount[i][1];
				m_nVolCount[i+30][0] = m_nVolCount[i][0];
				m_nVolCount[i+30][1] = m_nVolCount[i][1];
			}
		}
		// prices have gone down significantly: time to shift arrays by 30 (arbitrary)
		if (m_dPriceScale[70] == m_dArrMD[10][2])
		{
			for (i = 51; i<81; i++)	
			{
				m_dPriceScale[i] = 0;
				m_nTickCount[i][0] = 0;
				m_nTickCount[i][1] = 0;
				m_nVolCount[i][0] = 0;
				m_nVolCount[i][1] = 0;
			}
			for (i = 30; i<81; i++)
			{
				m_dPriceScale[i] = m_dPriceScale[i-30];
				m_nTickCount[i][0] = m_nTickCount[i-30][0];
				m_nTickCount[i][1] = m_nTickCount[i-30][1];
				m_nVolCount[i][0] = m_nVolCount[i-30][0];
				m_nVolCount[i][1] = m_nVolCount[i-30][1];
			}
		}
		// find pivot, then align arrays 
		i = 0;
		nPivot = -1;
		while (i<81)
		{	// technically PriceScale can only be offset by fixed increments so
			// one should be able to find the pivot quickly without scanning list through
			if ( m_dPriceScale[i] == m_dArrMD[0][2] )  // align to top of array
			{
				nPivot = i;  // position price scale
				break;
			}
			i++;
		}
		if (nPivot > -1) // pivot has been found
		{	// pivot could be missing if DOM is called before ticker started
			if (m_bTickCount)
			{
				CString str;
				for (i=0;i<10;i++)
				{
					if (nPivot+i>80) break; // boundary check
					long nTC = m_nTickCount[nPivot+i][1];
					if (nTC > 0)
					{	// change cell backcolour
						m_dArrMD[i][1] = (double)(t - nTC);
						int nColOffset = (100 * m_dArrMD[i][1]) / (m_nTimeMult5 * 300);
						int nCol = 255 - 255 * nColOffset / 100;	
						int nTextCol = (nCol > 127 ? Black : White);

						str.Format("%i (%.0fs)",m_nTickCount[nPivot+i][1], m_dArrMD[i][1]);
						m_lstDOM.SetItemText(i,1,str, nTextCol, RGB(nCol,nCol,nCol)); 
					}
					else if (nTC == 0)
						{
							m_lstDOM.SetItemText(i,1,"", DarkGrey, DarkGrey);
						}
					else 
						{
							m_lstDOM.SetItemText(i,1,"", Black, Black);
						}
				}
				for (i=11;i<21;i++)
				{
					if (nPivot+i>80) break;
					long nTC = m_nTickCount[nPivot+i-1][1];
					if (nTC > 0)
					{
						m_dArrMD[i][1] = (double)(t - nTC);
						int nColOffset = (100 * m_dArrMD[i][1]) / (m_nTimeMult5 * 300);
						int nCol = 255 - 255 * nColOffset / 100;	
						int nTextCol = (nCol > 127 ? Black : White);
						str.Format("%i (%.0fs)",m_nTickCount[nPivot+i-1][1], m_dArrMD[i][1]);
						m_lstDOM.SetItemText(i,1,str, nTextCol, RGB(nCol,nCol,nCol));  
					}
					else if (nTC == 0)
						{
							m_lstDOM.SetItemText(i,1,"", DarkGrey, DarkGrey);
						}
					else 
						{
							m_lstDOM.SetItemText(i,1,"", Black, Black);
						}
				}
			}
			else // volcount
			{
				CString str;
				for (i=0;i<10;i++)
				{
					if (nPivot+i>80) break;
					long nTC = m_nVolCount[nPivot+i][1];
					if (nTC > 0)
					{
						m_dArrMD[i][1] = (double)(t - nTC);
						int nColOffset = (100 * m_dArrMD[i][1]) / (m_nTimeMult5 * 300);
						int nCol = 255 - 255 * nColOffset / 100;	
						int nTextCol = (nCol > 127 ? Black : White);

						str.Format("%i (%.0fs)",m_nVolCount[nPivot+i][1], m_dArrMD[i][1]);
						m_lstDOM.SetItemText(i,1,str, nTextCol, RGB(nCol,nCol,nCol)); 
						//m_lstDOM.SetItemText(i,1,str, RGB(nTextCol,nTextCol,nTextCol), RGB(nCol,nCol,nCol)); 
					}
					else if (nTC == 0)
						{
							m_lstDOM.SetItemText(i,1,"", DarkGrey, DarkGrey);
						}
					else 
						{
							m_lstDOM.SetItemText(i,1,"", Black, Black);
						}
				}
				for (i=11;i<21;i++)
				{
					if (nPivot+i>80) break;
					long nTC = m_nVolCount[nPivot+i-1][1];
					if (nTC > 0)
					{
						m_dArrMD[i][1] = (double)(t - nTC);
						int nColOffset = (100 * m_dArrMD[i][1]) / (m_nTimeMult5 * 300);
						int nCol = 255 - 255 * nColOffset / 100;	
						int nTextCol = (nCol > 127 ? Black : White);

						str.Format("%i (%.0fs)",m_nVolCount[nPivot+i-1][1], m_dArrMD[i][1]);
						m_lstDOM.SetItemText(i,1,str, nTextCol, RGB(nCol,nCol,nCol));  
					}
					else if (nTC == 0)
						{
							m_lstDOM.SetItemText(i,1,"", DarkGrey, DarkGrey);
						}
					else 
						{
							m_lstDOM.SetItemText(i,1,"", Black, Black);
						}
				}
			}
		}
		else
		{
			((CClient3Dlg*)m_pParent)->AddStatusLine("Closing DOM. Please start ticker again",statWarn);
			((CClient3Dlg*)m_pParent)->AddStatusLine("Pivot price not found...",statWarn);
			OnBnClose(); // close dialog
			return;
		}	
	}

	m_lstDOM.SetCurSel(-1); // clear any selection
	if (bLock) UnlockWindowUpdate();
	CDialog::OnTimer(nIDEvent);
}

// right-clicking price selects which order to move
void CDoM::OnNMRclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	double dPrice;
	int nItem;
	int nSubItem = pNMIA->iSubItem;
	
	POSITION pos = m_lstDOM.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		*pResult = 0;
		return;
	}
	else
		nItem = m_lstDOM.GetNextSelectedItem(pos);

	CString str;

	dPrice = m_dArrMD[nItem][2];

	m_bS = m_bL1 = m_bL2 = m_bL3 = FALSE;
	if (((CClient3Dlg*)m_pParent)->order[1][0].auxPrice == dPrice) 
		m_bSelected = m_bS = TRUE;
	else if (((CClient3Dlg*)m_pParent)->order[4][0].lmtPrice == dPrice) 
		m_bSelected = m_bL1 = TRUE;
	else if (((CClient3Dlg*)m_pParent)->order[5][0].lmtPrice == dPrice) 
		m_bSelected = m_bL2 = TRUE;
	else if (((CClient3Dlg*)m_pParent)->order[6][0].lmtPrice == dPrice) 
		m_bSelected = m_bL3 = TRUE;
}

void CDoM::OnNMDblclkList1(NMHDR *pNMHDR, LRESULT *pResult) // update price
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	double dPrice;
	int nItem;
	int nSubItem = pNMIA->iSubItem;
	
	POSITION pos = m_lstDOM.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		*pResult = 0;
		return;
	}
	else
		nItem = m_lstDOM.GetNextSelectedItem(pos);

	CString str;

	dPrice = m_dArrMD[nItem][2];

	if (nSubItem == 4) // clicked price column (central column)
	{
		//((CClient3Dlg*)m_pParent)->m_cbbOrdType.SetCurSel(3);//LMT
		((CClient3Dlg*)m_pParent)->OnCbnSelchangeCombo1();
		str.Format("%.3f",dPrice);
		if (m_bLimit)
		{
			((CClient3Dlg*)m_pParent)->m_strLmtPrice = m_lstDOM.GetItemText(nItem,4);
			((CClient3Dlg*)m_pParent)->m_strStpPrice = "0";
			if (nItem > 10) // bid side
			{
				if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) // in position
				{	
					if (((CClient3Dlg*)m_pParent)->m_nPosition1 == 0) // entered limit, unfilled
					{	// price can be amended
						((CClient3Dlg*)m_pParent)->OnBnClickedModorder();
						m_lstDOM.SetItemText(nItem,4, str, White, Blue);
					}
					else
					{	// place an exit limit
						if (((CClient3Dlg*)m_pParent)->m_strLastAction != "BUY") // short
						{
							//if (((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 +
							//	((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 +
							//	((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 == 0)
							//{ // no limit orders in place -> set limit exit order
								((CClient3Dlg*)m_pParent)->OnShortExit();
								m_lstDOM.SetItemText(nItem,4, str, White, Blue);
							//}
							//else // lmt order already there, so go update it by clicking correct column
							//	m_edtStatusText.SetWindowText("SELECT LIMIT EXIT TO MOVE (<-)");
						}
/*						else // long
							if (((CClient3Dlg*)m_pParent)->m_lLastStopOrderId1_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastStopOrderId2_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastStopOrderId3_tws1 == 0)
							{ // no stop orders in place -> set stop exit order
								((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);	
								((CClient3Dlg*)m_pParent)->m_strLmtPrice = "0";
								((CClient3Dlg*)m_pParent)->OnLongExit();
								m_lstDOM.SetItemText(nItem,4, str, White, Red);
							}
							else
								m_edtStatusText.SetWindowText("SELECT STOP EXIT TO MOVE (<-)");*/
					}
				}
				else
				{	// no position, so set a buy limit
					m_lstDOM.SetItemText(nItem,4, str, White, Blue);
					double dLmtPrice = atof(m_lstDOM.GetItemText(nItem,4));
					for (int i=0;i<3;i++) 
					{
						((CClient3Dlg*)m_pParent)->order[0][i].lmtPrice  = dLmtPrice;
						((CClient3Dlg*)m_pParent)->order[0][i].auxPrice  = 0;
					}
					((CClient3Dlg*)m_pParent)->OnLongEntry();
				}
			}
			else if (nItem < 10) // ask side
				{
					if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) 
					{
						if (((CClient3Dlg*)m_pParent)->m_nPosition1 == 0) // entered limit, unfilled
						{
							((CClient3Dlg*)m_pParent)->OnBnClickedModorder();
							m_lstDOM.SetItemText(nItem,4, str, White, Blue);
						}
						else
						{
							if (((CClient3Dlg*)m_pParent)->m_strLastAction == "BUY")
							{	// long
								//if (((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 +
								//((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 +
								//((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 == 0)
								//{ // no limit exit in place
									m_lstDOM.SetItemText(nItem,4, str, White, Blue);
									double dLmtPrice = atof(m_lstDOM.GetItemText(nItem,4));
									for (int i=0;i<3;i++) 
									{
										((CClient3Dlg*)m_pParent)->order[0][i].lmtPrice  = dLmtPrice;
										((CClient3Dlg*)m_pParent)->order[0][i].auxPrice  = 0;
									}
									((CClient3Dlg*)m_pParent)->OnLongExit();
								//}
								//else
								//	m_edtStatusText.SetWindowText("SELECT LIMIT EXIT TO MOVE (->)");
							}
/*							else // short
								if (((CClient3Dlg*)m_pParent)->m_lLastStopOrderId1_tws1 +
									((CClient3Dlg*)m_pParent)->m_lLastStopOrderId2_tws1 +
									((CClient3Dlg*)m_pParent)->m_lLastStopOrderId3_tws1 == 0)
								{ // no stop orders in place -> set stop exit order
									((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);	
									((CClient3Dlg*)m_pParent)->m_strLmtPrice = "0";
									((CClient3Dlg*)m_pParent)->OnShortExit();
									m_lstDOM.SetItemText(nItem,4, str, White, Red);
								}
								else
									m_edtStatusText.SetWindowText("SELECT STOP EXIT TO MOVE (<-)");*/
						}
					}
					else
					{	// no position, so set a sell limit
						m_lstDOM.SetItemText(nItem,4, str, White, Blue);
						double dLmtPrice = atof(m_lstDOM.GetItemText(nItem,4));
						((CClient3Dlg*)m_pParent)->m_strLmtPrice = str;
						((CClient3Dlg*)m_pParent)->m_strStpPrice = "0";
						for (int i=0;i<3;i++) 
						{
							((CClient3Dlg*)m_pParent)->order[0][i].lmtPrice  = dLmtPrice;
							((CClient3Dlg*)m_pParent)->order[0][i].auxPrice  = 0;
						}
						((CClient3Dlg*)m_pParent)->OnShortEntry();
					}
			}
		}
	/*
		if (m_bStop)
		{
			if (nItem > 10) // bid side
			{
				if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) // in position
				{
					((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);
					((CClient3Dlg*)m_pParent)->m_strLmtPrice = "0";
					if (((CClient3Dlg*)m_pParent)->m_nPosition1 == 0) // entered stop, but unfilled so far
					{
						((CClient3Dlg*)m_pParent)->OnBnClickedModorder();
						m_lstDOM.SetItemText(nItem,4, str, White, Blue);
					}
					else
					{
						if (((CClient3Dlg*)m_pParent)->m_strLastAction != "BUY") // short
						{
							if (((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 == 0)
							{ // no limit orders in place -> set limit exit order
								((CClient3Dlg*)m_pParent)->OnShortEntry();
								m_lstDOM.SetItemText(nItem,4, str, White, Blue);
							}
							else // lmt order already there, so go update it by clicking correct column
								m_edtStatusText.SetWindowText("SELECT LIMIT EXIT TO MOVE (<-)");
						}
/*						else // long
							if (((CClient3Dlg*)m_pParent)->m_lLastStopOrderId1_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastStopOrderId2_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastStopOrderId3_tws1 == 0)
							{ // no stop orders in place -> set stop exit order
								((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);	
								((CClient3Dlg*)m_pParent)->m_strLmtPrice = "0";
								((CClient3Dlg*)m_pParent)->OnLongExit();
								m_lstDOM.SetItemText(nItem,4, str, White, Red);
							}
							else
								m_edtStatusText.SetWindowText("SELECT STOP EXIT TO MOVE (<-)");
					}
				}
				else
				{	// no position, so set a buy stop
					m_lstDOM.SetItemText(nItem,4, str, White, Blue);
					double dLmtPrice = atof(m_lstDOM.GetItemText(nItem,4));
					((CClient3Dlg*)m_pParent)->m_strLmtPrice = str;
					((CClient3Dlg*)m_pParent)->m_strStpPrice = "0";
					for (int i=0;i<3;i++) 
					{
						((CClient3Dlg*)m_pParent)->order[i][0].lmtPrice  = dLmtPrice;
						((CClient3Dlg*)m_pParent)->order[i][0].auxPrice  = 0;
					}
					((CClient3Dlg*)m_pParent)->OnLongEntry();
				}
			}
			else if (nItem < 10) 
				{
					if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) 
					{
						((CClient3Dlg*)m_pParent)->m_strLmtPrice = m_lstDOM.GetItemText(nItem,4);
						((CClient3Dlg*)m_pParent)->m_strStpPrice = "0";
						if (((CClient3Dlg*)m_pParent)->m_nPosition1 == 0) // entered limit, unfilled
						{
							((CClient3Dlg*)m_pParent)->OnBnClickedModorder();
							m_lstDOM.SetItemText(nItem,4, str, White, Blue);
						}
						else
						{
							if (((CClient3Dlg*)m_pParent)->m_strLastAction == "BUY")
							{	// long
								if (((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 +
								((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 == 0)
								{ // no limit exit in place
									m_lstDOM.SetItemText(nItem,4, str, White, Blue);
									((CClient3Dlg*)m_pParent)->OnLongExit();
								}
								else
									m_edtStatusText.SetWindowText("SELECT LIMIT EXIT TO MOVE (->)");
							}
/*							else // short
								if (((CClient3Dlg*)m_pParent)->m_lLastStopOrderId1_tws1 +
									((CClient3Dlg*)m_pParent)->m_lLastStopOrderId2_tws1 +
									((CClient3Dlg*)m_pParent)->m_lLastStopOrderId3_tws1 == 0)
								{ // no stop orders in place -> set stop exit order
									((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);	
									((CClient3Dlg*)m_pParent)->m_strLmtPrice = "0";
									((CClient3Dlg*)m_pParent)->OnShortExit();
									m_lstDOM.SetItemText(nItem,4, str, White, Red);
								}
								else
									m_edtStatusText.SetWindowText("SELECT STOP EXIT TO MOVE (<-)");
						}
					}
					else
					{	// no position, so set a sell stop
						m_lstDOM.SetItemText(nItem,4, str, White, Blue);
						double dLmtPrice = atof(m_lstDOM.GetItemText(nItem,4));
						((CClient3Dlg*)m_pParent)->m_strLmtPrice = str;
						((CClient3Dlg*)m_pParent)->m_strStpPrice = "0";
						for (int i=0;i<3;i++) 
						{
							((CClient3Dlg*)m_pParent)->order[i][0].lmtPrice  = dLmtPrice;
							((CClient3Dlg*)m_pParent)->order[i][0].auxPrice  = 0;
						}
						((CClient3Dlg*)m_pParent)->OnShortEntry();
					}
			}

/*			((CClient3Dlg*)m_pParent)->m_strStpPrice = m_lstDOM.GetItemText(nItem,4);
			if (nItem < 10) 
			{
				if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) 
					if (((CClient3Dlg*)m_pParent)->m_strLastAction != "BUY")
					{
						m_lstDOM.SetItemText(nItem,4, str, White, Blue);
						((CClient3Dlg*)m_pParent)->OnLongEntry();
					}
					else
						m_edtStatusText.SetWindowText("BUY ACTION NOT PERMITTED");
			}
			else if (nItem > 10) 
				{
					if (((CClient3Dlg*)m_pParent)->m_lLastOrderId_tws1 > 0) 
						if (((CClient3Dlg*)m_pParent)->m_strLastAction == "BUY")
						{
							m_lstDOM.SetItemText(nItem,4, str, White, Red);
							((CClient3Dlg*)m_pParent)->OnShortEntry();
						}
						else
							m_edtStatusText.SetWindowText("SELL ACTION NOT PERMITTED");
				}
		}*/
	}
	else if ((nSubItem == 3) || (nSubItem == 5))
	{	
		if (m_bSelected)
		{
			if (m_bS == TRUE)
			{
					((CClient3Dlg*)m_pParent)->m_dStopPrice = dPrice;
					((CClient3Dlg*)m_pParent)->CommitNewStop();
			}
			else if (m_bL1 == TRUE)
				{
					((CClient3Dlg*)m_pParent)->m_dLimitTarget = dPrice;
					((CClient3Dlg*)m_pParent)->CommitNewLimit1();
				} 
			else if (m_bL2 == TRUE)
				{
					((CClient3Dlg*)m_pParent)->m_dLimitTarget2 = dPrice;
					((CClient3Dlg*)m_pParent)->CommitNewLimit2();
				} 	
			else if (m_bL3 == TRUE)
				{
					((CClient3Dlg*)m_pParent)->m_dLimitTarget3 = dPrice;
					((CClient3Dlg*)m_pParent)->CommitNewLimit3();
				} 
		}	
		m_bSelected = FALSE;
	}

	*pResult = 0;
}

void CDoM::OnNMHoverList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
}

void CDoM::OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	int nItem;
	int nSubItem = pNMIA->iSubItem;
	
	POSITION pos = m_lstDOM.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		*pResult = 0;
		return;
	}
	else
		nItem = m_lstDOM.GetNextSelectedItem(pos);

	*pResult = 0;
}

void CDoM::OnBnClickedRadio1()
{
	m_bTickCount = TRUE;
	m_bVolCount = FALSE;
}

void CDoM::OnBnClickedRadio2()
{
	m_bTickCount = FALSE;
	m_bVolCount = TRUE;
}

void CDoM::OnCbnSelchangeCombo1()
{	// event not needed
	m_nTimeMult5 = m_cbbActRecord.GetCurSel() + 1;
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, TRUE))
		m_Reg.WriteInt("DOMrec", m_nTimeMult5);
}

void CDoM::OnBnStop()  // STP
{
	m_edtStatusText.SetWindowText("Option currently disabled");
	return;
	m_bStop = TRUE;
	m_bLimit = FALSE;
	((CClient3Dlg*)m_pParent)->m_cbbOrdType.SetCurSel(4);  // STP
	((CClient3Dlg*)m_pParent)->OnCbnSelchangeCombo1();
	m_edtStatusText.SetWindowText("Default order is : STP");
}

void CDoM::OnBnLimit() // LMT
{
	CString str = "Limit type order: LMT, LIT, MIT";
	m_bStop = FALSE;
	m_bLimit = TRUE;
	//((CClient3Dlg*)m_pParent)->m_cbbOrdType.SetCurSel(3);  // LMT
	((CClient3Dlg*)m_pParent)->OnCbnSelchangeCombo1();
	m_edtStatusText.SetWindowText(str);
	if (((CClient3Dlg*)m_pParent)->mlInfo != NULL) 
		((CClient3Dlg*)m_pParent)->AddStatusLine(str,statWarn);
}

void CDoM::OnLvnColumnclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{	// open slexits dialog upon clicking the column header
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	((CClient3Dlg*)m_pParent)->OnBnClickedSlExit();
	*pResult = 0;
}
