#pragma once

#include "resource.h"
#include "xlistctrl.h"
#include "afxwin.h"
#include "registry.h"


// CDoM dialog

class CDoM : public CDialog
{
	DECLARE_DYNAMIC(CDoM)

private:
	UINT	m_nTimer1;			// update list display on fixed time intervals
	UINT	m_nTimer2;			// update list display on fixed time intervals
	BOOL	m_bMktDepth;
	BOOL	m_bS;
	BOOL    m_bL1;
	BOOL    m_bL2;
	BOOL	m_bL3;
	BOOL	m_bSelected;


	CRegistry	m_Reg;			// Registry location where parameter defaults are stored
	
	CString  m_RegIBDKey;
	BOOL	m_bStop;
	BOOL	m_bLimit;


protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	HICON m_hIcon;

	DECLARE_MESSAGE_MAP()

public:
	CDoM(CWnd* pParent = NULL);   // standard constructor
	void updateMktDepth( long id, long position, CString marketMaker, long operation, 
        long side, double price, long size);
	virtual ~CDoM();
	CString  m_strSessionNo;
    int			m_tickerId;
	int			m_nTimeMult5;
	double		m_dArrMD[21][4];
				// Col 0 : book bid/ask size
				// Col 1 : 
				// Col 2 : prices
				// Col 3 :

	double		m_dPriceScale[81];		// initialised with ticker (CLOSE)
	long		m_nTickCount[81][2];
	long		m_nVolCount[81][2];
				// Col 0 : tick count
				// Col 1 : time stamp for last update (init=-1; reset=0, otherwise time elapsed since time ref)
	CTime		m_tTimeRef;
	long		m_nSumVol;
	long		m_nSumTick;
	long		m_nSumBid;
	long		m_nSumAsk;

	long		m_nRecordBidSize;
	long		m_nBidCountLeft;
	long		m_nRecordAskSize;
	long		m_nAskCountLeft;
	//double		m_dRecordTradePrice;

// Dialog Data
	enum { IDD = IDD_DOM };

	CWnd*			m_pParent;				// pointer to parent window
	CRect			m_dlgRect;
	virtual BOOL	OnInitDialog();
	CXListCtrl		m_lstDOM;				// 
	afx_msg void	OnBnClickedButton1();	// hide
	afx_msg void	OnBnClose();	// close
	afx_msg void	OnTimer(UINT nIDEvent);
	afx_msg void	OnNMRclickList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void	OnNMDblclkList1(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void	OnNMHoverList1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void	OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg void	OnBnClickedRadio1();
	afx_msg void	OnBnClickedRadio2();
	afx_msg void	OnCbnSelchangeCombo1();

	BOOL			m_bVolCount;
	BOOL			m_bTickCount;
	CComboBox		m_cbbActRecord;
	CButton			m_chkTick;
	CEdit disp2;
	CEdit disp1;
	afx_msg void OnBnStop();
	afx_msg void OnBnLimit();
	CButton m_chkLmt;
	CEdit m_edtStatusText;
	afx_msg void OnLvnColumnclickList1(NMHDR *pNMHDR, LRESULT *pResult);
};
