// CDlgConnect.cpp : implementation file
//

#include "stdafx.h"
#include "client3.h"
#include "registry.h"
#include "DlgConnect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgConnect dialog

CDlgConnect::CDlgConnect(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgConnect::IDD, pParent)
	, iNumShares(0)
	, m_nSessionNo(0)
{

	m_port = 7496;	// default port
	m_clientId = m_accidx;
	//{{AFX_DATA_INIT(CDlgConnect)
	//}}AFX_DATA_INIT
}


void CDlgConnect::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgConnect)
	DDX_Text(pDX, IDC_IP1, m_ipAddress);
	DDX_Text(pDX, IDC_PORT1, m_port);
	DDX_Text(pDX, IDC_CLIENT1, m_clientId);
	DDX_Text(pDX, IDC_NUMSHARES, iNumShares);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_CHECK1, m_chkSpecifics);
	DDX_Control(pDX, IDC_LABEL, lblNumShares);
	DDX_Control(pDX, IDC_NUMSHARES, NumShares);
}

BEGIN_MESSAGE_MAP(CDlgConnect, CDialog)
	//{{AFX_MSG_MAP(CDlgConnect)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgConnect message handlers

void CDlgConnect::OnCancel() 
{
	UpdateData(TRUE);
	CDialog::OnCancel();
}

void CDlgConnect::OnOK() 
{
	UpdateData(TRUE);
	CDialog::OnOK();
}

void CDlgConnect::OnBnClickedCancel()
{
	m_port = 0;
	OnCancel();
}

BOOL CDlgConnect::OnInitDialog()
{
	CRegistry Reg;
	CDialog::OnInitDialog();

	m_chkSpecifics.SetCheck(FALSE);
	OnBnClickedCheck1();

	CString title;
    title.Format(_T("Connect Parameters for Tws%d"), m_accidx);
    SetWindowText(title);
	m_clientId = m_accidx-1;
	str_client.Format(_T("%d"),m_clientId);

	IPkey = "IP";
	IPkey += str_client;

	Portkey = "Port";
	Portkey += str_client;

	IDkey = "ClientID";
	IDkey += str_client;

	NumShareskey = "NumShares";
	NumShareskey += str_client;

	RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\Connect";
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(RegIBDKey, FALSE))	
	{
		m_ipAddress =  Reg.ReadString(IPkey,"" );
		m_port = Reg.ReadDword(Portkey,7496);
		m_clientId = Reg.ReadDword(IDkey,0);
		iNumShares = Reg.ReadDword(NumShareskey,0);
	}

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgConnect::OnBnClickedOk()
{
	CRegistry Reg;
	UpdateData(TRUE);
	BOOL bSpec = m_chkSpecifics.GetCheck();
	if (!bSpec) iNumShares = 0;
	RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\Connect";
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(RegIBDKey, TRUE))
	{
		Reg.WriteDword(Portkey,m_port);
		Reg.WriteString(IPkey,m_ipAddress);
		Reg.WriteDword(IDkey,m_clientId);
		Reg.WriteDword(NumShareskey,iNumShares);
	}
	OnOK();
}

void CDlgConnect::OnBnClickedCheck1()
{
	BOOL bSpec = m_chkSpecifics.GetCheck();
	if (!bSpec)
	{
		lblNumShares.ShowWindow(SW_HIDE);
		NumShares.ShowWindow(SW_HIDE);
	}
	else
	{
		lblNumShares.ShowWindow(SW_SHOW);
		NumShares.ShowWindow(SW_SHOW);
	}
}
