// DlgMktDepth.cpp : implementation file
//
#include "stdafx.h"
#include "client3Dlg.h"
#include "DlgMktDepth.h"
#include <iostream>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgMktDepth dialog
const static int OPERATION_INSERT = 0;
const static int OPERATION_UPDATE = 1;
const static int OPERATION_DELETE = 2;

const static int SIDE_ASK = 0;
const static int SIDE_BID = 1;

const static int MAX_ROWS = 5;

CDlgMktDepth::CDlgMktDepth(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgMktDepth::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgMktDepth)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pParent = pParent;		// pointer to parent dialog
	m_nCumBid = 0;				// Cum Vol on Bid
	m_nCumAsk = 0;				// Cum Vol on Ask
	m_nActThres = 0;			// Vol Threshold. On Timer, display warning
}

void CDlgMktDepth::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgMktDepth)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_LIST2, m_lstBid);
	DDX_Control(pDX, IDC_LIST1, m_lstAsk);
	DDX_Control(pDX, IDC_EDIT2, m_edtActivity);
}

BEGIN_MESSAGE_MAP(CDlgMktDepth, CDialog)
	//{{AFX_MSG_MAP(CDlgMktDepth)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_EN_CHANGE(IDC_EDIT2, OnEnChangeEdit2)
	ON_WM_TIMER()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgMktDepth message handlers
BOOL CDlgMktDepth::OnInitDialog() 
{
	CDialog::OnInitDialog();
	long nr = 10;
	RECT rect;

	CString title;
    title.Format("Market Depth for: %s", ((CClient3Dlg*)m_pParent)->cont.symbol);
    SetWindowText(title);

	if (((CClient3Dlg*)m_pParent)->m_bAdvMktDepth == FALSE)
	{
		((CClient3Dlg*)m_pParent)->m_tws1.reqMktDepth(
				((CClient3Dlg*)m_pParent)->m_lTickerId,
				((CClient3Dlg*)m_pParent)->cont.symbol,
				((CClient3Dlg*)m_pParent)->cont.secType,
				((CClient3Dlg*)m_pParent)->cont.expiry,
				((CClient3Dlg*)m_pParent)->cont.strike,
				((CClient3Dlg*)m_pParent)->cont.right,
				((CClient3Dlg*)m_pParent)->cont.multiplier,
				((CClient3Dlg*)m_pParent)->cont.exchange,
				((CClient3Dlg*)m_pParent)->cont.currency,
				nr);  // number of rows max
	}
    // Setup the bid /ask  lists
	m_lstBid.GetClientRect(&rect);
	int lw = rect.right - rect.left;
	
    m_lstBid.InsertColumn(0, "MM", LVCFMT_LEFT, 0, -1 );
    m_lstBid.InsertColumn(1, "Price", LVCFMT_CENTER, 60, -1 );
    m_lstBid.InsertColumn(2, "Size", LVCFMT_LEFT, 40, -1 );
    m_lstBid.InsertColumn(3, "Cum Size", LVCFMT_LEFT, 55, -1 );
	m_lstBid.InsertColumn(4, "Pos", LVCFMT_CENTER, 20, -1 );
	m_lstBid.InsertColumn(5, "Avg P", LVCFMT_CENTER, lw-175, -1 );

	m_lstAsk.GetClientRect(&rect);
	lw = rect.right - rect.left;
    m_lstAsk.InsertColumn(0, "MM", LVCFMT_LEFT, 0, -1 );
    m_lstAsk.InsertColumn(1, "Price", LVCFMT_CENTER, 60, -1 );
    m_lstAsk.InsertColumn(2, "Size", LVCFMT_LEFT, 40, -1 );
    m_lstAsk.InsertColumn(3, "Cum Size", LVCFMT_LEFT, 55, -1 );
	m_lstAsk.InsertColumn(4, "Pos", LVCFMT_CENTER, 20, -1 );
    m_lstAsk.InsertColumn(5, "Avg P", LVCFMT_CENTER, lw-175, -1 );

	((CClient3Dlg*)m_pParent)->m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\DefaultSettings";
	BOOL bRegKey = ((CClient3Dlg*)m_pParent)->m_Reg.SetKey(((CClient3Dlg*)m_pParent)->m_RegIBDKey, FALSE);
	if (bRegKey)	
	{
		CString str;
		m_nActThres = ((CClient3Dlg*)m_pParent)->m_Reg.ReadInt("ActivThres", 4000);
		str.Format("%d",m_nActThres);
		m_edtActivity.SetWindowText(str);
	}
		
	m_nTimer = SetTimer(1,5000,0); // 5secs timer

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// Public Methods
/////////////////////////////////////////////////////////////////////////////

void CDlgMktDepth::updateMktDepth( long id, long position, CString marketMaker, 
    long operation, long side, double price, long size)
{
    //.*** Display list restriction ***
    if ( position > MAX_ROWS )
    {   // This sample display list has not been optimized so we restrict to top 10 rows!!
        return;
    }

    if (operation == OPERATION_INSERT ) 
    {
        addEntry( (side == SIDE_BID?&m_lstBid : &m_lstAsk), position, marketMaker, price, size);
    }
    else if (operation == OPERATION_UPDATE ) 
    {
        updateEntry( (side == SIDE_BID?&m_lstBid : &m_lstAsk), position, price, size);
    }
    else if  (operation == OPERATION_DELETE)
    {
        deleteEntry( (side == SIDE_BID?&m_lstBid : &m_lstAsk), position); 
    }
}

/////////////////////////////////////////////////////////////////////////////
// Private Methods
/////////////////////////////////////////////////////////////////////////////
void CDlgMktDepth::addEntry(CXListCtrl* pList, int position, CString marketMaker, 
        double price, int size)
{
    CString val;

    pList->InsertItem(position, marketMaker);

    val.Format("%.2f", price);
    pList->SetItemText(position, 1, val);

    val.Format("%d", size);
    pList->SetItemText(position, 2, val);

	val.Format("%d",position);
	pList->SetItemText(position,4,val);

    updateLists();
}

void CDlgMktDepth::updateEntry(CXListCtrl* pList, int position, double price, int size)
{
    CString val;

    val.Format("%.2f", price);
    pList->SetItemText(position, 1, val);

    val.Format("%d", size);
    pList->SetItemText(position, 2, val);

	val.Format("%d",position);
	pList->SetItemText(position,4,val);

    updateLists();
}

void CDlgMktDepth::deleteEntry(CXListCtrl* pList, int position)
{
    pList->DeleteItem(position);
    updateLists();
}

void CDlgMktDepth::updateLists()
{
    updateList(&m_lstBid);
    updateList(&m_lstAsk);
}

void CDlgMktDepth::updateList(CXListCtrl* pList)
{
    // need to recalc the cum
    CString val;
    CString strSize;
    CString strPrice;
    int     cumSize;
    double  totalPrice;

    for (int i=0 ; i< pList->GetItemCount() ; i++) 
    {   // Calculate the cumulative size & average price
        cumSize = 0;
        totalPrice = 0.0;
        for (int j=0 ; j<= i ; j++) 
        {
			
            strPrice = pList->GetItemText(j, 1);
            strSize = pList->GetItemText(j, 2);
            int size = atoi(strSize);
			cumSize += size;
            totalPrice += atof(strPrice) * size;
        }

        val.Format("%d", cumSize);
        pList->SetItemText(i, 3, val);

		if (pList == &m_lstBid) m_nCumBid = cumSize;
		if (pList == &m_lstAsk) m_nCumAsk = cumSize;

        val.Format("%.2f", (totalPrice / cumSize));
        pList->SetItemText(i, 5, val);        
    }
}

void CDlgMktDepth::OnBnClickedOk() // close
{
	OnEnChangeEdit2();
	KillTimer(m_nTimer);
	DestroyWindow();
}

void CDlgMktDepth::PostNcDestroy()
{
	// clear pointer in parent form, mktdepth is cancelled if not called elsewhere
	//if (((CClient3Dlg*)m_pParent)->m_bMktDepth == TRUE &&
	//	((CClient3Dlg*)m_pParent)->mlDOM == NULL) 
	//{
		((CClient3Dlg*)m_pParent)->m_tws1.cancelMktDepth( m_tickerId);
	//	((CClient3Dlg*)m_pParent)->m_bMktDepth = FALSE;
	//}

	((CClient3Dlg*)m_pParent)->mlMktDepth = NULL;		
	delete this;	// delete pointer to modeless form
	CDialog::PostNcDestroy();
}

void CDlgMktDepth::OnBnClickedCancel()	// hide dialog
{
	this->ShowWindow(SW_HIDE);
}

void CDlgMktDepth::OnEnChangeEdit2()
{
	CString str;
	m_edtActivity.GetWindowText(str);
	int m_nActThres = atol(str);
	((CClient3Dlg*)m_pParent)->m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\DefaultSettings";
	BOOL bRegKey = ((CClient3Dlg*)m_pParent)->m_Reg.SetKey(((CClient3Dlg*)m_pParent)->m_RegIBDKey, FALSE);
	if (bRegKey)	
		((CClient3Dlg*)m_pParent)->m_Reg.WriteInt("ActivThres", m_nActThres);
}

void CDlgMktDepth::OnTimer(UINT nIDEvent)
{
	if (((CClient3Dlg*)m_pParent)->m_bVerbose == TRUE)
	{
		CTime CurrentTime = CTime::GetCurrentTime();
		CString str = CurrentTime.Format("%H:%M:%S");

		CString str2;
		m_edtActivity.GetWindowText(str2);
		int m_nActThres = atol(str2);

		// display buy/sell pressure
		if ((m_nCumBid > 2 * m_nCumAsk) && (m_nCumAsk > m_nActThres))
			((CClient3Dlg*)m_pParent)->AddStatusLine(str+ " Strong buying pressure",statInfo);
		else if ((m_nCumBid > 1.5 * m_nCumAsk) && (m_nCumAsk > m_nActThres))
			((CClient3Dlg*)m_pParent)->AddStatusLine(str+ " Buying pressure",statInfo);

		if ((m_nCumAsk > 2 * m_nCumBid) && (m_nCumBid > m_nActThres))
			((CClient3Dlg*)m_pParent)->AddStatusLine(str+ " Strong selling pressure",statInfo);
		else if ((m_nCumAsk > 1.5 * m_nCumBid) && (m_nCumBid > m_nActThres))
			((CClient3Dlg*)m_pParent)->AddStatusLine(str + " Selling pressure",statInfo);
	}
	CDialog::OnTimer(nIDEvent);
}
