// DlgOrder.cpp : implementation file
//

#include "stdafx.h"
#include "client3.h"
#include "client3Dlg.h"
#include "registry.h"
#include "include\Contract.h"
#include "include\Order.h"
#include "DlgOrder.h"
#include "DlgExtOrd.h"
#include "FractExits.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgOrder dialog

CDlgOrder::CDlgOrder(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOrder::IDD, pParent)
	, m_lTickerId(1)
	, m_dStopPoints(0)
	, m_dLimitPoints(0)
	, m_dLimitPoints2(0)
	, m_dLimitPoints3(0)
	, m_bUseAutoStop(TRUE)
	, m_bUseAutoLimit(TRUE)
	, m_bTrail(TRUE)
	, m_bPopupStatus(FALSE)
	, m_bFractExits(FALSE)
	, m_bVerbose(FALSE)
	, m_bDebug(FALSE)
	, m_nLowVol(0)
	, m_nPeakVol(0)
	, m_bPaperTrade(FALSE)
	, m_bVolAlerts(FALSE)
	, m_nOCAType(0)
	, m_nEODhour(16)
	, m_nEODmin(10)
	, m_nTimeOffset(0)
	, m_bRegInit(TRUE)
{
	//{{AFX_DATA_INIT(CDlgOrder)
	contract.symbol = "";
	contract.secType = "";
	contract.expiry = "";
	contract.strike = 0;
	contract.right = "";
	contract.exchange = "";
	contract.currency = "";
	contract.localSymbol = "";
	contract.primaryExchange = "";
	contract.multiplier = "";
	order.lmtPrice = 0;
	order.auxPrice = 0;
	order.orderType = "MKT";
	order.action = "";
	order.totalQuantity = 2;
	order.lmtPrice = 0.0f;
	order.auxPrice = 0.0f;
	order.tif = "DAY";
	//}}AFX_DATA_INIT
	m_pParent = pParent;		// pointer to parent dialog

}

void CDlgOrder::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOrder)
	DDX_Text(pDX, IDC_EDIT11, m_lTickerId);
	DDX_Text(pDX, IDC_EDIT17, order.totalQuantity);
	DDX_Text(pDX, IDC_EDIT1, contract.symbol);
	DDX_Text(pDX, IDC_EDIT3, contract.expiry);
	DDX_Text(pDX, IDC_EDIT18, contract.primaryExchange);
	DDX_Text(pDX, IDC_EDIT19, contract.multiplier);

	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_TYPE, m_cbbSecType);
	DDX_Control(pDX, IDC_EXCHANGE, m_cbbExchange);
	DDX_Control(pDX, IDC_CHECK1, m_chkTransmit);
	DDX_Control(pDX, IDC_TIMESERVER, m_edtITS);
	DDX_Control(pDX, IDC_EDIT2, m_edtStopPoints);
	DDX_Control(pDX, IDC_EDIT4, m_edtLimitPoints);
	DDX_Control(pDX, IDC_CHECK2, m_chkAutoStop);
	DDX_Control(pDX, IDC_CHECK3, m_chkAutoLimit);
	DDX_Control(pDX, IDC_CHECK4, m_chkTrail);
	DDX_Control(pDX, IDC_CHECK5, m_chkPopupStatus);
	DDX_Control(pDX, IDC_CHECK6, m_chkPaperTrade);
	DDX_Control(pDX, IDC_EDIT7, m_edtLog);
	DDX_Control(pDX, IDC_EDIT5, m_edtLowVol);
	DDX_Control(pDX, IDC_EDIT6, m_edtPeakVol);
	DDX_Control(pDX, IDC_CHECK7, m_chkAutoClose);
	DDX_Control(pDX, IDC_DATETIMEPICKER1, m_dtEODTime);
	DDX_Control(pDX, IDC_CHECK8, m_chkFractExits);
	DDX_Control(pDX, IDC_EDIT8, m_edtFractExits);
	DDX_Control(pDX, IDC_BUTTON1, m_btnFractExits);
	DDX_Control(pDX, IDC_BUTTON11, m_btnUpdFractExits);
	DDX_Control(pDX, IDC_CHECK9, m_chkVolAlerts);
	DDX_Control(pDX, IDC_STATIC1, m_statLowVol);
	DDX_Control(pDX, IDC_STATIC2, m_statPeakVol);
	DDX_Control(pDX, IDC_EDIT17, OrdSize);
	DDX_Control(pDX, IDC_CHECK10, m_chkVerbose);
	DDX_Control(pDX, IDC_CHECK11, m_chkDebug);
	DDX_Control(pDX, IDC_COMBO1, m_cbbOCAType);
	DDX_Control(pDX, IDC_EDIT9, m_edtTimeOffset);
	DDX_Control(pDX, IDC_SPIN1, m_spnTimeOffset);
}

BEGIN_MESSAGE_MAP(CDlgOrder, CDialog)
	//{{AFX_MSG_MAP(CDlgOrder)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(ID_EXTENDED, OnBnClickedExtended)
	ON_CBN_SELCHANGE(IDC_TYPE, OnCbnSelchangeType)
	ON_CBN_SELCHANGE(IDC_EXCHANGE, OnCbnSelchangeExchange)
	ON_BN_CLICKED(IDC_CHECK2, OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnBnClickedCheck3)
	ON_BN_CLICKED(IDC_CHECK7, OnBnClickedCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnBnClickedCheck8)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON11, OnBnClickedButton11)
	ON_BN_CLICKED(IDC_CHECK9, OnBnClickedCheck9)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_CHECK4, OnBnClickedCheck4)
	ON_EN_CHANGE(IDC_EDIT1, OnEnChangeEdit1)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_CHECK11, OnBnClickedCheck11)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOrder message handlers

BOOL CDlgOrder::OnInitDialog() 
{
	CRegistry Reg;
	CDialog::OnInitDialog();
    //SetWindowText(m_dlgTitle);

	CString strSection       = "IBD";
	CString ITS;	// Internet Time Server
	//CWinApp* pApp = AfxGetApp();
	// Restore defaults

	CTime CurrentTime = CTime::GetCurrentTime();
	int y = CurrentTime.GetYear();
	int m = CurrentTime.GetMonth();

	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(m_RegIBDKey, FALSE))	
	{
		m_bRegInit = Reg.ReadBool("RegInit",TRUE);
		m_lTickerId = Reg.ReadDword("TickerId",1);
		contract.symbol = Reg.ReadString("Symbol","ES");
		contract.expiry = Reg.ReadString("Expiry", "200803");
		order.totalQuantity = Reg.ReadDword("Qty", 2);
		contract.multiplier = Reg.ReadString("Multiplier","");
		contract.exchange = Reg.ReadString("Exchange", "GLOBEX");
		contract.primaryExchange = Reg.ReadString("PrimExch","");
		order.orderType = Reg.ReadString("OrdType", "MKT");
		contract.secType = Reg.ReadString("Type", "FUT");
		order.transmit = (bool)Reg.ReadBool("Transmit",TRUE);
		ITS = Reg.ReadString("ITS","time.ien.it");
		m_bUseAutoStop = Reg.ReadBool("AutoStop",TRUE);
		m_bUseAutoLimit = Reg.ReadBool("AutoLimit",TRUE);
		m_bTrail = Reg.ReadBool("AutoTrail",TRUE);
		m_bPopupStatus = Reg.ReadBool("PopupStatus",FALSE);
		m_dStopPoints = Reg.ReadFloat("StopPoints",2.0);
		m_dLimitPoints = Reg.ReadFloat("LimitPoints",2.0);
		m_dLimitPoints2 = Reg.ReadFloat("LimitPoints2",2.0);
		m_dLimitPoints3 = Reg.ReadFloat("LimitPoints3",2.0);
		m_nLowVol = Reg.ReadDword("LowVol",0);
		m_nPeakVol = Reg.ReadDword("PeakVol",2500);
		m_bPaperTrade = Reg.ReadBool("PaperTrade",FALSE);
		m_bAutoClose = Reg.ReadBool("AutoClose",TRUE);
		m_bVolAlerts = Reg.ReadBool("VolAlerts", TRUE);
		m_nEODhour = Reg.ReadInt("EODh", 16);
		m_nEODmin = Reg.ReadInt("EODm",10);
		m_bFractExits = Reg.ReadBool("FractExits",FALSE);
		m_nLimitCts = Reg.ReadInt("LimitCts",order.totalQuantity);
		m_nLimitCts2 = Reg.ReadInt("LimitCts2",0);
		m_nLimitCts3 = Reg.ReadInt("LimitCts3",0);
		m_bVerbose = Reg.ReadBool("Verbose",FALSE);
		m_bDebug = Reg.ReadBool("Debug",FALSE);
		m_nOCAType = Reg.ReadInt("OCAType",1);
		m_nTimeOffset = Reg.ReadInt("TimeOffset",0);
	}

	if (m_bFractExits)
	{
		m_btnFractExits.SetWindowText("Reset Fractional Exits");
		m_btnUpdFractExits.ShowWindow(SW_SHOW);
	}
	else
	{
		m_btnFractExits.SetWindowText("Set Fractional Exits");
		m_btnUpdFractExits.ShowWindow(SW_HIDE);
	}

	m_chkAutoStop.SetCheck(m_bUseAutoStop);
	m_chkTrail.SetCheck(m_bTrail);
	m_chkAutoLimit.SetCheck(m_bUseAutoLimit);
	m_chkPopupStatus.SetCheck(m_bPopupStatus);
	m_chkPaperTrade.SetCheck(m_bPaperTrade);
	m_chkAutoClose.SetCheck(m_bAutoClose);
	m_chkFractExits.SetCheck(m_bFractExits);
	m_chkVolAlerts.SetCheck(m_bVolAlerts);
	m_chkVerbose.SetCheck(m_bVerbose);
	m_chkDebug.SetCheck(m_bDebug);

	m_cbbOCAType.SetCurSel(m_nOCAType -1);

	OnBnClickedCheck8();

	CString str;
	str.Format("%.2f",m_dStopPoints);
	m_edtStopPoints.SetWindowText(str);
	str.Format("%.2f",m_dLimitPoints);
	m_edtLimitPoints.SetWindowText(str);

	str.Format("%i",m_nLowVol);
	m_edtLowVol.SetWindowText(str);

	str.Format("%i",m_nPeakVol);
	m_edtPeakVol.SetWindowText(str);

	str.Format("%i",m_nTimeOffset);
	m_edtTimeOffset.SetWindowText(str);

	m_spnTimeOffset.SetRange(-12,+12);		//  time zones worldwide

	m_edtITS.SetWindowText(ITS);
	// could record cursor position in registry instead

	// optional, to activate dropdown in VC7
	CRect lprect, lprect2, lprect3;
	int nLines = 3;
	m_cbbSecType.GetWindowRect(&lprect);
	lprect.bottom = lprect.top + nLines * m_cbbSecType.GetItemHeight( 0 ) + lprect.Height();
	m_cbbSecType.SetWindowPos(NULL, 0, 0, lprect.Width(), lprect.Height(), SWP_NOMOVE | SWP_NOZORDER );
	m_cbbExchange.GetWindowRect(&lprect2);
	nLines = 4;
	lprect2.bottom = lprect2.top + nLines * m_cbbExchange.GetItemHeight( 0 ) + lprect2.Height();
	m_cbbExchange.SetWindowPos(NULL, 0, 0, lprect2.Width(), lprect2.Height(), SWP_NOMOVE | SWP_NOZORDER );
	
	nLines = 4;
	m_cbbOCAType.GetWindowRect(&lprect3);
	lprect3.bottom = lprect3.top + nLines * m_cbbOCAType.GetItemHeight( 0 ) + lprect3.Height();
	m_cbbOCAType.SetWindowPos(NULL, 0, 0, lprect3.Width(), lprect3.Height(), SWP_NOMOVE | SWP_NOZORDER );


	m_chkTransmit.SetCheck(order.transmit);

	m_cbbSecType.InsertString(0,"FUT");
	m_cbbSecType.InsertString(1,"STK");

	m_cbbExchange.InsertString(0,"GLOBEX");
	m_cbbExchange.InsertString(1,"ACE");
	m_cbbExchange.InsertString(2,"SMART");

	m_cbbOCAType.InsertString(0,"Cancel on Fill w/ Block");
	m_cbbOCAType.InsertString(1,"Reduce on Fill w/ Block");
	m_cbbOCAType.InsertString(2,"Reduce on Fill w/o Block");

	m_cbbOCAType.SetCurSel(1);

	if (contract.secType == "FUT")	m_cbbSecType.SetCurSel(0);
	else							m_cbbSecType.SetCurSel(1);

	if (contract.exchange == "GLOBEX")	m_cbbExchange.SetCurSel(0);
	else if (contract.exchange == "ACE")m_cbbExchange.SetCurSel(1);
	else								
		{
			m_cbbExchange.SetCurSel(2);
			contract.exchange = "SMART";
		}

	m_edtLog.SetWindowText(m_strLogPath + m_strLog);

	CTime t(y,1,1,m_nEODhour,m_nEODmin,0);
	//m_dtEODTime.SetFormat(DTS_TIMEFORMAT);
	m_dtEODTime.SetTime(&t);

	if (m_bFractExits)
	{
		CString strExits, str1, str2, str3, str4, str5, str6;
		str1.Format("%i",m_nLimitCts);
		str2.Format("%i",m_nLimitCts2);
		str3.Format("%i",m_nLimitCts3);
		str4.Format("%.2f",m_dLimitPoints);
		str5.Format("%.2f",m_dLimitPoints2);
		str6.Format("%.2f",m_dLimitPoints3);
		strExits.Format("Exit1:%s/%s; Exit2:%s/%s; Exit3:%s/%s",
						 str1, str4, str2, str5, str3, str6);
		m_edtFractExits.SetWindowText(strExits);
	}

	if (m_bRegInit)
		MessageBox("Please check application settings carefully, then restart application upon closing","Registry Init for IB_Direct",MB_OK);


	UpdateData(FALSE); // initialise values
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgOrder::OnBnClickedOk()
{
	CRegistry Reg;
	CString ITS;
	
	UpdateData(TRUE); // get values from controls

	if (order.totalQuantity  <= 0) 
	{
		AfxMessageBox("Incorrect order size!");
		return;
	}

	m_edtITS.GetWindowText(ITS);
	order.transmit = (bool)m_chkTransmit.GetCheck();
	m_bUseAutoStop = m_chkAutoStop.GetCheck();
	m_bUseAutoLimit = m_chkAutoLimit.GetCheck();
	m_bTrail = m_chkTrail.GetCheck();
	m_bPopupStatus = m_chkPopupStatus.GetCheck();
	m_bPaperTrade = m_chkPaperTrade.GetCheck();
	m_bAutoClose = m_chkAutoClose.GetCheck();
	m_bFractExits = m_chkFractExits.GetCheck();
	m_bVolAlerts = m_chkVolAlerts.GetCheck();
	m_bVerbose = m_chkVerbose.GetCheck();
	m_bDebug = m_chkDebug.GetCheck();

	m_nOCAType = m_cbbOCAType.GetCurSel()+1;
	order.OCAtype = m_nOCAType;

	CString str;
	m_edtStopPoints.GetWindowText(str);
	m_dStopPoints = atof(str);

	if ((m_bUseAutoStop == TRUE) && (m_dStopPoints <= 0))
		m_bUseAutoStop = FALSE;

	m_edtLowVol.GetWindowText(str);
	m_nLowVol = atol(str);

	m_edtPeakVol.GetWindowText(str);
	m_nPeakVol = atol(str);

	m_edtTimeOffset.GetWindowText(str);
	m_nTimeOffset = atol(str);

	CTime t;
	m_dtEODTime.GetTime(t);

	m_nEODhour = t.GetHour();
	m_nEODmin = t.GetMinute();

	CString strY = contract.expiry.Left(4);
	CString strM = contract.expiry.Right(2);
	long y = atol(strY);
	long m = atol(strM);
	if (y < t.GetYear())
	{
		AfxMessageBox("Expiry year... expired!");
		return;
	}
	else if (m < t.GetMonth())
		{
			AfxMessageBox("Expiry month... expired!");
			return;
		}

	if (!m_bFractExits)
	{
		m_edtLimitPoints.GetWindowText(str);
		m_dLimitPoints = atof(str);
	}
	
	if ((m_bUseAutoLimit == TRUE) && (m_dLimitPoints <= 0))
		m_bUseAutoLimit = FALSE;

	m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\DefaultSettings";
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(m_RegIBDKey, TRUE))	
	{
		int reg;
		reg = Reg.WriteDword("TickerId",m_lTickerId);
		reg = Reg.WriteString("Symbol",contract.symbol);
		reg = Reg.WriteString("Type",contract.secType);
		reg = Reg.WriteString("Expiry",contract.expiry);
		reg = Reg.WriteString("Exchange",contract.exchange);
		reg = Reg.WriteString("PrimExch",contract.primaryExchange);
		reg = Reg.WriteDword("Qty",order.totalQuantity);
		reg = Reg.WriteString("Multiplier",contract.multiplier);
		reg = Reg.WriteString("OrdType",order.orderType);
		reg = Reg.WriteBool("Transmit",order.transmit);
		reg = Reg.WriteString("ITS",ITS);
		reg = Reg.WriteFloat("StopPoints",m_dStopPoints);
		reg = Reg.WriteFloat("LimitPoints",m_dLimitPoints);
		reg = Reg.WriteFloat("LimitPoints2",m_dLimitPoints2);
		reg = Reg.WriteFloat("LimitPoints3",m_dLimitPoints3);
		reg = Reg.WriteInt("LimitCts", m_nLimitCts);
		reg = Reg.WriteInt("LimitCts2", m_nLimitCts2);
		reg = Reg.WriteInt("LimitCts3", m_nLimitCts3);
		reg = Reg.WriteBool("AutoStop",m_bUseAutoStop);
		reg = Reg.WriteBool("AutoLimit",m_bUseAutoLimit);
		reg = Reg.WriteBool("AutoTrail",m_bTrail);
		reg = Reg.WriteBool("PopupStatus",m_bPopupStatus);
		reg = Reg.WriteBool("VolAlerts",m_bVolAlerts);
		reg = Reg.WriteDword("LowVol",m_nLowVol);
		reg = Reg.WriteDword("PeakVol",m_nPeakVol);
		reg = Reg.WriteBool("PaperTrade", m_bPaperTrade);
		reg = Reg.WriteBool("AutoClose", m_bAutoClose);
		reg = Reg.WriteBool("FractExits", m_bFractExits);
		reg = Reg.WriteBool("Verbose", m_bVerbose);
		reg = Reg.WriteBool("Debug", m_bDebug);
		reg = Reg.WriteInt("EODh",m_nEODhour);
		reg = Reg.WriteInt("EODm",m_nEODmin);
		reg = Reg.WriteInt("OCAType",m_nOCAType);
		reg = Reg.WriteInt("TimeOffset",m_nTimeOffset);
		if (m_bRegInit)	 
		{
			MessageBox("Please restart application now to validate your settings","One-off Registry Init for IB_Direct",MB_OK);
			reg = Reg.WriteInt("RegInit",FALSE);
		}
	}
	m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\LastOrders";	// bug fix
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(m_RegIBDKey, TRUE))	Reg.WriteDword("Qty",order.totalQuantity);

	OnOK();
}

//	Set additional TWS parameters
void CDlgOrder::OnBnClickedExtended()
{
	CRegistry Reg;
	static CDlgExtOrd s_dlg;
	m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\DefaultSettings";
	Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (Reg.SetKey(m_RegIBDKey, TRUE))	
	{
		s_dlg.m_tif = Reg.ReadString("TIF","DAY");
		s_dlg.m_oca = Reg.ReadString("OCA","");
		s_dlg.m_account = Reg.ReadString("Account","");
		s_dlg.m_openClose = Reg.ReadString("OpenClose","O");
		s_dlg.m_origin = Reg.ReadInt("Origin",CUSTOMER);
		s_dlg.m_orderRef = Reg.ReadString("OrderRef","");
		s_dlg.m_transmit = Reg.ReadBool("Transmit",TRUE);
		s_dlg.m_parentId = Reg.ReadDword("ParentID",0);
		s_dlg.m_blockOrder = Reg.ReadBool("BlockOrder",FALSE);
		s_dlg.m_sweepToFill = Reg.ReadBool("SweepToFill",FALSE);
		s_dlg.m_triggerMethod = Reg.ReadInt("TriggerMethod",0);
		s_dlg.m_ignoreRth = Reg.ReadBool("IgnoreRTH",FALSE);
		s_dlg.m_rthOnly = Reg.ReadBool("RTHonly",FALSE);
		s_dlg.m_hidden = Reg.ReadBool("Hidden",FALSE);
	}
	if( s_dlg.DoModal() != IDOK) return;

	order.tif = s_dlg.m_tif;
	order.ocaGroup = s_dlg.m_oca;
	order.OCAtype = m_cbbOCAType.GetCurSel()+1;
	order.account = s_dlg.m_account;
	order.openClose = s_dlg.m_openClose; 
	order.origin = (Origin)s_dlg.m_origin;
	order.orderRef = s_dlg.m_orderRef;
	order.transmit = (bool)s_dlg.m_transmit;
	order.parentId = s_dlg.m_parentId;
	order.blockOrder = (bool)s_dlg.m_blockOrder;
	order.sweepToFill = (bool)s_dlg.m_sweepToFill;
	order.displaySize = s_dlg.m_displaySize;
	order.triggerMethod = s_dlg.m_triggerMethod;
	order.ignoreRth = (bool)s_dlg.m_ignoreRth;
	order.RTHonly = (bool)s_dlg.m_rthOnly;
	order.hidden = (bool)s_dlg.m_hidden;

	if (Reg.SetKey(m_RegIBDKey, TRUE))	
	{
		Reg.WriteString("TIF",order.tif);
		Reg.WriteString("OCA",order.ocaGroup);
		Reg.WriteString("Account",order.account);
		Reg.WriteString("OpenClose",order.openClose);
		Reg.WriteInt("Origin",order.origin);
		Reg.WriteString("OrderRef",order.orderRef);
		Reg.WriteBool("Transmit",order.transmit);
		Reg.WriteBool("BlockOrder",order.blockOrder);
		Reg.WriteBool("SweepToFill",order.sweepToFill);
		Reg.WriteInt("TriggerMethod",order.triggerMethod);
		Reg.WriteBool("IgnoreRTH",order.ignoreRth);
		Reg.WriteBool("RTHonly",order.RTHonly);
		Reg.WriteBool("Hidden",order.hidden);
	}
}

void CDlgOrder::OnCbnSelchangeType()
{
	int n = m_cbbSecType.GetCurSel();
	if (n==0)	contract.secType = "FUT";
	else		
	{
		contract.secType = "STK";
		contract.expiry = "";
	}
}

void CDlgOrder::OnCbnSelchangeExchange()
{
	int n = m_cbbExchange.GetCurSel();
	switch (n)
	{
		default:
		case 0:
			contract.exchange  = "GLOBEX";
			break;
		case 1:
			contract.exchange  = "ACE";
			break;
		case 2:
			contract.exchange  = "SMART";
			break;
	}
}

void CDlgOrder::OnBnClickedCheck2() // "Use AutoStop" button
{
	m_edtStopPoints.EnableWindow(m_chkAutoStop.GetCheck()) ;
}

void CDlgOrder::OnBnClickedCheck3() // "Use AutoLimit" button
{
	m_edtLimitPoints.EnableWindow(m_chkAutoLimit.GetCheck());
	m_chkFractExits.EnableWindow(m_chkAutoLimit.GetCheck());
}

void CDlgOrder::OnBnClickedCheck7() // AutoClode EOD
{
	m_dtEODTime.EnableWindow(m_chkAutoClose.GetCheck());
}

void CDlgOrder::OnBnClickedButton1()  // Set/Reset Fractional Exits
{
	FractExits dlgFExits;
	CString strExits, str, str1, str2, str3, str4, str5, str6;

	//UpdateData(TRUE); // retrieve data
	
	if (m_bFractExits)
	{
		m_btnFractExits.SetWindowText("Reset Fractional Exits");
		m_btnUpdFractExits.ShowWindow(SW_SHOW);
	}
	else
	{
		m_btnFractExits.SetWindowText("Set Fractional Exits");
		m_btnUpdFractExits.ShowWindow(SW_HIDE);
	}

	m_edtFractExits.EnableWindow(m_bFractExits);

	OrdSize.GetWindowText(str);
	order.totalQuantity = atol(str);
	dlgFExits.m_nTotalShares = order.totalQuantity;
	if ((m_nLimitCts == order.totalQuantity) || !m_bFractExits )
	{	// reset
		CString str;		
		m_nLimitCts = order.totalQuantity;
		dlgFExits.m_nNumShares1 = m_nLimitCts;
		m_nLimitCts2 = 0;
		m_nLimitCts2 = 0;
		m_edtLimitPoints.GetWindowText(str);
		m_dLimitPoints = atof(str);
		dlgFExits.m_dNumPoints1 = m_dLimitPoints;
	}

	if (m_bFractExits) dlgFExits.DoModal();
	m_nLimitCts = dlgFExits.m_nNumShares1;
	str1.Format("%i",m_nLimitCts);
	m_nLimitCts2 = dlgFExits.m_nNumShares2;
	str2.Format("%i",m_nLimitCts2);
	m_nLimitCts3 = dlgFExits.m_nNumShares3;
	str3.Format("%i",m_nLimitCts3);
	m_dLimitPoints = dlgFExits.m_dNumPoints1;
	str4.Format("%.2f",m_dLimitPoints);
	m_dLimitPoints2 = dlgFExits.m_dNumPoints2;
	str5.Format("%.2f",m_dLimitPoints2);
	m_dLimitPoints3 = dlgFExits.m_dNumPoints3;
	str6.Format("%.2f",m_dLimitPoints3);
	strExits.Format("Exit1:%s/%s; Exit2:%s/%s; Exit3:%s/%s",
					 str1, str4, str2, str5, str3, str6);
	m_edtFractExits.SetWindowText(strExits);

	m_bFractExits = !m_bFractExits;
}

void CDlgOrder::OnBnClickedCheck8() // "Use Fractional Exits" button
{
	BOOL fe = m_chkFractExits.GetCheck();
	if (fe)
	{
		m_btnFractExits.ShowWindow(SW_SHOW);
		m_btnUpdFractExits.ShowWindow(SW_SHOW);
	}
	else
	{	
		CString strExits, str1, str2, str3, str4, str5, str6;
		m_btnFractExits.ShowWindow(SW_HIDE);
		m_btnUpdFractExits.ShowWindow(SW_HIDE);
		OrdSize.GetWindowText(str1);
		m_nLimitCts = atol(str1);
		str1.Format("%i",m_nLimitCts);
		m_nLimitCts2 = 0;
		str2.Format("%i",m_nLimitCts2);
		m_nLimitCts3 = 0;
		str3.Format("%i",m_nLimitCts3);
		str4.Format("%.2f",m_dLimitPoints);
		m_dLimitPoints2 = 0;
		str5.Format("%.2f",m_dLimitPoints2);
		m_dLimitPoints3 = 0;
		str6.Format("%.2f",m_dLimitPoints3);
		strExits.Format("Exit1:%s/%s; Exit2:%s/%s; Exit3:%s/%s",
			str1, str4, str2, str5, str3, str6);
		m_edtFractExits.SetWindowText(strExits);
	}
}

void CDlgOrder::OnBnClickedButton11() // "Update Fractional Exits" button
{
	FractExits dlgFExits;
	CString strExits, str, str1, str2, str3, str4, str5, str6;
	OrdSize.GetWindowText(str);
	order.totalQuantity = atol(str);
	dlgFExits.m_nTotalShares = order.totalQuantity;
	dlgFExits.m_nNumShares1 = m_nLimitCts;
	dlgFExits.m_nNumShares2 = m_nLimitCts2;
	dlgFExits.m_nNumShares3 = m_nLimitCts3;
	dlgFExits.m_dNumPoints1 = m_dLimitPoints;
	dlgFExits.m_dNumPoints2 = m_dLimitPoints2;
	dlgFExits.m_dNumPoints3 = m_dLimitPoints3;
	dlgFExits.DoModal();
	m_nLimitCts = dlgFExits.m_nNumShares1;
	str1.Format("%i",m_nLimitCts);
	m_nLimitCts2 = dlgFExits.m_nNumShares2;
	str2.Format("%i",m_nLimitCts2);
	m_nLimitCts3 = dlgFExits.m_nNumShares3;
	str3.Format("%i",m_nLimitCts3);
	m_dLimitPoints = dlgFExits.m_dNumPoints1;
	str4.Format("%.2f",m_dLimitPoints);
	m_dLimitPoints2 = dlgFExits.m_dNumPoints2;
	str5.Format("%.2f",m_dLimitPoints2);
	m_dLimitPoints3 = dlgFExits.m_dNumPoints3;
	str6.Format("%.2f",m_dLimitPoints3);
	strExits.Format("Exit1:%s/%s; Exit2:%s/%s; Exit3:%s/%s",
					 str1, str4, str2, str5, str3, str6);
	m_edtFractExits.SetWindowText(strExits);
}

void CDlgOrder::OnBnClickedCheck9()
{
	if (m_chkVolAlerts.GetCheck())
	{
		m_statLowVol.ShowWindow(SW_SHOW);
		m_statPeakVol.ShowWindow(SW_SHOW);
		m_edtLowVol.ShowWindow(SW_SHOW);
		m_edtPeakVol.ShowWindow(SW_SHOW);
	}
	else
	{
		m_statLowVol.ShowWindow(SW_HIDE);
		m_statPeakVol.ShowWindow(SW_HIDE);
		m_edtLowVol.ShowWindow(SW_HIDE);
		m_edtPeakVol.ShowWindow(SW_HIDE);
	}
}

void CDlgOrder::OnBnClickedButton3()
{	
	CString strURL= "http://www.interactivebrokers.com/php/webhelp/webhelp.htm";
		::ShellExecute(NULL, NULL, strURL, NULL, NULL, SW_SHOWNORMAL);
}
void CDlgOrder::OnBnClickedCheck4()  // caution when changing order type
{
	int p1 = ((CClient3Dlg*)m_pParent)->m_nPosition1;
	CString str = "CAUTION: Changing order type (STP->TRAIL or TRAIL->STP) is not allowed while in position";
	if (p1 != 0) ((CClient3Dlg*)m_pParent)->AddStatusLine(str, statWarn);
}

void CDlgOrder::OnEnChangeEdit1()	// new symbol : clear stop/limit pts
{
	m_edtLimitPoints.SetWindowText("");
	m_edtStopPoints.SetWindowText("");
	m_edtFractExits.SetWindowText("");
}

void CDlgOrder::OnBnClickedButton4() // display doc from web site
{
	CString strURL= "http://www.interactivebrokers.com/en/software/releaseNotes/Betanotes.php";
		::ShellExecute(NULL, NULL, strURL, NULL, NULL, SW_SHOWNORMAL);}

void CDlgOrder::OnBnClickedCheck11()	// Debug mode
{
	m_bDebug = m_chkDebug.GetCheck();
}
