// DlgShareAllocation.cpp : implementation file
//

#include "stdafx.h"
#include "client3.h"
#include "DlgShareAllocation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgShareAllocation dialog


CDlgShareAllocation::CDlgShareAllocation(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgShareAllocation::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgShareAllocation)
	m_numShares = 0;
	//}}AFX_DATA_INIT
}


void CDlgShareAllocation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgShareAllocation)
	DDX_Control(pDX, IDC_EDT_SHARE_ALLOC, m_edtShareAlloc);
	DDX_Control(pDX, IDC_ACCTS, m_cmbAccts);
	DDX_Text(pDX, IDC_NUM_SHARES, m_numShares);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgShareAllocation, CDialog)
	//{{AFX_MSG_MAP(CDlgShareAllocation)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDlgShareAllocation::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    CString tmpAccts(m_strAccts);
    int     delimiterIndex = 0;

    delimiterIndex = tmpAccts.Find(',');
    while ( delimiterIndex != -1 ) 
    {
        // Add the subString
        m_cmbAccts.AddString( tmpAccts.Left(delimiterIndex));
        tmpAccts = m_strAccts.Right( tmpAccts.GetLength() - delimiterIndex - 1);
        delimiterIndex = tmpAccts.Find(',');
    }
    
    m_cmbAccts.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CDlgShareAllocation message handlers

void CDlgShareAllocation::OnAdd() 
{
    UpdateData(); // get the order legs

    if ( CB_ERR == m_cmbAccts.GetCurSel() && m_numShares < 0 ) 
    {
        return;
    }

    char    numSharesStr[20];
    CString acctStr;
    CString tmpAcctSharePairStr;

    // Get the new acct/shares pair details
    m_cmbAccts.GetLBText( m_cmbAccts.GetCurSel(), acctStr);
    _itoa(m_numShares, numSharesStr, 10);
    
    // Add the new pair to our shares allocation profile string.
    //      format is <acct1>/<shares1>,<acctN>/<sharesN>
    m_edtShareAlloc.GetWindowText(tmpAcctSharePairStr);
    if ( tmpAcctSharePairStr != "" ) {
        tmpAcctSharePairStr += ",";
    }
    m_edtShareAlloc.SetWindowText(tmpAcctSharePairStr + acctStr + "/" + numSharesStr);
}

void CDlgShareAllocation::OnCancel() 
{
	CDialog::OnCancel();
}

void CDlgShareAllocation::OnOK() 
{
    UpdateData(); // get the order legs

    m_edtShareAlloc.GetWindowText(m_strShareAllocations);
	
	CDialog::OnOK();
}
