// FractExits.cpp : implementation file
//

#include "stdafx.h"
#include "client3.h"  // to have access to resources
#include "FractExits.h"


// FractExits dialog

IMPLEMENT_DYNAMIC(FractExits, CDialog)
FractExits::FractExits(CWnd* pParent /*=NULL*/)
	: CDialog(FractExits::IDD, pParent)
	, m_nNumShares1(0)
	, m_nNumShares2(0)
	, m_nNumShares3(0)
	, m_dNumPoints1(0)
	, m_dNumPoints2(0)
	, m_dNumPoints3(0)
	, m_nTotalShares(0)
{
}

FractExits::~FractExits()
{
}

void FractExits::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_nNumShares1);
	DDX_Text(pDX, IDC_EDIT3, m_nNumShares2);
	DDX_Text(pDX, IDC_EDIT5, m_nNumShares3);
	DDX_Text(pDX, IDC_EDIT2, m_dNumPoints1);
	DDX_Text(pDX, IDC_EDIT4, m_dNumPoints2);
	DDX_Text(pDX, IDC_EDIT6, m_dNumPoints3);
	DDX_Text(pDX, IDC_EDIT7, m_nTotalShares);
}


BEGIN_MESSAGE_MAP(FractExits, CDialog)
	ON_EN_CHANGE(IDC_EDIT1, OnEnChangeEdit1)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_EN_CHANGE(IDC_EDIT3, OnEnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT5, OnEnChangeEdit5)
END_MESSAGE_MAP()


// FractExits message handlers

BOOL FractExits::OnInitDialog()
{
	CDialog::OnInitDialog();

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void FractExits::OnBnClickedOk()
{
	UpdateData(TRUE);

	if (m_nNumShares1 <0 ||
		m_nNumShares2 <0 ||
		m_nNumShares3 <0 )
		if ((m_nNumShares1 > 0 && m_dNumPoints1 <=0) ||
			(m_nNumShares2 > 0 && m_dNumPoints2 <=0) ||
			(m_nNumShares3 > 0 && m_dNumPoints3 <=0))
	{
		AfxMessageBox("Incorrect settings: negative values!!");
		return;
	}
	if (m_nNumShares1 +	m_nNumShares2 +	m_nNumShares3 != m_nTotalShares)
	{
		AfxMessageBox("Incorrect sum of contracts/shares!!");
		return;
	}

	if ((m_dNumPoints1 > 0) && 
		(m_dNumPoints2 <= m_dNumPoints1) &&
		(m_dNumPoints2 != 0))
	{
		AfxMessageBox("Limit Target: please check order");
		return;
	}


	if (m_nNumShares1 <=0)
	{	
		AfxMessageBox("First Limit Target is required.");
		return;
	}

	OnOK();
}

void FractExits::OnEnChangeEdit1()
{
	UpdateData(TRUE);
	if (m_nNumShares3 == 0)
		m_nNumShares2 = m_nTotalShares - m_nNumShares1;
	else
		m_nNumShares3 = m_nTotalShares - m_nNumShares1 - m_nNumShares2;
	UpdateData(FALSE);
}

void FractExits::OnEnChangeEdit3()
{
	UpdateData(TRUE);
	m_nNumShares3 = m_nTotalShares - m_nNumShares1 - m_nNumShares2;
	UpdateData(FALSE);
}

void FractExits::OnEnChangeEdit5()
{
	UpdateData(TRUE);
	m_nNumShares2 = m_nTotalShares - m_nNumShares1 - m_nNumShares3;
	UpdateData(FALSE);
}
