// IB_Info.cpp : implementation file
//

#include "stdafx.h"
#include "IB_Info.h"
#include "client3Dlg.h"

// IB_Info dialog

IMPLEMENT_DYNAMIC(IB_Info, CDialog)
IB_Info::IB_Info(CWnd* pParent /*=NULL*/)
	: CDialog(IB_Info::IDD, pParent)
	, m_statType(0)
	, m_strInfo(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pParent = pParent;		// pointer to parent dialog
}

IB_Info::~IB_Info()
{
}

void IB_Info::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATUS, ListStatus);
	DDX_Control(pDX, IDC_BUTTON12, m_btnClear);
	DDX_Control(pDX, IDC_BUTTON11, m_btnHide);
	DDX_Control(pDX, IDC_BUTTON1, m_btnClose);
}

BEGIN_MESSAGE_MAP(IB_Info, CDialog)
	ON_NOTIFY(NM_DBLCLK, IDC_STATUS, OnNMDblclkStatus)
	ON_WM_ACTIVATE()
	ON_BN_CLICKED(IDC_BUTTON12, OnBnClickedButton12)
	ON_BN_CLICKED(IDC_BUTTON11, OnBnClickedButton11)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()


// IB_Info message handlers

BOOL IB_Info::OnInitDialog()
{
	RECT rect;
	LONG lw;
	CDialog::OnInitDialog();

	ListStatus.SetExtendedStyle(		// setup list control
		LVS_OWNERDRAWFIXED |
		LVS_EX_LABELTIP | 
		LVS_EX_GRIDLINES);
	ListStatus.GetClientRect(&rect);
	lw = rect.right - rect.left;
	ListStatus.SetBkColor(RGB(192,192,192));
	ListStatus.InsertColumn(0, "Status", LVCFMT_LEFT, lw - 1 , -1 );
	ListStatus.InsertItem(0,"");

	GetWindowRect(m_dlgRect);

	m_strSessionNo = ((CClient3Dlg*)m_pParent)->m_strSessionNo;
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, TRUE))
	{
		int nL = m_Reg.ReadInt("INFOleft",50);
		int nT = m_Reg.ReadInt("INFOtop",50);
		MoveWindow(nL,nT,m_dlgRect.Width(),m_dlgRect.Height(),TRUE);
	}

	ListStatus.GetWindowRect(m_rectList);
	//m_btnHide.GetWindowRect(m_rectHide);
	//m_btnClear.GetWindowRect(m_rectClear);
	//m_btnClose.GetWindowRect(m_rectClose);

	ListStatus.MoveWindow(
		0,0,
		m_dlgRect.Width()-30,
		m_dlgRect.Height()-20);

	return TRUE;

}

void IB_Info::ClearList(void)
{
	ListStatus.DeleteAllItems();
	ListStatus.SetBkColor(Colour);
}

void IB_Info::OnNMDblclkStatus(NMHDR *pNMHDR, LRESULT *pResult)
{
	ClearList();
	*pResult = 0;
}

void IB_Info::PostNcDestroy()
{
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, TRUE))
	{
		m_Reg.WriteInt("INFOleft", m_dlgRect.left);
		m_Reg.WriteInt("INFOtop",m_dlgRect.top);
	}
	((CClient3Dlg*)m_pParent)->mlInfo = NULL;		
	delete this;	// delete pointer to modeless form
	CDialog::PostNcDestroy();
}

void IB_Info::OnBnClickedButton12()	// clear
{
	ClearList();
}

void IB_Info::OnBnClickedButton11()	// hide
{
	this->ShowWindow(SW_HIDE);
}

void IB_Info::OnBnClickedButton1()	// close
{
	GetWindowRect(m_dlgRect);
	((CClient3Dlg*)m_pParent)->SetFocus(); // focus back to main dialog
	DestroyWindow();
}

void IB_Info::OnWindowPosChanged(WINDOWPOS* lpwndpos)
{
	CDialog::OnWindowPosChanged(lpwndpos);
	GetWindowRect(m_dlgRect);
	m_btnHide.GetClientRect(m_rectHide);
	m_btnClear.GetClientRect(m_rectClear);
	m_btnClose.GetClientRect(m_rectClose);
	ListStatus.MoveWindow(
		0,0,
		//m_rectList.left,m_rectList.top,
		m_dlgRect.Width()-60,m_dlgRect.Height()-20);	// TODO: Add your message handler code here
	ListStatus.SetColumnWidth(0,m_dlgRect.Width()-63);
	int n = m_dlgRect.Width();
	m_btnClear.MoveWindow(n-58,0,// m_rectHide.top,
						m_rectHide.Width(), m_rectHide.Height());
	m_btnHide.MoveWindow(n-58,35,// m_rectHide.top,
						m_rectHide.Width(), m_rectHide.Height());
	m_btnClose.MoveWindow(n-58,70,// m_rectHide.top,
						m_rectHide.Width(), m_rectHide.Height());


}
