// SL_AttExitAdjust.cpp : implementation file
//

#include "stdafx.h"
#include "client3Dlg.h"
#include "SL_AttExitAdjust.h"

// SL_AttExitAdjust dialog

IMPLEMENT_DYNAMIC(SL_AttExitAdjust, CDialog)
SL_AttExitAdjust::SL_AttExitAdjust(CWnd* pParent /*=NULL*/)
	: CDialog(SL_AttExitAdjust::IDD, pParent)
	, m_nPosition(0)
	, m_dNumStpPts(0)
	, m_dNumLmtPts(0)
	, m_dNumLmtPts2(0)
	, m_dNumLmtPts3(0)
	, m_dStopPrice(0)
	, m_dLimitPrice(0)
	, m_dLimitPrice2(0)
	, m_dLimitPrice3(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pParent = pParent;		// pointer to parent dialog
}

SL_AttExitAdjust::~SL_AttExitAdjust()
{
}

void SL_AttExitAdjust::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STOPLOSS, m_chkStopLoss);
	DDX_Control(pDX, IDC_LIMITTARGET, m_chkLmtTarget);
	DDX_Control(pDX, IDC_LIMITTARGET2, m_chkLmtTarget2);
	DDX_Control(pDX, IDC_LIMITTARGET3, m_chkLmtTarget3);
	DDX_Control(pDX, IDC_EDIT2, m_edtStpLoss);
	DDX_Control(pDX, IDC_EDIT10, m_edtLmtTarget);
	DDX_Control(pDX, IDC_SLIDER1, StopLossSlider);
	DDX_Control(pDX, IDC_SLIDER2, LmtTargetSlider);
	DDX_Control(pDX, IDC_BUTTON10, m_btnClose);
	DDX_Control(pDX, IDC_BUTTON13, m_btnApply);
	DDX_Control(pDX, IDC_BUTTON9, m_btnCancel);
	DDX_Control(pDX, IDC_BUTTON16, m_btnApply2);
	DDX_Control(pDX, IDC_EDIT11, m_edtLmtTarget2);
	DDX_Control(pDX, IDC_SLIDER3, LmtTargetSlider2);
	DDX_Control(pDX, IDC_EDIT12, m_edtLmtTarget3);
	DDX_Control(pDX, IDC_SLIDER4, LmtTargetSlider3);
	DDX_Control(pDX, IDC_BUTTON17, m_btnApply3);
	DDX_Control(pDX, IDC_BUTTON18, m_btnApply4);
	DDX_Control(pDX, IDC_BUTTON1, m_btnCancelLimit1);
	DDX_Control(pDX, IDC_BUTTON11, m_btnCancelLimit2);
	DDX_Control(pDX, IDC_BUTTON19, m_btnCancelLimit3);
}

BEGIN_MESSAGE_MAP(SL_AttExitAdjust, CDialog)
	ON_BN_CLICKED(IDC_BUTTON10, CommitNewPrices)
	ON_BN_CLICKED(IDC_BUTTON13, OnBnClickedButton13)
	ON_BN_CLICKED(IDC_BUTTON9, CloseDialog)
	ON_BN_CLICKED(IDC_STOPLOSS, OnBnClickedStoploss)
	ON_BN_CLICKED(IDC_LIMITTARGET, OnBnClickedLimittarget)
	ON_BN_CLICKED(IDC_BUTTON16, OnBnAdjustLimit1)
	ON_BN_CLICKED(IDC_LIMITTARGET2, OnBnClickedLimittarget2)
	ON_BN_CLICKED(IDC_LIMITTARGET3, OnBnClickedLimittarget3)
	ON_BN_CLICKED(IDC_BUTTON17, OnBnAdjustLimit2)
	ON_BN_CLICKED(IDC_BUTTON18, OnBnAdjustLimit3)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnCancelLimit1)
	ON_BN_CLICKED(IDC_BUTTON11, OnBnCancelLimit2)
	ON_BN_CLICKED(IDC_BUTTON19, OnBnCancelLimit3)
//	ON_WM_ACTIVATE()
END_MESSAGE_MAP()

// SL_AttExitAdjust message handlers

BOOL SL_AttExitAdjust::OnInitDialog()
{
	short crBtnColor = 30;
	CDialog::OnInitDialog();

	// Set sliders
	m_edtLmtTarget.SetSlideLink(this,IDC_SLIDER2);
	m_edtLmtTarget.SetParams(0.0,0.0,1,"%.3f");
	m_edtLmtTarget.SetValue(0.0);

	m_edtLmtTarget2.SetSlideLink(this,IDC_SLIDER3);
	m_edtLmtTarget2.SetParams(0.0,0.0,1,"%.3f");
	m_edtLmtTarget2.SetValue(0.0);

	m_edtLmtTarget3.SetSlideLink(this,IDC_SLIDER4);
	m_edtLmtTarget3.SetParams(0.0,0.0,1,"%.3f");
	m_edtLmtTarget3.SetValue(0.0);

	m_edtStpLoss.SetSlideLink(this,IDC_SLIDER1);
	m_edtStpLoss.SetParams(0.0,0.0,1,"%.3f");
	m_edtStpLoss.SetValue(0.0);

	m_edtStpLoss.SetIncrement(m_dTickSize);
	m_edtStpLoss.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.3f");

	m_edtLmtTarget.SetIncrement(m_dTickSize);
	m_edtLmtTarget.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.3f");

	m_edtLmtTarget2.SetIncrement(m_dTickSize);
	m_edtLmtTarget2.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.3f");

	m_edtLmtTarget3.SetIncrement(m_dTickSize);
	m_edtLmtTarget3.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.3f");
	
	if (m_nPosition >= 0)
	{
		m_edtStpLoss.SetValue(m_dRefPrice - m_dNumStpPts);
		m_edtLmtTarget.SetValue(m_dRefPrice + m_dNumLmtPts);
		m_edtLmtTarget2.SetValue(m_dRefPrice + m_dNumLmtPts2);
		m_edtLmtTarget3.SetValue(m_dRefPrice + m_dNumLmtPts3);
	}
	else
	{
		m_edtStpLoss.SetValue(m_dRefPrice + m_dNumStpPts);
		m_edtLmtTarget.SetValue(m_dRefPrice - m_dNumLmtPts);
		m_edtLmtTarget2.SetValue(m_dRefPrice - m_dNumLmtPts2);
		m_edtLmtTarget3.SetValue(m_dRefPrice - m_dNumLmtPts3);
	}

	m_btnCancelLimit1.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnCancelLimit1.SetTooltipText(_T("Cancel Limit Order1"));

	m_btnCancelLimit2.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnCancelLimit2.SetTooltipText(_T("Cancel Limit Order2"));

	m_btnCancelLimit3.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnCancelLimit3.SetTooltipText(_T("Cancel Limit Order3"));

	m_btnClose.SetIcon(IDI_X);
	m_btnClose.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnClose.SetTooltipText(_T("Apply Stop&Limit and then close"));

	//m_btnApply.SetIcon(IDI_OK);
	m_btnApply.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnApply.SetTooltipText(_T("Apply STOP"));

	//m_btnApply2.SetIcon(IDI_OK);
	m_btnApply2.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnApply2.SetTooltipText(_T("Apply LIMIT1"));

	m_btnApply3.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnApply3.SetTooltipText(_T("Apply LIMIT2"));

	m_btnApply4.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnApply4.SetTooltipText(_T("Apply LIMIT3"));

	m_btnCancel.SetIcon(IDI_CANCELORD);
	m_btnCancel.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnCancel.SetTooltipText(_T("Close this dialog"));

	// enable only where applicable
	m_chkStopLoss.SetCheck(m_dNumStpPts>0);
	m_chkLmtTarget.SetCheck(m_dNumLmtPts>0);
	m_chkLmtTarget2.SetCheck(m_dNumLmtPts2>0);
	m_chkLmtTarget3.SetCheck(m_dNumLmtPts3>0);
	OnBnClickedStoploss();
	OnBnClickedLimittarget();
	OnBnClickedLimittarget2();
	OnBnClickedLimittarget3();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void SL_AttExitAdjust::PostNcDestroy()
{
	// clear pointer in parent form
	((CClient3Dlg*)m_pParent)->mlSLExits = NULL;		
	delete this;	// delete pointer to modeless form
	CDialog::PostNcDestroy();
}

//  This modeless form adjusts member variables in parent dialog
void SL_AttExitAdjust::AdjustStop(void)
{
	CString strPrice;
	m_edtStpLoss.GetWindowText(strPrice);
	m_dStopPrice = atof(strPrice);
	((CClient3Dlg*)m_pParent)->m_dStopPrice = m_dStopPrice;
	((CClient3Dlg*)m_pParent)->m_strStopLoss = strPrice;
	((CClient3Dlg*)m_pParent)->CommitNewStop();	// commit stop
}

void SL_AttExitAdjust::AdjustLimit(void)
{
	CString strPrice;
	m_edtLmtTarget.GetWindowText(strPrice);
	m_dLimitPrice = atof(strPrice);
	((CClient3Dlg*)m_pParent)->m_dLimitTarget = m_dLimitPrice;
	((CClient3Dlg*)m_pParent)->m_strLimitTarget = strPrice;
	((CClient3Dlg*)m_pParent)->CommitNewLimit1();	// commit limit
}

void SL_AttExitAdjust::AdjustLimit2(void)
{
	CString strPrice;
	m_edtLmtTarget2.GetWindowText(strPrice);
	m_dLimitPrice2 = atof(strPrice);
	((CClient3Dlg*)m_pParent)->m_dLimitTarget2 = m_dLimitPrice2;
	((CClient3Dlg*)m_pParent)->m_strLimitTarget2 = strPrice;
	((CClient3Dlg*)m_pParent)->CommitNewLimit2();	// commit limit
}

void SL_AttExitAdjust::AdjustLimit3(void)
{
	CString strPrice;
	m_edtLmtTarget.GetWindowText(strPrice);
	m_dLimitPrice = atof(strPrice);
	((CClient3Dlg*)m_pParent)->m_dLimitTarget3 = m_dLimitPrice;
	((CClient3Dlg*)m_pParent)->m_strLimitTarget3 = strPrice;
	((CClient3Dlg*)m_pParent)->CommitNewLimit3();	// commit limit
}

void SL_AttExitAdjust::CommitNewPrices()
{
	AdjustStop();
	AdjustLimit();
	AdjustLimit2();
	AdjustLimit3();
	DestroyWindow();
}

void SL_AttExitAdjust::OnBnClickedButton13()  // "adjust stop" button
{
	AdjustStop();
}

void SL_AttExitAdjust::CloseDialog() // close dialog without updating
{
	DestroyWindow();
}

void SL_AttExitAdjust::OnBnClickedStoploss() // checkbox stop loss
{
	if (m_chkStopLoss.GetCheck())
	{
		m_edtStpLoss.ShowWindow(SW_SHOW);
		StopLossSlider.ShowWindow(SW_SHOW);
	}
	else
	{
		m_edtStpLoss.ShowWindow(SW_HIDE);
		StopLossSlider.ShowWindow(SW_HIDE);
	}
	m_btnApply.EnableWindow(m_dNumStpPts>0);
}

void SL_AttExitAdjust::OnBnClickedLimittarget()
{
	if (m_chkLmtTarget.GetCheck())
	{
		m_edtLmtTarget.ShowWindow(SW_SHOW);
		LmtTargetSlider.ShowWindow(SW_SHOW);
		m_btnCancelLimit1.ShowWindow(SW_SHOW);
	}
	else
	{
		m_edtLmtTarget.ShowWindow(SW_HIDE);
		LmtTargetSlider.ShowWindow(SW_HIDE);
		m_btnCancelLimit1.ShowWindow(SW_HIDE);
	}
	m_btnApply2.EnableWindow(m_dNumLmtPts>0);
}

void SL_AttExitAdjust::OnBnClickedLimittarget2() // checkbox limit2
{
	if (m_chkLmtTarget2.GetCheck())
	{
		m_edtLmtTarget2.ShowWindow(SW_SHOW);
		LmtTargetSlider2.ShowWindow(SW_SHOW);
		m_btnCancelLimit2.ShowWindow(SW_SHOW);
	}
	else
	{
		m_edtLmtTarget2.ShowWindow(SW_HIDE);
		LmtTargetSlider2.ShowWindow(SW_HIDE);
		m_btnCancelLimit2.ShowWindow(SW_HIDE);
	}
	m_btnApply3.EnableWindow(m_dNumLmtPts2>0);
}

void SL_AttExitAdjust::OnBnClickedLimittarget3() // checkbox limit3
{
	if (m_chkLmtTarget3.GetCheck())
	{
		m_edtLmtTarget3.ShowWindow(SW_SHOW);
		LmtTargetSlider3.ShowWindow(SW_SHOW);
		m_btnCancelLimit3.ShowWindow(SW_SHOW);
	}
	else
	{
		m_edtLmtTarget3.ShowWindow(SW_HIDE);
		LmtTargetSlider3.ShowWindow(SW_HIDE);
		m_btnCancelLimit3.ShowWindow(SW_HIDE);
	}
	m_btnApply4.EnableWindow(m_dNumLmtPts3>0);
}

void SL_AttExitAdjust::OnBnAdjustLimit1()  // "adjust limit1" button 
{
	AdjustLimit();
}

void SL_AttExitAdjust::OnBnAdjustLimit2()  // "adjust limit2" button
{
	AdjustLimit2();
}

void SL_AttExitAdjust::OnBnAdjustLimit3()  // "adjust limit3" button
{
	AdjustLimit3();
}


void SL_AttExitAdjust::OnBnCancelLimit1()
{
	if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[0] == TRUE && 
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 > 0) 
	{
		((CClient3Dlg*)m_pParent)->m_tws1.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1);
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws1 = 0;
	}

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>1) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[1] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws2 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws2);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws2 = 0;
		}	

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>2) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[2] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws3 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws3);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId1_tws3 = 0;
		}
}

void SL_AttExitAdjust::OnBnCancelLimit2()
{
	if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[0] == TRUE && 
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 > 0) 
	{
		((CClient3Dlg*)m_pParent)->m_tws1.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1);
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws1 = 0;
	}

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>1) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[1] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws2 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws2);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws2 = 0;
		}	

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>2) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[2] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws3 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws3);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId2_tws3 = 0;
		}
}

void SL_AttExitAdjust::OnBnCancelLimit3()
{
	if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[0] == TRUE && 
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 > 0) 
	{
		((CClient3Dlg*)m_pParent)->m_tws1.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1);
		((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws1 = 0;
	}

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>1) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[1] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws2 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws2);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws2 = 0;
		}	

	if (((CClient3Dlg*)m_pParent)->m_lNumIB>2) 
		if (((CClient3Dlg*)m_pParent)->m_bTwsChecked1[2] == TRUE && 
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws3 > 0) 
		{
			((CClient3Dlg*)m_pParent)->m_tws2.cancelOrder(((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws3);
			((CClient3Dlg*)m_pParent)->m_lLastLimitOrderId3_tws3 = 0;
		}
}

//void SL_AttExitAdjust::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
//{
//	CDialog::OnActivate(nState, pWndOther, bMinimized);
//
//	if (m_nPosition >= 0)
//	{
//		m_edtStpLoss.SetValue(m_dRefPrice - m_dNumStpPts);
//		m_edtLmtTarget.SetValue(m_dRefPrice + m_dNumLmtPts);
//		m_edtLmtTarget2.SetValue(m_dRefPrice + m_dNumLmtPts2);
//		m_edtLmtTarget3.SetValue(m_dRefPrice + m_dNumLmtPts3);
//	}
//	else
//	{
//		m_edtStpLoss.SetValue(m_dRefPrice + m_dNumStpPts);
//		m_edtLmtTarget.SetValue(m_dRefPrice - m_dNumLmtPts);
//		m_edtLmtTarget2.SetValue(m_dRefPrice - m_dNumLmtPts2);
//		m_edtLmtTarget3.SetValue(m_dRefPrice - m_dNumLmtPts3);
//	}
//}
