// SL_EntryAdjust.cpp : implementation file
//

#include "stdafx.h"
#include "client3Dlg.h"
#include "SL_EntryAdjust.h"


// SL_EntryAdjust dialog

IMPLEMENT_DYNAMIC(SL_EntryAdjust, CDialog)
SL_EntryAdjust::SL_EntryAdjust(CWnd* pParent /*=NULL*/)
	: CDialog(SL_EntryAdjust::IDD, pParent)
	, m_dRefPrice(0.0)
	, m_nRange(0)
	, m_dTickSize(0.0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pParent = pParent;		// pointer to parent dialog
}

SL_EntryAdjust::~SL_EntryAdjust()
{
}

void SL_EntryAdjust::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MODORDER, btnAdjust);
	DDX_Control(pDX, IDC_PRICE, m_edtLmtPrice);
	DDX_Control(pDX, IDC_PRICE2, m_edtStpPrice);
	DDX_Control(pDX, IDC_SLIDER3, LmtSlider);
	DDX_Control(pDX, IDC_SLIDER4, StpSlider);
	DDX_Control(pDX, IDOK, btnClose);
	DDX_Control(pDX, IDOK2, btnCancelOrd);
	DDX_Control(pDX, IDOK3, btnCloseNoAdjust);
}


BEGIN_MESSAGE_MAP(SL_EntryAdjust, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_MODORDER, OnBnClickedModorder)
	ON_BN_CLICKED(IDOK2, OnBnClickedOk2)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDOK3, OnBnClickedOk3)
END_MESSAGE_MAP()


// SL_EntryAdjust message handlers

BOOL SL_EntryAdjust::OnInitDialog()
{
	double dStpP, dLmtP;
	short crBtnColor = 30;
	CDialog::OnInitDialog();

	dStpP = dLmtP = m_dRefPrice;

	if (((CClient3Dlg*)m_pParent)->order[0][0].orderType != "STP")
		dLmtP = (((CClient3Dlg*)m_pParent)->order[0][0].lmtPrice > 0 ?
				((CClient3Dlg*)m_pParent)->order[0][0].lmtPrice :
				m_dRefPrice);
	else
		if (((CClient3Dlg*)m_pParent)->order[0][0].orderType != "LMT")
			dStpP = (((CClient3Dlg*)m_pParent)->order[0][0].auxPrice > 0 ?
				((CClient3Dlg*)m_pParent)->order[0][0].auxPrice :
				m_dRefPrice);
		
	// Set sliders
	m_edtLmtPrice.SetSlideLink(this,IDC_SLIDER3);
	m_edtStpPrice.SetSlideLink(this,IDC_SLIDER4);

	m_edtLmtPrice.SetIncrement(m_dTickSize);
	m_edtLmtPrice.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.2f");
	m_edtLmtPrice.SetValue(dLmtP);

	m_edtStpPrice.SetIncrement(m_dTickSize);
	m_edtStpPrice.SetParams(m_dRefPrice - m_nRange, m_dRefPrice + m_nRange,1,"%.2f");
	m_edtStpPrice.SetValue(dStpP);

	btnClose.SetIcon(IDI_X);
	btnClose.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	btnClose.SetTooltipText(_T("Adjust Prices & Close"));

	btnAdjust.SetIcon(IDI_OK);
	btnAdjust.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	btnAdjust.SetTooltipText(_T("Adjust Prices"));

	btnCloseNoAdjust.SetIcon(IDI_RUN);
	btnCloseNoAdjust.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	btnCloseNoAdjust.SetTooltipText(_T("Just Close (no price update)"));

	btnCancelOrd.SetIcon(IDI_CANCELORD);
	btnCancelOrd.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	btnCancelOrd.SetTooltipText(_T("Cancel Open Order"));
	return TRUE;  // return TRUE unless you set the focus to a control
}

void SL_EntryAdjust::PostNcDestroy()
{
	// clear pointer in parent form
	((CClient3Dlg*)m_pParent)->mlSLEntry = NULL;		
	delete this;	// delete pointer to modeless form
	CDialog::PostNcDestroy();
}

void SL_EntryAdjust::AdjustPrices()
{
	CString strPrice;
	m_edtLmtPrice.GetWindowText(strPrice);
	((CClient3Dlg*)m_pParent)->m_strLmtPrice = strPrice;
	m_edtStpPrice.GetWindowText(strPrice);
	((CClient3Dlg*)m_pParent)->m_strStpPrice = strPrice;
	((CClient3Dlg*)m_pParent)->OnBnClickedModorder();
}

void SL_EntryAdjust::OnBnClickedOk()
{
	AdjustPrices();
	DestroyWindow();
}

void SL_EntryAdjust::OnBnClickedModorder()
{
	AdjustPrices();
}

void SL_EntryAdjust::OnBnClickedOk2()
{
	((CClient3Dlg*)m_pParent)->OnCanorder();
	DestroyWindow();
}

void SL_EntryAdjust::OnClose()
{
	((CClient3Dlg*)m_pParent)->SetFocus();
	CDialog::OnClose();
}

void SL_EntryAdjust::OnBnClickedOk3()
{
	DestroyWindow();
}
