#ifndef contract_def
#define contract_def

#include <vector>
using namespace std;

/*
    SAME_POS    = open/close leg value is same as combo
    OPEN_POS    = open
    CLOSE_POS   = close
    UNKNOWN_POS = unknown

*/
enum LegOpenClose { SAME_POS, OPEN_POS, CLOSE_POS, UNKNOWN_POS };

struct ComboLeg
{

   ComboLeg()
   {
      conId = 0;
      ratio = 0;
   }

   long    conId;
   CString action; //BUY/SELL
   long    ratio;
   CString exchange;
   long    openClose; // LegOpenClose enum values

   bool operator==( const ComboLeg &other) const
   {
      return (conId == other.conId &&
         ratio == other.ratio &&
         action.CompareNoCase(other.action) &&
         exchange.CompareNoCase(other.exchange) &&
         openClose == other.openClose);
   }

};

struct Contract
{
   Contract()
   {
      strike = coupon = 0;
      comboLegs = NULL;
	  callable = putable = convertible = includeExpired = nextOptionPartial = false;
   }

   CString symbol;
   CString secType;
   CString expiry;
   double  strike;
   CString right;
   CString multiplier;
   CString exchange;
   CString primaryExchange; // pick an actual (ie non-aggregate) exchange that the contract trades on.  DO NOT SET TO SMART.
   CString currency;
   CString localSymbol;
   bool includeExpired;
   vector<ComboLeg*>*   comboLegs;

   // BOND values
   CString cusip;
   CString ratings;
   CString descAppend;
   CString bondType;
   CString couponType;
   bool callable;
   bool putable;
   double coupon;
   bool convertible;
   CString maturity;
   CString issueDate;
   CString nextOptionDate;
   CString nextOptionType;
   bool nextOptionPartial;
   CString notes;
};

struct ContractDetails
{
   ContractDetails()
   {
      conid		= 0;
      minTick     = 0;
	  priceMagnifier = 0;
   }

   Contract	summary;
   CString	marketName;
   CString	tradingClass;
   long		conid;
   double	minTick;
   CString	multiplier;
   CString	orderTypes;
   CString	validExchanges;
   long     priceMagnifier;
};

#endif
