#ifndef eclient_def
#define eclient_def

#include "Contract.h"
#include "Order.h"
#include "Execution.h"

typedef long TickerId;
typedef long OrderId;

class EClient 
{
public:
	virtual ~EClient() {}
	virtual bool eConnect( const char *host, UINT port, int clientId=0) = 0;
	virtual void eDisconnect() = 0;
	virtual void reqMktData( TickerId id, const Contract &contract) = 0;
	virtual void cancelMktData( TickerId id) = 0;
	virtual void placeOrder( OrderId id, const Contract &contract, const Order &order) = 0;
	virtual void cancelOrder( OrderId id) = 0;
	virtual void reqOpenOrders() = 0;
	virtual void reqAccountUpdates() = 0;
	virtual void reqExecutions() = 0;
	virtual void reqIds( int numIds) = 0;
	virtual void checkMessages() = 0;
	virtual void reqContractDetails( const Contract &contract) = 0;
	virtual void reqMktDepth( TickerId id, const Contract &contract) = 0;
	virtual void cancelMktDepth( TickerId id) = 0;

private:
};

#endif
