#ifndef eclientsocket_def
#define eclientsocket_def

#ifndef DLLEXP
#define DLLEXP
#endif

#include "EClient.h"
#include "EWrapper.h"

class EWrapper;
class CSocket;
class CSocketFile;
class MySocket;

class DLLEXP EClientSocket : public EClient
{
friend MySocket;
public:
	EClientSocket( EWrapper *ptr);
	~EClientSocket();

	// override virtual funcs from EClient
	bool eConnect( const char *host, UINT port, int clientId=0);
	void eDisconnect();
	void reqMktData( TickerId id, const Contract &contract);
	void cancelMktData( TickerId id);
	void placeOrder( OrderId id, const Contract &contract, const Order &order);
	void cancelOrder( OrderId id) ;
	void reqOpenOrders();
	void reqAccountUpdates();
	void reqExecutions();
	void reqIds( int numIds);
	void checkMessages();
	void reqContractDetails( const Contract &contract);    
    void reqMktDepth( TickerId tickerId, const Contract &contract);
    void cancelMktDepth( TickerId tickerId);

private:
	// process single msg
	bool processMsg();

	// non-blocking read
	int readInt2();

	// blocking read/write funcs
	CString readStr();
	int		readInt();
	double	readDouble();
	void	send( const char *str);
	void	send( int val);
	void	send( double val);

	// callback from socket
	void onReceive( int i);
	void onClose( int i);
private:
	EWrapper *m_pEWrapper;
	HANDLE m_hmutex;			// synchronizes access to socket
	MySocket *m_pSocket;
	CSocketFile *m_pFile;
	CArchive *m_pArOut;
	bool m_connected;
	int m_serverVersion;
};

#endif






