#ifndef order_def
#define order_def

enum Origin { CUSTOMER, FIRM, UNKNOWN };

struct Order
{
	Order()
	{
		orderId			= 0;
		clientId		= 0;
        permId          = 0;
		totalQuantity	    = 0;
		lmtPrice	    = 0;
		auxPrice	    = 0;

		OCAtype			= 1;
		openClose	    = "O";
		origin		    = CUSTOMER;
		transmit	    = true;
        parentId        = 0;
        blockOrder      = false;
        sweepToFill     = false;
        displaySize     = 0;
        triggerMethod   = 0;
        ignoreRth       = false;
		RTHonly			= false;
        hidden          = false;
        discretionaryAmt= 0;
	}

   // order identifier
   long    orderId;
   long    clientId;
   long    permId; 

	// main order fields
	CString action;
	long    totalQuantity;
	CString orderType;
	double  lmtPrice;
	double  auxPrice;
	//double tickSize;		// added to original struct

	// extended order fields
	CString tif;
	CString ocaGroup;
	int		OCAtype;
	CString account;
	CString openClose;
	Origin  origin;
	CString orderRef;
	bool    transmit;		// if false, order will be created but not transmited
	long    parentId;		// The parent id, if this is an auto order
    bool    blockOrder;
    bool    sweepToFill;
    int     displaySize;
    int     triggerMethod;
    bool    ignoreRth;
	bool	RTHonly;
    bool    hidden;
	double  discretionaryAmt;
	CString goodAfterTime;
	CString goodTillDate;

    // share allocation
    CString sharesAllocation;

	//fa
	CString faGroup;
    CString faProfile;
    CString faMethod;
    CString faPercentage;

};


#endif
