/* This program for what it's worth, remains the intellectual property of :
		Bruno Voisin

	And has been solely designed for his trading style.
	Please bear in mind that piece of code is not provided with any express nor implied warranty whatsoever
	The InteractiveBrokers API may also change.  
	This program works with API version v8.5 (some display features not fully tested)
*/

#include "stdafx.h"
//#include "fstream.h"
#include <fstream>
#include "client3.h"
#include "EWrapper.h"    // C:\JTS\SocketClient\include must be added to include path
#include "include\Contract.h"
#include "include\Order.h"
#include "client3Dlg.h"
#include "DOM.h"
#include "DlgLogConfig.h"		// dialog
#include "DlgOrder.h"			// dialog
#include "DlgExtOrd.h"			// dialog
#include "SL_EntryAdjust.h"		// dialog
#include "SL_AttExitAdjust.h"	// dialog
#include "IB_Info.h"			// dialog
#include "DlgConnect.h"			// dialog
#include "DirFileSys.h"			// to write to file
#include "btnst.h"				// colour buttons

//#include "textfile.h"

#include "AcctUpdatesDlg.h"
#include "DlgFinancialAdvisor.h"

#include "math.h"

#define or ||
#define and &&

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//const int nHeightDiff = 139;
const int nHeightDiff = 0;

// control colours
long Blue = RGB(0,0,255);
long Red = RGB(255,0,0);
long Black = RGB(0,0,0);
long White = RGB(255,255,255);
long DarkRed = RGB(128,0,0);
long DarkBlue = RGB(0,0,128);
long Green = RGB(0,255,0);
long DarkGreen = RGB(0,128,0);
long Colour = RGB(210,140,140); // any colour
long DarkerBlue = RGB(0,0,64);
long Grey = RGB(100,100,100);
long LightGrey = RGB(150,150,150);
long DarkGrey = RGB(50,50,50);

const CString strSellShort = "SELL"; // "SSHORT";
const CString strSell = "SELL";
const CString strBuy = "BUY";

const CString RETURN_NEWLINE("\r\n");
const CString NEWLINE("\n");
const CString RETURN("\r");
const CString TAB("\t");
const CString FOUR_SPACES("    ");

/////////////////////////////////////////////////////////////////////////////
// static vars (modal dialogs)
static CDlgOrder		s_dlg;
static CDlgLogConfig    s_dlgLogConfig;


/////////////////////////////////////////////////////////////////////////////
// utility funcs
CString getField( TickType tickType) {
	switch( tickType)
	{
		case BID_SIZE:	                    return "bidSize";
		case BID:		                    return "bidPrice";
		case ASK:		                    return "askPrice";
		case ASK_SIZE:	                    return "askSize";
		case LAST:		                    return "lastPrice";
		case LAST_SIZE:	                    return "lastSize";
		case HIGH:		                    return "high";
		case LOW:		                    return "low";
		case VOLUME:	                    return "volume";
		case CLOSE:		                    return "close";
		case BID_OPTION_COMPUTATION:		return "bidOptComp";
		case ASK_OPTION_COMPUTATION:		return "askOptComp";
		case LAST_OPTION_COMPUTATION:		return "lastOptComp";
		case MODEL_OPTION:					return "optionModel";
        case OPEN:                          return "open";
        case LOW_13_WEEK:                   return "13WeekLow";
        case HIGH_13_WEEK:                  return "13WeekHigh";
        case LOW_26_WEEK:                   return "26WeekLow";
        case HIGH_26_WEEK:                  return "26WeekHigh";
        case LOW_52_WEEK:                   return "52WeekLow";
        case HIGH_52_WEEK:                  return "52WeekHigh";
        case AVG_VOLUME:                    return "AvgVolume";
        case OPEN_INTEREST:                 return "OpenInterest";
        case OPTION_HISTORICAL_VOL:         return "OptionHistoricalVolatility";
        case OPTION_IMPLIED_VOL:            return "OptionImpliedVolatility";
        case OPTION_BID_EXCH:               return "OptionBidExchStr";
        case OPTION_ASK_EXCH:               return "OptionAskExchStr";
        case OPTION_CALL_OPEN_INTEREST:     return "OptionCallOpenInterest";
        case OPTION_PUT_OPEN_INTEREST:      return "OptionPutOpenInterest";
        case OPTION_CALL_VOLUME:            return "OptionCallVolume";
        case OPTION_PUT_VOLUME:             return "OptionPutVolume";
        case INDEX_FUTURE_PREMIUM:          return "IndexFuturePremium";
        case BID_EXCH:                      return "bidExch";
        case ASK_EXCH:                      return "askExch";
        case AUCTION_VOLUME:                return "auctionVolume";
        case AUCTION_PRICE:                 return "auctionPrice";
        case AUCTION_IMBALANCE:             return "auctionImbalance";
        case MARK_PRICE:                    return "markPrice";
        case BID_EFP_COMPUTATION:           return "bidEFP";
        case ASK_EFP_COMPUTATION:           return "askEFP";
        case LAST_EFP_COMPUTATION:          return "lastEFP";
        case OPEN_EFP_COMPUTATION:          return "openEFP";
        case HIGH_EFP_COMPUTATION:          return "highEFP";
        case LOW_EFP_COMPUTATION:           return "lowEFP";
        case CLOSE_EFP_COMPUTATION:         return "closeEFP";
        case LAST_TIMESTAMP:                return "lastTimestamp";
        case SHORTABLE:                     return "shortable";
		default:		                    return "unknown";
	}
}


#define NUM_FA_ERROR_CODES 6
static int faErrorCodes[NUM_FA_ERROR_CODES] =
{ 503, 504, 505, 522, 1100 } ;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	CButtonST OK;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDOK, OK);
}

BOOL CAboutDlg::OnInitDialog()
{
	short crBtnColor = 30;
	CDialog::OnInitDialog();
	OK.SetIcon(IDI_HOME);
	OK.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	OK.SetTooltipText(_T("home sweet home..."));
	// TODO:  Add auto version number here...
	return TRUE;  // return TRUE unless you set the focus to a control
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient3Dlg dialog

CClient3Dlg::CClient3Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClient3Dlg::IDD, pParent)
	, m_nProgStatus(0)
	, m_bTwsChecked1(NULL)		// TWS selected
	, m_bTwsConnected(NULL)		// TWS connected
	, m_bTickerActive(FALSE)	// Ticker start/stop
	, m_bWinOnTop(TRUE)			// Window stays on top
	, m_bUseStop(TRUE)			// Use attached stop exit
	, m_bUseLimit(TRUE)			// Use attached limit exit
	, m_dLatestTrade(0.0)		// Latest trade price
	, m_dDayLow(0.0)				// Low of the day
	, m_dDayHigh(0.0)				// High of the day
	, m_nLatestVol(0)			// Latest volume traded
	, m_dLatestBid(0.0)			// Latest Bid
	, m_dLatestAsk(0.0)			// Latest Ask
	, m_lTickerId(1)			// Only one ticker in this version
	, m_nStopBookSize1(0)
	, m_nLmt1BookSize1(0)
	, m_nLmt2BookSize1(0)
	, m_nLmt3BookSize1(0)
	, m_dAvgFillPrice1(0)
	, m_dAvgFillPrice2(0)
	, m_dAvgFillPrice3(0)
	, m_lLastStopOrderId1_tws1(0)
	, m_lLastStopOrderId2_tws1(0)
	, m_lLastStopOrderId3_tws1(0)
	, m_lLastStopOrderId1_tws2(0)
	, m_lLastStopOrderId2_tws2(0)
	, m_lLastStopOrderId3_tws2(0)
	, m_lLastStopOrderId1_tws3(0)
	, m_lLastStopOrderId2_tws3(0)
	, m_lLastStopOrderId3_tws3(0)
	, m_lLastLimitOrderId1_tws1(0)
	, m_lLastLimitOrderId2_tws1(0)
	, m_lLastLimitOrderId3_tws1(0)
	, m_lLastLimitOrderId1_tws2(0)// fractional exit
	, m_lLastLimitOrderId2_tws2(0)
	, m_lLastLimitOrderId3_tws2(0)
	, m_lLastLimitOrderId1_tws3(0)
	, m_lLastLimitOrderId2_tws3(0)
	, m_lLastLimitOrderId3_tws3(0)
	, m_nNumFilled1(0)
	, m_nNumFilled2(0)
	, m_nNumFilled3(0)
	, m_bLastEntrySig(FALSE)
	, m_bReqIBnews(FALSE)
	, m_dOriginalStopPrice1(0)
	, m_dOriginalStopPrice2(0)
	, m_dOriginalStopPrice3(0)
	, m_dPointsSinceEntry(0)
	, m_lDefaultOrderSize(0)
	, m_nLowVol(0)
	, m_nPeakVol(0)
	, m_dSymbolTickSize(0)
	, m_dMultiplier(0)
	, m_dEntryPrice(0.0)
	, m_dStopPrice(0)
	, m_dLimitTarget(0)
	, m_dLimitTarget2(0)
	, m_dLimitTarget3(0)
	, m_nRange(0)
	, m_nOrdSizeMult(1)
	, m_nFAAcctNo(1)
	, m_bPaperTrade(FALSE)
	, m_bAutoClose(TRUE)
	, m_bAutoReturnToMKT(TRUE)
	, m_nEODhour(0)				// EOD Close
	, m_nEODmin(0)
	, m_nTimeOffset(0)
	, m_bFractExits(FALSE)
	, m_nSessionNo(1)
	, m_bEnableButtonControl(FALSE)
	, m_bVerbose(TRUE)
	, m_bDebug(FALSE)
	, m_strCaption(_T("IB_Direct."))
	, m_nTimerTicker(0)
	, m_nRectHeight(0)
	, m_bMarketOrder(TRUE)	// default order type is MKT
	, m_bBidAskLimitOrder(FALSE)
	, m_bOneTickLimitOrder(FALSE)
	, m_bLimitOrder(FALSE)
	, m_bStopOrder(FALSE)
	, m_bLITOrder(FALSE)
	, m_bMITOrder(FALSE)
{
	//{{AFX_DATA_INIT(CClient3Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pWnd = pParent;

	m_tTimeRef = CTime::GetCurrentTime(); // record a time reference

	//	3 Tws accounts: could maybe be later changed to array of connect struct
	//	but more difficult to handle the TWS ActiveX components...
	//	hence a true multi user version should rather use the socket version
	c1.PortNo = 0;
	c1.ClientID = 0;
	c1.IP_Address = "";
	c1.NumShares = 0;

	for (int i=0;i<3;i++)	//  3 limit levels
	{
		m_nNumShares[i]=0;	//  num shares per limit level
		m_dNumLmtPts[i]=0;	//  num points for each level
	}

	c3 = c2 = c1;		//  3 connect structs

	for (int i=0;i<m_lNumIB;i++) // FA specifics
	{
		FA[i].faGoodAfterTime = "";
		FA[i].faGoodTillDate = "";
		FA[i].faGroup = "";
		FA[i].faPercentage = "";
		FA[i].faProfile = "";
	}

	m_bTickerActive = FALSE;
	cont.symbol = "";

	// temp (blank for futures)
	cont.multiplier = "";
	cont.primaryExchange = "";

	for (int i=0;i<3;i++)
	{
		order[0][i].action = "";
		order[0][i].totalQuantity = 0;

		//  order structs [i][j]
		//  i:
		//  0 = Entry / Exit
		//  1 = Stop1
		//  2 = Stop2
		//  3 = Stop3
		//  4 = Limit1
		//  5 = Limit2
		//  6 = Limit3
		//  j: TWS number - 1

		order[6][i] = order[5][i] =
		order[4][i] = order[3][i] = 
		order[2][i] = order[1][i] = order[0][i];	// copy whole struct content (default values)
	}

	//  pointers to modeless forms (none created at this stage)
	mlDOM = NULL;
	mlInfo = NULL;
	mlSLExits = NULL;
	mlSLEntry = NULL;
	mlMktDepth = NULL;

	m_financialAdvisor1 = false;
	m_financialAdvisor2 = false;
	m_financialAdvisor3 = false;
}

void CClient3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClient3Dlg)
	DDX_Control(pDX, IDC_TWSCTRL1, m_tws1);				// TWS1
	DDX_Control(pDX, IDC_TWSCTRL2, m_tws2);				// TWS2
	DDX_Control(pDX, IDC_TWSCTRL3, m_tws3);				// TWS3
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_QTY, NumContracts);			// Order size
	DDX_Control(pDX, IDOK, m_btnClose);					// Close button
	DDX_Control(pDX, IDC_CONNECT, m_btnConnect);		// Connect button
	DDX_Control(pDX, IDC_DISCONNECT, m_btnDisconnect);	// Disconnect button
	DDX_Control(pDX, IDC_ORDERSETTINGS, m_btnSettings);	// Settings button
	DDX_Control(pDX, IDC_CANORDER, m_btnCancelOrders);	// Cancel order button
	DDX_Control(pDX, IDC_BUTTON3, m_btnLE);				// Long Entry button
	DDX_Control(pDX, IDC_BUTTON4, m_btnLX);
	DDX_Control(pDX, IDC_BUTTON5, m_btnRS);
	DDX_Control(pDX, IDC_BUTTON6, m_btnSE);
	DDX_Control(pDX, IDC_BUTTON7, m_btnSX);
	DDX_Control(pDX, IDC_BUTTON8, m_btnRL);
	DDX_Control(pDX, IDC_COMBO1, m_cbbOrdType);
	DDX_Control(pDX, IDC_OPEN1, ListOpenOrder1);
	DDX_Control(pDX, IDC_OPEN2, ListOpenOrder2);
	DDX_Control(pDX, IDC_BIDASKTICKER, ListBidAsk);
	DDX_Control(pDX, IDC_STATUS, m_btnStatus);
	DDX_Control(pDX, IDC_SL_EXIT, m_btnSLExits);
	DDX_Control(pDX, IDC_LIST4, m_lstEntry);
	DDX_Control(pDX, IDC_SL_ENTRY, m_btnSLEntry);
	DDX_Control(pDX, IDC_FAA, m_lstFAAccounts);
	DDX_Control(pDX, IDC_MKTDEPTH, m_btnMktDepth);
	DDX_Control(pDX, IDC_BUTTON13, m_btnFA);
	DDX_Control(pDX, IDC_BUTTON14, m_btnFAaccts);
	DDX_Control(pDX, IDC_BUTTON15, m_btnAllocation);
	DDX_Control(pDX, IDC_EDIT4, OrdMult);
	DDX_Control(pDX, IDREFRESH, m_btnRefresh);
}

BEGIN_MESSAGE_MAP(CClient3Dlg, CDialog)
	//{{AFX_MSG_MAP(CClient3Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_REQMKTDATA, OnReqmktdata)
	//ON_BN_CLICKED(IDC_CANMKTDATA, OnCanmktdata)
	ON_BN_CLICKED(IDC_CANORDER, OnCanorder)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_BUTTON1, OnSetExtOrdAttribs)
	//ON_BN_CLICKED(IDC_reqOpenOrders, OnreqAllOpenOrders)
	//ON_BN_CLICKED(IDC_ReqExecutions, OnReqExecutions)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ORDERSETTINGS, OnBnClickedOrdersettings)
	ON_BN_CLICKED(IDC_BUTTON3, OnLongEntry)		// long entry
	ON_BN_CLICKED(IDC_BUTTON4, OnLongExit)		// long exit
	ON_BN_CLICKED(IDC_BUTTON5, OnReverseToShort)// reverse to short
	ON_BN_CLICKED(IDC_BUTTON6, OnShortEntry)	// short entry
	ON_BN_CLICKED(IDC_BUTTON7, OnShortExit)		// short exit
	ON_BN_CLICKED(IDC_BUTTON8, OnReverseToLong) // reverse to long
	ON_EN_CHANGE(IDC_QTY, OnEnChangeQty)		// Edit Box to change order size
	ON_BN_CLICKED(IDC_RADIO4, OnStartTicker)	// Ticker ON
	ON_BN_CLICKED(IDC_RADIO5, OnStopTicker)		// Ticker OFF
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_CLOSE()
	ON_WM_DESTROY()

	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
	ON_WM_CREATE()
	ON_NOTIFY(NM_CLICK, IDC_BIDASKTICKER, OnNMClickBidaskticker)
	ON_NOTIFY(NM_CLICK, IDC_OPEN1, OnNMClickOpen1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_OPEN1, OnNMCustomdrawList1)
	ON_WM_TIMER()
	ON_NOTIFY(NM_RCLICK, IDC_BIDASKTICKER, OnNMRclickBidaskticker)
	ON_NOTIFY(NM_HOVER, IDC_BIDASKTICKER, OnNMHoverBidaskticker)
	ON_NOTIFY(NM_RCLICK, IDC_OPEN1, OnNMRclickOpen1)
	ON_WM_LBUTTONDOWN()

	ON_NOTIFY(NM_DBLCLK, IDC_OPEN2, OnNMDblclkOpen2)
	ON_NOTIFY(NM_DBLCLK, IDC_OPEN1, OnNMDblclkOpen1)
	ON_NOTIFY(NM_DBLCLK, IDC_ID, OnNMDblclkId)

	ON_EN_KILLFOCUS(IDC_QTY, OnEnKillfocusQty)
	ON_NOTIFY(NM_RCLICK, IDC_ID, OnNMRclickId)
	ON_NOTIFY(NM_CLICK, IDC_OPEN2, OnNMClickOpen2)
	ON_NOTIFY(NM_DBLCLK, IDC_BIDASKTICKER, OnNMDblclkBidaskticker)
	ON_BN_CLICKED(IDC_SL_ENTRY, OnBnClickedSlEntry)
	ON_BN_CLICKED(IDC_STATUS, OnBnClickedStatus)
	ON_BN_DOUBLECLICKED(IDC_DISCONNECT, OnBnDoubleclickedDisconnect)
	ON_BN_CLICKED(IDC_SL_EXIT, OnBnClickedSlExit)
	ON_BN_CLICKED(IDC_MKTDEPTH, OnBnClickedMktdepth)
	ON_BN_DOUBLECLICKED(IDC_BUTTON3, OnBnDoubleclickedButton3)
	ON_NOTIFY(NM_CLICK, IDC_LIST4, OnNMClickList4)
	ON_BN_CLICKED(IDC_BUTTON13, OnBnClickedButton13)
	ON_BN_CLICKED(IDC_BUTTON14, OnBnClickedButton14)
	ON_BN_CLICKED(IDC_BUTTON15, OnBnClickedButton15)
	ON_BN_CLICKED(IDREFRESH, OnBnClickedRefresh)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_BIDASKTICKER, OnLvnColumnclickBidaskticker)
	ON_NOTIFY(NM_RCLICK, IDC_OPEN2, OnNMRclickOpen2)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_OPEN1, OnLvnColumnclickOpen1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Message handlers

BOOL CClient3Dlg::OnInitDialog()
{
	CWinApp *pApp= AfxGetApp();

	CDialog::OnInitDialog();
	int nL,nT;
	CString strId, strNumIB, strCaption;
	m_strSessionNo.Format(_T("%i"),m_nSessionNo);
	strCaption += "(Session:"+ m_strSessionNo + ") Multiple IB Order Entry System.  Num linked accounts=";
	strNumIB.Format(_T("%i"),m_lNumIB);
	strCaption += strNumIB;

	GetWindowRect(m_dlgRect);  // dlg resize in next version
	ClientToScreen(m_dlgRect);
	m_nRectHeight = m_dlgRect.Height();

	ClearAllRegSettings();  // will clear registry is flag is up

	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);

	BOOL bRegKey = m_Reg.SetKey(m_RegIBDKey, TRUE);
	if (bRegKey)
	{
		m_bWinOnTop = m_Reg.ReadBool("WinOnTop",FALSE);
		if (m_bWinOnTop) WinOnTop();
		m_bSL = m_Reg.ReadBool("UseStopLoss",TRUE);
		m_bLT = m_Reg.ReadBool("UseLimitTarget",TRUE);
		m_bPopupStatus = m_Reg.ReadBool("PopupStatus",FALSE);
		m_bAutoClose = m_Reg.ReadBool("AutoClose",TRUE);
		m_bAutoReturnToMKT = m_Reg.ReadBool("AutoRetMKT",TRUE);
		m_bAdvMktDepth = m_Reg.ReadBool("AdvMktDepth",FALSE);
		nL = m_Reg.ReadInt("WLeft",0);
		nT = m_Reg.ReadInt("WTop",0);
		/////m_Reg.WriteRect("DlgRect",&m_dlgRect);
	}
	
	if (m_nProgStatus == 0)
		strCaption += " (BETA DEMO) ";

	SetWindowText(strCaption);

	// path for log files (temporary)
	m_strLogPath = "C:\\JTS\\IB_DIRECT_Log\\";
	m_strTradeLogPath = "C:\\JTS\\IB_DIRECT_LogTrade\\";

	SetLogFile();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	// Modify system menu (top left menu)
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	pSysMenu->AppendMenu(MF_SEPARATOR);
	if (pSysMenu != NULL)
	{	// system menu
		CString strSettings;
		strSettings.LoadString(IDS_SETTINGS);
		if (!strSettings.IsEmpty())	
			pSysMenu->AppendMenu(MF_STRING, IDS_SETTINGS, strSettings);		
		
		CString strButtons;
		strButtons.LoadString(IDS_RESETBUTTONS);
		if (!strButtons.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_RESETBUTTONS, strButtons);
		pSysMenu->AppendMenu(MF_SEPARATOR);
		
		CString strButtonCtrl;
		strButtonCtrl.LoadString(IDS_BUTTONCTRL);
		if (!strButtonCtrl.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_BUTTONCTRL, strButtonCtrl);
		pSysMenu->AppendMenu(MF_SEPARATOR);

		CString strClearReg;
		strClearReg.LoadString(IDS_RESETID_REG);
		if (!strClearReg.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_RESETID_REG, strClearReg);
		
		CString strClearConnect;
		strClearConnect.LoadString(IDS_CLEARCONNECT);
		if (!strClearConnect.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_CLEARCONNECT, strClearConnect);
		pSysMenu->AppendMenu(MF_SEPARATOR);		

		CString strClearAllRegistrySettings;
		strClearAllRegistrySettings.LoadString(IDS_CLEAR_REG);
		if (!strClearAllRegistrySettings.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_CLEAR_REG, strClearAllRegistrySettings);
		pSysMenu->AppendMenu(MF_SEPARATOR);		

		CString strRetMKT;
		strRetMKT.LoadString(IDS_RETURNMKT);
		if (!strRetMKT.IsEmpty())
			pSysMenu->AppendMenu(MF_STRING, IDS_RETURNMKT, strRetMKT);
		pSysMenu->AppendMenu(MF_SEPARATOR);	

		CString strAdvDOM;
		strAdvDOM.LoadString(IDS_ADVMKTDEPTH);
		if (!strAdvDOM.IsEmpty())
			pSysMenu->AppendMenu(MF_STRING,IDS_ADVMKTDEPTH, strAdvDOM);
		pSysMenu->AppendMenu(MF_SEPARATOR);

		CString strConnect;
		strConnect.LoadString(IDS_CONNECT);
		if (!strConnect.IsEmpty())	
			pSysMenu->AppendMenu(MF_STRING, IDS_CONNECT, strConnect);
		
		CString strDisconnect;
		strDisconnect.LoadString(IDS_DISCONNECT);
		if (!strDisconnect.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_DISCONNECT, strDisconnect);
		pSysMenu->AppendMenu(MF_SEPARATOR);
		
		CString strReqNewsBulletins;
		strReqNewsBulletins.LoadString(IDS_IB_NEWS);
		if (!strReqNewsBulletins.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_IB_NEWS, strReqNewsBulletins);

		CString strLogLevel;
		strLogLevel.LoadString(IDS_LOGLEVEL);
		if (!strLogLevel.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_LOGLEVEL, strLogLevel);

		pSysMenu->AppendMenu(MF_SEPARATOR);
		CString strStayOnTop;
		strStayOnTop.LoadString(IDS_STAYONTOP);
		if (!strStayOnTop.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDS_STAYONTOP, strStayOnTop);
		
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) 
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	UINT ret;
	if (m_bAutoReturnToMKT)
		ret = pSysMenu->CheckMenuItem(IDS_RETURNMKT,MF_CHECKED);
	else
		ret = pSysMenu->CheckMenuItem(IDS_RETURNMKT,MF_UNCHECKED);

	if (!m_bAdvMktDepth)
		ret = pSysMenu->CheckMenuItem(IDS_ADVMKTDEPTH,MF_CHECKED);
	else
		ret = pSysMenu->CheckMenuItem(IDS_ADVMKTDEPTH,MF_UNCHECKED);

	if (m_bWinOnTop == TRUE)
	{
		ret = pSysMenu->CheckMenuItem(IDS_STAYONTOP, MF_CHECKED | MF_BYCOMMAND );
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}
	else
	{
		ret = pSysMenu->CheckMenuItem(IDS_STAYONTOP,MF_UNCHECKED | MF_BYCOMMAND );
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndNoTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}

	pApp->m_pMainWnd->MoveWindow(		//  the main window can have 2 heights (min footprint)
		nL,
		nT,
		m_dlgRect.Width(),
		m_nRectHeight - nHeightDiff,	//	vs. m_dlgRect.Height()
		TRUE);
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_bTwsChecked1 = new BOOL[m_lNumIB];	// keep track on list1 (selected row(s))
	m_bTwsConnected = new BOOL[m_lNumIB];	// keep track on connections

	for (int i=0;i<m_lNumIB;i++)
	{	// init arrays: none selected at start-up
		m_bTwsConnected[i] = FALSE;
		m_bTwsChecked1[i] = FALSE;
	}

	OnInitButtons(TRUE);	// cosmetics
	SetupListCtrls();		// setup (width, colours etc)
	OnCbnSelchangeCombo1();	// some default order settings
	SetAdvMktDepthFlag();

	OrdMult.SetWindowText("1");		// init the order multiplier to 1
	// edit box above will change OrdType, so reset it to MKT
	m_cbbOrdType.SetCurSel(0);

	mlInfo = NULL;		// no modeless form at first
	mlDOM = NULL;
	mlSLEntry = NULL;
	mlSLExits = NULL;	
	mlMktDepth = NULL;
	
	AddToLog(pApp->m_pszAppName);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

//  exec sys menu commands
void CClient3Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{	// system menu (top left)
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
		return;
	}

	if (nID == IDS_SETTINGS)
	{
		OnBnClickedOrdersettings();
		return;
	}

	if (nID == IDS_BUTTONCTRL)
	{
		AfxMessageBox("feature to be activated soon...");
		return;
	}

	if (nID == IDS_RETURNMKT)
	{
		AutoReturntoMKT();
		int ret = m_Reg.WriteBool("AutoRetMKT",TRUE);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
		return;
	}

	if (nID == IDS_ADVMKTDEPTH)
	{
		SetAdvMktDepthFlag();
		return;
	}

	if (nID == IDS_CLEAR_REG)
	{
		if (m_bTwsConnected[0] == TRUE) return; // still connected
		m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\DefaultSettings";
		BOOL bRegKey = m_Reg.SetKey(m_RegIBDKey, TRUE);
		if (bRegKey)	
		{
			BOOL bClearAll = m_Reg.ReadBool("ClearAll",TRUE);
			if (bClearAll)
				AfxMessageBox("Clear Flag now set. Registry will be cleared on restart");
			return;
		}
	}

	if (nID == IDS_CLEARCONNECT)
	{
		if (m_bTwsConnected[0] == TRUE) return; // still connected
		AddStatusLine("Connect Info has been cleared",statInfo);
		c1.PortNo = 0;
		c1.ClientID = 0;
		c1.IP_Address = "";
		c1.NumShares = 0;
		c3 = c2 = c1;
		return;
	}

	if (nID == IDS_RESETID_REG)
	{
		for (int i=1;i<=3;i++) ResetOrderIds(i);
		return;
	}

	if (nID == IDS_CONNECT)
	{
		OnConnect();
		return;
	}

	if (nID == IDS_RESETBUTTONS)
	{
		ResetButtons();
		return;
	}

	if (nID == IDS_DISCONNECT)
	{
		OnDisconnect();
		return;
	}

	if (nID == IDS_STAYONTOP)
	{
		WinOnTop();
		int ret = m_Reg.WriteBool("WinOnTop",m_bWinOnTop);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
		return;
	}

	if (nID == IDS_IB_NEWS)
	{
		Req_IB_News();
		return;
	}

	if (nID == IDS_LOGLEVEL)
	{
		SetLogLevel();
		return;
	}

	CDialog::OnSysCommand(nID, lParam);
}


//  system menu commands
void CClient3Dlg::ResetButtons(void)
{	// Reset all buttons if necessary
	m_btnLE.EnableWindow(TRUE);
	m_btnLX.EnableWindow(TRUE);
	m_btnRS.EnableWindow(TRUE);
	m_btnSE.EnableWindow(TRUE);
	m_btnSX.EnableWindow(TRUE);
	m_btnRL.EnableWindow(TRUE);
}

// Clear all registry settings by deleting main keys and regenerating them
void CClient3Dlg::ClearAllRegSettings(void)
{
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	BOOL bRegKey = m_Reg.SetKey(m_RegIBDKey, TRUE);
	if (bRegKey)	
	{
		BOOL bClearAll = m_Reg.ReadBool("ClearAll",FALSE);
		if (bClearAll)
		{
			m_Reg.DeleteKey(m_RegIBDKey);
			m_Reg.SetKey(m_RegIBDKey,TRUE);
			m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\Connect";
			m_Reg.DeleteKey(m_RegIBDKey);
			m_Reg.SetKey(m_RegIBDKey,TRUE);
			m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
			m_Reg.DeleteKey(m_RegIBDKey);
			m_Reg.SetKey(m_RegIBDKey,TRUE);
			int ret = m_Reg.WriteBool("ClearAll",FALSE);
			AfxMessageBox("Registry settings have been deleted. Please restart application");
			OnOK();
		}
	}
}

// To return order type to MKT after a LMT or STP entry
void CClient3Dlg::AutoReturntoMKT(void)
{
	CString m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	CMenu* pSysMenu = GetSystemMenu(FALSE); // copy system menu for modifs.
	if (m_bAutoReturnToMKT)
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_RETURNMKT,MF_UNCHECKED);
		m_bAutoReturnToMKT = FALSE;
	}
	else
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_RETURNMKT,MF_CHECKED);
		m_bAutoReturnToMKT = TRUE;
	}
	if (m_Reg.SetKey(m_RegIBDKey, TRUE)) 
	{
		int ret = m_Reg.WriteBool("AutoRetMKT", m_bAutoReturnToMKT);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}

// To choose between normal and advanced mkt depth
void CClient3Dlg::SetAdvMktDepthFlag(void)
{
	CString m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	CMenu* pSysMenu = GetSystemMenu(FALSE); // copy system menu for modifs.
	if (m_bAdvMktDepth)
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_ADVMKTDEPTH,MF_UNCHECKED);
		m_bAdvMktDepth = FALSE;
		m_btnMktDepth.SetWindowText("MktDepth");
	}
	else
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_ADVMKTDEPTH,MF_CHECKED);
		m_bAdvMktDepth = TRUE;
		m_btnMktDepth.SetWindowText("AdvMktDepth");
	}
	if (m_Reg.SetKey(m_RegIBDKey, TRUE)) 
	{
		int ret = m_Reg.WriteBool("AdvMktDepth",!m_bAdvMktDepth);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}

void CClient3Dlg::WinOnTop(void)	// Window on top
{
	CString m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	CMenu* pSysMenu = GetSystemMenu(FALSE); // copy system menu for modifs.
	CWinApp *pApp= AfxGetApp();
	if (m_bWinOnTop == TRUE)
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_STAYONTOP, MF_UNCHECKED | MF_BYCOMMAND );
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndNoTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}
	else
	{
		UINT ret = pSysMenu->CheckMenuItem(IDS_STAYONTOP,MF_CHECKED | MF_BYCOMMAND );
		pApp->m_pMainWnd->SetWindowPos(&CWnd::wndTopMost, 0, 0, 0, 0,SWP_NOMOVE|SWP_NOSIZE);
	}
	m_bWinOnTop = !m_bWinOnTop;	// toggle
	if (m_Reg.SetKey(m_RegIBDKey, TRUE)) 
	{
		int ret = m_Reg.WriteBool("WinOnTop",m_bWinOnTop);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}

void CClient3Dlg::Req_IB_News(void)
{	// Request news bulletins from IB
	CMenu* pSysMenu = GetSystemMenu(FALSE); // copy system menu for modifs.
	CWinApp *pApp= AfxGetApp();
	if (!m_bReqIBnews)
	{
		pSysMenu->CheckMenuItem(IDS_IB_NEWS,MF_CHECKED);
		m_tws1.reqNewsBulletins(FALSE); // only forthcoming news, no backlog
	}
	else
	{
		pSysMenu->CheckMenuItem(IDS_IB_NEWS,MF_UNCHECKED);
		m_tws1.cancelNewsBulletins();
	}
	m_bReqIBnews = !m_bReqIBnews;
}

//  end - system menu commands

void CClient3Dlg::SetLogLevel(void)
{
	if (s_dlgLogConfig.DoModal() != IDOK) return;
	// set the TWS log level for API requests/responses
    m_tws1.setServerLogLevel( s_dlgLogConfig.serverLogLevel() );
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClient3Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
		CDialog::OnPaint();
}

void CClient3Dlg::OnDestroy()
{	// some cleaning up to do
	if (m_bTwsChecked1 != NULL)
	{
		delete [] m_bTwsChecked1;
		m_bTwsChecked1 = NULL;
	}

	if (m_bTwsConnected != NULL)
	{
		delete [] m_bTwsConnected;
		m_bTwsConnected = NULL;
	}

	if (mlInfo) mlInfo->DestroyWindow();	// should reset pointer, but prog is closing anyway
	if (mlSLEntry) mlSLEntry->DestroyWindow();
	if (mlSLExits) mlSLExits->DestroyWindow();	
	if (mlDOM)	mlDOM->DestroyWindow();
	if (mlMktDepth) mlMktDepth->DestroyWindow();

	GetWindowRect(m_dlgRect);

	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\DefaultSettings";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);

	if (m_Reg.SetKey(m_RegIBDKey, FALSE))
	{	// could use a WriteRect
		m_Reg.WriteInt("WLeft",m_dlgRect.left);
		m_Reg.WriteInt("WTop",m_dlgRect.top);
		//m_Reg.WriteInt("WWidth",m_dlgRect.Width());
		//m_Reg.WriteInt("WHeight",m_dlgRect.Height());
	}
	if ( m_nTimerTicker > 0 ) KillTimer(m_nTimerTicker);
	CDialog::OnDestroy();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClient3Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////
//	EVENT SINK
/////////////////////////////////////////////////////////////////////////////////////////////////////////

BEGIN_EVENTSINK_MAP(CClient3Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CClient3Dlg)
	// ActiveX interface may change in future versions of the API
	// several events are not coded here.  See API sample code for a more comprehensive list
	
	// Tws1 event sink.		compatible with API 8.71 Nov 22nd 05


	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 1 /* tickPrice */, OntickPriceTwsctrl1, VTS_I4 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 2 /* tickSize */, OntickSizeTwsctrl1, VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 3 /* connectionClosed */, OnconnectionClosedTwsctrl1, VTS_NONE)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 4 /* openOrder1 */, OnopenOrder1Twsctrl1, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 5 /* openOrder2 */, OnopenOrder2Twsctrl1, VTS_I4 VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 6 /* updateAccountTime */, OnupdateAccountTimeTwsctrl1, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 7 /* updateAccountValue */, OnupdateAccountValueTwsctrl1, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 8 /* nextValidId */, OnnextValidIdTwsctrl1, VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 10 /* permId */, OnpermIdTwsctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 11 /* errMsg */, OnerrMsgTwsctrl1, VTS_I4 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 12 /* updatePortfolio */, OnupdatePortfolioTwsctrl1, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 13 /* orderStatus */, OnorderStatusTwsctrl1, VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 14 /* contractDetails */, OncontractDetailsTwsctrl1, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 15 /* execDetails */, OnexecDetailsTwsctrl1, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 16 /* updateMktDepth */, OnupdateMktDepthTwsctrl1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 17 /* updateMktDepthL2 */, OnupdateMktDepthL2Twsctrl1, VTS_I4 VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 18 /* updateNewsBulletin */, OnupdateNewsBulletinTwsctrl1, VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 19 /* managedAccounts */, OnmanagedAccountsTwsctrl1, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 20 /* openOrder3 */, OnopenOrder3Twsctrl1, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 21 /* receiveFA */, receiveFATwsctrl1, VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 22 /* historicalData */, OnhistoricalDataTwsctrl1, VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 23 /* openOrder4 */, OnopenOrder4Twsctrl1, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 24 /* bondContractDetails */, OnbondContractDetailsTwsctrl1, VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_R8  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4  VTS_R8  VTS_BSTR  VTS_BSTR )
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 25 /* scannerParameters */, OnScannerParametersTwsctrl1, VTS_BSTR )
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 26 /* scannerdata */, OnScannerDataTwsctrl1, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR )
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 27 /* tickOptionComputation */, OntickOptionComputationTwsctrl1, VTS_I4 VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 28 /* tickGeneric */, OntickGenericTwsctrl1, VTS_I4 VTS_I4 VTS_R8)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 29 /* tickString */, OntickStringTwsctrl1, VTS_I4 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 30 /* tickEFP */, OntickEFPTwsctrl1, VTS_I4 VTS_I4 VTS_R8 VTS_BSTR VTS_R8 VTS_I4 VTS_BSTR VTS_R8 VTS_R8)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 31 /* realtimeBar */, OnrealtimeBarTwsctrl1, VTS_I4 VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 32 /* currentTime */, OncurrentTimeTwsctrl1, VTS_I4)

	// Tws2 event sink

//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 1 /* tickPrice */, OntickPriceTwsctrl2, VTS_I4 VTS_I4 VTS_R8)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 2 /* tickSize */, OntickSizeTwsctrl2, VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 3 /* connectionClosed */, OnconnectionClosedTwsctrl2, VTS_NONE)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 4 /* openOrder1 */, OnopenOrder1Twsctrl2, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 5 /* openOrder2 */, OnopenOrder2Twsctrl2, VTS_I4 VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 6 /* updateAccountTime */, OnupdateAccountTimeTwsctrl2, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 7 /* updateAccountValue */, OnupdateAccountValueTwsctrl2, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 8 /* nextValidId */, OnnextValidIdTwsctrl2, VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 10 /* permId */, OnpermIdTwsctrl2, VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 11 /* errMsg */, OnerrMsgTwsctrl2, VTS_I4 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 12 /* updatePortfolio */, OnupdatePortfolioTwsctrl2, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 13 /* orderStatus */, OnorderStatusTwsctrl2, VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 14 /* contractDetails */, OncontractDetailsTwsctrl2, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 15 /* execDetails */, OnexecDetailsTwsctrl2, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_I4 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 16 /* updateMktDepth */, OnupdateMktDepthTwsctrl2, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 17 /* updateMktDepthL2 */, OnupdateMktDepthL2Twsctrl2, VTS_I4 VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 18 /* updateNewsBulletin */, OnupdateNewsBulletinTwsctrl2, VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL2, 19 /* managedAccounts */, OnmanagedAccountsTwsctrl2, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 20 /* openOrder3 */, OnopenOrder3Twsctrl2, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 21 /* receiveFA */, receiveFATwsctrl2, VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 22 /* historicalData */, OnhistoricalDataTwsctrl1, VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 23 /* openOrder4 */, OnopenOrder4Twsctrl2, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 24 /* bondContractDetails */, OnbondContractDetailsTwsctrl2, VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_R8  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4  VTS_R8  VTS_BSTR  VTS_BSTR )

	// Tws3 event sink

//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 1 /* tickPrice */, OntickPriceTwsctrl3, VTS_I4 VTS_I4 VTS_R8)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 2 /* tickSize */, OntickSizeTwsctrl3, VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 3 /* connectionClosed */, OnconnectionClosedTwsctrl3, VTS_NONE)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 4 /* openOrder1 */, OnopenOrder1Twsctrl3, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 5 /* openOrder2 */, OnopenOrder2Twsctrl3, VTS_I4 VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 6 /* updateAccountTime */, OnupdateAccountTimeTwsctrl3, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 7 /* updateAccountValue */, OnupdateAccountValueTwsctrl3, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 8 /* nextValidId */, OnnextValidIdTwsctrl3, VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 10 /* permId */, OnpermIdTwsctrl3, VTS_I4 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 11 /* errMsg */, OnerrMsgTwsctrl3, VTS_I4 VTS_I4 VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 12 /* updatePortfolio */, OnupdatePortfolioTwsctrl3, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 13 /* orderStatus */, OnorderStatusTwsctrl3, VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 14 /* contractDetails */, OncontractDetailsTwsctrl3, VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 15 /* execDetails */, OnexecDetailsTwsctrl3, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_R8 VTS_I4 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 16 /* updateMktDepth */, OnupdateMktDepthTwsctrl3, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 17 /* updateMktDepthL2 */, OnupdateMktDepthL2Twsctrl3, VTS_I4 VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 18 /* updateNewsBulletin */, OnupdateNewsBulletinTwsctrl3, VTS_I2 VTS_I2 VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 19 /* managedAccounts */, OnmanagedAccountsTwsctrl3, VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 20 /* openOrder3 */, OnopenOrder3Twsctrl3, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL3, 21 /* receiveFA */, receiveFATwsctrl3, VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 22 /* historicalData */, OnhistoricalDataTwsctrl1, VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_R8 VTS_I4)
	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 23 /* openOrder4 */, OnopenOrder4Twsctrl3, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_R8 VTS_R8 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_R8 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
//	ON_EVENT(CClient3Dlg, IDC_TWSCTRL1, 24 /* bondContractDetails */, OnbondContractDetailsTwsctrl3, VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_R8  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4  VTS_R8  VTS_BSTR  VTS_BSTR )

	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//  Ticker
//
//  This function traps prices from the IB ticker, and displays them accordingly
void CClient3Dlg::UpdateTickerPrice(TickType field, double dPrice)
{	// Function called after tickPrice is fired (OntickPriceTwsctrl1)
	// Note that market data subscription is linked to Tws1
	static double dLastBid = 0.0;
	static double dLast = 0.0;
	static double dLastAsk = 0.0;
	static BOOL	  bTickerStarted = FALSE;
	CString strValue, str;
	
	if (dPrice <=0) return;
	strValue.Format(_T("%.3f"),dPrice);

	CurrentTime = CTime::GetCurrentTime();
	str = CurrentTime.Format("%H:%M:%S");
	ListBidAsk.SetItemText(1,1,str,White,DarkRed); // display ticker time

	switch( field )
	{	//  Field codes follow the API (cf sample code)
		case BID:		{
						m_dLatestBid = dPrice;	// store it
						if (( m_dLatestBid != dLastBid) && (mlDOM != NULL)) // for AdvMktDepth
						{	// display new prices in DOM
							for (int i=0;i<10;i++)
							{
								CString strP;
								// ArrMD col2 contains prices (bid and under)
								mlDOM->m_dArrMD[11+i][2] = m_dLatestBid - i * m_dSymbolTickSize;
								mlDOM->m_dArrMD[11+i][0] = 0;
								strP.Format(_T("%.3f"),mlDOM->m_dArrMD[11+i][2]);
								mlDOM->m_lstDOM.SetItemText(11+i,4, strP, Blue, White); //price
								mlDOM->m_lstDOM.SetItemText(11+i,2, "", Blue, White); //price
							}
						}
						str.Format("%.3f",dPrice - m_dSymbolTickSize); 
						ListBidAsk.SetItemText(0,1,str,DarkBlue,White);
						if (dPrice > dLastBid)
							ListBidAsk.SetItemText(0,2,strValue, Blue, White);
						else if (dPrice < dLastBid)
							ListBidAsk.SetItemText(0,2,strValue, Red, White);
						else ListBidAsk.SetItemText(0,2,strValue, Black, White);
						dLastBid = dPrice;
						/*if (m_nPosition1 != 0 || m_nPosition2 != 0 || m_nPosition3 !=0)
							if (m_dEntryPrice != 0 && m_nPosition1 > 0)
							{
								m_dPointsSinceEntry = m_dLatestBid - m_dEntryPrice;
							}
						*/
						break;
						}
		case ASK:		{
						m_dLatestAsk = dPrice;	// store it
						if (( m_dLatestAsk != dLastAsk) && (mlDOM != NULL))
						{
							for (int i=0;i<10;i++)
							{
								CString strP;
								// ArrMD col[2] contains prices (ask and above)
								mlDOM->m_dArrMD[9-i][2] = m_dLatestAsk + i * m_dSymbolTickSize;
								mlDOM->m_dArrMD[9-i][0] = 0;
								strP.Format(_T("%.3f"),mlDOM->m_dArrMD[9-i][2]);
								mlDOM->m_lstDOM.SetItemText(9-i,4, strP, Red, White);
								mlDOM->m_lstDOM.SetItemText(9-i,6, "", Red, White);
							}
						}
						str.Format(_T("%.3f"),dPrice + m_dSymbolTickSize);
						ListBidAsk.SetItemText(0,5,str,DarkBlue,White);
						if (dPrice > dLastAsk)
							ListBidAsk.SetItemText(0,4,strValue, Blue, White);
						else if (dPrice < dLastAsk)
							ListBidAsk.SetItemText(0,4,strValue, Red, White);
						else ListBidAsk.SetItemText(0,4,strValue, Black, White);
						dLastAsk = dPrice;
						/*if (m_nPosition1 != 0 || m_nPosition2 != 0 || m_nPosition3 !=0)
							if (m_dEntryPrice != 0 && m_nPosition1 < 0)
							{
								m_dPointsSinceEntry = m_dLatestAsk - m_dEntryPrice;
							}
						*/
						break;
						}
		case LAST:		{	// PRICE OF LAST TRADE 
						m_dLatestTrade = dPrice;	// store it
						
						//	price is used to update arrays : recording tick activity and last time stamp
						// 
						if (mlDOM != NULL)
						{
							CString strP;	// display current price
							strP.Format(_T("%.3f"),m_dLatestTrade);
							mlDOM->m_dArrMD[10][2] = m_dLatestTrade;
							if (dPrice > dLast)
								mlDOM->m_lstDOM.SetItemText(10,4,strP,Blue,LightGrey);
							else if (dPrice < dLast)
									mlDOM->m_lstDOM.SetItemText(10,4,strP,Red,LightGrey);
							else
									mlDOM->m_lstDOM.SetItemText(10,4,strP,Black,LightGrey);
						}

						if (dPrice > dLast)
							ListBidAsk.SetItemText(0,3,strValue, Blue, White);
						else if (dPrice < dLast)
							ListBidAsk.SetItemText(0,3,strValue, Red, White);
						else ListBidAsk.SetItemText(0,3,strValue, Black, White);
						dLast = dPrice;
						break;
						}
		case HIGH:		{
						m_dDayHigh = dPrice;
						break;
						}
		case LOW:		{
						m_dDayLow = dPrice;		
						break;
						}
		case CLOSE:		{
						CString strTemp;
						double dRange = fabs(dPrice-m_dLatestTrade);
						strTemp.Format(_T("Last EOD Close: %.3f, Current range from Last EOD Close: %.3f"), 
										dPrice, dRange);
						AddStatusLine(strTemp,statInfo);
						if (cont.secType == "FUT")	
						{
							if (dRange < m_dLatestTrade / 100)
									m_nRange = 10;  // temporary
							else	m_nRange = 20;  // temporary
						}
						else
						{
							if (dRange < m_dLatestTrade / 100)
									m_nRange = 30;
							else	m_nRange = 60;
						}
						break;
						}
		default:		{
						AddStatusLine("Unknown ticker message", statInfo);			//  hmmm... 
						}
	}
}

//	This routine displays ticker volumes 
void CClient3Dlg::UpdateTickerVolume(TickType field, long Vol)
{
	static int nCurrMin = 0;
	static long lVol = 0;
	CString strValue, strTimeU;
	CurrentTime = CTime::GetCurrentTime();
	strTimeU = CurrentTime.Format("%H:%M:%S");
	int nHour = CurrentTime.GetHour() - m_nTimeOffset;	  // must be changed
	int nMin = CurrentTime.GetMinute();
	if (nMin != nCurrMin)
	{	// time change (every minute)
		//ReqIBPosition();	// update position information
		if ((lVol < m_nLowVol) && (m_bVerbose==TRUE))	
			AddStatusLine(strTimeU + ": Low Volume in the last minute...",statInfo);
		if ((lVol > m_nPeakVol) && (m_bVerbose==TRUE))  
			AddStatusLine(strTimeU + ": High Volume in the last minute...",statInfo);

		if (m_bAutoClose)			// AutoClose EOD
		{
			if (nHour >= m_nEODhour)
				if (nMin >= m_nEODmin)
				{
					if (m_nPosition1 > 0 || m_nPosition2 > 0 || m_nPosition3 >0)
					{
						OnLongExit();  // exit long button
						AddStatusLine("Closing long position(s) now...",statInfo);
					}
					if (m_nPosition1 < 0 || m_nPosition2 < 0 || m_nPosition3 <0)
					{
						OnShortExit();  // exit short button
						AddStatusLine("Closing short position(s) now...",statInfo);
					}
				}
				else
					if (nMin = m_nEODmin -1)
						AddStatusLine("Auto-closing any open positions in 1 minute...", statInfo);
		}
		nCurrMin = nMin;
		lVol = 0;
		ListBidAsk.SetItemText(1,5,"0", White, DarkRed);
	} // end minute change
	strValue.Format(_T("%i"),Vol);
	switch (field)
	{
		case BID_SIZE:	{// display time of last volume update
						ListBidAsk.SetItemText(1,2,strValue); 
						ListBidAsk.SetItemText(1,1,strTimeU,White,DarkRed);	
						break;
						}
		case ASK_SIZE:	{
						ListBidAsk.SetItemText(1,1,strTimeU,White,DarkRed);
						ListBidAsk.SetItemText(1,4,strValue); 
						break;
						}
		case LAST_SIZE:	{	
						ListBidAsk.SetItemText(1,1,strTimeU,White,Red);
						if ((mlDOM != NULL)  && (m_dLatestTrade > 0))
						{	
							CTime t;
							CTimeSpan tdiff;
							int n = 0;
							// count volume at important stop/limit levels (used in OrderStatus)
							if (m_dLatestTrade == order[1][0].auxPrice) m_nStopVolCount1 += Vol;
							if (m_dLatestTrade == order[4][0].lmtPrice) m_nLmt1VolCount1 += Vol;
							if (m_dLatestTrade == order[5][0].lmtPrice) m_nLmt2VolCount1 += Vol;
							if (m_dLatestTrade == order[6][0].lmtPrice) m_nLmt3VolCount1 += Vol;

							if (mlDOM->m_dPriceScale[0] > 0)
							{	// wait for CLOSE event in ticker otherwise it does not make any sense
								t = CTime::GetCurrentTime();
								tdiff = t - m_tTimeRef;
								for (int i = 0; i<81; i++)
								{
									if (m_dLatestTrade == mlDOM->m_dPriceScale[i]) 
									{
										CString strTest;
										long lTSecs = (long)tdiff.GetTotalSeconds();
										mlDOM->m_nVolCount[i][0] += Vol;// add vol to count
										mlDOM->m_nTickCount[i][0]++;	// add 1 tick to count
										mlDOM->m_nVolCount[i][1] = lTSecs;
										mlDOM->m_nTickCount[i][1] = lTSecs;
										if (m_bDebug == TRUE)
										{
											strTest.Format(_T("Price:%.3f Vol:%i TotVol:%i Tick:%i Time:%i"),
												mlDOM->m_dPriceScale[i], Vol,
												mlDOM->m_nVolCount[i][0],
												mlDOM->m_nTickCount[i][0],
												mlDOM->m_nVolCount[i][1]);
											AddToLog(strTest);
										}
										n = i;
										break;
									}
								}
								if (n == 0) 
								{
									//Beep(500,1000);
									mlDOM->m_lstDOM.SetItemText(10,2,"ERROR",Red,Black);
									mlDOM->m_lstDOM.SetItemText(10,6,"ERROR",Red,Black);
								}
							}
							
							if (m_dLatestTrade == m_dEntryPrice) //mlDOM->m_dRecordTradePrice)
							{
								double dLeft;
								if (m_dLatestTrade == m_dLatestBid)	
								{
									if (mlDOM->m_nRecordBidSize > 0)
									{
										mlDOM->m_nBidCountLeft -= Vol;
										if (mlDOM->m_nBidCountLeft < 0)
										{
											CString str;
											mlDOM->m_nAskCountLeft = mlDOM->m_nRecordAskSize = 0;
											mlDOM->m_nBidCountLeft = mlDOM->m_nRecordBidSize = 0;
											dLeft = 0;
											str.Format(_T("Bid book exhausted for price level:%.3f"),
												m_dEntryPrice);//mlDOM->m_dRecordTradePrice);
											AddStatusLine(str, statInfo);
										}
										else
											dLeft = (double)(mlDOM->m_nRecordBidSize - mlDOM->m_nBidCountLeft)/
														(double)mlDOM->m_nRecordBidSize;
										mlDOM->m_lstDOM.UpdateProgress(10,1, 100*(int)dLeft );
									}
								}
								else
									mlDOM->m_lstDOM.UpdateProgress(10,1,0);

								if (m_dLatestTrade == m_dLatestAsk)
								{
									if (mlDOM->m_nRecordAskSize > 0)
									{
										mlDOM->m_nAskCountLeft -= Vol;
										if (mlDOM->m_nAskCountLeft < 0)
										{
											CString str;
											mlDOM->m_nAskCountLeft = mlDOM->m_nRecordAskSize = 0;
											mlDOM->m_nBidCountLeft = mlDOM->m_nRecordBidSize = 0;
											dLeft = 0;
											str.Format(_T("Ask book exhausted for price level:%.3f"),
												m_dEntryPrice);//mlDOM->m_dRecordTradePrice);
											AddStatusLine(str, statInfo);
										}
										else
											dLeft = (double)(mlDOM->m_nRecordAskSize - mlDOM->m_nAskCountLeft)/
														(double)mlDOM->m_nRecordAskSize;
										mlDOM->m_lstDOM.UpdateProgress(10,7, 100*(int)dLeft );
									}
								}
								else
										mlDOM->m_lstDOM.UpdateProgress(10,7,0);
							}
							// update DOM display
							if (m_dLatestTrade == m_dLatestAsk)
							{
								mlDOM->m_lstDOM.SetItemText(9,1,strValue,White,Colour);
								mlDOM->m_lstDOM.SetItemText(10,2,"",White,LightGrey);
								mlDOM->m_lstDOM.SetItemText(10,6,strValue,White,LightGrey);
							}
							else if (m_dLatestTrade == m_dLatestBid)
								{
									mlDOM->m_lstDOM.SetItemText(11,1,strValue,White,Colour);
									mlDOM->m_lstDOM.SetItemText(10,6,"",White,LightGrey);
									mlDOM->m_lstDOM.SetItemText(10,2,strValue,White,LightGrey);
								}
							else
								{
									mlDOM->m_lstDOM.SetItemText(10,2,"ERROR",White,LightGrey);
									mlDOM->m_lstDOM.SetItemText(10,6,"ERROR",White,LightGrey);
								}
						}
						ListBidAsk.SetItemText(1,3,strValue); 
						lVol += Vol;// displays current volume traded in the last minute
						strValue.Format(_T("%i"),lVol);
						ListBidAsk.SetItemText(1,5,strValue, White, DarkRed);
						break;
						}
		case VOLUME:	break;
		default:		;
	}
}

// End Ticker

//
//  FA stuff (basic stuff: not fully implemented... couldn't test anything on demo account!)
//
void CClient3Dlg::receiveFATwsctrl1(long pFaDataType, LPCTSTR cxml)
{
	switch (pFaDataType) {
		case 1: //GROUPS:
          faGroupsXML = cxml ;
          break ;
		case 2: //PROFILES:
          faProfilesXML = cxml ;
          break ;
		case 3: //ALIASES:
          faAliasesXML = cxml ;
          break ;
    }

	CString faStr("TWS1 FA: ");
	faStr += faDataTypeStr ( (faDataType)pFaDataType );
	faStr += "=";
	faStr += cxml;
	AddStatusLine(faStr,statInfo);

	if (!faError && faGroupsXML != "" && faProfilesXML != "" && faAliasesXML != "") 
	{
		CDlgFinancialAdvisor dlg;
		dlg.receiveInitialXML(faGroupsXML, faProfilesXML, faAliasesXML);

		if (dlg.DoModal() != IDOK) return;

		dlg.extractXML(faGroupsXML, faProfilesXML, faAliasesXML);
		m_tws1.replaceFA( 1 /*GROUPS*/, faGroupsXML );
		m_tws1.replaceFA( 2 /*PROFILES*/, faProfilesXML );
		m_tws1.replaceFA( 3 /*ALIASES*/, faAliasesXML );
	}
}

void CClient3Dlg::receiveFATwsctrl2(long pFaDataType, LPCTSTR cxml)
{
	switch (pFaDataType) {
		case 1: //GROUPS:
          faGroupsXML = cxml ;
          break ;
		case 2: //PROFILES:
          faProfilesXML = cxml ;
          break ;
		case 3: //ALIASES:
          faAliasesXML = cxml ;
          break ;
    }

	CString faStr("TWS2 FA: ");
	faStr += faDataTypeStr ( (faDataType)pFaDataType );
	faStr += "=";
	faStr += cxml;
	AddStatusLine(faStr,statInfo);

	if (!faError && faGroupsXML != "" && faProfilesXML != "" && faAliasesXML != "") 
	{
		CDlgFinancialAdvisor dlg;
		dlg.receiveInitialXML(faGroupsXML, faProfilesXML, faAliasesXML);

		if (dlg.DoModal() != IDOK) return;

		dlg.extractXML(faGroupsXML, faProfilesXML, faAliasesXML);
		m_tws2.replaceFA( 1 /*GROUPS*/, faGroupsXML );
		m_tws2.replaceFA( 2 /*PROFILES*/, faProfilesXML );
		m_tws2.replaceFA( 3 /*ALIASES*/, faAliasesXML );
	}
}

void CClient3Dlg::receiveFATwsctrl3(long pFaDataType, LPCTSTR cxml)
{
	switch (pFaDataType) 
	{
		case 1: //GROUPS:
          faGroupsXML = cxml ;
          break ;
		case 2: //PROFILES:
          faProfilesXML = cxml ;
          break ;
		case 3: //ALIASES:
          faAliasesXML = cxml ;
          break ;
    }

	CString faStr("TWS3 FA: ");
	faStr += faDataTypeStr ( (faDataType)pFaDataType );
	faStr += "=";
	faStr += cxml;
	AddStatusLine(faStr,statInfo);

	if (!faError && faGroupsXML != "" && faProfilesXML != "" && faAliasesXML != "") 
	{
		CDlgFinancialAdvisor dlg;
		dlg.receiveInitialXML(faGroupsXML, faProfilesXML, faAliasesXML);

		if (dlg.DoModal() != IDOK) return;

		dlg.extractXML(faGroupsXML, faProfilesXML, faAliasesXML);
		m_tws3.replaceFA( 1 /*GROUPS*/, faGroupsXML );
		m_tws3.replaceFA( 2 /*PROFILES*/, faProfilesXML );
		m_tws3.replaceFA( 3 /*ALIASES*/, faAliasesXML );
	}
}

void CClient3Dlg::OnFinancialAdvisor1()
{
      faGroupsXML = faProfilesXML = faAliasesXML = "" ;
      faError = false ;
      m_tws1.requestFA(1 /*GROUPS*/) ;
      m_tws1.requestFA(2 /*PROFILES*/) ;
      m_tws1.requestFA(3 /*ALIASES*/) ;
}

void CClient3Dlg::OnFinancialAdvisor2()
{
      faGroupsXML = faProfilesXML = faAliasesXML = "" ;
      faError = false ;
      m_tws2.requestFA(1) ;
      m_tws2.requestFA(2) ;
      m_tws2.requestFA(3) ;
}

void CClient3Dlg::OnFinancialAdvisor3()
{
      faGroupsXML = faProfilesXML = faAliasesXML = "" ;
      faError = false ;
      m_tws3.requestFA(1) ;
      m_tws3.requestFA(2) ;
      m_tws3.requestFA(3) ;
}

void CClient3Dlg::OnmanagedAccountsTwsctrl1(LPCTSTR accountsList) 
{
    m_financialAdvisor1 = true;  // This event is only triggered for FA customers.
    m_managedAccounts1 = accountsList;

	AddStatusLine("TWS1 Connected : The list of managed accounts are :", statInfo);
	AddStatusLine(accountsList, statInfo);
}

void CClient3Dlg::OnmanagedAccountsTwsctrl2(LPCTSTR accountsList) 
{
    m_financialAdvisor2 = true;  // This event is only triggered for FA customers.
    m_managedAccounts2 = accountsList;

	AddStatusLine("TWS2 Connected : The list of managed accounts are :", statInfo);
	AddStatusLine(accountsList, statInfo);
}

void CClient3Dlg::OnmanagedAccountsTwsctrl3(LPCTSTR accountsList) 
{
    m_financialAdvisor3 = true;  // This event is only triggered for FA customers.
    m_managedAccounts3 = accountsList;

	AddStatusLine("TWS3 Connected : The list of managed accounts are :", statInfo);
	AddStatusLine(accountsList, statInfo);
}
//  end FA Stuff

void CClient3Dlg::OntickEFPTwsctrl1(long tickerId, long tickType, double basisPoints, LPCTSTR formattedBasisPoints,
						  double totalDividends, long holdDays, LPCTSTR futureExpiry, double dividendImpact,
						  double dividendsToExpiry) 
{}

void CClient3Dlg::OnrealtimeBarTwsctrl1(long tickerId, long time, double open,
										double high, double low, double close,
										long volume, double WAP, long count)
{}

void CClient3Dlg::OncurrentTimeTwsctrl1(long millis)
{}



////////////////////////////////////////////////////////////////
// Button clicks (some call the API directly)
// Other API calls are further down

// A connect/disconnect toggle button has not been used on purpose to allow TWS to be connected disconnected almost independently
// Other design options are possible

// Double clicking the Disconnect button now clears the connect structs

/*
void CClient3Dlg::InitConnectThread(void)
{
	m_ConnectThread = AfxBeginThread(StartConnectThread, this);	// start new thread
}

UINT CClient3Dlg::StartConnectThread(LPVOID p)
{	// Set a pointer to function to be called in thread
	CClient3Dlg *me = (CClient3Dlg*)p;
	me->Connect();
	return 0;
}
*/

//  Connect to IB TWS for each account
//  Any response will be sent through an error message and/or ValidID
void CClient3Dlg::OnConnect() 
{	// IMPORTANT: TWS must be running, and API calls must be enabled
	CString status = "Connection attempt to IB TWS through port(s): ";
	CString strPort, str;
	//Beep(1000,100);	
	OnBnClickedStatus();

	// Note that it is possible to have selected more IB accounts than running TWS
	// The available TWSs will connect independently on the other(s)
	if (m_bTwsConnected[0] != TRUE)
	{	
		AddStatusLine("Note: The IB TWS console(s) must be running,",statInfo);
		AddStatusLine("Port(s) must be set, and ActiveX client(s) enabled",statInfo);
		if (c1.PortNo == 0) DefineConnectParam(1); // Dialog : details of 1st TWS
		if (c1.PortNo == 0) return; // 1st TWS
		strPort.Format(_T("%d"),c1.PortNo);
		str.Format(_T("Check TWS1 console now. Port: %d"),c1.PortNo);
		AddStatusLine(str ,statWarn);
		m_tws1.connect( c1.IP_Address, c1.PortNo , c1.ClientID ); // now connect to TWS
		if (c1.NumShares > 0)
		{
			str.Format(_T("%n shares/contracts"),c1.NumShares);
			AddStatusLine("TWS1: " + str, statInfo);
			AddStatusLine("TWS1: order default size will be overruled", statWarn);
		}
		else
			AddStatusLine("TWS1: default order size will be used" , statInfo);
	}

	if (m_lNumIB>1)
		if (m_bTwsConnected[1] != TRUE)
		{	// Tws2
			if (c2.PortNo == 0) DefineConnectParam(2);
			if (c2.PortNo > 0)
			{
				strPort.Format(_T("%d"),c2.PortNo);
				AddStatusLine("Check TWS2 console now. Port:" + strPort,statWarn);
				m_tws2.connect( c2.IP_Address, c2.PortNo , c2.ClientID );
				if (c2.NumShares > 0)
				{
					str.Format(_T("%i shares/contracts"),c2.NumShares);
					AddStatusLine("TWS2: " + str, statInfo);
					AddStatusLine("TWS2: order default size will be overruled", statWarn);
				}
				else
					AddStatusLine("TWS2: default order size will be used" , statInfo);
			}
			else m_lNumIB = 1;
		}
	if (m_lNumIB>2)
		if (m_bTwsConnected[2] != TRUE)
		{	// Tws3
			if (c3.PortNo == 0) DefineConnectParam(3);
			if (c3.PortNo > 0)
			{
				strPort.Format(_T("%d"),c3.PortNo);
				AddStatusLine("Check TWS3 console now. Port:" + strPort,statWarn);
				m_tws3.connect( c3.IP_Address, c3.PortNo , c3.ClientID );
				if (c3.NumShares > 0)
				{
					str.Format(_T("%d shares/contracts"),c3.NumShares);
					AddStatusLine("TWS3: " + str, statInfo);
					AddStatusLine("TWS3: order default size will be overruled", statWarn);
				}
				else
					AddStatusLine("TWS3: default order size will be used" , statInfo);
			}
			else m_lNumIB = 2;
		}

	if (m_lNumIB ==1) strPort.Format(_T("%d"),c1.PortNo);
	else
		if (m_lNumIB ==2)	strPort.Format(_T("%d & %d"),c1.PortNo, c2.PortNo);
		else				strPort.Format(_T("%d, %d & %d"),c1.PortNo,c2.PortNo,c3.PortNo);
	status += strPort;
	AddStatusLine(status,statInfo);
}
//  end connect


////////////////////////////////////////////////////
//	Modeless forms
////////////////////////////////////////////////////
// Status or Info returned from IB displayed in modeless form
void CClient3Dlg::OnBnClickedStatus()
{
	if (mlInfo)
	{
		mlInfo->ShowWindow(SW_SHOW);
		mlInfo->UpdateData(FALSE);
		mlInfo->SetForegroundWindow();
	}
	else
	{
		mlInfo = new IB_Info(this); // this dialog is Parent
		mlInfo->Create(IB_Info::IDD,GetDesktopWindow());
		mlInfo->ShowWindow(SW_SHOW);
		//////////////////////////
		AddStatusLine("ERRORS: 505/506 ARE TRAPPED IN THIS VERSION PENDING BUG FIX IN THE API...", statWarn);
		AddStatusLine("PLEASE ALWAYS TRY PLACING AN ORDER ON A PAPER TRADING ACCOUNT AFTER UPGRADING IB TWS OR API", statWarn);
		//////////////////////////
	}	
}

// Open Dialog to adjust Stp/Lmt entry prices
// it can of course only apply to pending orders (not MKT orders)
void CClient3Dlg::OnBnClickedSlEntry()
{
	if (!m_bTickerActive) 
	{
		AddStatusLine("Can't set prices (No active ticker)",statInfo);
		return;
	}
	if (mlSLEntry)
	{
		mlSLEntry->ShowWindow(SW_SHOW);
		mlSLEntry->UpdateData(FALSE);
		mlSLEntry->SetForegroundWindow();
	}
	else
	{
		mlSLEntry = new SL_EntryAdjust(this); // this dialog is Parent
		mlSLEntry->m_nRange = m_nRange;
		mlSLEntry->m_dRefPrice = m_dLatestTrade;
		mlSLEntry->m_dTickSize = m_dSymbolTickSize;
		mlSLEntry->Create(SL_EntryAdjust::IDD,GetDesktopWindow());
		mlSLEntry->ShowWindow(SW_SHOW);
	}	
}

// Open dialog to adjust exit prices
void CClient3Dlg::OnBnClickedSlExit()
{
	if (!m_bPaperTrade || (!m_bUseStop && !m_bUseLimit))
		if (m_nPosition1 == 0 && m_nPosition2 == 0 && m_nPosition3 == 0)
		{
			AddStatusLine("No current position in the market...", statInfo);
			return;
		}
	if (mlSLExits) // already there, so just display it
	{
		mlSLExits->m_dRefPrice = m_dLatestTrade;

		mlSLExits->ShowWindow(SW_SHOW);
		mlSLExits->UpdateData(FALSE);
		mlSLExits->SetForegroundWindow();
	}
	else
	{
		mlSLExits = new SL_AttExitAdjust(this); // this dialog is Parent

		if (m_nPosition1 > 0 || m_nPosition2 > 0 || m_nPosition3 > 0)
			mlSLExits->m_nPosition = 1;
		else if (m_nPosition1 < 0 || m_nPosition2 < 0 || m_nPosition3 < 0)
				mlSLExits->m_nPosition = -1;
		else mlSLExits->m_nPosition = 0;


		if (order[1][0].auxPrice > 0) 
			mlSLExits->m_dNumStpPts = fabs(m_dLatestTrade - order[1][0].auxPrice);
		else
			mlSLExits->m_dNumStpPts = m_dNumStpPts;
		if (order[4][0].lmtPrice > 0) 
			mlSLExits->m_dNumLmtPts = fabs(m_dLatestTrade - order[4][0].lmtPrice);
		else
			mlSLExits->m_dNumLmtPts = m_dNumLmtPts[0];
		if (order[5][0].lmtPrice > 0) 
			mlSLExits->m_dNumLmtPts2 = fabs(m_dLatestTrade - order[5][0].lmtPrice);
		else
			if (m_nNumShares[1] > 0) 
				mlSLExits->m_dNumLmtPts2 = m_dNumLmtPts[1];
		if (order[6][0].lmtPrice > 0) 
			mlSLExits->m_dNumLmtPts3 = fabs(m_dLatestTrade - order[6][0].lmtPrice);
		else
			if (m_nNumShares[2] > 0) 
				mlSLExits->m_dNumLmtPts3 = m_dNumLmtPts[2];

		mlSLExits->m_nRange = m_nRange;
		if (m_dLatestTrade > 0)
			mlSLExits->m_dRefPrice = m_dLatestTrade;
		else
			mlSLExits->m_dRefPrice = m_dEntryPrice;
		
		mlSLExits->m_dTickSize = m_dSymbolTickSize;
		mlSLExits->Create(SL_AttExitAdjust::IDD,GetDesktopWindow());
		mlSLExits->ShowWindow(SW_SHOW);
	}
}

//  Open modeless mktdepth form
void CClient3Dlg::OnBnClickedMktdepth()
{
	if (m_bAdvMktDepth) // advanced marktet depth with DOM
	{
		if (mlDOM)
		{
			mlDOM->ShowWindow(SW_SHOW);
			mlDOM->UpdateData(FALSE);
			mlDOM->SetForegroundWindow();
		}
		else
		{
			if ((m_dLatestTrade == 0) ||
				(m_dLatestAsk == 0) ||
				(m_dLatestBid == 0) ||
				(m_dSymbolTickSize == 0))
			{
				AddStatusLine("Ticker not ready for DOM",statWarn);
				return;
			}
			mlDOM = new CDoM(this); // this dialog is Parent
			mlDOM->m_strSessionNo = m_strSessionNo;
			mlDOM->m_tickerId = m_lTickerId;
			mlDOM->m_tTimeRef = m_tTimeRef;		// copy time reference for lapsed time calc in DOM
			mlDOM->Create(CDoM::IDD,GetDesktopWindow());
			mlDOM->ShowWindow(SW_HIDE);
		}
	}
	else		// regular market depth form
	{
		if (mlMktDepth)
		{
			mlMktDepth->ShowWindow(SW_SHOW);
			mlMktDepth->UpdateData(FALSE);
			mlMktDepth->SetForegroundWindow();
		}
		else
		{
			mlMktDepth = new CDlgMktDepth(this); // this dialog is Parent
			mlMktDepth->m_tickerId = m_lTickerId;
			mlMktDepth->Create(CDlgMktDepth::IDD,GetDesktopWindow());
			mlMktDepth->ShowWindow(SW_SHOW);
		}
	}
}

//  end modeless forms

///////////////////////////////////////////////////////////////////////////////////
// process IB messages

//  connection has been closed
void CClient3Dlg::OnconnectionClosedTwsctrl1() 
{
	m_bTwsConnected[0] = FALSE;
	CString strTime;
	CurrentTime = CTime::GetCurrentTime();
	strTime = CurrentTime.Format("%H:%M:%S : ");
	AddStatusLine(strTime+ "Connection to TWS1 has been closed!",statWarn);
	AddToLog("Connection to TWS1 has been closed!");
}

void CClient3Dlg::OnconnectionClosedTwsctrl2() 
{
	m_bTwsConnected[1] = FALSE;
	CString strTime;
	CurrentTime = CTime::GetCurrentTime();
	strTime = CurrentTime.Format("%H:%M:%S : ");
	AddStatusLine(strTime+ "Connection to TWS2 has been closed!",statWarn);
	AddToLog("Connection to TWS2 has been closed!");
}

void CClient3Dlg::OnconnectionClosedTwsctrl3() 
{
	m_bTwsConnected[2] = FALSE;
	CString strTime;
	CurrentTime = CTime::GetCurrentTime();
	strTime = CurrentTime.Format("%H:%M:%S : ");
	AddStatusLine(strTime+"Connection to TWS3 has been closed!",statWarn);
	AddToLog("Connection to TWS3 has been closed!");
}
// end connection closed


// update mktdepth (1st TWS only)
// info is sent either to mlDOM or mlMktDepth

void CClient3Dlg::OnupdateMktDepthTwsctrl1(long id, long position, long operation, 
        long side, double price, long size) 
{
	if (mlMktDepth)	// marketmaker string left empty (may change in the future)
		mlMktDepth->updateMktDepth(id, position, "", operation, side, price, size);	

	if (mlDOM)	// marketmaker string left empty (may change in the future)
		mlDOM->updateMktDepth(id, position, "", operation, side, price, size);	
}

void CClient3Dlg::OnupdateMktDepthL2Twsctrl1(long id, long position, 
        LPCTSTR marketMaker, long operation, long side, double price, long size) 
{	// this event may not always return info (depends on market traded)
	return;
    if (mlMktDepth)
		mlMktDepth->updateMktDepth(id, position, marketMaker, operation, side, price, size);	

	if (mlDOM)
		mlDOM->updateMktDepth(id, position, marketMaker, operation, side, price, size);	
}


//  process UI (buttons)

// settings (modal form)
void CClient3Dlg::OnBnClickedOrdersettings()
{	// These items are rarely changed (usually called once only per session)

	CString strBlank = "";
	CString sym = cont.symbol;
	CString exp = cont.expiry;
	s_dlg.m_strSessionNo = m_strSessionNo;
	s_dlg.m_strLogPath = m_strLogPath;
	s_dlg.m_strLog = m_strLog;
	if( s_dlg.DoModal() != IDOK ) return;	// display static dlg
	if (s_dlg.contract.symbol != sym || s_dlg.contract.expiry != exp)
		OnStopTicker();// new symbol, so cancel ticker display
	
	cont = s_dlg.contract;
	for (int i=0;i<3;i++)  // num IB
	{	// copy struct from Settings dialog
		order[0][i] = s_dlg.order;	// info fed back to main order (order[0])
		order[0][i].action = "";
	}

	m_lTickerId = s_dlg.m_lTickerId; // only 1 ticker 
	m_lDefaultOrderSize = s_dlg.order.totalQuantity;

	m_bUseStop = s_dlg.m_bUseAutoStop;		// auto stop order 
	m_bUseLimit = s_dlg.m_bUseAutoLimit;	// auto limit order
	m_bTrail = s_dlg.m_bTrail;				// auto trail
	m_bPopupStatus = s_dlg.m_bPopupStatus;	// popup status info
	m_bPaperTrade = s_dlg.m_bPaperTrade;	// Paper Trading mode
	m_bFractExits = s_dlg.m_bFractExits;	// use fractional exits (up to 3 limit target orders)

	if (m_bPaperTrade) AddStatusLine("IB_Direct: Paper Trading", statInfo);
	if (m_bFractExits) AddStatusLine("Fractional exit orders will be generated. Please check settings.",statInfo);

	m_nLowVol = s_dlg.m_nLowVol;
	m_nPeakVol = s_dlg.m_nPeakVol;

	m_bAutoClose = s_dlg.m_bAutoClose;
	m_nEODhour = s_dlg.m_nEODhour;
	m_nEODmin = s_dlg.m_nEODmin;
	m_nTimeOffset = s_dlg.m_nTimeOffset;

	CString str;
	str.Format(_T("%.2i:%.2i"), m_nEODhour, m_nEODmin);

	if (m_bUseStop)
		AddStatusLine("Exit Stop Order(s) will be attached to entry", statInfo);
	else
		AddStatusLine("NO exit Stop Order to be attached to entry", statWarn);

	if (m_bUseLimit)
		AddStatusLine("Limit target Order(s) will be attached to entry", statInfo);
	else
		AddStatusLine("No Limit target Order to be attached to entry", statWarn);

	if (m_bAutoClose)
		AddStatusLine("Any open position will be closed at " + str, statInfo);
	else
		AddStatusLine("Any open positions WILL Not be closed at EOD " + str, statWarn);

	if (m_bTrail)
		AddStatusLine("Trailing stop activated. Please check order attribute is valid for: "
			+ cont.exchange + "/" + cont.symbol, statWarn);
	else
		AddStatusLine("Regular stop order will be used", statInfo);

	order[0][0].orderType == "MKT";		// reset order type to MKT (default)
	m_cbbOrdType.SetCurSel(0);

	CString strQty;
	strQty.Format(_T("%i"),m_lDefaultOrderSize);
	NumContracts.SetWindowText(strQty);

	if (m_bTwsConnected[0] == TRUE)
	{
		// send same general order parameter settings to all TWS (see online help for details)
		// stored in 'order' structure
		// in most cases default parameters are OK
		m_tws1.SetBlockOrder(FALSE);					// not implemented
		m_tws1.SetShortSaleSlot(0);						// not implemented (institutionals only)
		m_tws1.SetDesignatedLocation(strBlank);			//  
		m_tws1.SetRule80A(strBlank);					//
		m_tws1.SetSettlingFirm(strBlank);				//

		m_tws1.SetAllOrNone(FALSE);						//
		m_tws1.SetMinQty(0);							//

		m_tws1.SetPercentOffset(0);						//
		m_tws1.SetNbboPriceCap(0);						//

		m_tws1.SetTif( order[0][0].tif);
		m_tws1.SetOca( order[0][0].ocaGroup);
		m_tws1.SetOcaType( order[0][0].OCAtype);
		m_tws1.SetAccount( order[0][0].account);		// not used at this stage for trading
		m_tws1.SetOpenClose( order[0][0].openClose);	// not used
		m_tws1.SetOrigin( order[0][0].origin);			// not used
		m_tws1.SetOrderRef( order[0][0].orderRef);		// not used
		m_tws1.SetTransmit( order[0][0].transmit);	
		m_tws1.SetParentId( order[0][0].parentId);	
		m_tws1.SetBlockOrder( order[0][0].blockOrder);
		m_tws1.SetSweepToFill( order[0][0].sweepToFill);
		m_tws1.SetDisplaySize( order[0][0].displaySize);
		m_tws1.SetTriggerMethod( order[0][0].triggerMethod);
		m_tws1.SetIgnoreRth( order[0][0].ignoreRth);
		m_tws1.SetHidden( order[0][0].hidden);
		m_tws1.SetDiscretionaryAmt(order[0][0].discretionaryAmt);

		m_tws1.SetRthOnly(order[0][0].RTHonly);

		if (!order[0][0].transmit) 
			AddStatusLine("Caution: IB orders stopped at TWS1 console for confirmation",statWarn);
		else
			AddStatusLine("TWS1: IB orders will be sent through",statWarn);
		m_tws1.reqContractDetails(
			cont.symbol,cont.secType,
			cont.expiry,cont.strike,
			cont.right,cont.multiplier,
			cont.exchange,cont.currency, FALSE);
	}
	if ((m_lNumIB >1) && (m_bTwsConnected[1] == TRUE))
	{
		m_tws2.SetBlockOrder(FALSE);					// not implemented
		m_tws2.SetShortSaleSlot(0);						// not implemented (institutionals only)
		m_tws2.SetDesignatedLocation(strBlank);			//  
		m_tws2.SetRule80A(strBlank);					//
		m_tws2.SetSettlingFirm(strBlank);				//

		m_tws2.SetAllOrNone(FALSE);						//
		m_tws2.SetMinQty(0);							//

		m_tws2.SetPercentOffset(0);						//
		m_tws2.SetNbboPriceCap(0);						//

		m_tws2.SetBlockOrder(FALSE);
		m_tws2.SetTif( order[0][1].tif);
		m_tws2.SetOca( order[0][1].ocaGroup);
		m_tws2.SetOcaType( order[0][1].OCAtype);
		m_tws2.SetAccount( order[0][1].account);
		m_tws2.SetOpenClose( order[0][1].openClose);
		m_tws2.SetOrigin( order[0][1].origin);
		m_tws2.SetOrderRef( order[0][1].orderRef);
		m_tws2.SetTransmit( order[0][1].transmit);
		m_tws2.SetParentId( order[0][1].parentId);
		m_tws2.SetBlockOrder( order[0][1].blockOrder);
		m_tws2.SetSweepToFill( order[0][1].sweepToFill);
		m_tws2.SetDisplaySize( order[0][1].displaySize);
		m_tws2.SetTriggerMethod( order[0][1].triggerMethod);
		m_tws2.SetIgnoreRth( order[0][1].ignoreRth);
		m_tws2.SetHidden( order[0][1].hidden);
		m_tws2.SetDiscretionaryAmt(order[0][1].discretionaryAmt);

		m_tws2.SetRthOnly(order[0][1].RTHonly);

		if (!order[0][1].transmit) 
			AddStatusLine("Caution: IB orders stopped at TWS2 console for confirmation",statWarn);
		else
			AddStatusLine("TWS2: IB orders will be sent through",statWarn);
	}

	if ((m_lNumIB >2) && (m_bTwsConnected[2]== TRUE))
	{
		m_tws3.SetBlockOrder(FALSE);					// not implemented
		m_tws3.SetShortSaleSlot(0);						// not implemented (institutionals only)
		m_tws3.SetDesignatedLocation(strBlank);			//  
		m_tws3.SetRule80A(strBlank);					//
		m_tws3.SetSettlingFirm(strBlank);				//

		m_tws3.SetAllOrNone(FALSE);						//
		m_tws3.SetMinQty(0);							//

		m_tws3.SetPercentOffset(0);						//
		m_tws3.SetNbboPriceCap(0);						//

		m_tws3.SetBlockOrder(FALSE);
		m_tws3.SetTif( order[0][2].tif);
		m_tws3.SetOca( order[0][2].ocaGroup);
		m_tws1.SetOcaType( order[0][2].OCAtype);
		m_tws3.SetAccount( order[0][2].account);
		m_tws3.SetOpenClose( order[0][2].openClose);
		m_tws3.SetOrigin( order[0][2].origin);
		m_tws3.SetOrderRef( order[0][2].orderRef);
		m_tws3.SetTransmit( order[0][2].transmit);
		m_tws3.SetParentId( order[0][2].parentId);
		m_tws3.SetBlockOrder( order[0][2].blockOrder);
		m_tws3.SetSweepToFill( order[0][2].sweepToFill);
		m_tws3.SetDisplaySize( order[0][2].displaySize);
		m_tws3.SetTriggerMethod( order[0][2].triggerMethod);
		m_tws3.SetIgnoreRth( order[0][2].ignoreRth);
		m_tws3.SetHidden( order[0][2].hidden);
		m_tws3.SetDiscretionaryAmt(order[0][2].discretionaryAmt);

		m_tws3.SetRthOnly(order[0][2].RTHonly);

		if (!order[0][2].transmit) 
			AddStatusLine("Caution: IB orders stopped at TWS3 console for confirmation",statWarn);
		else
			AddStatusLine("TWS3: IB orders will be sent through",statWarn);
	}

//	OnBnClickedMktdepth();		// start mkt depth now without showing dialog

} // end OrderSettings


// modify extended order attributes (not used!)
void CClient3Dlg::OnSetExtOrdAttribs() 
{	// default values should be ok in most cases
	static CDlgExtOrd s_dlg;
	if( s_dlg.DoModal() != IDOK) return;

	if (m_bTwsConnected[0] == TRUE)
	{
		m_tws1.SetTif( s_dlg.m_tif ); // Valid values are: DAY, GTC, IOC
		m_tws1.SetOca( s_dlg.m_oca ); // Identifies an OCA (one cancels all) group.
		m_tws1.SetAccount( s_dlg.m_account );			// institutions only
		m_tws1.SetOpenClose( s_dlg.m_openClose );		// institutions only
		m_tws1.SetOrigin( s_dlg.m_origin );				// institutions only
		m_tws1.SetOrderRef( s_dlg.m_orderRef );			// institutions only
		m_tws1.SetTransmit( s_dlg.m_transmit );	
		m_tws1.SetParentId( s_dlg.m_parentId );//order ID of the parent order, used for bracket and auto trailing stop orders.
		m_tws1.SetBlockOrder( s_dlg.m_blockOrder );//If true, specifies that the order is an ISE Block order.
		m_tws1.SetSweepToFill( s_dlg.m_sweepToFill );
		m_tws1.SetDisplaySize( s_dlg.m_displaySize );//The publicly disclosed order size, used when placing Iceberg orders.
	
//Specifies how Simulated Stop, Stop-Limit and Trailing Stop orders are triggered. Valid values are:
//	O - the default value. The "double bid/ask" method will be used for orders for OTC stocks and US options. All other orders will used the "last" method.
//	1 - use "double bid/ask" method, where stop orders are triggered based on two consecutive bid or ask prices.
//	2 - "last" method, where stop orders are triggered based on the last price.
//	3 - "double-last" method, where stop orders are triggered based on last two prices. 

		m_tws1.SetTriggerMethod( s_dlg.m_triggerMethod );
		m_tws1.SetIgnoreRth( s_dlg.m_ignoreRth ); // If true, allows triggering of orders outside of m_Regular trading hours.
		m_tws1.SetHidden( s_dlg.m_hidden );
		m_tws1.SetDiscretionaryAmt( s_dlg.m_discretionaryAmt  );
	}

	if ((m_lNumIB>1) && (m_bTwsConnected[1] == TRUE))
	{
		m_tws2.SetTif( s_dlg.m_tif );
		m_tws2.SetOca( s_dlg.m_oca );
		m_tws2.SetAccount( s_dlg.m_account );
		m_tws2.SetOpenClose( s_dlg.m_openClose );
		m_tws2.SetOrigin( s_dlg.m_origin );
		m_tws2.SetOrderRef( s_dlg.m_orderRef );
		m_tws2.SetTransmit( s_dlg.m_transmit );
		m_tws2.SetParentId( s_dlg.m_parentId );
		m_tws2.SetBlockOrder( s_dlg.m_blockOrder );
		m_tws2.SetSweepToFill( s_dlg.m_sweepToFill );
		m_tws2.SetDisplaySize( s_dlg.m_displaySize );
		m_tws2.SetTriggerMethod( s_dlg.m_triggerMethod );
		m_tws2.SetIgnoreRth( s_dlg.m_ignoreRth );
		m_tws2.SetHidden( s_dlg.m_hidden );
		m_tws2.SetDiscretionaryAmt(s_dlg.m_discretionaryAmt );
	}
	if ((m_lNumIB>2) && (m_bTwsConnected[2] == TRUE))
	{
		m_tws3.SetTif( s_dlg.m_tif );
		m_tws3.SetOca( s_dlg.m_oca );
		m_tws3.SetAccount( s_dlg.m_account );
		m_tws3.SetOpenClose( s_dlg.m_openClose );
		m_tws3.SetOrigin( s_dlg.m_origin );
		m_tws3.SetOrderRef( s_dlg.m_orderRef );
		m_tws3.SetTransmit( s_dlg.m_transmit );
		m_tws3.SetParentId( s_dlg.m_parentId );
		m_tws3.SetBlockOrder( s_dlg.m_blockOrder );
		m_tws3.SetSweepToFill( s_dlg.m_sweepToFill );
		m_tws3.SetDisplaySize( s_dlg.m_displaySize );
		m_tws3.SetTriggerMethod( s_dlg.m_triggerMethod );
		m_tws3.SetIgnoreRth( s_dlg.m_ignoreRth );
		m_tws3.SetHidden( s_dlg.m_hidden );
		m_tws3.SetDiscretionaryAmt(s_dlg.m_discretionaryAmt );
	}
}

void CClient3Dlg::OnStartTicker() // request ticker
{
	if (m_bTwsConnected[0] != TRUE) return;
	if (m_lTickerId == 0) OnBnClickedOrdersettings();	// no ticker defined
	if (!m_bTickerActive && m_lTickerId>0) 
	{
		OnReqmktdata();		// request ticker
		m_bTickerActive = TRUE;
	}
}

void CClient3Dlg::OnStopTicker() // cancel ticker
{	// only 1 ticker Id used
	if ((m_bTickerActive == TRUE) && (m_lTickerId>0))
	{
		m_tws1.cancelMktData(m_lTickerId);
		for (int i = 0;i<ListBidAsk.GetHeaderCtrl()->GetItemCount();i++)
		{
			ListBidAsk.SetItemText(0,i,"");
			ListBidAsk.SetItemText(1,i,"");
		}
		m_bTickerActive = FALSE;
		AddStatusLine("Ticker stopped", statInfo);
	}
}

void CClient3Dlg::OnBnClickedClearexec() // clear executions
{	// Clear both list controls
	for (int i=0;i<m_lNumIB;i++)
	{
		int j;
		for (j=1;j<ListOpenOrder1.GetHeaderCtrl()->GetItemCount();j++)
			ListOpenOrder1.SetItemText(i,j,"");
		for (j=1;j<ListOpenOrder2.GetHeaderCtrl()->GetItemCount();j++)
			ListOpenOrder2.SetItemText(i,j,"");
	}
}

// Modify entry/exit primary order (stp/lmt price and/or qty)   
// Order type cannot be changed (not allowed at time of coding)

//  The following code updates order[0] i.e. the main order entry/exit only
//
//  Reference to the last OrderId is made through  m_lLastOrderId1 (Id2 and Id3)
//  saved in PlaceOrder()
void CClient3Dlg::OnBnClickedModorder()	// only applies to primary order
{
	OnCbnSelchangeCombo1(); // check order type

	if (m_bMarketOrder)
	{	
		AddStatusLine("Caution: OrderType must be STP/TRAIL or LMT, LIT or MIT",statWarn);  // obvious!
		return;
	}
	else
		if (m_nPosition1 !=0 || m_nPosition2 !=0 || m_nPosition3 !=0)
		{				
			AddStatusLine("Not applicable while already in position...", statWarn);
			return;
		}

	if (order[0][0].action == "")	// should not happen
	{	
		m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
		m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
		if (m_Reg.SetKey(m_RegIBDKey, FALSE))	
		{	// read from m_Registry (important if IB_Direct has shut down with pending orders)
			m_lLastOrderId_tws1 = m_Reg.ReadDword("LastOrderIdTWS1",0);
			m_lLastOrderId_tws2 = m_Reg.ReadDword("LastOrderIdTWS2",0);
			m_lLastOrderId_tws3 = m_Reg.ReadDword("LastOrderIdTWS3",0);
			order[0][0].action = m_Reg.ReadString("LastAction","");
		}
	}

	GetAccounts();	// check accounts activation status
	if ((m_bTwsConnected[0] == TRUE) && 
		(m_bTwsChecked1[0] == TRUE))
	{	// tws1
		if (order[0][0].orderType == "LMT")
		{
			order[0][0].lmtPrice = atof(m_strLmtPrice);
			order[0][0].auxPrice = 0.0f;
			if (m_lLastOrderId_tws1 > 0)
				AddToLog("Tws1: New limit price: " + m_strLmtPrice);
			else
				AddToLog("Tws1: Limit price set: " + m_strLmtPrice);
		}
		if (order[0][0].orderType == "STP" || order[0][0].orderType == "TRAIL")
		{
			order[0][0].lmtPrice = 0.0f;
			order[0][0].auxPrice = atof(m_strStpPrice);
			if (m_lLastOrderId_tws1 > 0)
				AddToLog("Tws1: New stop price: " + m_strStpPrice);
			else
				AddToLog("Tws1: Stop price set: " + m_strStpPrice);
		}
		if (order[0][0].orderType == "STPLMT")
		{
			order[0][0].lmtPrice = atof(m_strLmtPrice);
			order[0][0].auxPrice = atof(m_strStpPrice);
			if (m_lLastOrderId_tws1 > 0)
				AddToLog("Tws1: New stop price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			else
				AddToLog("Tws1: Stop price set: " + m_strStpPrice + ". Limit price set: " + m_strLmtPrice);
		}
		if (order[0][0].orderType == "LIT")
		{
			order[0][0].lmtPrice = atof(m_strLmtPrice);
			order[0][0].auxPrice = atof(m_strStpPrice);
			if (m_lLastOrderId_tws1 > 0)
				AddToLog("Tws1: New LIT price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			else
				AddToLog("Tws1: LIT price set: " + m_strStpPrice + ". Limit price set: " + m_strLmtPrice);
		}
		if (order[0][0].orderType == "MIT")
		{
			order[0][0].lmtPrice = 0.0f;
			order[0][0].auxPrice = atof(m_strStpPrice);
			if (m_lLastOrderId_tws1 > 0)
				AddToLog("Tws1: New MIT price: " + m_strLmtPrice);
			else
				AddToLog("Tws1: MIT price set: " + m_strLmtPrice);
		}

		//  only the last order can be modified with new info
		if (!m_bPaperTrade)
		{
			if (m_lLastOrderId_tws1 > 0)
				m_tws1.placeOrder(
					m_lLastOrderId_tws1,	// last order id
					order[0][0].action,
					order[0][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[0][0].orderType,
					order[0][0].lmtPrice,
					order[0][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate
					);
		}
	}

	if (m_lNumIB>1) // tws2
	{
		if ((m_bTwsConnected[1] == TRUE) && 
				(m_bTwsChecked1[1] == TRUE) && 
				(m_lLastOrderId_tws2 > 0))
		{	// check prices again in the unlikely case Tws1 is deactivated
			if (order[0][1].orderType == "LMT")
			{
				order[0][1].lmtPrice = atof(m_strLmtPrice);
				order[0][1].auxPrice = 0.0f;
				AddToLog("Tws2: New limit price: " + m_strLmtPrice);
			}
			if (order[0][1].orderType == "STP" || order[0][1].orderType == "TRAIL")
			{
				order[0][1].lmtPrice = 0.0f;
				order[0][1].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws2: New stop price: " + m_strStpPrice);
			}
			if (order[0][1].orderType == "STPLMT")
			{
				order[0][1].lmtPrice = atof(m_strLmtPrice);
				order[0][1].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws2: New stop price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			}
			if (order[0][1].orderType == "LIT")
			{
				order[0][1].lmtPrice = atof(m_strLmtPrice);
				order[0][1].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws2: New LIT price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			}
			if (order[0][1].orderType == "MIT")
			{
				order[0][1].lmtPrice = 0.0f;
				order[0][1].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws2: New MIT price: " + m_strLmtPrice);
			}

			if (!m_bPaperTrade)
			m_tws2.placeOrder(
				m_lLastOrderId_tws2,	// last order id for TWS2
				order[0][1].action,
				order[0][1].totalQuantity,
				cont.symbol,
				cont.secType,
				cont.expiry,
				cont.strike,
				cont.right,
				cont.multiplier,
				cont.exchange,
				cont.primaryExchange,
				cont.currency,
				order[0][1].orderType,
				order[0][1].lmtPrice,
				order[0][1].auxPrice,
				FA[1].faGoodAfterTime,
				FA[1].faGroup,
				FA[1].faMethod,
				FA[1].faPercentage,
				FA[1].faProfile,
				FA[1].faGoodTillDate
				);
		}
	}

	if (m_lNumIB>2) // tws3
	{
		if ((m_bTwsConnected[2] == TRUE) &&
			(m_bTwsChecked1[2] == TRUE) && 
			(m_lLastOrderId_tws3 > 0))
		{
			if (order[0][2].orderType == "LMT")
			{
				order[0][2].lmtPrice = atof(m_strLmtPrice);
				order[0][2].auxPrice = 0.0f;
				AddToLog("Tws3: New limit price: " + m_strLmtPrice);
			}
			if (order[0][2].orderType == "STP" || order[0][2].orderType == "TRAIL")
			{
				order[0][2].lmtPrice = 0.0f;
				order[0][2].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws3: New stop price: " + m_strStpPrice);
			}
			if (order[0][2].orderType == "STPLMT")
			{
				order[0][2].lmtPrice = atof(m_strLmtPrice);
				order[0][2].auxPrice = atof(m_strLmtPrice);
				AddToLog("Tws3: New stop price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			}

			if (order[0][2].orderType == "LIT")
			{
				order[0][2].lmtPrice = atof(m_strLmtPrice);
				order[0][2].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws3: New LIT price: " + m_strStpPrice + ". New limit price: " + m_strLmtPrice);
			}
			if (order[0][2].orderType == "MIT")
			{
				order[0][2].lmtPrice = 0.0f;
				order[0][2].auxPrice = atof(m_strStpPrice);
				AddToLog("Tws3: New MIT price: " + m_strLmtPrice);
			}
			if (!m_bPaperTrade)
			m_tws3.placeOrder(
				m_lLastOrderId_tws3,	// last order id
				order[0][2].action,
				order[0][2].totalQuantity,
				cont.symbol,
				cont.secType,
				cont.expiry,
				cont.strike,
				cont.right,
				cont.multiplier,
				cont.exchange,
				cont.primaryExchange,
				cont.currency,
				order[0][2].orderType,
				order[0][2].lmtPrice,
				order[0][2].auxPrice,
				FA[2].faGoodAfterTime,
				FA[2].faGroup,
				FA[2].faMethod,
				FA[2].faPercentage,
				FA[2].faProfile,
				FA[2].faGoodTillDate
				);			
		}
	}

	OnreqOpenOrders(); 
	return;
}

// pressed "Cancel" button
void CClient3Dlg::OnCanorder() 
{	// Can only cancel last pending order at this stage
	CString strCancel;
	GetAccounts();	// check listbox for account activation/deactivation
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";

	/*  // can't remember why i did this....
	if (m_Reg.SetKey(m_RegIBDKey, FALSE))	
	{	// read from m_Registry (important if IBD_Direct has shut down with pending orders)
		m_lLastOrderId_tws1 = m_Reg.ReadDword("LastOrderId_Tws1",0);
		m_lLastOrderId_tws2 = m_Reg.ReadDword("LastOrderId_Tws2",0);
		m_lLastOrderId_tws3 = m_Reg.ReadDword("LastOrderId_Tws3",0);
		order[0][2].action = order[0][1].action = order[0][0].action = m_Reg.ReadString("LastAction","");
	}*/

	if (m_bTwsChecked1[0] == TRUE && m_lLastOrderId_tws1 > 0) 
	{
		m_tws1.cancelOrder(m_lLastOrderId_tws1);
		strCancel.Format(_T("TWS1: Canceling Order %i"),m_lLastOrderId_tws1);
		AddStatusLine(strCancel,statInfo);
		m_lLastOrderId_tws1 = 0;
		order[0][0].lmtPrice = 0.0f;
		order[0][0].auxPrice = 0.0f;
		int ret = m_Reg.WriteDword("LastOrderId_Tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	else	AddStatusLine("TWS1: No order to cancel",1);
	
	if (m_lNumIB>1) 
		if (m_bTwsChecked1[1] == TRUE && m_lLastOrderId_tws2 > 0) 
		{
			m_tws2.cancelOrder(m_lLastOrderId_tws2);
			strCancel.Format(_T("TWS2: Canceling Order %i"),m_lLastOrderId_tws2);
			AddStatusLine(strCancel,statInfo);
			m_lLastOrderId_tws2 = 0;
			order[0][1].lmtPrice = 0.0f;
			order[0][1].auxPrice = 0.0f;
			int ret = m_Reg.WriteDword("LastOrderId_Tws2",0);
			if (ret != 1) AddStatusLine("Windows registry error", statWarn);
		}
		else	AddStatusLine("TWS2: No order to cancel",1);
	
	if (m_lNumIB>2) 
		if (m_bTwsChecked1[2] == TRUE && m_lLastOrderId_tws3 > 0) 
		{
			m_tws2.cancelOrder(m_lLastOrderId_tws3);
			strCancel.Format(_T("TWS3: Canceling Order %i"),m_lLastOrderId_tws3);
			AddStatusLine(strCancel,statInfo);
			m_lLastOrderId_tws3 = 0;
			order[0][2].lmtPrice = 0.0f;
			order[0][2].auxPrice = 0.0f;
			int ret = m_Reg.WriteDword("LastOrderId_Tws3",0);
			if (ret != 1) AddStatusLine("Windows registry error", statWarn);
		}
		else 	AddStatusLine("TWS3: No order to cancel",1);
	
	ResetButtons();
}

void CClient3Dlg::OnreqOpenOrders() 
{	//The open orders will be fed back through openOrder1 and openOrder2 events.
	GetAccounts();
	OnBnClickedClearexec(); // clear lists first
	if (m_bTwsChecked1[0] == TRUE) m_tws1.reqOpenOrders();
	if ((m_lNumIB>1) && (m_bTwsChecked1[1] == TRUE))	m_tws2.reqOpenOrders();
	if ((m_lNumIB>2) && (m_bTwsChecked1[2] == TRUE))	m_tws3.reqOpenOrders();
}

void CClient3Dlg::OnReqExecutions() 
{	//call execution reports are downloaded to the client via the openOrder1(), 
	// openOrder2() and orderStatus() events.

	// optional filters could be used
	CString strEmpty = "";
	GetAccounts();
	//OnBnClickedClearexec(); // clear lists first

	m_tws2.SetSymbolFilter(cont.symbol);
	m_tws3.SetSymbolFilter(cont.symbol);

    m_tws1.SetClientIdFilter(c1.ClientID);
    m_tws1.SetAcctCodeFilter(strEmpty);
    m_tws1.SetTimeFilter(strEmpty);
    m_tws1.SetSymbolFilter( cont.symbol);
    m_tws1.SetSecTypeFilter( strEmpty);
    m_tws1.SetExchangeFilter( strEmpty);
    m_tws1.SetSideFilter( strEmpty);
	/*if (m_bTwsChecked2[0] == TRUE)*/ m_tws1.reqExecutions();	
	if ((m_lNumIB>1) /*&& (m_bTwsChecked2[1] == TRUE)*/) 
	{	
		m_tws2.SetClientIdFilter(c2.ClientID);
		m_tws2.SetAcctCodeFilter(strEmpty);
		m_tws2.SetTimeFilter(strEmpty);
		m_tws2.SetSymbolFilter( cont.symbol);
		m_tws2.SetSecTypeFilter( strEmpty);
		m_tws2.SetExchangeFilter( strEmpty);
		m_tws2.SetSideFilter( strEmpty);
		m_tws2.reqExecutions();
	}

	if ((m_lNumIB>2) /*&& (m_bTwsChecked2[2] == TRUE)*/) 
	{
		m_tws3.SetClientIdFilter(c3.ClientID);
		m_tws3.SetAcctCodeFilter(strEmpty);
		m_tws3.SetTimeFilter(strEmpty);
		m_tws3.SetSymbolFilter( cont.symbol);
		m_tws3.SetSecTypeFilter( strEmpty);
		m_tws3.SetExchangeFilter( strEmpty);
		m_tws3.SetSideFilter( strEmpty);
		m_tws3.reqExecutions();
	}
}

// button has been removed, but code is called from various locations in the prog
void CClient3Dlg::ReqIBPosition(int nTWS)
{	// info returned by updateAccountTime, updateAccountValue 
	// and updatePortfolio events
	CString strAcc="";

	if ((nTWS == 1) && (m_bTwsConnected[0] == TRUE)) 
		m_tws1.reqAccountUpdates(TRUE,strAcc);	

	if ((nTWS == 2) && (m_bTwsConnected[1] == TRUE))
		m_tws2.reqAccountUpdates(TRUE,strAcc);	

	if ((nTWS == 3) && (m_bTwsConnected[2] == TRUE))
		m_tws3.reqAccountUpdates(TRUE,strAcc);
}

void CClient3Dlg::OnDisconnect() 
{	
	if (m_nPosition1 != 0 || m_nPosition2 != 0 || m_nPosition3 != 0)
	{	// but does not check if pending orders (would not be that difficult)
		int retval = MessageBox("Disconnect request with positions left open. Continue!?",
				"Caution!",MB_YESNO);
		if (retval != 6) return; // answer was yes
	}

	OnStopTicker(); // stop ticker
	m_tws1.disconnect();

	//c1.PortNo = 0; // can also reset PortNo here (optional)
	m_bTwsConnected[0] = FALSE;
	ListOpenOrder2.SetItemText(0,1,"Disc");
	ListOpenOrder2.SetCheck(0,FALSE);

	if (m_lNumIB>1) 
	{
		m_tws2.disconnect();
		m_bTwsConnected[1] = FALSE;
		ListOpenOrder2.SetItemText(1,1,"Disc.");
		ListOpenOrder2.SetCheck(1,FALSE);
	}

	if (m_lNumIB>2) 
	{
		m_tws3.disconnect();
		m_bTwsConnected[2] = FALSE;
		ListOpenOrder2.SetItemText(2,1,"Disc.");
		ListOpenOrder2.SetCheck(2,FALSE);
	}

	AddStatusLine("Disconnected from IB TWS",statWarn);
}

// disconnect and clear connect structs
void CClient3Dlg::OnBnDoubleclickedDisconnect()
{
	OnDisconnect();		// Disconnect
	// Clear connect ports
	AddStatusLine("Connection Info has been cleared",statInfo);
	c1.PortNo = 0;
	c1.ClientID = 0;
	c1.IP_Address = "";
	c1.NumShares = 0;
	c3 = c2 = c1;
}

void CClient3Dlg::OnBnClickedOk()
{
	int retval = -1;
	if (m_nPosition1 != 0 || m_nPosition2 != 0 || m_nPosition3 != 0)
	{
		retval = MessageBox("Leaving program with open positions... Continue?","Caution!",MB_YESNO);
		if (retval != 6) return; // answer was yes
	}

//	retval = 0;
//	if (nPend1 != 0 || nPend2 != 0 || nPend3 != 0)
//	{
//		CString msg = "Leaving program with pending orders... ";
//		msg +=	"Exit and clear (YES), Exit (NO), or CANCEL Exit ?";
//		retval = MessageBox(msg,"Caution!",MB_YESNOCANCEL);
//		if (retval == 2) return; // answer was cancel
//	}

//	if ((retval == 0) || (retval == 6))	ResetOrderIds();

	OnOK();
}

// End button clicks

////////////////////////////////////////////////////////////
// Calls to TWS APIs

void CClient3Dlg::OnReqmktdata() 
{	// Only first TWS connection requests data (subscription required)
	CString strNumIB, strWinText, strTicker;

	if (m_bTwsConnected[0] != TRUE) 
	{
		AddStatusLine("Not connected to TWS1",statWarn);
		OnStopTicker();  // stop ticker
		return;
	}

	if (cont.symbol == "")	OnBnClickedOrdersettings(); // what ticker?

	if (m_bTickerActive == TRUE) return;
	m_tws1.reqMktData( 
		m_lTickerId,  // single ticker
		cont.symbol,
		cont.secType,
		cont.expiry,
		cont.strike,
		cont.right,
		cont.multiplier,
		cont.exchange,
		cont.primaryExchange,
		cont.currency,
		"", 0);  // generic ticks ???

	m_bTickerActive = TRUE;
	strTicker.Format(_T(" (Symbol %s-%s)"), cont.exchange, cont.symbol);
	strWinText = m_strCaption + strTicker;
	SetWindowText(strWinText);

	m_nTimerTicker = SetTimer(10, 1000, 0);  // attempt launching mktdepth now
}

///////////////////////////////////////////////////////////
// handle ActiveX events (response from TWS)

//  Get and display some details about contract traded
void CClient3Dlg::OncontractDetailsTwsctrl1(
        LPCTSTR symbol,         LPCTSTR secType,        LPCTSTR expiry, 
        double strike,          LPCTSTR right,          LPCTSTR exchange, 
        LPCTSTR curency,        LPCTSTR localSymbol,    LPCTSTR marketName, 
        LPCTSTR tradingClass,   long conId,             double minTick, 
        long priceMagnifier,    LPCTSTR multiplier,     LPCTSTR orderTypes,
		LPCTSTR validExchanges)
{
	CString disp;
	m_dMultiplier = atof(multiplier);
	disp.Format(_T("$Mult or point value:%s, US$ Tick Value:%.2f"),multiplier, m_dMultiplier*minTick);
	AddStatusLine(disp, statInfo);
	disp.Format("Tick Size for %s is: %.3f", symbol, minTick);
	AddStatusLine(disp, statInfo);
	m_dSymbolTickSize = minTick;
	disp.Format(_T("%s %s Exp:%s Mkt:%s"),symbol,secType,expiry,exchange);
	AddStatusLine(disp, statInfo);
	disp.Format(_T("Accepted orders for %s/%s: %s"),exchange, symbol, orderTypes);
	AddStatusLine(disp, statInfo);
	if (m_dSymbolTickSize == 0)
	{
		CString str = "Tick size information is missing!.  Closing IB_Direct is strongly recommended.";
		AfxMessageBox(str);
		AddToLog(str);
		return;
	}
	// points must be in tick increments, so a bit of rounding is now done
	m_dNumStpPts = (int)(s_dlg.m_dStopPoints/m_dSymbolTickSize)*m_dSymbolTickSize;
	m_dNumLmtPts[0] = (int)(s_dlg.m_dLimitPoints/m_dSymbolTickSize)*m_dSymbolTickSize;
	m_dNumLmtPts[1] = (int)(s_dlg.m_dLimitPoints2/m_dSymbolTickSize)*m_dSymbolTickSize;
	m_dNumLmtPts[2] = (int)(s_dlg.m_dLimitPoints3/m_dSymbolTickSize)*m_dSymbolTickSize;
	m_nNumShares[0] = s_dlg.m_nLimitCts;
	m_nNumShares[1] = s_dlg.m_nLimitCts2;
	m_nNumShares[2] = s_dlg.m_nLimitCts3;

	OnBnClickedMktdepth();
}

void CClient3Dlg::OnbondContractDetailsTwsctrl1(LPCTSTR symbol, LPCTSTR secType, LPCTSTR cusip,
												double coupon, LPCTSTR maturity, LPCTSTR issueDate,
												LPCTSTR ratings, LPCTSTR bondType, LPCTSTR couponType,
												long convertible, long callable, long putable,
												LPCTSTR descAppend, LPCTSTR exchange, LPCTSTR curency,
												LPCTSTR marketName, LPCTSTR tradingClass, long conId,
												double minTick, LPCTSTR orderTypes, LPCTSTR validExchanges) 
{
}

//	Display IB news 
void CClient3Dlg::OnupdateNewsBulletinTwsctrl1(short msgId, short msgType, LPCTSTR message, LPCTSTR origExchange) 
{
	CString disp ="IB_MSG:"+(CString)message; 
	AddStatusLine(disp,statWarn);
}

//	ticker
void CClient3Dlg::OntickPriceTwsctrl1(long id, long tickType, double price, int canAutoExecute) 
{	// This event is linked to Tws1 (id is a ticker id)
	UpdateTickerPrice((TickType)tickType,price);
}

void CClient3Dlg::OntickSizeTwsctrl1(long id, long tickType, long size) 
{	// This event is linked to Tws1 only
	UpdateTickerVolume((TickType)tickType, size);
}

void CClient3Dlg::OnhistoricalDataTwsctrl1(long reqId, LPCTSTR date, double open, 
										 double high, double low, double close,
										 int volume, double WAP, long hasGaps) 
{
	// later...
}
// end ticker

//
//  first feedback from IB about order sent through (i.e. received by IB)
//  no longer used in latest API code samples, so dropped
//void CClient3Dlg::OnopenOrder1Twsctrl1(long id, LPCTSTR symbol, LPCTSTR secType, 
//		LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
//		LPCTSTR curency, LPCTSTR localSymbol) 
//{	// 1st set of info returned (Event1)
//}

//
//  second feedback from IB about order being processed (queued or executed)
//  no longer used in latest API code samples, so dropped

//void CClient3Dlg::OnopenOrder2Twsctrl1(long id, LPCTSTR action, long quantity, 
//	LPCTSTR orderType, double lmtPrice, double auxPrice, 
//	LPCTSTR tif, LPCTSTR ocaGroup, LPCTSTR account, 
  //  LPCTSTR openClose, long origin, LPCTSTR orderRef, long clientId) 
//{	// 2nd set of info returned (Event2)
//}

void CClient3Dlg::OnopenOrder3Twsctrl1(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate) 
{
	LPCSTR szLmt = "LMT";
	LPCSTR szStp = "STP";
	LPCSTR szTrail = "TRAIL";
	LPCSTR szStpLmt = "STP LMT";
	CString str, strLog = "TWS1:", space = " ";
	strLog += account;
	str.Format(_T(" Id: %i"), id);

	m_strAcct1 = account;
	ListOpenOrder1.SetItemText(0,0,m_strAcct1);
	ListOpenOrder2.SetItemText(0,0,m_strAcct1);

	//if (id == order[0][0].orderId)
		ListOpenOrder1.SetItemText(0,1,str,Blue,White);
	ListOpenOrder1.SetItemText(0,2,action);
	strLog += str;
	strLog += space;
	strLog += action;
	if (m_nPosition1 == 0)				// if not filled yet, give qty
		str.Format(_T(" %i"),quantity);
	else
		str.Format(_T(" %i"),abs(m_nPosition1));
	ListOpenOrder1.SetItemText(0,3,str,Blue,White);
	str.Format(_T(" %i"),quantity);	// for the log, only display the actual qty
	strLog += str;
	strLog += space;
	strLog += orderType;
	if (id == m_lLastOrderId_tws1)
		ListOpenOrder1.SetItemText(0,4,orderType);
	else
		ListOpenOrder1.SetItemText(0,4," STP/LMT EXITS");
	if (strcmp(orderType,szLmt)==0)	
	{
		str.Format(_T(" %.3f"), lmtPrice);
		if (id == m_lLastLimitOrderId1_tws1 || id == m_lLastOrderId_tws1) 
			ListOpenOrder1.SetItemText(0,6,str);
		if (id == m_lLastLimitOrderId2_tws1) ListOpenOrder1.SetItemText(0,7,str);
		if (id == m_lLastLimitOrderId3_tws1) ListOpenOrder1.SetItemText(0,8,str);
		strLog += str;
	}
	else if ((strcmp(orderType,szStp)==0) || (strcmp(orderType,szTrail)==0))
	{
		str.Format(_T(" %.3f"), auxPrice);
		ListOpenOrder1.SetItemText(0,5,str);
		strLog += str;
	}
    else if (strcmp(orderType,szStpLmt)==0)
	{
		str.Format(_T(" %.3f"), auxPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(0,5,str);
		str.Format(_T(" %.3f"), lmtPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(0,6,str);
	}
	if (m_bVerbose)
	{
		//str.Format(" (LMT: %.3f STP %.3f)", lmtPrice, auxPrice);
		//strLog += str;
		AddStatusLine(strLog, statInfo);
	}
	AddToLog(strLog);
}

void CClient3Dlg::OnopenOrder4Twsctrl1(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate,
		long ocaType, long rthOnly, LPCTSTR rule80A, LPCTSTR settlingFirm,
		long allOrNone, long minQty, double percentOffset, long eTradeOnly, long firmQuoteOnly,
		double nbboPriceCap, long auctionStrategy, double startingPrice, double stockRefPrice,
		double delta, double stockRangeLower, double stockRangeUpper, 
		long blockOrder, long sweepToFill, long ignoreRth, long hidden,
		double discretionaryAmt, long displaySize, long parentId, long triggerMethod,
		long shortSaleSlot, LPCTSTR designatedLocation)
{
}

void CClient3Dlg::OnopenOrder3Twsctrl2(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate) 
{
	LPCSTR szLmt = "LMT";
	LPCSTR szStp = "STP";
	LPCSTR szTrail = "TRAIL";
	LPCSTR szStpLmt = "STP LMT";
	CString str, strLog = "TWS2: ", space;
	strLog += account;
	str.Format(_T(" %i"), id);

	m_strAcct2 = account;
	ListOpenOrder1.SetItemText(1,0,m_strAcct2);
	ListOpenOrder2.SetItemText(1,0,m_strAcct2);

	//if (id == order[0][0].orderId)
	ListOpenOrder1.SetItemText(1,1,str,Blue,White);
	ListOpenOrder1.SetItemText(1,2,action);
	strLog += str;
	strLog += space;
	strLog += action;
	if (m_nPosition2 == 0)				// if not filled yet, give qty
		str.Format(_T(" %i"),quantity);
	else
		str.Format(_T(" %i"),abs(m_nPosition2));
	ListOpenOrder1.SetItemText(1,3,str,Blue,White);
	str.Format(_T(" %i"),quantity);	// for the log, only display the actual qty
	strLog += str;
	strLog += space;
	strLog += orderType;
	if (id == m_lLastOrderId_tws2)
		ListOpenOrder1.SetItemText(1,4,orderType);
	else
		ListOpenOrder1.SetItemText(1,4," STP/LMT EXITS");
	if (strcmp(orderType,szLmt)==0)	
	{
		str.Format(_T(" %.3f"), lmtPrice);
		if (id == m_lLastLimitOrderId1_tws2 || id == m_lLastOrderId_tws2) 
			ListOpenOrder1.SetItemText(1,6,str);
		if (id == m_lLastLimitOrderId2_tws2) ListOpenOrder1.SetItemText(1,7,str);
		if (id == m_lLastLimitOrderId3_tws2) ListOpenOrder1.SetItemText(1,8,str);
		strLog += str;
	}
	else if ((strcmp(orderType,szStp)==0) || (strcmp(orderType,szTrail)==0))
	{
		str.Format(_T(" %.3f"), auxPrice);
		ListOpenOrder1.SetItemText(1,5,str);
		strLog += str;
	}
    else if (strcmp(orderType,szStpLmt)==0)
	{
		str.Format(_T(" %.3f"), auxPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(1,5,str);
		str.Format(_T(" %.3f"), lmtPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(1,6,str);
	}
	if (m_bVerbose)
	{
		//str.Format(" (LMT: %.3f STP %.3f)", lmtPrice, auxPrice);
		//strLog += str;
		AddStatusLine(strLog, statInfo);
	}
	AddToLog(strLog);
}

void CClient3Dlg::OnopenOrder4Twsctrl2(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate,
		long ocaType, long rthOnly, LPCTSTR rule80A, LPCTSTR settlingFirm,
		long allOrNone, long minQty, double percentOffset, long eTradeOnly, long firmQuoteOnly,
		double nbboPriceCap, long auctionStrategy, double startingPrice, double stockRefPrice,
		double delta, double stockRangeLower, double stockRangeUpper, 
		long blockOrder, long sweepToFill, long ignoreRth, long hidden,
		double discretionaryAmt, long displaySize, long parentId, long triggerMethod,
		long shortSaleSlot, LPCTSTR designatedLocation) 
{
}

void CClient3Dlg::OnopenOrder3Twsctrl3(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate) 
{
	LPCSTR szLmt = "LMT";
	LPCSTR szStp = "STP";
	LPCSTR szTrail = "TRAIL";
	LPCSTR szStpLmt = "STP LMT";
	CString str, strLog = "TWS3:", space;
	strLog += account;
	str.Format(_T(" %i"), id);

	m_strAcct3 = account;
	ListOpenOrder1.SetItemText(2,0,m_strAcct3);
	ListOpenOrder2.SetItemText(2,0,m_strAcct3);

	//if (id == order[0][0].orderId)
		ListOpenOrder1.SetItemText(2,1,str,Blue,White);
	ListOpenOrder1.SetItemText(2,2,action);
	strLog += str;
	strLog += space;
	strLog += action;
	if (m_nPosition3 == 0)				// if not filled yet, give qty
		str.Format(_T(" %i"),quantity);
	else
		str.Format(_T(" %i"),abs(m_nPosition3));
	ListOpenOrder1.SetItemText(2,3,str,Blue,White);
	str.Format(_T(" %i"),quantity);	// for the log, only display the actual qty
	strLog += str;
	strLog += space;
	strLog += orderType;
	if (id == m_lLastOrderId_tws3)
		ListOpenOrder1.SetItemText(2,4,orderType);
	else
		ListOpenOrder1.SetItemText(2,4," STP/LMT EXITS");
	if (strcmp(orderType,szLmt)==0)	
	{
		str.Format(_T(" %.3f"), lmtPrice);
		if (id == m_lLastLimitOrderId1_tws3 || id == m_lLastOrderId_tws3) 
			ListOpenOrder1.SetItemText(2,6,str);
		if (id == m_lLastLimitOrderId2_tws3) ListOpenOrder1.SetItemText(2,7,str);
		if (id == m_lLastLimitOrderId3_tws3) ListOpenOrder1.SetItemText(2,8,str);
		strLog += str;
	}
	else if ((strcmp(orderType,szStp)==0) || (strcmp(orderType,szTrail)==0))
	{
		str.Format(_T("%.3f"), auxPrice);
		ListOpenOrder1.SetItemText(2,5,str);
		strLog += str;
	}
    else if (strcmp(orderType,szStpLmt)==0)
	{
		str.Format(_T(" %.3f"), auxPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(2,5,str);
		str.Format(_T(" %.3f"), lmtPrice);
		strLog += str;
		ListOpenOrder1.SetItemText(2,6,str);
	}
	if (m_bVerbose)
	{
		//str.Format(" (LMT: %.3f STP %.3f)", lmtPrice, auxPrice);
		//strLog += str;
		AddStatusLine(strLog, statInfo);
	}
	AddToLog(strLog);
}

void CClient3Dlg::OnopenOrder4Twsctrl3(long id, LPCTSTR symbol, LPCTSTR secType,
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange, 
        LPCTSTR curency, LPCTSTR localSymbol, LPCTSTR action, long quantity, 
        LPCTSTR orderType, double lmtPrice, double auxPrice, LPCTSTR tif, 
        LPCTSTR ocaGroup, LPCTSTR account, LPCTSTR openClose, long origin, 
        LPCTSTR orderRef, long clientId, long permId, LPCTSTR sharesAllocation,
		LPCTSTR faGroup, LPCTSTR faMethod, LPCTSTR faPercentage, LPCTSTR faProfile,
		LPCTSTR goodAfterTime, LPCTSTR goodTillDate,
		long ocaType, long rthOnly, LPCTSTR rule80A, LPCTSTR settlingFirm,
		long allOrNone, long minQty, double percentOffset, long eTradeOnly, long firmQuoteOnly,
		double nbboPriceCap, long auctionStrategy, double startingPrice, double stockRefPrice,
		double delta, double stockRangeLower, double stockRangeUpper, 
		long blockOrder, long sweepToFill, long ignoreRth, long hidden,
		double discretionaryAmt, long displaySize, long parentId, long triggerMethod,
		long shortSaleSlot, LPCTSTR designatedLocation) 
{
}


// Valid Id is the next order id number (upon successful connection)
void CClient3Dlg::OnnextValidIdTwsctrl1(long id) 
{	// NextValidID is an event triggered upon connection
	// Order IDs are simply incremented after that
	// Another ordering scheme could be devised, like multiples of 10
	// with attached orders following (eg 10 is the entry, 11 stop loss, 12 limit target, etc...)
	CString strId, strAcc= "";
	m_lOrderId_tws1 = id;	// initial id for TWS1
	strId.Format(_T("%i"),id);
	ListOpenOrder2.SetItemText(0,1," Wait...");
	ListOpenOrder1.SetItemText(0,1," OK",White,Blue);
	strId.Format(_T("Tws1 connected: Next Valid Order Id = %i"),id);
	m_bTwsConnected[0] = TRUE;
	AddStatusLine(strId,statInfo);
	AddToLog(strId);
	strId.Format(_T("Connected to TWS server version %d at %s."),
		m_tws1.serverVersion(), m_tws1.TwsConnectionTime());
	AddStatusLine(strId,statInfo);
	if (m_lTickerId > 0) 
		OnStartTicker();  // attempt to start ticker immediately
	ReqIBPosition(1); // get position

	try
	{
	// All Registry settings are stored in subkeys of Software\IBD 
	// (hard-coded at this stage)
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, FALSE))	
	{	// read from m_Registry (important if IB_Direct has shut down with pending orders)
		//order[0][0].totalQuantity = m_Reg.ReadDword("Qty",0);
		order[0][0].action = m_Reg.ReadString("LastAction","");
		m_bLastEntrySig = m_Reg.ReadBool("EntrySig",TRUE);
		m_lLastOrderId_tws1 = m_Reg.ReadDword("LastOrderId_tws1",0);
		strId.Format(_T("%i"),m_lLastOrderId_tws1);
		if (m_lLastOrderId_tws1 != 0)	
			AddStatusLine("Registry TWS1: " + order[0][0].action + " order id:" + strId,statWarn);
		
		m_lLastStopOrderId1_tws1 = m_Reg.ReadDword("LastStopOrderId1_tws1",0);
		strId.Format(_T("%i"),m_lLastStopOrderId1_tws1);
		if (m_lLastStopOrderId1_tws1 != 0)	
			AddStatusLine("Registry TWS1 stop order id:" +strId,statWarn);

		m_dOriginalStopPrice1 = m_Reg.ReadFloat("OrigStopPrice1_tws1",0.0);

		m_lLastLimitOrderId1_tws1 = m_Reg.ReadDword("LastLimitOrderId1_tws1",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId1_tws1);
		if (m_lLastLimitOrderId1_tws1 != 0)	
			AddStatusLine("Registry TWS1 limit order id1: " + strId,statWarn);
		
		m_lLastLimitOrderId2_tws1 = m_Reg.ReadDword("LastLimitOrderId2_tws1",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId2_tws1);
		if (m_lLastLimitOrderId2_tws1 != 0)	
			AddStatusLine("Registry TWS1 limit order id2: " + strId,statWarn);

		m_lLastLimitOrderId3_tws1 = m_Reg.ReadDword("LastLimitOrderId3_tws1",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId3_tws1);
		if (m_lLastLimitOrderId3_tws1 != 0)	
			AddStatusLine("Registry TWS1 limit order id3: " + strId,statWarn);

		m_strLastOCA1_tws1 = m_Reg.ReadString("LastOCA1_tws1","");
		if (m_strLastOCA1_tws1 != "")	
			AddStatusLine("TWS1 Recorded group OCA1:" + m_strLastOCA1_tws1,statInfo);

		m_strLastOCA2_tws1 = m_Reg.ReadString("LastOCA2_tws1","");
		if (m_strLastOCA2_tws1 != "")	
			AddStatusLine("TWS1 Recorded group OCA2:" + m_strLastOCA2_tws1,statInfo);

		m_strLastOCA3_tws1 = m_Reg.ReadString("LastOCA3_tws1","");
		if (m_strLastOCA3_tws1 != "")	
			AddStatusLine("TWS1 Recorded group OCA3:" + m_strLastOCA3_tws1,statInfo);
	}

	if (m_lLastOrderId_tws1 + 
		m_lLastStopOrderId1_tws1 + m_lLastLimitOrderId1_tws1 +
		m_lLastStopOrderId2_tws1 + m_lLastLimitOrderId2_tws1 +
		m_lLastStopOrderId3_tws1 + m_lLastLimitOrderId3_tws1)
		{
			CString msg = "TWS1 Orders Ids found in Registry";
			AddStatusLine(msg,statWarn);
			int retval = MessageBox(msg,"TWS1: Clear all order ids stored in Registry?",MB_YESNO);
			if (retval == 6) ResetOrderIds(1);
			else
			{
				CString str;
				str.Format(_T("%s Order (id:%i) restored"),order[0][0].action,m_lLastOrderId_tws1);
				AddStatusLine(str,statWarn);
			}
		}
	}
	catch (...)
	{
		AfxMessageBox("Registry Settings are corrupt.  Program will shut down");
		CDialog::OnClose();
	}
}

void CClient3Dlg::OnnextValidIdTwsctrl2(long id) 
{	// NextValidID is an event triggered upon connection
	CString strId, strAcc= "";
	m_lOrderId_tws2 = id;	// initial id for TWS2
	strId.Format(_T("%i"),id);
	ListOpenOrder2.SetItemText(1,1," Wait...");
	ListOpenOrder1.SetItemText(1,1," OK",White,Blue);
	strId.Format(_T("Tws2 connected: Next Valid Order Id = %i"),id);
	m_bTwsConnected[1] = TRUE;
	AddStatusLine(strId,statInfo);
	AddToLog(strId);
	//ReqIBPosition(2);

	try
	{
	// All Registry settings are stored in subkeys of Software\IBD 
	// (hard-coded at this stage)
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, FALSE))	
	{	// read from m_Registry (important if IB_Direct has shut down with pending orders)
		//order[0][1].totalQuantity = m_Reg.ReadDword("Qty",0);
		order[0][1].action = m_Reg.ReadString("LastAction","");
		m_bLastEntrySig = m_Reg.ReadBool("EntrySig",TRUE);
		m_lLastOrderId_tws2 = m_Reg.ReadDword("LastOrderId_tws2",0);
		strId.Format(_T("%i"),m_lLastOrderId_tws2);
		if (m_lLastOrderId_tws2 != 0)	
			AddStatusLine("Registry TWS2: " + order[0][1].action + " order id:" + strId,statWarn);
		
		m_lLastStopOrderId1_tws2 = m_Reg.ReadDword("LastStopOrderId1_tws2",0);
		strId.Format(_T("%i"),m_lLastStopOrderId1_tws2);
		if (m_lLastStopOrderId1_tws2 != 0)	
			AddStatusLine("Registry TWS2 stop order id:" +strId,statWarn);

		m_dOriginalStopPrice2 = m_Reg.ReadFloat("OrigStopPrice_tws2",0.0);

		m_lLastLimitOrderId1_tws2 = m_Reg.ReadDword("LastLimitOrderId1_tws2",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId1_tws2);
		if (m_lLastLimitOrderId1_tws2 != 0)	
			AddStatusLine("Registry TWS2 limit order id1: " + strId,statWarn);
		
		m_lLastLimitOrderId2_tws2 = m_Reg.ReadDword("LastLimitOrderId2_tws2",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId2_tws2);
		if (m_lLastLimitOrderId2_tws2 != 0)	
			AddStatusLine("Registry TWS2 limit order id2: " + strId,statWarn);

		m_lLastLimitOrderId3_tws2 = m_Reg.ReadDword("LastLimitOrderId3_tws2",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId3_tws2);
		if (m_lLastLimitOrderId3_tws2 != 0)	
			AddStatusLine("Registry TWS2 limit order id3: " + strId,statWarn);

		m_strLastOCA1_tws2 = m_Reg.ReadString("LastOCA1_tws2","");
		if (m_strLastOCA1_tws2 != "")	
			AddStatusLine("TWS2 Recorded group OCA1:" + m_strLastOCA1_tws2,statInfo);

		m_strLastOCA2_tws2 = m_Reg.ReadString("LastOCA2_tws2","");
		if (m_strLastOCA2_tws2 != "")	
			AddStatusLine("TWS2 Recorded group OCA2:" + m_strLastOCA2_tws2,statInfo);

		m_strLastOCA3_tws2 = m_Reg.ReadString("LastOCA3_tws2","");
		if (m_strLastOCA3_tws2 != "")	
			AddStatusLine("TWS2 Recorded group OCA3:" + m_strLastOCA3_tws2,statInfo);
	}

	if (m_lLastOrderId_tws2 + m_lLastStopOrderId1_tws2 + m_lLastLimitOrderId1_tws2 +
		m_lLastStopOrderId2_tws2 + m_lLastLimitOrderId2_tws2 +
		m_lLastStopOrderId3_tws2 + m_lLastLimitOrderId3_tws2)
		{
			CString msg = "TWS2 Orders Ids found in Registry";
			AddStatusLine(msg,statWarn);
			int retval = MessageBox(msg,"TWS2: Clear all order ids stored in Registry?",MB_YESNO);
			if (retval == 6) ResetOrderIds(2);
			else
			{
				CString str;
				str.Format(_T("TWS2: %s Order (%i) restored"),order[0][0].action,m_lLastOrderId_tws1);
				AddStatusLine(str,statWarn);
			}
		}
	}
	catch (...)
	{
		AfxMessageBox("Registry Settings are corrupt.  Program will shut down");
		CDialog::OnClose();
	}
}

void CClient3Dlg::OnnextValidIdTwsctrl3(long id) 
{	// NextValidID is an event triggered upon connection
	CString strId, strAcc= "";
	m_lOrderId_tws3 = id;	// initial id for TWS3
	strId.Format(_T("%i"),id);
	ListOpenOrder2.SetItemText(2,1," Wait...");
	ListOpenOrder1.SetItemText(2,1," OK",White,Blue);
	strId.Format(_T("Tws3 connected: Next Valid Order Id = %i"),id);
	m_bTwsConnected[2] = TRUE;
	AddStatusLine(strId,statInfo);
	AddToLog(strId);
	//ReqIBPosition(3);

	try
	{
	// All Registry settings are stored in subkeys of Software\IBD 
	// (hard-coded at this stage)
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	if (m_Reg.SetKey(m_RegIBDKey, FALSE))	
	{	// read from m_Registry (important if IB_Direct has shut down with pending orders)
		//order[0][2].totalQuantity = m_Reg.ReadDword("Qty",0);
		order[0][2].action = m_Reg.ReadString("LastAction","");
		m_bLastEntrySig = m_Reg.ReadBool("EntrySig",TRUE);
		m_lLastOrderId_tws3 = m_Reg.ReadDword("LastOrderId_tws3",0);
		strId.Format(_T("%i"),m_lLastOrderId_tws3);
		if (m_lLastOrderId_tws3 != 0)	
			AddStatusLine("Registry TWS3: " + order[0][2].action + " order id:" + strId,statWarn);
		
		m_lLastStopOrderId1_tws3 = m_Reg.ReadDword("LastStopOrderId1_tws3",0);
		strId.Format(_T("%i"),m_lLastStopOrderId1_tws3);
		if (m_lLastStopOrderId1_tws3 != 0)	
			AddStatusLine("Registry TWS3 stop order id:" +strId,statWarn);

		m_dOriginalStopPrice3 = m_Reg.ReadFloat("OrigStopPrice_tws3",0.0);

		m_lLastLimitOrderId1_tws3 = m_Reg.ReadDword("LastLimitOrderId1_tws3",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId1_tws3);
		if (m_lLastLimitOrderId1_tws3 != 0)	
			AddStatusLine("Registry TWS3 limit order id1: " + strId,statWarn);
		
		m_lLastLimitOrderId2_tws3 = m_Reg.ReadDword("LastLimitOrderId2_tws3",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId2_tws3);
		if (m_lLastLimitOrderId2_tws3 != 0)	
			AddStatusLine("Registry TWS3 limit order id2: " + strId,statWarn);

		m_lLastLimitOrderId3_tws3 = m_Reg.ReadDword("LastLimitOrderId3_tws3",0);
		strId.Format(_T("%i"),m_lLastLimitOrderId3_tws3);
		if (m_lLastLimitOrderId3_tws3 != 0)	
			AddStatusLine("Registry TWS3 limit order id3: " + strId,statWarn);

		m_strLastOCA1_tws3 = m_Reg.ReadString("LastOCA1_tws2","");
		if (m_strLastOCA1_tws3 != "")	
			AddStatusLine("TWS3 Recorded group OCA1:" + m_strLastOCA1_tws3,statInfo);

		m_strLastOCA2_tws3 = m_Reg.ReadString("LastOCA2_tws3","");
		if (m_strLastOCA2_tws3 != "")	
			AddStatusLine("TWS3 Recorded group OCA2:" + m_strLastOCA2_tws3,statInfo);

		m_strLastOCA3_tws3 = m_Reg.ReadString("LastOCA3_tws3","");
		if (m_strLastOCA3_tws3 != "")	
			AddStatusLine("TWS3 Recorded group OCA3:" + m_strLastOCA3_tws3,statInfo);
	}

	if (m_lLastOrderId_tws3 + m_lLastStopOrderId1_tws3 + m_lLastLimitOrderId1_tws3 +
		m_lLastStopOrderId2_tws3 + m_lLastLimitOrderId2_tws3 +
		m_lLastStopOrderId3_tws3 + m_lLastLimitOrderId3_tws3)
		{
			CString msg = "TWS3 Orders Ids found in Registry";
			AddStatusLine(msg,statWarn);
			int retval = MessageBox(msg,"TWS3: Clear all order ids stored in Registry?",MB_YESNO);
			if (retval == 6) ResetOrderIds(3);
		}
	}
	catch (...)
	{
		AfxMessageBox("Registry Settings are corrupt.  Program will shut down");
		CDialog::OnClose();
	}
}

//  error feedback (a few errors are trapped pending bug fix at IB)
void CClient3Dlg::OnerrMsgTwsctrl1(long id, long errorCode, LPCTSTR errorMsg) 
{	// simple error msg mgt with log and status line
	CString errorStr("TWS1 Id: ");
	CString str = errorMsg;;

	// Not very smart, but a user cancelled order also fires an error msg event...
	// check whether now resolved in later API updates
	if ((errorCode == 202) && str == "Order Canceled - reason:") return;

	if ((errorCode == 505) || errorCode == 506 ) 
	{
		AddStatusLine ("Error 505 or 506 has to be filtered", statInfo);
		return;
	}

	if (errorCode == 161) return;

	//if (errorCode == nHeightDiff)
	//	AddStatusLine(errorStr + " Order modification or cancellation failed.  Probably already effected at TWS.", statWarn);

	if ((errorCode == 200) && (cont.secType != "STK"))
		AddStatusLine("Invalid symbol. Possible cause is wrong expiry date...", statWarn);

	str.Format(_T("%i Code:%i"),id,errorCode);
	errorStr += str;
	AddStatusLine(errorStr,statError);
	errorStr = errorMsg;
	AddStatusLine(errorStr,statError);

	if (errorCode >= 1100 && errorCode < 1200)
		AddStatusLine("CAUTION: your open orders may be LOST!!! (even if IB reports 'Data maintained')",statError);

	for (int ctr=0; ctr < NUM_FA_ERROR_CODES; ctr++)
       faError |= (errorCode == faErrorCodes[ctr]) ;

	AddToLog(errorStr);
	ResetButtons();
}

void CClient3Dlg::OnerrMsgTwsctrl2(long id, long errorCode, LPCTSTR errorMsg) 
{
	CString errorStr("TWS2 Id: ");
	CString str = errorMsg;
	if ((errorCode == 202) && str == "Order Canceled - reason:") return;
	if (errorCode == 505  || errorCode == 506)	
	{
		AddStatusLine ("Error 505 or 506 has to be filtered", statInfo);
		return;
	}
	if (errorCode == 161) return;

	str.Format(_T("%i Code:%i"),id,errorCode);
	errorStr += str;
	AddStatusLine(errorStr,statError);
	errorStr = errorMsg;
	AddStatusLine(errorStr,statError);

	if (errorCode >= 1100 && errorCode < 1200)
		AddStatusLine("CAUTION: your open orders may be LOST!!! (even if IB reports 'Data maintained')",statError);

	for (int ctr=0; ctr < NUM_FA_ERROR_CODES; ctr++)
       faError |= (errorCode == faErrorCodes[ctr]) ;

	AddToLog(errorStr);
	ResetButtons();
}

void CClient3Dlg::OnerrMsgTwsctrl3(long id, long errorCode, LPCTSTR errorMsg) 
{
	CString errorStr("TWS3 Id: ");
	CString str = errorMsg;
	if ((errorCode == 202) && str == "Order Canceled - reason:") return;
	if (errorCode == 505 || errorCode == 506)
	{
		AddStatusLine ("Error 505 or 506 has to be filtered", statInfo);
		return;
	}
	if (errorCode == 161) return;

	str.Format(_T("%i Code:%i"),id,errorCode);
	errorStr += str;
	AddStatusLine(errorStr,statError);
	errorStr = errorMsg;
	AddStatusLine(errorStr,statError);

	if (errorCode >= 1100 && errorCode < 1200)
		AddStatusLine("CAUTION: your open orders may be LOST!!! (even if IB reports 'Data maintained')",statError);

	for (int ctr=0; ctr < NUM_FA_ERROR_CODES; ctr++)
       faError |= (errorCode == faErrorCodes[ctr]) ;

	AddToLog(errorStr);
	ResetButtons();
}
// end error logging

//
//  We're now to catch order feedback, display it
//  and send attached orders through if required
//
//  Order1 and Order2 seem to have been dropped (without notice...)
//  Now all salient info will be gathered through Order3 and OrderStatus
void CClient3Dlg::OnorderStatusTwsctrl1(long id, LPCTSTR status, long filled, long remaining, 
    double avgFillPrice, long permId, long parentId, double lastFillPrice, long clientId) 
{	// Order Status (list2)

	//  construct a string (strLog) for logging purposes
	CString str, strId, strLog = " Status: ";
	CString space = " ";
	strId.Format(_T(" %i "),id);					// order id
	strLog += strId;
	ListOpenOrder2.SetItemText(0,1,strId);		// display Order Id
	strLog += status;
	ListOpenOrder2.SetItemText(0,2,status);		// display status
	m_nNumFilled1 = filled;  // used in ticker (trailing stop)
    str.Format(_T(" %i"),filled);					
	strLog += " Filled:";
	strLog += str;
	ListOpenOrder2.SetItemText(0,3,str);		// display num filled
	str.Format(_T(" %i"),remaining);
	strLog += " Remaining:";
	strLog += str;
	ListOpenOrder2.SetItemText(0,4,str);		// display remaining
	str.Format(_T(" %.3f"),lastFillPrice);
	if (lastFillPrice > 0) m_dLastFillPrice1 = lastFillPrice;
	strLog += " LastFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(0,5,str);		// display fill price
	str.Format(_T(" %.3f"),avgFillPrice);
	if (avgFillPrice > 0) m_dAvgFillPrice1 = avgFillPrice;
	strLog += " AvgFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(0,6,str);		// display avg fill price

	if (m_bVerbose)	AddToLog(strLog);	

	if (status == "Filled")						// log to TradeLog
	{
		CString str;
		str.Format(_T("TWS1 OrdId:%i Filled:%i Price:%.3f Remaining:%i"),id, filled,lastFillPrice,remaining);
		AddToTradeLog(str);
		if (mlDOM != NULL)
		{	// clear counters upon fill (TWS1 only)
			mlDOM->m_nAskCountLeft = mlDOM->m_nRecordAskSize = 0;
			mlDOM->m_nBidCountLeft = mlDOM->m_nRecordBidSize = 0;
		}
	}

	if (m_bLastEntrySig == TRUE)
	{	// last signal was an entry, so place stop & limit orders (up to 3 groups) if so required
		if ((m_lLastOrderId_tws1 == id) && (lastFillPrice > 0))	// not to be executed if no fill
		{	// for some odd reason, event may fire a first message with Fill Price = 0 upon actual fill...
			if ((m_bAutoReturnToMKT == TRUE) && (m_lNumIB == 1))	
			{	// reset order type to MKT
				if (m_bVerbose && order[0][0].orderType != "MKT") 
					AddStatusLine("Order Type reset to MKT", statInfo);
				m_cbbOrdType.SetCurSel(0);  // reset order type
				OnCbnSelchangeCombo1();
			}

			if (order[0][0].orderType != "MKT" && mlSLEntry != NULL)
			{	// if entry adjust dialog was there, close it now
				mlSLEntry->DestroyWindow();
				mlSLEntry = NULL;
			}

			if (order[0][0].totalQuantity != filled)
			{	// stop/lmt entry may not be fully filled
				CString strPartFill;
				strPartFill.Format(_T("TWS1: Caution! Filled: %i, Remaining:%i"), filled, remaining);
				AddStatusLine(strPartFill, statWarn);
			}
			
			// First OCA group
			if (m_bUseStop)  // protect entry with a stop loss order
			{	// if no stop, OCA group becomes irrelevant
				if (m_lLastStopOrderId1_tws1 == 0) // first time stop is set
				{	// Place stop loss
					strId.Format(_T("%i"),m_lLastOrderId_tws1);
					order[1][0].ocaGroup = "SL" + strId + "_1";	// entry id + group1
					m_tws1.SetOca(order[1][0].ocaGroup);
					if (m_bVerbose)
						AddStatusLine("TWS1 Stop OCA Group1: " + order[1][0].ocaGroup, statInfo);
					strLog += " (ENTRY)";
					if (m_bTrail)	order[1][0].orderType = "TRAIL";
					else			order[1][0].orderType = "STP";		// fixed stop
					order[1][0].lmtPrice = 0.0;
					// set stop price (same for the 3 OCA groups here)
					if (order[0][0].action == "BUY")	// set stop price (aux)
					{
						order[1][0].action = "SELL";	// cover by opposite order
						m_dOriginalStopPrice1 = avgFillPrice - m_dNumStpPts;
						order[1][0].auxPrice = m_dOriginalStopPrice1;
					}
					else
					{
						order[1][0].action = "BUY";
						m_dOriginalStopPrice1 = avgFillPrice + m_dNumStpPts;
						order[1][0].auxPrice = m_dOriginalStopPrice1;
					}
					// check order size for each OCA group
					if (filled < m_nNumShares[0] * m_nOrdSizeMult)
							order[1][0].totalQuantity = filled;
					else	order[1][0].totalQuantity = m_nNumShares[0] * m_nOrdSizeMult;

					m_Reg.WriteFloat("OrigStopPrice1_tws1", m_dOriginalStopPrice1); // not used yet

					if (order[1][0].totalQuantity > 0 && m_dNumStpPts > 0) 
					{
						PlaceOrder_tws1(1,TRUE);  // send stop order 1 through
						//  record book size at stop price
						if (mlDOM != NULL)	// DOM must exist
						{					// Code for TWS1 only
							CString strBS;
							if (order[1][0].action == "SELL") // SELL STOP (LONG POSITION)
							{	
								for (int i=0;i<10;i++)
									if (order[1][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
										m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
							}
							else
							{
								for (int i=0;i<10;i++)
									if (order[1][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
										m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][0];
							}
							strBS.Format(_T("Book Size at time of entry: %i"),m_nStopBookSize1);
						}
					}		
					if (mlSLExits)
					{	// update new stop on modeless SLExits dialog
						CString str;
						str.Format(_T("%.2f"),order[1][0].auxPrice);
						mlSLExits->m_edtStpLoss.SetWindowText(str);
					}
				} // end if id = 0
				else
				{	// modify stop order 1
					if (filled > order[1][0].totalQuantity * m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0] * m_nOrdSizeMult)	
							order[1][0].totalQuantity = filled;
						else							
							order[1][0].totalQuantity = m_nNumShares[0] * m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
						{
							m_tws1.placeOrder(
								m_lLastStopOrderId1_tws1, // last stop order id
								order[1][0].action,
								order[1][0].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[1][0].orderType,
								order[1][0].lmtPrice,
								order[1][0].auxPrice,
								FA[0].faGoodAfterTime,
								FA[0].faGroup,
								FA[0].faMethod,
								FA[0].faPercentage,
								FA[0].faProfile,
								FA[0].faGoodTillDate);
							if (mlDOM != NULL)
							{	// update book size record for stop order	(TWS1 only)
								CString strBS;
								if (order[1][0].action == "SELL") // SELL STOP (LONG POSITION)
								{	
									for (int i=0;i<10;i++)
										if (order[1][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0]; // bid booksize
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[1][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][4]; // ask booksize 
								}
								strBS.Format(_T("Book Size at time of update: %i"),m_nStopBookSize1);
							}
						}
						AddStatusLine("TWS1: Stop Order1 updated", statInfo);
					}
				}
			} // end if use stop
			
			if (m_bUseLimit)
			{
				if (m_lLastLimitOrderId1_tws1 == 0) // no limit order already in the market
				{	// Place limit target if not done already (Id = 0)
					strId.Format(_T("%i"),m_lLastOrderId_tws1);
					order[4][0].ocaGroup = "SL" + strId + "_1";
					m_tws1.SetOca( order[4][0].ocaGroup); // same OCA group as the attached stop order
					if (m_bVerbose)
						AddStatusLine("TWS1 Limit OCA Group1: " + order[4][0].ocaGroup, statInfo);
					if (order[0][0].action == "BUY")
					{
						order[4][0].action = "SELL";
						order[4][0].lmtPrice = avgFillPrice + m_dNumLmtPts[0];
					}
					else
					{
						order[4][0].action = "BUY";
						order[4][0].lmtPrice = avgFillPrice - m_dNumLmtPts[0];
					}
					order[4][0].orderType = "LMT";
					order[4][0].auxPrice = 0.0;
					// check order size for each OCA group
					if (filled < m_nNumShares[0]*m_nOrdSizeMult)	
							order[4][0].totalQuantity = filled;
					else	order[4][0].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;

					if (order[4][0].totalQuantity > 0 && m_dNumLmtPts[0] > 0) 
					{
						PlaceOrder_tws1(4,TRUE);	// send limit order 1 through
						//  record book size at lmt1 price
						if (mlDOM != NULL)			// TWS1 only
						{
							CString strBS;
							if (order[4][0].action == "SELL") // SELL LIMIT1 (FROM LONG POSITION)
							{
								for (int i=0;i<10;i++)
									if (order[4][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
										m_nLmt1BookSize1 = (long)mlDOM->m_dArrMD[9-i][4]; // ask booksize
							}
							else
							{
								for (int i=0;i<10;i++)
									if (order[4][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
										m_nLmt1BookSize1 = (long)mlDOM->m_dArrMD[11+i][0]; // bid booksize
							}
							strBS.Format(_T("Book Size at time of entry: %i"),m_nLmt1BookSize1);
						}
					}
					if (mlSLExits)
					{	// update Limit price on SLExits dialog
						CString str;
						str.Format(_T("%.2f"),order[4][0].lmtPrice);
						mlSLExits->m_edtLmtTarget.SetWindowText(str);
					}
				} // end id = 0 
				else
				{	// modify limit order 1
					if (filled > order[4][0].totalQuantity * m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0] * m_nOrdSizeMult)	
							order[4][0].totalQuantity = filled;
						else							
							order[4][0].totalQuantity = m_nNumShares[0] * m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
						{
							m_tws1.placeOrder(
								m_lLastLimitOrderId1_tws1, // last limit order id
								order[4][0].action,
								order[4][0].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[4][0].orderType,
								order[4][0].lmtPrice,
								order[4][0].auxPrice,
								FA[0].faGoodAfterTime,
								FA[0].faGroup,
								FA[0].faMethod,
								FA[0].faPercentage,
								FA[0].faProfile,
								FA[0].faGoodTillDate);
							if (mlDOM != NULL)
							{	// update book size record for lmt1 order
								CString strBS;
								if (order[4][0].action == "SELL") // MODIFY SELL LIMIT (FROM LONG)
								{	
									for (int i=0;i<10;i++)
										if (order[4][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nLmt1BookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[4][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nLmt1BookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
								}
							strBS.Format(_T("Book Size at time of update: %i"),m_nLmt1BookSize1);
							}
						}
						AddStatusLine("TWS1: Stop Order1 updated", statInfo);
					}
				}
			} // end if use limits
			// end OCA 1
			// start OCA 2
			if (m_bFractExits)
			{
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId2_tws1 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws1);
						order[2][0].ocaGroup = "SL" + strId + "_2";	// entry id
						m_tws1.SetOca( order[2][0].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS1 Stop OCA Group2: " + order[2][0].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)	order[2][0].orderType = "TRAIL";
						else			order[2][0].orderType = "STP";
						order[2][0].lmtPrice = 0.0;
						if (order[0][0].totalQuantity != filled)
						{
							CString strPartFill;
							strPartFill.Format(_T("TWS1: Caution! Filled: %i, Remaining:%i"), filled, remaining);
							AddStatusLine(strPartFill, statWarn);
						}
						// set stop price (same for the 3 OCA groups here)
						if (order[0][0].action == "BUY")	
						{
							order[2][0].action = "SELL";
							m_dOriginalStopPrice1 = avgFillPrice - m_dNumStpPts;
							order[2][0].auxPrice = m_dOriginalStopPrice1;
						}
						else
						{
							order[2][0].action = "BUY";
							m_dOriginalStopPrice1 = avgFillPrice + m_dNumStpPts;
							order[2][0].auxPrice = m_dOriginalStopPrice1;
						}
						// check order size for each OCA group
						if (filled <= m_nNumShares[0] * m_nOrdSizeMult)
							order[2][0].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0] * m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1]) * m_nOrdSizeMult))
									order[2][0].totalQuantity = filled - m_nNumShares[0] * m_nOrdSizeMult;
							else	order[2][0].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;

						if (order[2][0].totalQuantity > 0 && m_dNumStpPts > 0)
						{
							PlaceOrder_tws1(2,TRUE);  // send stop order(s) through
							//  record book size at stop price
							if (mlDOM != NULL)
							{
								CString strBS;
								if (order[2][0].action == "SELL")
								{	// m_nStopBookSize1 : same as for OCA 1
									for (int i=0;i<10;i++)
										if (order[2][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[2][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
								}
								strBS.Format(_T("Book Size at time of entry: %i"),m_nStopBookSize1);
							}
						}
		
						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format("%.2f",order[2][0].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
					} // end if id = 0 (stop order is now set)
					else
					{	// modify stop order 2
						if (filled > order[2][0].totalQuantity + m_nNumShares[0]*m_nOrdSizeMult)
						{	// calc qty for stop order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[2][0].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[2][0].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
							{
								m_tws1.placeOrder(
									m_lLastStopOrderId1_tws1, // last stop order id
									order[2][0].action,
									order[2][0].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[1][0].orderType,
									order[1][0].lmtPrice,
									order[1][0].auxPrice,
									FA[0].faGoodAfterTime,
									FA[0].faGroup,
									FA[0].faMethod,
									FA[0].faPercentage,
									FA[0].faProfile,
									FA[0].faGoodTillDate);
								if (mlDOM != NULL)
								{	// update book size record for stop order
									CString strBS;
									if (order[2][0].action == "SELL")
									{	
										for (int i=0;i<10;i++)
											if (order[2][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
												m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
									}
									else
									{
										for (int i=0;i<10;i++)
											if (order[2][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
												m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
									}
									strBS.Format(_T("Book Size at time of update: %i"),m_nStopBookSize1);
								}
							}
							AddStatusLine("TWS1: Stop Order2 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId2_tws1 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws1);
						order[5][0].ocaGroup = "SL" + strId + "_2";
						m_tws1.SetOca( order[5][0].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS1 Limit OCA Group2: " + order[5][0].ocaGroup, statInfo);
						if (order[0][0].action == "BUY")
						{
							order[5][0].action = "SELL";
							order[5][0].lmtPrice = avgFillPrice + m_dNumLmtPts[1];
						}
						else
						{
							order[5][0].action = "BUY";
							order[5][0].lmtPrice = avgFillPrice - m_dNumLmtPts[1];
						}
						order[5][0].orderType = "LMT";
						order[5][0].auxPrice = 0.0;

						// check order size for each OCA group
						if (filled <= m_nNumShares[0]*m_nOrdSizeMult)
							order[2][0].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0]*m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult))
									order[5][0].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][0].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
						if	(order[5][0].totalQuantity > 0 && m_dNumLmtPts[1] > 0) 
						{
							PlaceOrder_tws1(5,TRUE);  // send limit order(s) through
							//  record book size at stop price
							if (mlDOM != NULL)
							{
								CString strBS;
								if (order[5][0].action == "SELL")// SELL LIMIT2 (FROM LONG POSITION)
								{	
									for (int i=0;i<10;i++)
										if (order[5][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nLmt2BookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[5][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nLmt2BookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
								}
								strBS.Format(_T("Book Size at time of entry: %i"),m_nLmt2BookSize1);
							}
						}
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[5][0].lmtPrice);
							mlSLExits->m_edtLmtTarget2.SetWindowText(str);
						}
					} // end id = 0 
					else
					{	// modify limit 2
						if (filled > order[5][0].totalQuantity + m_nNumShares[0]*m_nOrdSizeMult)
						{	// calc qty for limit order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[5][0].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][0].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
							{
								m_tws1.placeOrder(
									m_lLastLimitOrderId1_tws1, // last stop order id
									order[5][0].action,
									order[5][0].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[5][0].orderType,
									order[5][0].lmtPrice,
									order[5][0].auxPrice,
									FA[0].faGoodAfterTime,
									FA[0].faGroup,
									FA[0].faMethod,
									FA[0].faPercentage,
									FA[0].faProfile,
									FA[0].faGoodTillDate);
								if (mlDOM != NULL)
								{	// update book size record for stop order
									CString strBS;
									if (order[5][0].action == "SELL")// MODIFY SELL LIMIT2 (FROM LONG)
									{	
										for (int i=0;i<10;i++)
											if (order[5][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
												m_nLmt2BookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
									}
									else
									{
										for (int i=0;i<10;i++)
											if (order[5][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
												m_nLmt2BookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
									}
									strBS.Format(_T("Book Size at time of update: %i"),m_nLmt2BookSize1);
								}
							}
							AddStatusLine("TWS1: Limit Order2 updated", statInfo);						
						}
					}
				} // end if use limits

				// OCA 3
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId3_tws1 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws1);
						order[3][0].ocaGroup = "SL" + strId + "_3";	// entry id
						m_tws1.SetOca( order[3][0].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS1 OCA Group3: " + order[3][0].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)
							order[3][0].orderType = "TRAIL";
						else
							order[3][0].orderType = "STP";
						order[3][0].lmtPrice = 0.0;

						// set stop price (same for the 3 OCA groups here)
						if (order[0][0].action == "BUY")	
						{
							order[3][0].action = "SELL";
							m_dOriginalStopPrice1 = avgFillPrice - m_dNumStpPts;
							order[3][0].auxPrice = m_dOriginalStopPrice1;
						}
						else
						{
							order[3][0].action = "BUY";
							m_dOriginalStopPrice1 = avgFillPrice + m_dNumStpPts;
							order[3][0].auxPrice = m_dOriginalStopPrice1;
						}
						
						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[3][0].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[3][0].totalQuantity = 0;

						if (order[3][0].totalQuantity > 0 && m_dNumStpPts > 0) 
						{
							PlaceOrder_tws1(3,TRUE);  // send stop order(s) through
							//  record book size at stop price
							if (mlDOM != NULL)
							{
								CString strBS;
								if (order[3][0].action == "SELL") // SELL STOP3 (LONG POSITION) 
								{	// m_nStopBookSize1 : same as for OCA 1
									for (int i=0;i<10;i++)
										if (order[3][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[3][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
								}
								strBS.Format(_T("Book Size at time of entry: %i"),m_nStopBookSize1);
							}
						}

						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format("%.2f",order[3][0].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
						
					} // end if id = 0
					else
					{	// modify stop 3
						if (filled > order[3][0].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[3][0].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
							{
								m_tws1.placeOrder(
									m_lLastStopOrderId3_tws1, // last stop order id
									order[3][0].action,
									order[3][0].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[3][0].orderType,
									order[3][0].lmtPrice,
									order[3][0].auxPrice,
									FA[0].faGoodAfterTime,
									FA[0].faGroup,
									FA[0].faMethod,
									FA[0].faPercentage,
									FA[0].faProfile,
									FA[0].faGoodTillDate);
								if (mlDOM != NULL)
								{	// update book size record for stop order
									CString strBS;
									if (order[3][0].action == "SELL")
									{	
										for (int i=0;i<10;i++)
											if (order[3][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
												m_nStopBookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
									}
									else
									{
										for (int i=0;i<10;i++)
											if (order[3][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
												m_nStopBookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
									}
									strBS.Format(_T("Book Size at time of update: %i"),m_nStopBookSize1);
								}
							}
							AddStatusLine("TWS1: Stop Order3 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId3_tws1 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws1);
						order[6][0].ocaGroup = "SL" + strId + "_3";
						m_tws1.SetOca( order[6][0].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS1 Limit OCA Group3: " + order[6][0].ocaGroup, statInfo);
						if (order[0][0].action == "BUY")
						{
							order[6][0].action = "SELL";
							order[6][0].lmtPrice = avgFillPrice + m_dNumLmtPts[2];
						}
						else
						{
							order[6][0].action = "BUY";
							order[6][0].lmtPrice = avgFillPrice - m_dNumLmtPts[2];
						}
						order[6][0].orderType = "LMT";
						order[6][0].auxPrice = 0.0;

						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[6][0].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[6][0].totalQuantity = 0;
						if (order[6][0].totalQuantity > 0 && m_dNumLmtPts[2] > 0) 
						{
							PlaceOrder_tws1(6,TRUE);  // send limit order(s) through
							//  record book size at stop price
							if (mlDOM != NULL)
							{
								CString strBS;
								if (order[6][0].action == "SELL")// SELL LIMIT3 (FROM LONG POSITION)
								{	
									for (int i=0;i<10;i++)
										if (order[6][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
											m_nLmt3BookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
								}
								else
								{
									for (int i=0;i<10;i++)
										if (order[5][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
											m_nLmt3BookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
								}
							strBS.Format(_T("Book Size at time of entry: %i"),m_nLmt3BookSize1);
							}
						}
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[6][0].lmtPrice);
							mlSLExits->m_edtLmtTarget3.SetWindowText(str);
						}
					} // end id = 0
					else
					{	// modify limit 3
						if (filled > order[6][0].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[6][0].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
							{
								m_tws1.placeOrder(
									m_lLastLimitOrderId3_tws1, // last limit order id
									order[6][0].action,
									order[6][0].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[6][0].orderType,
									order[6][0].lmtPrice,
									order[6][0].auxPrice,
									FA[0].faGoodAfterTime,
									FA[0].faGroup,
									FA[0].faMethod,
									FA[0].faPercentage,
									FA[0].faProfile,
									FA[0].faGoodTillDate);
								if (mlDOM != NULL)
								{	// update book size record for stop order
									CString strBS;
									if (order[6][0].action == "SELL") // SELL LIMIT (FROM LONG)
									{	
										for (int i=0;i<10;i++)
											if (order[6][0].auxPrice == mlDOM->m_dArrMD[9-i][2])
												m_nLmt3BookSize1 = (long)mlDOM->m_dArrMD[9-i][4];
									}
									else
									{
										for (int i=0;i<10;i++)
											if (order[6][0].auxPrice == mlDOM->m_dArrMD[11+i][2])
												m_nLmt3BookSize1 = (long)mlDOM->m_dArrMD[11+i][0];
									}
								strBS.Format(_T("Book Size at time of update: %i"),m_nLmt3BookSize1);
								}
							}
							AddStatusLine("TWS1: Limit Order3 updated", statInfo);
						}
					}
				} // end if use limits
			} // end if FractExits (skip OCA 2 and OCA 3)
		} // end attach stops & limits
		else
		{	// no need to place an updated order, it is already in the book
		}

		// EXITS
		// all cover orders now in place
		// the following code takes care of stop/limit hits
		// stop exits
		if ((m_lLastStopOrderId1_tws1 == id) && (lastFillPrice > 0))
		{	// stop has been hit (bEntry is still TRUE)
			m_lLastStopOrderId1_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			m_nStopBookSize1 = 0;	// reset book size record for stop order
			m_nStopVolCount1 = 0;	// reset count
			strLog += " (STOP LOSS EXIT 1)";
			m_bLastEntrySig = FALSE;
			m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastStopOrderId1_tws1",0);
			m_Reg.WriteFloat("OrigStopPrice_tws1",0.0);
			if (m_lLastLimitOrderId1_tws1 != 0) // will be cancelled (same OCA group)
			{	// reset limit order 1
				m_lLastLimitOrderId1_tws1 = 0;
				m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
		}
		if ((m_lLastStopOrderId2_tws1 == id) && (lastFillPrice > 0))
		{	// stop has been hit (bEntry is still TRUE)
			m_lLastStopOrderId2_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			strLog += " (STOP LOSS EXIT 2)";
			m_bLastEntrySig = FALSE;
			m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastStopOrderId2_tws1",0);
			m_Reg.WriteFloat("OrigStopPrice_tws1",0.0);
			if (m_lLastLimitOrderId2_tws1 != 0) 
			{
				m_lLastLimitOrderId2_tws1 = 0;
				m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
		}
		if ((m_lLastStopOrderId3_tws1 == id) && (lastFillPrice > 0))
		{	// stop has been hit (bEntry is still TRUE)
			m_lLastStopOrderId3_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			strLog += " (STOP LOSS EXIT 3)";
			m_bLastEntrySig = FALSE;
			m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastStopOrderId3_tws1",0);
			m_Reg.WriteFloat("OrigStopPrice_tws1",0.0);
			if (m_lLastLimitOrderId3_tws1 != 0) 
			{
				m_lLastLimitOrderId3_tws1 = 0;
				m_Reg.WriteDword("LastLimitOrderId3_tws1",0);
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
		}
		// limit exits
		if ((m_lLastLimitOrderId1_tws1 == id) && (lastFillPrice > 0))
		{	// limit has been hit
			m_lLastLimitOrderId1_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			m_nLmt1BookSize1 = 0; // reset book size record for lmt2 order
			m_nLmt1VolCount1 = 0;
			strLog += " (LIMIT TARGET EXIT 1)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
			if (m_lLastStopOrderId1_tws1 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId1_tws1",0);
				m_lLastStopOrderId1_tws1 = 0;
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget();
			}
		}	

		if ((m_lLastLimitOrderId2_tws1 == id) && (lastFillPrice > 0))
		{	// limit has been hit
			m_lLastLimitOrderId2_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			m_nLmt2BookSize1 = 0; // reset book size record for lmt2 order
			m_nLmt2VolCount1 = 0;
			strLog += " (LIMIT TARGET EXIT 2)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
			if (m_lLastStopOrderId2_tws1 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId2_tws1",0);
				m_lLastStopOrderId2_tws1 = 0;
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget2.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget2();
			}
		}

		if ((m_lLastLimitOrderId3_tws1 == id) && (lastFillPrice > 0))
		{	// limit has been hit
			m_lLastLimitOrderId3_tws1 = 0;
			m_lLastOrderId_tws1 = 0;
			m_nLmt3BookSize1 = 0; // reset book size record for lmt3 order
			m_nLmt3VolCount1 = 0;
			strLog += " (LIMIT TARGET EXIT 3)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws1",0);
			
			if (m_lLastStopOrderId3_tws1 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId3_tws1",0);
				m_lLastStopOrderId3_tws1 = 0;
				if (order[0][0].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget3.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget3();
			}
		}
	}
	else // normal exit (order exit button)
	{
		strLog += " (EXIT SIGNAL)";
		if (m_lLastOrderId_tws1 == 0)	// reset to 0 on exit in PlaceOrder
		{
			if (remaining == 0)
			{
				CancelAttachedOrders_tws1();
			}
			else
			{
				// modify orders
			}

			/*
			if (remaining == 0)
			{
				if (m_lLastStopOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastStopOrderId1",0);
					m_lLastStopOrderId1_tws1 = 0;
				}
				if (m_lLastLimitOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastLimitOrderId1",0);
					m_lLastLimitOrderId1_tws1 = 0;
				}
			}
			*/

			m_Reg.WriteFloat("OrigStopPrice_tws1",0.0);
			for (int i=0;i<7;i++)	order[i][0].ocaGroup = "";
		}
	}
	AddToLog(strLog);			//
	//ReqIBPosition(1);   // get acct update
}


void CClient3Dlg::OnorderStatusTwsctrl2(long id, LPCTSTR status, long filled, long remaining, 
    double avgFillPrice, long permId, long parentId, double lastFillPrice, long clientId) 
{// Order Status (list2)
	CString str, strId, strLog = "Status - ";
	CString space = " ";
	strId.Format(_T("%i"),id);						// order id
	strLog += "Tws2:" + strId + space;
	ListOpenOrder2.SetItemText(1,1,strId);		// display Order Id
	strLog += status;
	ListOpenOrder2.SetItemText(1,2,status);		// display status
	m_nNumFilled2 = filled;  // used in ticker (trailing stop)
    str.Format(_T("%i"),filled);					
	strLog += " Filled:";
	strLog += str;
	ListOpenOrder2.SetItemText(1,3,str);		// display num filled
	str.Format(_T("%i"),remaining);
	strLog += " Remaining:";
	strLog += str;
	ListOpenOrder2.SetItemText(1,4,str);		// display remaining
	str.Format(_T("%.2f"),lastFillPrice);
	strLog += " LastFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(1,5,str);		// display fill price
	str.Format(_T("%.2f"),avgFillPrice);
	if (avgFillPrice > 0) m_dAvgFillPrice2 = avgFillPrice;
	strLog += " AvgFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(1,6,str);		// display avg fill price

	if (m_bVerbose)	AddToLog(strLog);	

	if (status == "Filled")						// log to TradeLog
	{
		CString str;
		str.Format(_T("TWS2 OrdId:%i Filled:%i Price:%.3f Remaining:%i"),id, filled,lastFillPrice,remaining);
		AddToTradeLog(str);
	}

	if (m_bLastEntrySig == TRUE)
	{	// last signal was an entry, so place stop & limit orders (up to 3 groups) if so required
		if ((m_lLastOrderId_tws2 == id) && (lastFillPrice > 0))	// not to be executed if no fill
		{	// for some odd reason, event may fire a first message with Fill Price = 0 upon actual fill...
			if ((m_bAutoReturnToMKT == TRUE) && (m_lNumIB == 2) && (m_bTwsChecked1[1] == TRUE))	
			{	// reset order type to MKT
				if (m_bVerbose && order[0][1].orderType != "MKT") 
					AddStatusLine("TWS2: Order Type reset to MKT", statInfo);
				m_cbbOrdType.SetCurSel(0);  // reset order type
			}

			if (order[0][1].orderType != "MKT" && mlSLEntry != NULL)
			{	// if entry adjust dialog was there, close it now
				mlSLEntry->DestroyWindow();
				mlSLEntry = NULL;
			}

			if (order[0][1].totalQuantity != filled)
			{	// stop/lmt entry may not be fully filled
				CString strPartFill;
				strPartFill.Format(_T("TWS2: Caution! Filled: %i, Remaining:%i"), filled, remaining);
				AddStatusLine(strPartFill, statWarn);
			}
			
			// OCA 1
			if (m_bUseStop)  // protect entry with a stop loss order
			{	// if no stop, OCA group becomes irrelevant
				if (m_lLastStopOrderId1_tws2 == 0) // first time stop is set
				{	// Place stop loss
					strId.Format(_T("%i"),m_lLastOrderId_tws2);
					order[1][1].ocaGroup = "SL" + strId + "_1";	// entry id + group1
					m_tws2.SetOca(order[1][1].ocaGroup);
					if (m_bVerbose)
						AddStatusLine("TWS2 Stop OCA Group1: " + order[1][1].ocaGroup, statInfo);
					strLog += " (ENTRY)";
					if (m_bTrail)	order[1][1].orderType = "TRAIL";
					else			order[1][1].orderType = "STP";
					order[1][1].lmtPrice = 0.0;
					// set stop price (same for the 3 OCA groups here)
					if (order[0][1].action == "BUY")	
					{
						order[1][1].action = "SELL";
						m_dOriginalStopPrice2 = avgFillPrice - m_dNumStpPts;
						order[1][1].auxPrice = m_dOriginalStopPrice2;
					}
					else
					{
						order[1][1].action = "BUY";
						m_dOriginalStopPrice2 = avgFillPrice + m_dNumStpPts;
						order[1][1].auxPrice = m_dOriginalStopPrice2;
					}
					// check order size for each OCA group
					if (filled < m_nNumShares[0]*m_nOrdSizeMult)
							order[1][1].totalQuantity = filled;
					else	order[1][1].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;

					m_Reg.WriteFloat("OrigStopPrice1_tws2", m_dOriginalStopPrice2);

					if (order[1][1].totalQuantity > 0 && m_dNumStpPts > 0) 
					{
						PlaceOrder_tws2(1,TRUE);  // send stop order through
					}
					//if (mlSLExits)
					//{	// update new stop on modeless SLExits dialog
					//	CString str;
					//	str.Format("%.2f",order[1][1].auxPrice);
					//	mlSLExits->m_edtStpLoss.SetWindowText(str);
					//}
					
				} // end if id = 0
				else
				{	// modify stop order 1
					if (filled > order[1][1].totalQuantity * m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0] * m_nOrdSizeMult)	
							order[1][1].totalQuantity = filled;
						else							
							order[1][1].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
						{
							m_tws2.placeOrder(
								m_lLastStopOrderId1_tws2, // last stop order id
								order[1][1].action,
								order[1][1].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[1][1].orderType,
								order[1][1].lmtPrice,
								order[1][1].auxPrice,
								FA[1].faGoodAfterTime,
								FA[1].faGroup,
								FA[1].faMethod,
								FA[1].faPercentage,
								FA[1].faProfile,
								FA[1].faGoodTillDate);
						}
						AddStatusLine("TWS2: Stop Order1 updated", statInfo);
					}
				}
			} // end if use stop
			
			if (m_bUseLimit)
			{
				if (m_lLastLimitOrderId1_tws2 == 0) // no limit order already in the market
				{	// Place limit target if not done already (Id = 0)
					strId.Format(_T("%i"),m_lLastOrderId_tws2);
					order[4][1].ocaGroup = "SL" + strId + "_1";
					m_tws2.SetOca( order[4][1].ocaGroup); // same OCA group as the attached stop order
					if (m_bVerbose)
						AddStatusLine("TWS2 Limit OCA Group1: " + order[4][1].ocaGroup, statInfo);
					if (order[0][1].action == "BUY")
					{
						order[4][1].action = "SELL";
						order[4][1].lmtPrice = avgFillPrice + m_dNumLmtPts[0];
					}
					else
					{
						order[4][1].action = "BUY";
						order[4][1].lmtPrice = avgFillPrice - m_dNumLmtPts[0];
					}
					order[4][1].orderType = "LMT";
					order[4][1].auxPrice = 0.0;
					// check order size for each OCA group
					if (filled < m_nNumShares[0]*m_nOrdSizeMult)	
							order[4][1].totalQuantity = filled;
					else	order[4][1].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;

					if (order[4][1].totalQuantity > 0 && m_dNumLmtPts[0] > 0) 
						PlaceOrder_tws2(4,TRUE);  // send limit order 1 through
					
					if (mlSLExits)
					{
						CString str;
						str.Format(_T("%.2f"),order[4][1].lmtPrice);
						mlSLExits->m_edtLmtTarget.SetWindowText(str);
					}
				} // end id = 0 
				else
				{	// modify limit order 1
					if (filled > order[4][1].totalQuantity * m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0] * m_nOrdSizeMult)	
							order[4][1].totalQuantity = filled;
						else							
							order[4][1].totalQuantity = m_nNumShares[0] * m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
							m_tws2.placeOrder(
								m_lLastLimitOrderId1_tws2, // last limit order id
								order[4][1].action,
								order[4][1].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[4][1].orderType,
								order[4][1].lmtPrice,
								order[4][1].auxPrice,
								FA[1].faGoodAfterTime,
								FA[1].faGroup,
								FA[1].faMethod,
								FA[1].faPercentage,
								FA[1].faProfile,
								FA[1].faGoodTillDate);
						AddStatusLine("TWS2: Stop Order1 updated", statInfo);
					}
				}
			} // end if use limits
			// end OCA 1
			// start OCA 2
			if (m_bFractExits)
			{
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId2_tws2 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws2);
						order[2][1].ocaGroup = "SL" + strId + "_2";	// entry id
						m_tws2.SetOca( order[2][1].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS2 Stop OCA Group2: " + order[2][1].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)	order[2][1].orderType = "TRAIL";
						else			order[2][1].orderType = "STP";
						order[2][1].lmtPrice = 0.0;
						if (order[0][1].totalQuantity != filled)
						{
							CString strPartFill;
							strPartFill.Format(_T("TWS2: Caution! Filled: %i, Remaining:%i"), filled, remaining);
							AddStatusLine(strPartFill, statWarn);
						}
						// set stop price (same for the 3 OCA groups here)
						if (order[0][1].action == "BUY")	
						{
							order[2][1].action = "SELL";
							m_dOriginalStopPrice2 = avgFillPrice - m_dNumStpPts;
							order[2][1].auxPrice = m_dOriginalStopPrice2;
						}
						else
						{
							order[2][1].action = "BUY";
							m_dOriginalStopPrice2 = avgFillPrice + m_dNumStpPts;
							order[2][1].auxPrice = m_dOriginalStopPrice2;
						}
						// check order size for each OCA group
						if (filled <= m_nNumShares[0] * m_nOrdSizeMult)
							order[2][1].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0] * m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1]) * m_nOrdSizeMult))
									order[2][1].totalQuantity = filled - m_nNumShares[0] * m_nOrdSizeMult;
							else	order[2][1].totalQuantity = m_nNumShares[1] * m_nOrdSizeMult;

						if (order[2][1].totalQuantity > 0 && m_dNumStpPts > 0) 
							PlaceOrder_tws2(2,TRUE);  // send stop order(s) through
		
						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format(_T("%.2f"),order[2][1].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
					} // end if id = 0 (stop order is now set)
					else
					{	// modify stop order 2
						if (filled > order[2][1].totalQuantity + m_nNumShares[0] * m_nOrdSizeMult)
						{	// calc qty for stop order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[2][1].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[2][1].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws2.placeOrder(
									m_lLastStopOrderId1_tws2, // last stop order id
									order[1][1].action,
									order[1][1].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[1][1].orderType,
									order[1][1].lmtPrice,
									order[1][1].auxPrice,
									FA[1].faGoodAfterTime,
									FA[1].faGroup,
									FA[1].faMethod,
									FA[1].faPercentage,
									FA[1].faProfile,
									FA[1].faGoodTillDate);
							AddStatusLine("TWS2: Stop Order2 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId2_tws2 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws2);
						order[5][1].ocaGroup = "SL" + strId + "_2";
						m_tws2.SetOca( order[5][1].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS2 Limit OCA Group2: " + order[5][1].ocaGroup, statInfo);
						if (order[0][1].action == "BUY")
						{
							order[5][1].action = "SELL";
							order[5][1].lmtPrice = avgFillPrice + m_dNumLmtPts[1];
						}
						else
						{
							order[5][1].action = "BUY";
							order[5][1].lmtPrice = avgFillPrice - m_dNumLmtPts[1];
						}
						order[5][1].orderType = "LMT";
						order[5][1].auxPrice = 0.0;

						// check order size for each OCA group
						if (filled <= m_nNumShares[0]*m_nOrdSizeMult)
							order[2][1].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0]*m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult))
									order[5][1].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][1].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
						
						if	(order[5][1].totalQuantity > 0 && m_dNumLmtPts[1] > 0) 
							PlaceOrder_tws2(5,TRUE);  // send limit order(s) through
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[5][1].lmtPrice);
							mlSLExits->m_edtLmtTarget2.SetWindowText(str);
						}
					} // end id = 0 
					else
					{	// modify limit 2
						if (filled > order[5][1].totalQuantity + m_nNumShares[0]*m_nOrdSizeMult)
						{	// calc qty for limit order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[5][1].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][1].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws2.placeOrder(
									m_lLastLimitOrderId1_tws2, // last stop order id
									order[5][1].action,
									order[5][1].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[5][1].orderType,
									order[5][1].lmtPrice,
									order[5][1].auxPrice,
									FA[1].faGoodAfterTime,
									FA[1].faGroup,
									FA[1].faMethod,
									FA[1].faPercentage,
									FA[1].faProfile,
									FA[1].faGoodTillDate);
							AddStatusLine("TWS2: Limit Order2 updated", statInfo);						
						}
					}
				} // end if use limits

				// OCA 3
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId3_tws2 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws2);
						order[3][1].ocaGroup = "SL" + strId + "_3";	// entry id
						m_tws2.SetOca( order[3][1].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS2 OCA Group3: " + order[3][1].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)
							order[3][1].orderType = "TRAIL";
						else
							order[3][1].orderType = "STP";
						order[3][1].lmtPrice = 0.0;

						// set stop price (same for the 3 OCA groups here)
						if (order[0][1].action == "BUY")	
						{
							order[3][1].action = "SELL";
							m_dOriginalStopPrice2 = avgFillPrice - m_dNumStpPts;
							order[3][1].auxPrice = m_dOriginalStopPrice2;
						}
						else
						{
							order[3][1].action = "BUY";
							m_dOriginalStopPrice2 = avgFillPrice + m_dNumStpPts;
							order[3][1].auxPrice = m_dOriginalStopPrice2;
						}
						
						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[3][1].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[3][1].totalQuantity = 0;

						if (order[3][1].totalQuantity > 0 && m_dNumStpPts > 0) 
							PlaceOrder_tws2(3,TRUE);  // send stop order(s) through

						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format(_T("%.2f"),order[3][1].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
						
					} // end if id = 0
					else
					{	// modify stop 3
						if (filled > order[3][1].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[3][1].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws2.placeOrder(
									m_lLastStopOrderId3_tws2, // last stop order id
									order[3][1].action,
									order[3][1].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[3][1].orderType,
									order[3][1].lmtPrice,
									order[3][1].auxPrice,
									FA[1].faGoodAfterTime,
									FA[1].faGroup,
									FA[1].faMethod,
									FA[1].faPercentage,
									FA[1].faProfile,
									FA[1].faGoodTillDate);
							AddStatusLine("TWS2: Stop Order3 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId3_tws2 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws2);
						order[6][1].ocaGroup = "SL" + strId + "_3";
						m_tws2.SetOca( order[6][1].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS2 Limit OCA Group3: " + order[6][1].ocaGroup, statInfo);
						if (order[0][1].action == "BUY")
						{
							order[6][1].action = "SELL";
							order[6][1].lmtPrice = avgFillPrice + m_dNumLmtPts[2];
						}
						else
						{
							order[6][1].action = "BUY";
							order[6][1].lmtPrice = avgFillPrice - m_dNumLmtPts[2];
						}
						order[6][1].orderType = "LMT";
						order[6][1].auxPrice = 0.0;

						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[6][1].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[6][1].totalQuantity = 0;
						
						if (order[6][1].totalQuantity > 0 && m_dNumLmtPts[2] > 0) 
							PlaceOrder_tws2(6,TRUE);  // send limit order(s) through
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[6][1].lmtPrice);
							mlSLExits->m_edtLmtTarget3.SetWindowText(str);
						}
					} // end id = 0
					else
					{	// modify limit 3
						if (filled > order[6][1].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[6][1].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws2.placeOrder(
									m_lLastLimitOrderId3_tws2, // last limit order id
									order[6][1].action,
									order[6][1].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[6][1].orderType,
									order[6][1].lmtPrice,
									order[6][1].auxPrice,
									FA[1].faGoodAfterTime,
									FA[1].faGroup,
									FA[1].faMethod,
									FA[1].faPercentage,
									FA[1].faProfile,
									FA[1].faGoodTillDate);
							AddStatusLine("TWS2: Limit Order3 updated", statInfo);
						}
					}
				} // end if use limits
			} // end if FractExits (skip OCA 2 and OCA 3)
		} // end attach stops & limits
		else
		{	// no need to place an updated order, it is already in the book
//			if (!bTotalFill)
//				if (filled == order[0][0].totalQuantity
//					bTotalFill = filled;
		}

		/// stop exits
		if ((m_lLastStopOrderId1_tws2 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId1_tws2 = 0;
				m_lLastOrderId_tws2 = 0;
				strLog += " (STOP LOSS EXIT 1)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws2",0);
				m_Reg.WriteDword("LastStopOrderId1_tws2",0);
				m_Reg.WriteFloat("OrigStopPrice_tws2",0.0);
				if (m_lLastLimitOrderId1_tws2 != 0) // will be cancelled (same OCA group)
				{	// reset limit order 1
					m_lLastLimitOrderId1_tws2 = 0;
					m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
					if (order[0][1].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		if ((m_lLastStopOrderId2_tws2 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId2_tws2 = 0;
				m_lLastOrderId_tws2 = 0;
				strLog += " (STOP LOSS EXIT 2)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws2",0);
				m_Reg.WriteDword("LastStopOrderId2_tws2",0);
				m_Reg.WriteFloat("OrigStopPrice_tws2",0.0);
				if (m_lLastLimitOrderId2_tws2 != 0) 
				{
					m_lLastLimitOrderId2_tws2 = 0;
					m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
					if (order[0][1].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		if ((m_lLastStopOrderId3_tws2 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId3_tws2 = 0;
				m_lLastOrderId_tws2 = 0;
				strLog += " (STOP LOSS EXIT 3)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws2",0);
				m_Reg.WriteDword("LastStopOrderId3_tws2",0);
				m_Reg.WriteFloat("OrigStopPrice_tws2",0.0);
				if (m_lLastLimitOrderId3_tws2 != 0) 
				{
					m_lLastLimitOrderId3_tws2 = 0;
					m_Reg.WriteDword("LastLimitOrderId3_tws2",0);
					if (order[0][1].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		// limit exits
		if ((m_lLastLimitOrderId1_tws2 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId1_tws2 = 0;
			m_lLastOrderId_tws2 = 0;
			strLog += " (LIMIT TARGET EXIT 1)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
			if (m_lLastStopOrderId1_tws2 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId1_tws2",0);
				m_lLastStopOrderId1_tws2 = 0;
				if (order[0][1].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget();
			}
		}	

		if ((m_lLastLimitOrderId2_tws2 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId2_tws2 = 0;
			m_lLastOrderId_tws2 = 0;
			strLog += " (LIMIT TARGET EXIT 2)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
			if (m_lLastStopOrderId2_tws2 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId2_tws2",0);
				m_lLastStopOrderId2_tws2 = 0;
				if (order[0][1].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget2.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget2();
			}

		}

		if ((m_lLastLimitOrderId3_tws2 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId3_tws2 = 0;
			m_lLastOrderId_tws2 = 0;
			strLog += " (LIMIT TARGET EXIT 3)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws2",0);
			
			if (m_lLastStopOrderId3_tws2 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId3_tws2",0);
				m_lLastStopOrderId3_tws2 = 0;
				if (order[0][1].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget3.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget3();
			}
		}
	}
	else // normal exit (order exit button)
	{
		strLog += " (EXIT SIGNAL)";
		if (m_lLastOrderId_tws2 == 0)	// reset to 0 on exit in PlaceOrder
		{
			if (remaining == 0)
			{
				CancelAttachedOrders_tws2();
			}
			else
			{
				// modify orders
			}

			/*
			if (remaining == 0)
			{
				if (m_lLastStopOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastStopOrderId1",0);
					m_lLastStopOrderId1_tws1 = 0;
				}
				if (m_lLastLimitOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastLimitOrderId1",0);
					m_lLastLimitOrderId1_tws1 = 0;
				}
			}
			*/

			m_Reg.WriteFloat("OrigStopPrice_tws2",0.0);
			for (int i=0;i<7;i++)	order[i][1].ocaGroup = "";
		}
	}
	AddToLog(strLog);
	//ReqIBPosition(2);  // get acct update
}

void CClient3Dlg::OnorderStatusTwsctrl3(long id, LPCTSTR status, long filled, long remaining, 
    double avgFillPrice, long permId, long parentId, double lastFillPrice, long clientId) 
{// Order Status (list2)
	CString str, strId, strLog = "Status - ";
	CString space = " ";
	strId.Format(_T("%i"),id);						// order id
	strLog += "Tws3:" + strId + space;
	ListOpenOrder2.SetItemText(2,1,strId);		// display Order Id
	strLog += status;
	ListOpenOrder2.SetItemText(2,2,status);		// display status
	m_nNumFilled2 = filled;  // used in ticker (trailing stop)
    str.Format(_T("%i"),filled);					
	strLog += " Filled:";
	strLog += str;
	ListOpenOrder2.SetItemText(2,3,str);		// display num filled
	str.Format(_T("%i"),remaining);
	strLog += " Remaining:";
	strLog += str;
	ListOpenOrder2.SetItemText(2,4,str);		// display remaining
	str.Format(_T("%.2f"),lastFillPrice);
	strLog += " LastFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(2,5,str);		// display fill price
	str.Format(_T("%.2f"),avgFillPrice);
	if (avgFillPrice > 0) m_dAvgFillPrice3 = avgFillPrice;
	strLog += " AvgFill:";
	strLog += str;
	ListOpenOrder2.SetItemText(2,6,str);		// display avg fill price

	if (m_bVerbose)	AddToLog(strLog);	

	if (status == "Filled")						// log to TradeLog
	{
		CString str;
		str.Format(_T("TWS3 OrdId:%i Filled:%i Price:%.3f Remaining:%i"),id, filled,lastFillPrice,remaining);
		AddToTradeLog(str);
	}

	if (m_bLastEntrySig == TRUE)
	{	// last signal was an entry, so place stop & limit orders (up to 3 groups) if so required
		if ((m_lLastOrderId_tws3 == id) && (lastFillPrice > 0))	// not to be executed if no fill
		{	// for some odd reason, event may fire a first message with Fill Price = 0 upon actual fill...
			if ((m_bAutoReturnToMKT == TRUE) && (m_lNumIB == 3) && (m_bTwsChecked1[2] == TRUE))	
			{	// reset order type to MKT
				if (m_bVerbose && order[0][2].orderType != "MKT") 
					AddStatusLine("Order Type reset to MKT", statInfo);
				m_cbbOrdType.SetCurSel(0);  // reset order type
			}

			if (order[0][2].orderType != "MKT" && mlSLEntry != NULL)
			{	// if entry adjust dialog was there, close it now
				mlSLEntry->DestroyWindow();
				mlSLEntry = NULL;
			}

			if (order[0][2].totalQuantity != filled)
			{	// stop/lmt entry may not be fully filled
				CString strPartFill;
				strPartFill.Format(_T("TWS3: Caution! Filled: %i, Remaining:%i"), filled, remaining);
				AddStatusLine(strPartFill, statWarn);
				//bTotalFill = FALSE;
			}
			//else bTotalFill = TRUE;
			
			// OCA 1
			if (m_bUseStop)  // protect entry with a stop loss order
			{	// if no stop, OCA group becomes irrelevant
				if (m_lLastStopOrderId1_tws3 == 0) // first time stop is set
				{	// Place stop loss
					strId.Format(_T("%i"),m_lLastOrderId_tws3);
					order[1][2].ocaGroup = "SL" + strId + "_1";	// entry id + group1
					m_tws3.SetOca(order[1][2].ocaGroup);
					if (m_bVerbose)
						AddStatusLine("TWS3 Stop OCA Group1: " + order[1][2].ocaGroup, statInfo);
					strLog += " (ENTRY)";
					if (m_bTrail)	order[1][2].orderType = "TRAIL";
					else			order[1][2].orderType = "STP";
					order[1][2].lmtPrice = 0.0;
					// set stop price (same for the 3 OCA groups here)
					if (order[0][2].action == "BUY")	
					{
						order[1][2].action = "SELL";
						m_dOriginalStopPrice3 = avgFillPrice - m_dNumStpPts;
						order[1][2].auxPrice = m_dOriginalStopPrice3;
					}
					else
					{
						order[1][2].action = "BUY";
						m_dOriginalStopPrice3 = avgFillPrice + m_dNumStpPts;
						order[1][2].auxPrice = m_dOriginalStopPrice3;
					}
					// check order size for each OCA group
					if (filled < m_nNumShares[0]*m_nOrdSizeMult)
							order[1][2].totalQuantity = filled;
					else	order[1][2].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;

					m_Reg.WriteFloat("OrigStopPrice1_tws3", m_dOriginalStopPrice3);

					if (order[1][2].totalQuantity > 0 && m_dNumStpPts > 0) 
					{
						PlaceOrder_tws3(1,TRUE);  // send stop order through
					}

					if (mlSLExits)
					{	// update new stop on modeless SLExits dialog
						CString str;
						str.Format(_T("%.2f"),order[1][2].auxPrice);
						mlSLExits->m_edtStpLoss.SetWindowText(str);
					}
					
				} // end if id = 0
				else
				{	// modify stop order 1
					if (filled > order[1][2].totalQuantity*m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0]*m_nOrdSizeMult)	
							order[1][2].totalQuantity = filled;
						else							
							order[1][2].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
						{
							m_tws3.placeOrder(
								m_lLastStopOrderId1_tws3, // last stop order id
								order[1][2].action,
								order[1][2].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[1][2].orderType,
								order[1][2].lmtPrice,
								order[1][2].auxPrice,
								FA[2].faGoodAfterTime,
								FA[2].faGroup,
								FA[2].faMethod,
								FA[2].faPercentage,
								FA[2].faProfile,
								FA[2].faGoodTillDate);
						}
						AddStatusLine("TWS3: Stop Order1 updated", statInfo);
					}
				}
			} // end if use stop
			
			if (m_bUseLimit)
			{
				if (m_lLastLimitOrderId1_tws3 == 0) // no limit order already in the market
				{	// Place limit target if not done already (Id = 0)
					strId.Format(_T("%i"),m_lLastOrderId_tws3);
					order[4][2].ocaGroup = "SL" + strId + "_1";
					m_tws2.SetOca( order[4][2].ocaGroup); // same OCA group as the attached stop order
					if (m_bVerbose)
						AddStatusLine("TWS3 Limit OCA Group1: " + order[4][2].ocaGroup, statInfo);
					if (order[0][2].action == "BUY")
					{
						order[4][2].action = "SELL";
						order[4][2].lmtPrice = avgFillPrice + m_dNumLmtPts[0];
					}
					else
					{
						order[4][2].action = "BUY";
						order[4][2].lmtPrice = avgFillPrice - m_dNumLmtPts[0];
					}
					order[4][2].orderType = "LMT";
					order[4][2].auxPrice = 0.0;
					// check order size for each OCA group
					if (filled < m_nNumShares[0]*m_nOrdSizeMult)	
							order[4][2].totalQuantity = filled;
					else	order[4][2].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;

					if (order[4][2].totalQuantity > 0 && m_dNumLmtPts[0] > 0) 
						PlaceOrder_tws3(4,TRUE);  // send limit order 1 through
					
					if (mlSLExits)
					{
						CString str;
						str.Format(_T("%.2f"),order[4][2].lmtPrice);
						mlSLExits->m_edtLmtTarget.SetWindowText(str);
					}
				} // end id = 0 
				else
				{	// modify limit order 1
					if (filled > order[4][2].totalQuantity*m_nOrdSizeMult)
					{
						if (filled < m_nNumShares[0]*m_nOrdSizeMult)	
							order[4][2].totalQuantity = filled;
						else							
							order[4][2].totalQuantity = m_nNumShares[0]*m_nOrdSizeMult;
						
						if (!m_bPaperTrade)
							m_tws3.placeOrder(
								m_lLastLimitOrderId1_tws3, // last limit order id
								order[4][2].action,
								order[4][2].totalQuantity,
								cont.symbol,
								cont.secType,
								cont.expiry,
								cont.strike,
								cont.right,
								cont.multiplier,
								cont.exchange,
								cont.primaryExchange,
								cont.currency,
								order[4][2].orderType,
								order[4][2].lmtPrice,
								order[4][2].auxPrice,
								FA[2].faGoodAfterTime,
								FA[2].faGroup,
								FA[2].faMethod,
								FA[2].faPercentage,
								FA[2].faProfile,
								FA[2].faGoodTillDate);
						AddStatusLine("TWS3: Stop Order1 updated", statInfo);
					}
				}
			} // end if use limits
			// end OCA 1
			// start OCA 2
			if (m_bFractExits)
			{
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId2_tws3 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws3);
						order[2][2].ocaGroup = "SL" + strId + "_2";	// entry id
						m_tws2.SetOca( order[2][2].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS3 Stop OCA Group2: " + order[2][1].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)	order[2][2].orderType = "TRAIL";
						else			order[2][2].orderType = "STP";
						order[2][2].lmtPrice = 0.0;
						if (order[0][2].totalQuantity != filled)
						{
							CString strPartFill;
							strPartFill.Format(_T("TWS3: Caution! Filled: %i, Remaining:%i"), filled, remaining);
							AddStatusLine(strPartFill, statWarn);
						}
						// set stop price (same for the 3 OCA groups here)
						if (order[0][2].action == "BUY")	
						{
							order[2][2].action = "SELL";
							m_dOriginalStopPrice3 = avgFillPrice - m_dNumStpPts;
							order[2][2].auxPrice = m_dOriginalStopPrice3;
						}
						else
						{
							order[2][2].action = "BUY";
							m_dOriginalStopPrice3 = avgFillPrice + m_dNumStpPts;
							order[2][2].auxPrice = m_dOriginalStopPrice3;
						}
						// check order size for each OCA group
						if (filled <= m_nNumShares[0]*m_nOrdSizeMult)
							order[2][2].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0]*m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult))
									order[2][2].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[2][2].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;

						if (order[2][2].totalQuantity > 0 && m_dNumStpPts > 0) 
							PlaceOrder_tws3(2,TRUE);  // send stop order(s) through
		
						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format(_T("%.2f"),order[2][2].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
					} // end if id = 0 (stop order is now set)
					else
					{	// modify stop order 2
						if (filled > order[2][2].totalQuantity + m_nNumShares[0]*m_nOrdSizeMult)
						{	// calc qty for stop order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[2][2].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[2][2].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws3.placeOrder(
									m_lLastStopOrderId1_tws3, // last stop order id
									order[1][2].action,
									order[1][2].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[1][2].orderType,
									order[1][2].lmtPrice,
									order[1][2].auxPrice,
									FA[2].faGoodAfterTime,
									FA[2].faGroup,
									FA[2].faMethod,
									FA[2].faPercentage,
									FA[2].faProfile,
									FA[2].faGoodTillDate);
							AddStatusLine("TWS3: Stop Order2 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId2_tws3 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws3);
						order[5][2].ocaGroup = "SL" + strId + "_2";
						m_tws3.SetOca( order[5][2].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS3 Limit OCA Group2: " + order[5][2].ocaGroup, statInfo);
						if (order[0][2].action == "BUY")
						{
							order[5][2].action = "SELL";
							order[5][2].lmtPrice = avgFillPrice + m_dNumLmtPts[1];
						}
						else
						{
							order[5][2].action = "BUY";
							order[5][2].lmtPrice = avgFillPrice - m_dNumLmtPts[1];
						}
						order[5][2].orderType = "LMT";
						order[5][2].auxPrice = 0.0;

						// check order size for each OCA group
						if (filled <= m_nNumShares[0]*m_nOrdSizeMult)
							order[2][2].totalQuantity = 0;
						else
							if ((filled > m_nNumShares[0]*m_nOrdSizeMult) && 
								(filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult))
									order[5][2].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][2].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
						if	(order[5][2].totalQuantity > 0 && m_dNumLmtPts[1] > 0) 
							PlaceOrder_tws3(5,TRUE);  // send limit order(s) through
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[5][2].lmtPrice);
							mlSLExits->m_edtLmtTarget2.SetWindowText(str);
						}
					} // end id = 0 
					else
					{	// modify limit 2
						if (filled > order[5][2].totalQuantity + m_nNumShares[0]*m_nOrdSizeMult)
						{	// calc qty for limit order2
							if (filled < (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
									order[5][2].totalQuantity = filled - m_nNumShares[0]*m_nOrdSizeMult;
							else	order[5][2].totalQuantity = m_nNumShares[1]*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws3.placeOrder(
									m_lLastLimitOrderId1_tws3, // last stop order id
									order[5][2].action,
									order[5][2].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[5][2].orderType,
									order[5][2].lmtPrice,
									order[5][2].auxPrice,
									FA[2].faGoodAfterTime,
									FA[2].faGroup,
									FA[2].faMethod,
									FA[2].faPercentage,
									FA[2].faProfile,
									FA[2].faGoodTillDate);
							AddStatusLine("TWS3: Limit Order2 updated", statInfo);						
						}
					}
				} // end if use limits

				// OCA 3
				if (m_bUseStop)  // protect entry with a stop loss order
				{	// if no stop, OCA group becomes irrelevant
					if (m_lLastStopOrderId3_tws3 == 0) // first time stop is set
					{	// Place stop loss
						strId.Format(_T("%i"),m_lLastOrderId_tws3);
						order[3][2].ocaGroup = "SL" + strId + "_3";	// entry id
						m_tws2.SetOca( order[3][2].ocaGroup);
						if (m_bVerbose)
							AddStatusLine("TWS3 OCA Group3: " + order[3][2].ocaGroup, statInfo);
						strLog += " (ENTRY)";
						if (m_bTrail)
							order[3][2].orderType = "TRAIL";
						else
							order[3][2].orderType = "STP";
						order[3][2].lmtPrice = 0.0;

						// set stop price (same for the 3 OCA groups here)
						if (order[0][2].action == "BUY")	
						{
							order[3][2].action = "SELL";
							m_dOriginalStopPrice3 = avgFillPrice - m_dNumStpPts;
							order[3][2].auxPrice = m_dOriginalStopPrice3;
						}
						else
						{
							order[3][2].action = "BUY";
							m_dOriginalStopPrice3 = avgFillPrice + m_dNumStpPts;
							order[3][2].auxPrice = m_dOriginalStopPrice3;
						}
						
						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[3][2].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[3][2].totalQuantity = 0;

						if (order[3][2].totalQuantity > 0 && m_dNumStpPts > 0) 
							PlaceOrder_tws3(3,TRUE);  // send stop order(s) through

						if (mlSLExits)
						{	// update new stop on modeless dialog
							CString str;
							str.Format(_T("%.2f"),order[3][2].auxPrice);
							mlSLExits->m_edtStpLoss.SetWindowText(str);
						}
						
					} // end if id = 0
					else
					{	// modify stop 3
						if (filled > order[3][2].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[3][2].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws3.placeOrder(
									m_lLastStopOrderId3_tws3, // last stop order id
									order[3][2].action,
									order[3][2].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[3][2].orderType,
									order[3][2].lmtPrice,
									order[3][2].auxPrice,
									FA[2].faGoodAfterTime,
									FA[2].faGroup,
									FA[2].faMethod,
									FA[2].faPercentage,
									FA[2].faProfile,
									FA[2].faGoodTillDate);
							AddStatusLine("TWS3: Stop Order3 updated", statInfo);
						}
					}
				} // end if use stop
				
				if (m_bUseLimit)
				{
					if (m_lLastLimitOrderId3_tws3 == 0) // no limit order already in the market
					{	// Place limit target if not done already (Id = 0)
						strId.Format(_T("%i"),m_lLastOrderId_tws3);
						order[6][2].ocaGroup = "SL" + strId + "_3";
						m_tws3.SetOca( order[6][2].ocaGroup); // same OCA group as the attached stop order
						if (m_bVerbose)
							AddStatusLine("TWS3 Limit OCA Group3: " + order[6][2].ocaGroup, statInfo);
						if (order[0][2].action == "BUY")
						{
							order[6][2].action = "SELL";
							order[6][2].lmtPrice = avgFillPrice + m_dNumLmtPts[2];
						}
						else
						{
							order[6][2].action = "BUY";
							order[6][2].lmtPrice = avgFillPrice - m_dNumLmtPts[2];
						}
						order[6][2].orderType = "LMT";
						order[6][2].auxPrice = 0.0;

						// check order size for each OCA group
						if	((filled > (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult) &&
							(filled <= (m_nNumShares[0] + m_nNumShares[1] + m_nNumShares[2])*m_nOrdSizeMult)) 
								order[6][2].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
						else	order[6][2].totalQuantity = 0;
						if (order[6][2].totalQuantity > 0 && m_dNumLmtPts[2] > 0) 
							PlaceOrder_tws3(6,TRUE);  // send limit order(s) through
						
						if (mlSLExits)
						{
							CString str;
							str.Format(_T("%.2f"),order[6][2].lmtPrice);
							mlSLExits->m_edtLmtTarget3.SetWindowText(str);
						}
					} // end id = 0
					else
					{	// modify limit 3
						if (filled > order[6][2].totalQuantity + (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult)
						{
							order[6][2].totalQuantity = filled - (m_nNumShares[0] + m_nNumShares[1])*m_nOrdSizeMult;
							if (!m_bPaperTrade)
								m_tws3.placeOrder(
									m_lLastLimitOrderId3_tws3, // last limit order id
									order[6][2].action,
									order[6][2].totalQuantity,
									cont.symbol,
									cont.secType,
									cont.expiry,
									cont.strike,
									cont.right,
									cont.multiplier,
									cont.exchange,
									cont.primaryExchange,
									cont.currency,
									order[6][2].orderType,
									order[6][2].lmtPrice,
									order[6][2].auxPrice,
									FA[2].faGoodAfterTime,
									FA[2].faGroup,
									FA[2].faMethod,
									FA[2].faPercentage,
									FA[2].faProfile,
									FA[2].faGoodTillDate);
							AddStatusLine("TWS3: Limit Order3 updated", statInfo);
						}
					}
				} // end if use limits
			} // end if FractExits (skip OCA 2 and OCA 3)
		} // end attach stops & limits
		else
		{	// no need to place an updated order, it is already in the book
//			if (!bTotalFill)
//				if (filled == order[0][0].totalQuantity
//					bTotalFill = filled;
		}

		/// stop exits
		if ((m_lLastStopOrderId1_tws3 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId1_tws3 = 0;
				m_lLastOrderId_tws3 = 0;
				strLog += " (STOP LOSS EXIT 1)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws3",0);
				m_Reg.WriteDword("LastStopOrderId1_tws3",0);
				m_Reg.WriteFloat("OrigStopPrice_tws3",0.0);
				if (m_lLastLimitOrderId1_tws3 != 0) // will be cancelled (same OCA group)
				{	// reset limit order 1
					m_lLastLimitOrderId1_tws3 = 0;
					m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
					if (order[0][2].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		if ((m_lLastStopOrderId2_tws3 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId2_tws3 = 0;
				m_lLastOrderId_tws3 = 0;
				strLog += " (STOP LOSS EXIT 2)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws3",0);
				m_Reg.WriteDword("LastStopOrderId2_tws3",0);
				m_Reg.WriteFloat("OrigStopPrice_tws3",0.0);
				if (m_lLastLimitOrderId2_tws3 != 0) 
				{
					m_lLastLimitOrderId2_tws3 = 0;
					m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
					if (order[0][2].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		if ((m_lLastStopOrderId3_tws3 == id) && (lastFillPrice > 0))
		{	// stop has been hit: cancel limit target  (bEntry is still TRUE)
			//if (remaining == 0)
			//{
				m_lLastStopOrderId3_tws3 = 0;
				m_lLastOrderId_tws3 = 0;
				strLog += " (STOP LOSS EXIT 3)";
				m_bLastEntrySig = FALSE;
				m_Reg.WriteBool("EntrySig",m_bLastEntrySig);
				m_Reg.WriteDword("LastOrderId_tws3",0);
				m_Reg.WriteDword("LastStopOrderId3_tws3",0);
				m_Reg.WriteFloat("OrigStopPrice_tws3",0.0);
				if (m_lLastLimitOrderId3_tws3 != 0) 
				{
					m_lLastLimitOrderId3_tws3 = 0;
					m_Reg.WriteDword("LastLimitOrderId3_tws3",0);
					if (order[0][2].action == "BUY")	SignalButton_Status(2);
					else								SignalButton_Status(4);
				}
			//}
		}
		// limit exits
		if ((m_lLastLimitOrderId1_tws3 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId1_tws3 = 0;
			m_lLastOrderId_tws3 = 0;
			strLog += " (LIMIT TARGET EXIT 1)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
			if (m_lLastStopOrderId1_tws3 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId1_tws3",0);
				m_lLastStopOrderId1_tws3 = 0;
				if (order[0][2].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget();
			}
		}	

		if ((m_lLastLimitOrderId2_tws3 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId2_tws3 = 0;
			m_lLastOrderId_tws3 = 0;
			strLog += " (LIMIT TARGET EXIT 2)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
			if (m_lLastStopOrderId2_tws3 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId2_tws3",0);
				m_lLastStopOrderId2_tws3 = 0;
				if (order[0][2].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget2.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget2();
			}
		}

		if ((m_lLastLimitOrderId3_tws3 == id) && (lastFillPrice > 0))
		{	// limit has been hit: cancel stop order
			m_lLastLimitOrderId3_tws3 = 0;
			m_lLastOrderId_tws2 = 0;
			strLog += " (LIMIT TARGET EXIT 3)";
			m_Reg.WriteBool("EntrySig",FALSE);
			m_Reg.WriteDword("LastOrderId_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws3",0);
			if (m_lLastStopOrderId3_tws3 != 0) 
			{
				m_Reg.WriteDword("LastStopOrderId3_tws3",0);
				m_lLastStopOrderId3_tws3 = 0;
				if (order[0][2].action == "BUY")	SignalButton_Status(2);
				else								SignalButton_Status(4);
			}
			if (mlSLExits)
			{
				mlSLExits->m_chkLmtTarget3.SetCheck(0);
				mlSLExits->OnBnClickedLimittarget3();
			}
		}
	}
	else // normal exit (order exit button)
	{
		strLog += " (EXIT SIGNAL)";
		if (m_lLastOrderId_tws3 == 0)	// reset to 0 on exit in PlaceOrder
		{
			if (remaining == 0)
			{
				CancelAttachedOrders_tws3();
			}
			else
			{
				// modify orders
			}

			/*
			if (remaining == 0)
			{
				if (m_lLastStopOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastStopOrderId1",0);
					m_lLastStopOrderId1_tws1 = 0;
				}
				if (m_lLastLimitOrderId1_tws1 == id)
				{
					m_Reg.WriteDword("LastLimitOrderId1",0);
					m_lLastLimitOrderId1_tws1 = 0;
				}
			}
			*/

			m_Reg.WriteFloat("OrigStopPrice_tws3",0.0);
			for (int i=0;i<7;i++)	order[i][2].ocaGroup = "";
		}
	}
	AddToLog(strLog);
	//ReqIBPosition(3);  // get acct update
}
// end order status

void CClient3Dlg::OnexecDetailsTwsctrl1(long id, LPCTSTR symbol, LPCTSTR secType, 
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR cExchange, LPCTSTR curency, 
        LPCTSTR localSymbol, LPCTSTR execId, LPCTSTR time, LPCTSTR acctNumber, 
        LPCTSTR eExchange, LPCTSTR side, long shares, double price, 
		long permId, long clientId, int liquidation) 
{	// execution details
	CString str, strC;
	strC.Format(_T("TWS1 %s %i@%.2f"),(CString)side, shares,price);
	str.Format(_T("(1) %s OrdId=%d"),(CString)acctNumber, id);
	str += strC;
	str +=" Time=" + (CString)time;
	AddStatusLine(str, statInfo);
}

void CClient3Dlg::OnexecDetailsTwsctrl2(long id, LPCTSTR symbol, LPCTSTR secType, 
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR cExchange, LPCTSTR curency, 
        LPCTSTR localSymbol, LPCTSTR execId, LPCTSTR time, LPCTSTR acctNumber, 
        LPCTSTR eExchange, LPCTSTR side, long shares, double price, 
		long permId, long clientId, int liquidation)
{
	CString str, strC;
	strC.Format(_T("TWS2 %s %i@%.2f"),(CString)side, shares,price);
	str.Format(_T("(2) %s OrdId=%d"),(CString)acctNumber, id);
	str += strC;
	str +=" Time=" + (CString)time;
	AddStatusLine(str, statInfo);
}

void CClient3Dlg::OnexecDetailsTwsctrl3(long id, LPCTSTR symbol, LPCTSTR secType, 
        LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR cExchange, LPCTSTR curency, 
        LPCTSTR localSymbol, LPCTSTR execId, LPCTSTR time, LPCTSTR acctNumber, 
        LPCTSTR eExchange, LPCTSTR side, long shares, double price, 
		long permId, long clientId, int liquidation)  
{
	CString str, strC;
	strC.Format(_T("TWS3 %s %i@%.2f"),(CString)side, shares,price);
	str.Format(_T("(3) %s OrdId=%d"),(CString)acctNumber, id);
	str += strC;
	str +=" Time=" + (CString)time;
	AddStatusLine(str, statInfo);
}

void CClient3Dlg::OnupdateAccountTimeTwsctrl1(LPCTSTR timeStamp) 
{
	m_strTime = (CString)timeStamp;
}


//  More can be done here.  Margin extracted from Account report and then displayed
void CClient3Dlg::OnupdateAccountValueTwsctrl1(LPCTSTR key, LPCTSTR value, LPCTSTR curency, LPCTSTR accountName) 
{	// key(s) to display
	//const char * szMargin = "MaintMarginReq";
	//CString str;
	//if (strcmp(key,szMargin) == 0)
	//	ListPosition.SetItemText(0,4,value,Blue,White);
}

void CClient3Dlg::OnupdateAccountValueTwsctrl2(LPCTSTR key, LPCTSTR value, LPCTSTR curency, LPCTSTR accountName) 
{	// other keys can here be implemented
	//const char * szMargin = "MaintMarginReq";
	//CString str;
	//if (strcmp(key,szMargin) == 0)
	//	ListPosition.SetItemText(1,4,value,Blue,White);
}

void CClient3Dlg::OnupdateAccountValueTwsctrl3(LPCTSTR key, LPCTSTR value, LPCTSTR curency, LPCTSTR accountName) 
{	
	//const char * szMargin = "MaintMarginReq";
	//CString str;
	//if (strcmp(key,szMargin) == 0)
	//	ListPosition.SetItemText(2,4,value,Blue,White);
}

void CClient3Dlg::OnupdatePortfolioTwsctrl1(LPCTSTR symbol, LPCTSTR secType, LPCTSTR expiry, double strike, 
        LPCTSTR right, LPCTSTR curency, LPCTSTR localSymbol, long position, double marketPrice, 
        double marketValue, double averageCost, double unrealizedPNL, double realizedPNL, LPCTSTR accountName ) 
{	// some returned info is dropped here below
	CString strSymbol = (CString) symbol;
	int pos = (position >= 0 ? position: -position); // for display
	if (strSymbol != cont.symbol) return;		// feedback restricted to the ticker being traded
	CWinApp *pApp= AfxGetApp();
	CString strFill, strT, strP, strPos, strPNL;
	strP.Format(_T("%i"),position);
	m_nPosition1 = position;
	ListOpenOrder2.SetItemText(0,1,strP);
	CurrentTime = CTime::GetCurrentTime();
	strT = CurrentTime.Format("%H:%M:%S");
	GetWindowRect(m_dlgRect);
	if (position > 0) strPos.Format(_T(" LONG %i "), pos);
	if (position < 0) strPos.Format(_T(" SHORT %i "), pos);
	if (position == 0) 
	{
		//ResetButtons();
		if (m_lLastOrderId_tws1 == 0)
			for (int i=0;i<7;i++)	order[i][0].totalQuantity = 0;
		strPos = " FLAT";
		m_Reg.WriteString("LastOCA1_tws1",""); // reset OCA groups
		m_Reg.WriteString("LastOCA2_tws1","");
		m_Reg.WriteString("LastOCA3_tws1","");
		if (mlSLExits) 
		{	// close exit dialog if visible, as no longer needed
			mlSLExits->DestroyWindow();
			mlSLExits = NULL;
		}
		SetWindowText(m_strCaption + "Symbol:" + symbol);
		pApp->m_pMainWnd->MoveWindow(
			m_dlgRect.left,
			m_dlgRect.top,
			m_dlgRect.Width(),
			m_nRectHeight - nHeightDiff, // reduce footprint
			TRUE);
	}
	if (position != 0)
	{
		CString strUpdatedCaption;
		//double dP2 = ((m_dEntryPrice == 0) ? m_dLatestTrade : m_dEntryPrice);
		double dP2 = ((m_dEntryPrice == 0) ? m_dLatestTrade : m_dAvgFillPrice1);
		strUpdatedCaption.Format(_T(" %s %s since %s Fill: %.2f") /*uP&L: %.2f*/,
							strPos, symbol, strT, dP2/*, dP2-m_dLatestTrade*/);
		if (mlDOM)
		{
			mlDOM->m_edtStatusText.SetWindowText(strUpdatedCaption);
		}
		pApp->m_pMainWnd->MoveWindow(
			m_dlgRect.left,
			m_dlgRect.top,
			m_dlgRect.Width(),
			m_nRectHeight ,
			TRUE);
		strFill.Format(_T(" ( Fill: %.2f )"), m_dAvgFillPrice1); // set in order status
		m_dEntryPrice = m_dLastFillPrice1;
		//m_dEntryPrice = m_dAvgFillPrice1;
		m_Reg.WriteFloat("LastEntryPrice",m_dEntryPrice);
		SetWindowText(m_strCaption + strUpdatedCaption);

		int n_opS = 0;
		int n_opL = 0;

		if (m_lLastStopOrderId1_tws1 > 0) n_opS += order[1][0].totalQuantity;
		if (m_lLastStopOrderId2_tws1 > 0) n_opS += order[2][0].totalQuantity;
		if (m_lLastStopOrderId3_tws1 > 0) n_opS += order[3][0].totalQuantity;

		if (m_lLastLimitOrderId1_tws1 > 0) n_opL += order[4][0].totalQuantity;
		if (m_lLastLimitOrderId2_tws1 > 0) n_opL += order[5][0].totalQuantity;
		if (m_lLastLimitOrderId3_tws1 > 0) n_opL += order[6][0].totalQuantity;

		if ((pos != n_opS) || (pos != n_opL))
		{
			AddStatusLine("Caution: Check for possible qty discrepancy in position (IB_Direct vs TWS)",statWarn);
		}
	}
	else	// position == 0
	{
		m_dEntryPrice = 0.0f;
		if (mlDOM)
		{
			mlDOM->m_edtStatusText.SetWindowText("FLAT");
		}
	}
	OnBnClickedRefresh();
}

void CClient3Dlg::OnupdatePortfolioTwsctrl2(
	LPCTSTR symbol, LPCTSTR secType, LPCTSTR expiry, 
	double strike, LPCTSTR right, LPCTSTR curency, 
	LPCTSTR localSymbol, long position, double marketPrice, double marketValue, 
	double averageCost, double unrealizedPNL, double realizedPNL, LPCTSTR accountName ) 
{	// some returned info is dropped here
	CString str, strP,strPf, strUnrPL, strRPL;
	strP.Format(_T("%i"),position);
	m_nPosition2 = position;
	ListOpenOrder2.SetItemText(1,1,strP);
	m_strAcct2 = accountName;
	if (m_lLastOrderId_tws2 == 0)
	{
		if (position == 0)	for (int i=0;i<7;i++)	order[i][1].totalQuantity = 0;
		m_Reg.WriteString("LastOCA1_tws2",""); // reset OCA groups
		m_Reg.WriteString("LastOCA2_tws2","");
		m_Reg.WriteString("LastOCA3_tws3","");	
	}
}

void CClient3Dlg::OnupdatePortfolioTwsctrl3(
	LPCTSTR symbol, LPCTSTR secType, LPCTSTR expiry, 
	double strike, LPCTSTR right, LPCTSTR curency, 
	LPCTSTR localSymbol, long position, double marketPrice, double marketValue, 
	double averageCost, double unrealizedPNL, double realizedPNL, LPCTSTR accountName ) 
{	// some returned info is dropped here
	CString str, strP,strPf, strUnrPL, strRPL;
	strP.Format(_T("%i"),position);
	m_nPosition3 = position;
	ListOpenOrder2.SetItemText(2,1,strP);
	m_strAcct3 = accountName;
	if (m_lLastOrderId_tws3 == 0)
	{
		if (position == 0)	for (int i=0;i<7;i++)	order[i][2].totalQuantity = 0;
		m_Reg.WriteString("LastOCA1_tws3",""); // reset OCA groups
		m_Reg.WriteString("LastOCA2_tws3","");
		m_Reg.WriteString("LastOCA3_tws3","");
	}
}

// end TWS events

//////////////////////////////////////////////////////////////

int CClient3Dlg::DefineConnectParam(int ib_accnum)
{	// Set Connect params into structure
	CDlgConnect dlg;
	dlg.m_strSessionNo = m_strSessionNo;
	dlg.m_accidx = ib_accnum; // Dlg title
	INT_PTR ret = dlg.DoModal();
	//if (ret == IDCANCEL) return -1;

	switch (ib_accnum)
	{
		case 1:
			c1.ClientID = dlg.m_clientId;
			c1.IP_Address = dlg.m_ipAddress;
			c1.PortNo = dlg.m_port;
			c1.NumShares = dlg.iNumShares;	// numshares = 0 if accounts specifics not checked
			break;
		case 2:
			c2.ClientID = dlg.m_clientId;
			c2.IP_Address = dlg.m_ipAddress;
			c2.PortNo = dlg.m_port;
			c2.NumShares = dlg.iNumShares;
			break;
		case 3:
			c3.ClientID = dlg.m_clientId;
			c3.IP_Address = dlg.m_ipAddress;
			c3.PortNo = dlg.m_port;
			c3.NumShares = dlg.iNumShares;
			break;
		default:
			MessageBox("3 IB accounts limit","Not implemented yet",MB_OK);
	}

	if (dlg.m_port == 0)	return -1;
	else					return 0;
}


//  Other buttons : override section  (orders will come from IBD in forthcoming version)
void CClient3Dlg::OnCbnSelchangeCombo1() // order type
{
	int n = m_cbbOrdType.GetCurSel();

	switch (n)
	{
		default:
		case 0:		// MKT
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "MKT";
			m_bMarketOrder = TRUE;
			m_bLimitOrder = FALSE;
			m_bStopOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			order[0][2].lmtPrice = order[0][1].lmtPrice = order[0][0].lmtPrice = 0.0f;
			order[0][2].auxPrice = order[0][1].auxPrice = order[0][1].auxPrice = 0.0f;
			break;
		case 1:	// Limit bid/ask order
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "LMT";
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = TRUE;
			m_bOneTickLimitOrder = FALSE;
			break;
		case 2:	// Limit 1 tick 
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "LMT";
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = TRUE;
			break;
		case 3:// LMT Price must be set
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "LMT";
			m_bLimitOrder = TRUE;
			m_bStopOrder = FALSE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			OnBnClickedSlEntry();	// display price entry dialog
			break;
		case 4:// LIT  Limit If Touched
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "LIT";
			m_bLimitOrder = TRUE;
			m_bStopOrder = TRUE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			OnBnClickedSlEntry();
			break;
		case 5:// MIT	Market If Touched
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "MIT";
			m_bLimitOrder = FALSE;
			m_bStopOrder = TRUE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			OnBnClickedSlEntry();
			break;
		case 6:// STP Price must be set
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "STP";
			m_bLimitOrder = FALSE;
			m_bStopOrder = TRUE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			OnBnClickedSlEntry();
			break;
		case 7: // STPLMT stop and limit prices must be set
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "STPLMT";
			m_bLimitOrder = TRUE;
			m_bStopOrder = TRUE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			OnBnClickedSlEntry();
			break;
		case 8: // REL stop and limit prices must be set
			order[0][2].orderType = order[0][1].orderType = order[0][0].orderType = "REL";
			m_bLimitOrder = FALSE;
			m_bStopOrder = FALSE;
			m_bMarketOrder = FALSE;
			m_bBidAskLimitOrder = FALSE;
			m_bOneTickLimitOrder = FALSE;
			break;	
	}
}

void CClient3Dlg::OnEnChangeQty() // Num Contracts update
{	// the edit box is restricted to numbers (mask)
	CString strQ;
	NumContracts.GetWindowText(strQ);

	if (m_nPosition1 !=0 || m_nPosition2 !=0 || m_nPosition3 !=0)
	{
		AddStatusLine("Changing order size while in position is not permitted", statWarn);
		return;
	}
	
	for (int i=0;i<3;i++) // num IB accounts
	{
		order[0][i].totalQuantity = atol(strQ) * m_nOrdSizeMult;
		if (order[0][i].totalQuantity < 0) 
		{
			order[0][i].totalQuantity = 0;
			NumContracts.SetWindowText("0");
			AddStatusLine("Invalid order size", statWarn);
		}
	}
}

void CClient3Dlg::OnEnKillfocusQty() // when qty is changed on the dialog
{
	CString str;
	for (int i=0;i<3;i++)
	{
		if (m_bTwsConnected[0] && m_bTwsChecked1[0])	
			if (order[0][0].totalQuantity == 0)
			{
				str.Format(_T("TWS%i: Num shares/contracts is incorrect!"),i);
				AddStatusLine(str,statError);
			}
	}
}

// Entry/Exit Buttons

void CClient3Dlg::SignalButton_Status(int nButtonNo)
{
	switch (nButtonNo)
	{
	case 6:		//SR
	case 1:	{	//LE
			m_btnLE.EnableWindow(FALSE);
			m_btnLX.EnableWindow(TRUE);
			m_btnRS.EnableWindow(TRUE);
			m_btnSE.EnableWindow(FALSE);
			m_btnSX.EnableWindow(FALSE);
			m_btnRL.EnableWindow(FALSE);
			break;
			}
	case 2:	{	//LX
			m_btnLE.EnableWindow(TRUE);
			m_btnLX.EnableWindow(FALSE);
			m_btnRS.EnableWindow(FALSE);
			m_btnSE.EnableWindow(TRUE);
			m_btnSX.EnableWindow(FALSE);
			m_btnRL.EnableWindow(FALSE);
			break;
			}
	case 3:		//LR
	case 4:	{	//SE
			m_btnLE.EnableWindow(FALSE);
			m_btnLX.EnableWindow(FALSE);
			m_btnRS.EnableWindow(FALSE);
			m_btnSE.EnableWindow(FALSE);
			m_btnSX.EnableWindow(TRUE);
			m_btnRL.EnableWindow(TRUE);
			break;
			}
	case 5:	{	//SX
			m_btnLE.EnableWindow(TRUE);
			m_btnLX.EnableWindow(FALSE);
			m_btnRS.EnableWindow(FALSE);
			m_btnSE.EnableWindow(TRUE);
			m_btnSX.EnableWindow(FALSE);
			m_btnRL.EnableWindow(FALSE);
			break;
			}
	default:	ResetButtons();
	}			
}

//	Order Entry/Exit Buttons Handlers
void CClient3Dlg::OnLongEntry() // Long Entry
{

	order[0][2].action = order[0][1].action = order[0][0].action = "BUY";
	
	SignalButton_Status(1);

	GetAccounts();

	if ((m_bTwsConnected[0] == TRUE) && (m_bTwsChecked1[0] == TRUE ))	
		PlaceOrder_tws1(0,TRUE); // TRUE for Entry

	if (m_lNumIB > 1)
		if ((m_bTwsConnected[1] == TRUE) && (m_bTwsChecked1[1] == TRUE ))	
			PlaceOrder_tws2(0,TRUE);

	if (m_lNumIB > 2)
		if ((m_bTwsConnected[2] == TRUE) && (m_bTwsChecked1[2] == TRUE ))	
			PlaceOrder_tws3(0,TRUE);
}

void CClient3Dlg::OnBnDoubleclickedButton3() // Long Entry - Buy Bid
{
	m_cbbOrdType.SetCurSel(1);
	OnCbnSelchangeCombo1();

	OnLongEntry();
}

void CClient3Dlg::OnLongExit()	// Long Exit
{
	order[0][2].action = order[0][1].action = order[0][0].action = "SELL";
	SignalButton_Status(2);

	GetAccounts();
	
	if ((m_bTwsConnected[0] == TRUE) && (m_bTwsChecked1[0] == TRUE ))	
		PlaceOrder_tws1(0,FALSE); // false for exit

	if (m_lNumIB > 1)
		if ((m_bTwsConnected[1] == TRUE) && (m_bTwsChecked1[1] == TRUE ))	
			PlaceOrder_tws2(0,FALSE);

	if (m_lNumIB > 2)
		if ((m_bTwsConnected[2] == TRUE) && (m_bTwsChecked1[2] == TRUE ))	
			PlaceOrder_tws3(0,FALSE);
	
	//m_cbbOrdType.SetCurSel(0);
}

void CClient3Dlg::OnReverseToShort() // Reverse to Short
{
	//m_cbbOrdType.SetCurSel(0);

	SignalButton_Status(3);
	order[0][2].action = order[0][1].action = order[0][0].action = "SELL";

	GetAccounts();

	if ((m_bTwsConnected[0] == TRUE) && (m_bTwsChecked1[0] == TRUE))	
		PlaceOrder_tws1(0,FALSE);

	if (m_lNumIB > 1)
		if ((m_bTwsConnected[1] == TRUE) && (m_bTwsChecked1[1] == TRUE ))	
			PlaceOrder_tws2(0,FALSE);

	if (m_lNumIB > 2)
		if ((m_bTwsConnected[2] == TRUE) && (m_bTwsChecked1[2] == TRUE ))	
			PlaceOrder_tws3(0,FALSE);

	order[0][2].action = order[0][1].action = order[0][0].action = strSellShort;

	if ((m_bTwsConnected[0] == TRUE) && (m_bTwsChecked1[0] == TRUE))	
		PlaceOrder_tws1(0,TRUE);

	if (m_lNumIB > 1)
		if (m_bTwsConnected[1] && m_bTwsChecked1[1])	
			PlaceOrder_tws2(0,TRUE);

	if (m_lNumIB > 2)
		if (m_bTwsConnected[2] && m_bTwsChecked1[2])	
			PlaceOrder_tws3(0,TRUE);
}

void CClient3Dlg::OnShortEntry() //  Short Entry
{
	SignalButton_Status(4);
	order[0][2].action = order[0][1].action = order[0][0].action = strSellShort;

	GetAccounts();

	if (m_bTwsConnected[0] && m_bTwsChecked1[0])	
		PlaceOrder_tws1(0,TRUE);

	if (m_lNumIB > 1)
		if (m_bTwsConnected[1] && m_bTwsChecked1[1])	
			PlaceOrder_tws2(0,TRUE);

	if (m_lNumIB > 2)
		if (m_bTwsConnected[2] && m_bTwsChecked1[2])	
			PlaceOrder_tws3(0,TRUE);

	//m_cbbOrdType.SetCurSel(0);
}

void CClient3Dlg::OnShortExit() // Short Exit
{
	SignalButton_Status(5);
	order[0][2].action = order[0][1].action = order[0][0].action = "BUY";

	GetAccounts();

	if (m_bTwsConnected[0] && m_bTwsChecked1[0])	
		PlaceOrder_tws1(0,FALSE);

	if (m_lNumIB > 1)
		if (m_bTwsConnected[1] && m_bTwsChecked1[1])	
			PlaceOrder_tws2(0,FALSE);

	if (m_lNumIB > 2)
		if (m_bTwsConnected[2] && m_bTwsChecked1[2])	
			PlaceOrder_tws3(0,FALSE);

	//m_cbbOrdType.SetCurSel(0);
}

void CClient3Dlg::OnReverseToLong()	// Reverse Long
{
	SignalButton_Status(6);
	order[0][2].action = order[0][1].action = order[0][0].action = "BUY";

	GetAccounts();

	if (m_bTwsConnected[0] && m_bTwsChecked1[0])	
		PlaceOrder_tws1(0,FALSE);

	if (m_lNumIB > 1)
		if (m_bTwsConnected[1] && m_bTwsChecked1[1])	
			PlaceOrder_tws2(0,FALSE);

	if (m_lNumIB > 2)
		if (m_bTwsConnected[2] && m_bTwsChecked1[2])	
			PlaceOrder_tws3(0,FALSE);

	order[0][2].action = order[0][1].action = order[0][0].action = "BUY";
	
	if (m_bTwsConnected[0] && m_bTwsChecked1[0])	
		PlaceOrder_tws1(0,TRUE);

	if (m_lNumIB > 1)
		if (m_bTwsConnected[1] && m_bTwsChecked1[1])	
			PlaceOrder_tws2(0,TRUE);

	if (m_lNumIB > 2)
		if (m_bTwsConnected[2] && m_bTwsChecked1[2])	
			PlaceOrder_tws3(0,TRUE);

	//m_cbbOrdType.SetCurSel(0);
}

//  End override section

void CClient3Dlg::ResetOrderIds(int twsn)
{
	CString str;
	str.Format(_T("Order Ids reset in Registry for TWS%i"), twsn);
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	if (m_Reg.SetKey(m_RegIBDKey, TRUE))
	{
		m_Reg.WriteString("LastAction","N/A");
		m_Reg.WriteDword("NumFilled",0);
		m_Reg.WriteFloat("LastEntryPrice",0);
		if (twsn == 1)
		{
			m_lLastOrderId_tws1 = 0;
			m_Reg.WriteFloat("OrigStopPrice_tws1",0.0);
			m_Reg.WriteDword("LastOrderId_tws1",0);
			m_Reg.WriteDword("LastStopOrderId1_tws1",0);
			m_Reg.WriteDword("LastStopOrderId2_tws1",0);
			m_Reg.WriteDword("LastStopOrderId3_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId2_tws1",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws1",0);
			m_Reg.WriteString("LastOCA1_tws1","");
			m_Reg.WriteString("LastOCA2_tws1","");
			m_Reg.WriteString("LastOCA3_tws1","");
		}
		if (twsn == 2)
		{
			m_lLastOrderId_tws2 = 0;
			m_Reg.WriteDword("LastOrderId_tws2",0);
			m_Reg.WriteDword("LastStopOrderId1_tws2",0);
			m_Reg.WriteDword("LastStopOrderId2_tws2",0);
			m_Reg.WriteDword("LastStopOrderId3_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId2_tws2",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws2",0);
			m_Reg.WriteString("LastOCA1_tws2","");
			m_Reg.WriteString("LastOCA2_tws2","");
			m_Reg.WriteString("LastOCA3_tws2","");
		}
		if (twsn == 3)
		{
			m_lLastOrderId_tws3 = 0;
			m_Reg.WriteDword("LastOrderId_tws3",0);
			m_Reg.WriteDword("LastStopOrderId1_tws3",0);
			m_Reg.WriteDword("LastStopOrderId2_tws3",0);
			m_Reg.WriteDword("LastStopOrderId3_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId2_tws3",0);
			m_Reg.WriteDword("LastLimitOrderId3_tws3",0);
			m_Reg.WriteString("LastOCA1_tws3","");
			m_Reg.WriteString("LastOCA2_tws3","");
			m_Reg.WriteString("LastOCA3_tws3","");
		}
		AddToLog(str);
		AddStatusLine(str, statInfo);
	}
}

//	Now, let's compile all info and send order to IB
//  all info is stored in the registry to cater for possible recovery
//
//
////////////////////////////////////////////////////////////
//	nOrdNum = 0		Buy/Sell signal 
//  nOrdNum = 1		Attached Stop Loss (optional)
//	nOrdNum = 2		Attached Limit Target (optional)
//
//	bEntry			Entry (TRUE) /Exit (FALSE)

void CClient3Dlg::PlaceOrder_tws1(int nOrdNum, BOOL bEntry)
{
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	if (m_Reg.SetKey(m_RegIBDKey, TRUE) && (nOrdNum == 0))	
	{
		m_Reg.WriteString("LastAction",order[0][0].action);	// record buy/sell into m_Registry
		m_Reg.WriteBool("EntrySig",bEntry);					// record entry/exit
	}
 
	CString str, strP;
	if (cont.symbol == "")	// local symbol not used in this implementation, so no alternative
	{
		AddStatusLine("No symbol defined: Order setup cancelled", statWarn);
		ResetButtons();
		return;
	}

	if ((order[nOrdNum][0].orderType != "MKT") &&
		(order[nOrdNum][0].auxPrice == 0.0f) &&
		(order[nOrdNum][0].lmtPrice  == 0.0f))
	{
		AddStatusLine("Order is not valid: no price set for STP/LMT order.",statWarn);
		if (m_bAutoReturnToMKT == TRUE) 
		{
			m_cbbOrdType.SetCurSel(0);
			OnCbnSelchangeCombo1();
		}
		ResetButtons();
		return;
	}

	m_strLastAction = order[0][0].action;

	m_bLastEntrySig = bEntry;	// record entry/exit sequence

	if (bEntry)
	{
		if (m_bAutoClose)
		{
			CurrentTime = CTime::GetCurrentTime();
			int h = CurrentTime.GetHour() - m_nTimeOffset;
			int m = CurrentTime.GetMinute();
			if ((h >= m_nEODhour) && (m >= m_nEODmin))
			{
				CString str = "TWS1: Order entry has been filtered on account of time of day";
				AfxMessageBox("Too late to enter a trade...");
				AddToLog(str);
				AddStatusLine(str, statWarn);
				ResetButtons();
				return;
			}
		}
	}
	else	ResetButtons();

	GetAccounts();				// Check for accounts activation

	if (nOrdNum == 0)			// applies to Main Order only. Other orders do not use UI info
	{	
		OnCbnSelchangeCombo1(); // Check order type (MKT, etc)

		if (bEntry)	// signal is an entry
		{
			// reset attached order ids (if not done yet, but should be)
			m_lLastLimitOrderId1_tws1 = 0;
			m_lLastStopOrderId1_tws1 = 0;
			m_lLastLimitOrderId2_tws1 = 0;
			m_lLastStopOrderId2_tws1 = 0;
			m_lLastLimitOrderId3_tws1 = 0;
			m_lLastStopOrderId3_tws1 = 0;

			CString strId;
			strId.Format(_T("%i"),m_lOrderId_tws1); // OrderId to be used below when order is sent through
			order[0][0].ocaGroup = "Ord" + strId;
			// this OCA group is set for possible conditional orders
			// there is no need for the main order to be part of the stp/lmt group
			m_tws1.SetOca(order[0][0].ocaGroup); // so mostly unused
			if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
				m_Reg.WriteString("LastEntryOCATws1",order[0][0].ocaGroup);
			if (c1.NumShares > 0) 
				order[0][0].totalQuantity = m_nOrdSizeMult * c1.NumShares;
			else
			{
				CString strQ;
				NumContracts.GetWindowText(strQ);
				order[0][0].totalQuantity = atol(strQ) * m_nOrdSizeMult ;	
			}
		}
		else  // exit
		{	// exit full remaining position
			order[0][0].totalQuantity = abs(m_nPosition1);
		}

		// set type of order, and eventually fix incompatibilities among lmt stp price settings
		if (m_bMarketOrder)		// Market order
		{
			order[0][0].orderType = "MKT";
			order[0][0].lmtPrice = 0.0f;
			order[0][0].auxPrice = 0.0f;
		}
		if (m_bBidAskLimitOrder)	// Bid/Ask Limit (no slippage)
		{
			order[0][0].orderType = "LMT";
			if (order[0][0].action == "BUY") 
				order[0][0].lmtPrice = m_dLatestBid;
			if (order[0][0].action == strSell || order[0][0].action == strSellShort) 
				order[0][0].lmtPrice = m_dLatestAsk;
			order[0][0].auxPrice = 0.0f;
		}
		if (m_bOneTickLimitOrder)	// try and save 1 more tick 
		{
			order[0][0].orderType = "LMT";
			if (order[0][0].action == "BUY")
				order[0][0].lmtPrice = m_dLatestBid - m_dSymbolTickSize;
			if (order[0][0].action == strSell || order[0][0].action == strSellShort) 
				order[0][0].lmtPrice = m_dLatestAsk + m_dSymbolTickSize;
			order[0][0].auxPrice = 0.0f;
		}
		if (m_bLimitOrder && !m_bStopOrder)	// limit order (limit price must be set)
		{	
			order[0][0].lmtPrice = atof(m_strLmtPrice);
			order[0][0].auxPrice = 0.0f;
		}
		if (m_bStopOrder && !m_bLimitOrder)	// stop order (stop price must be set)
		{
			order[0][0].lmtPrice = 0.0f;
			order[0][0].auxPrice = atof(m_strStpPrice);
		}
		if (m_bStopOrder && m_bLimitOrder)	// Stop-Limit (check IB stop/limit trigger methods)
		{
			order[0][0].lmtPrice = atof(m_strLmtPrice);
			order[0][0].auxPrice = atof(m_strStpPrice);
		}
	}	// end if nOrdNum == 0

	// Now, let's get going...

	// store order numbers in registry  (separated from above for better readability)
	if (nOrdNum == 0)	// main entry/exit order
	{
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
		{
			if (bEntry)	m_lLastOrderId_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			else		m_lLastOrderId_tws1 = 0;
			m_Reg.WriteDword("LastOrderId_tws1", m_lLastOrderId_tws1);
			str.Format(_T("%i"),m_lLastOrderId_tws1); // display main order id
			ListOpenOrder1.SetItemText(0,1,str,Blue,White);
			if (order[0][0].totalQuantity <= 0)
			{
				AddStatusLine("TWS1: Num contracts/shares is incorrect.", statWarn);
				return;
			}
		}

		if ((mlDOM != NULL) && (order[0][0].orderType == "LMT") && (!m_bPaperTrade))
		{
			if (order[0][0].action == "BUY")
			{
				for (int i=11; i<21; i++)
					if (mlDOM->m_dArrMD[i][2] == order[0][0].lmtPrice)
					{
						mlDOM->m_nBidCountLeft = mlDOM->m_nRecordBidSize = (long)mlDOM->m_dArrMD[i][0];
						CString str;
						str.Format(_T("%i in book at bid:%.3f"), 
							mlDOM->m_nBidCountLeft, 
							m_dEntryPrice); //mlDOM->m_dRecordTradePrice);
						AddStatusLine(str,statInfo);
						break;
					}
			}
			else
			{
				for (int i=0; i<11; i++)
					if (mlDOM->m_dArrMD[i][2] == order[0][0].lmtPrice)
					{
						mlDOM->m_nAskCountLeft = mlDOM->m_nRecordAskSize = (long)mlDOM->m_dArrMD[i][0];
						CString str;
						str.Format(_T("%i in book at bid:%.3f"), 
							mlDOM->m_nBidCountLeft, 
							m_dEntryPrice);//mlDOM->m_dRecordTradePrice);
						AddStatusLine(str,statInfo);
						break;
					}
			}
		}
	}

	if (nOrdNum == 1)	// attached stop order 1 (linked to limit order 4)
	{
		if (m_bTrail)	order[1][0].orderType = "TRAIL";
		else			order[1][0].orderType = "STP";
		order[1][0].lmtPrice = 0;
		if (bEntry)
		{	// order id will be incremented in the call, so store current value
			m_lLastStopOrderId1_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id1 TWS1: %i"), m_lLastStopOrderId1_tws1);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws1 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId1_tws1", m_lLastStopOrderId1_tws1);
	}

	if (nOrdNum == 2)	// attached stop order 2 (linked to limit order 5)
	{
		if (m_bTrail)	order[2][0].orderType = "TRAIL";
		else			order[2][0].orderType = "STP";
		order[2][0].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId2_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id2 TWS1: %i"), m_lLastStopOrderId2_tws1);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId2_tws1 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId2_tws1", m_lLastStopOrderId2_tws1);
	}

	if (nOrdNum == 3)	// attached stop order 3
	{
		if (m_bTrail)	order[3][0].orderType = "TRAIL";
		else			order[3][0].orderType = "STP";
		order[3][0].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId3_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id3 TWS1: %i"), m_lLastStopOrderId3_tws1);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId3_tws1 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId3_tws1", m_lLastStopOrderId3_tws1);
	}
	// end stop orders, now limit orders...

	if (nOrdNum == 4)	// attached limit order 4 (linked to stop order 1)
	{
		order[4][0].auxPrice = 0;
		if (bEntry)
		{	// order id will incremented in the call, so store current value
			m_lLastLimitOrderId1_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id1 TWS1: %i"), m_lLastLimitOrderId1_tws1);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws1 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId1_tws1", m_lLastLimitOrderId1_tws1);
	}

	if (nOrdNum == 5)	// attached limit order 5 (attached to stop 2)
	{
		order[5][0].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId2_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id2 TWS1: %i"), m_lLastLimitOrderId2_tws1);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastLimitOrderId2_tws1 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId2_tws1", m_lLastLimitOrderId2_tws1);
	}

	if (nOrdNum == 6)	// attached limit order 6 (attached to stop 3)
	{
		order[6][0].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId3_tws1 = m_lOrderId_tws1;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id3 TWS1: %i"), m_lLastLimitOrderId3_tws1);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastLimitOrderId3_tws1 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId3_tws1", m_lLastLimitOrderId3_tws1);
	}

	if (m_bVerbose)
	{
		CString str;
		str.Format(_T("->id:%i %s %s %i %s %s %.2f %.2f"),
			m_lOrderId_tws1,
			order[nOrdNum][0].ocaGroup,
			order[nOrdNum][0].action,
			order[nOrdNum][0].totalQuantity,
			cont.symbol,
			order[nOrdNum][0].orderType,
			order[nOrdNum][0].lmtPrice,
			order[nOrdNum][0].auxPrice);
		AddToLog(str);
	}	

	if (!m_bPaperTrade)
		m_tws1.placeOrder(
				m_lOrderId_tws1++,		// immediately incremented for next order
				order[nOrdNum][0].action,
				order[nOrdNum][0].totalQuantity,
				cont.symbol,
				cont.secType,
				cont.expiry,
				cont.strike,
				cont.right,
				cont.multiplier,
				cont.exchange,
				cont.primaryExchange,
				cont.currency,
				order[nOrdNum][0].orderType,
				order[nOrdNum][0].lmtPrice,
				order[nOrdNum][0].auxPrice,
				FA[0].faGoodAfterTime,
				FA[0].faGroup,
				FA[0].faMethod,
				FA[0].faPercentage,
				FA[0].faProfile,
				FA[0].faGoodTillDate
				);

	if (!bEntry) m_tws1.SetOca("");		// reset OCA for current TWS

	// get current price to account for slippage - display & record
	if (order[nOrdNum][0].action == "BUY" && order[nOrdNum][0].orderType == "MKT") // buy mkt
	{
		CString strAsk;
		strAsk.Format(_T("TWS1: %s %i %s MKT Ask:%.3f "),
			order[nOrdNum][0].action, order[nOrdNum][0].totalQuantity, 
			cont.symbol, m_dLatestAsk);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][0].action != "BUY" && order[nOrdNum][0].orderType == "MKT") // sell mkt
	{
		CString strBid;
		strBid.Format(_T("TWS1: %s %i %s MKT Bid:%.3f "),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, 
			cont.symbol, m_dLatestBid);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid, statInfo);
	}

	if (order[nOrdNum][0].action == "BUY" && order[nOrdNum][0].orderType == "LMT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS1: %s %i %s %.3f LMT"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].lmtPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][0].action != "BUY" && order[nOrdNum][0].orderType == "LMT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS1: %s %i %s %.3f LMT"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].lmtPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][0].action == "BUY" && order[nOrdNum][0].orderType == "MIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS1: %s %i %s %.3f MIT"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][0].action != "BUY" && order[nOrdNum][0].orderType == "MIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS1: %s %i %s %.3f MIT"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][0].action == "BUY" && order[nOrdNum][0].orderType == "LIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS1: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, 
			order[nOrdNum][0].lmtPrice, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][0].action != "BUY" && order[nOrdNum][0].orderType == "LIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS1: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, 
			order[nOrdNum][0].lmtPrice, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][0].action == "BUY" && 
		(order[nOrdNum][0].orderType == "STP" ||
		order[nOrdNum][0].orderType == "TRAIL")) // buy stp
	{
		CString strBid;
		strBid.Format(_T("TWS1: %s %i %s %.3f STP"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][0].action != "BUY" && 
		(order[nOrdNum][0].orderType == "STP" ||
		order[nOrdNum][0].orderType == "TRAIL")) // sell stp
	{
		CString strAsk;
		strAsk.Format(_T("TWS1: %s %i %s %.3f STP"),
			order[nOrdNum][0].action,order[nOrdNum][0].totalQuantity, cont.symbol, order[nOrdNum][0].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	//  Request OpenOrders on a 5sec timer
	if (order[nOrdNum][0].orderType != "MKT")	
		m_nTimer1 = SetTimer(1, 5000, 0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
void CClient3Dlg::PlaceOrder_tws2(int nOrdNum, BOOL bEntry)
{
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	if (m_Reg.SetKey(m_RegIBDKey, TRUE) && (nOrdNum == 0))	
	{
		m_Reg.WriteString("LastAction",order[0][1].action);	// record buy/sell into m_Registry
		m_Reg.WriteBool("EntrySig",bEntry);					// record entry/exit
	}
 
	CString str, strP;
	if (cont.symbol == "")	// local symbol not used in this implementation, so no alternative
	{
		AddStatusLine("No symbol defined: Order setup cancelled", statWarn);
		ResetButtons();
		return;
	}

	if ((order[nOrdNum][0].orderType != "MKT") &&
		(order[nOrdNum][0].auxPrice == 0.0f) &&
		(order[nOrdNum][0].lmtPrice  == 0.0f))
	{
		AddStatusLine("Order is not valid: no price set for STP/LMT order.",statWarn);
		if (m_bAutoReturnToMKT == TRUE) 
		{
			m_cbbOrdType.SetCurSel(0);
			OnCbnSelchangeCombo1();
		}
		ResetButtons();
		return;
	}
	
	m_bLastEntrySig = bEntry;

	if (bEntry)
	{
		if (m_bAutoClose)
		{
			CurrentTime = CTime::GetCurrentTime();
			int h = CurrentTime.GetHour() - m_nTimeOffset;
			int m = CurrentTime.GetMinute();
			if ((h >= m_nEODhour) && (m >= m_nEODmin))
			{
				CString str = "TWS2: Order entry has been filtered on account of time of day";
				AfxMessageBox("Too late to enter a trade...");
				AddToLog(str);
				AddStatusLine(str, statWarn);
				ResetButtons();
				return;
			}
		}
	}
	else ResetButtons();

	GetAccounts();				// Check for accounts activation

	if (nOrdNum == 0)			// applies to Main Order only. Other orders do not use UI info
	{	
		OnCbnSelchangeCombo1(); // Check order type (MKT, etc)

		if (bEntry)
		{
			// reset attached order ids (if not done yet, but should be)
			m_lLastLimitOrderId1_tws2 = 0;
			m_lLastStopOrderId1_tws2 = 0;
			m_lLastLimitOrderId2_tws2 = 0;
			m_lLastStopOrderId2_tws2 = 0;
			m_lLastLimitOrderId3_tws2 = 0;
			m_lLastStopOrderId3_tws2 = 0;

			CString strId;
			strId.Format(_T("%i"),m_lOrderId_tws2); // OrderId to be used below when order is sent through
			order[0][1].ocaGroup = "Ord" + strId;
			// this OCA group is set for possible conditional orders
			// there is no need for the main order to be part of the stp/lmt group
			m_tws2.SetOca(order[0][1].ocaGroup); // so mostly unused
			if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
				m_Reg.WriteString("LastEntryOCATws2",order[0][1].ocaGroup);
			if (c1.NumShares > 0) 
				order[0][1].totalQuantity = m_nOrdSizeMult * c1.NumShares;
			else
			{
				CString strQ;
				NumContracts.GetWindowText(strQ);
				order[0][1].totalQuantity = atol(strQ) * m_nOrdSizeMult ;	
			}
		}
		else  // exit
		{
			order[0][1].totalQuantity = abs(m_nPosition2);
		}

		// set type of order
		if (m_bMarketOrder)		// Market order
		{
			order[0][1].orderType = "MKT";
			order[0][1].lmtPrice = 0.0f;
			order[0][1].auxPrice = 0.0f;
		}
		if (m_bBidAskLimitOrder)	// Bid/Ask Limit (no slippage)
		{
			order[0][1].orderType = "LMT";
			if (order[0][1].action == "BUY") 
				order[0][1].lmtPrice = m_dLatestBid;
			if (order[0][1].action == strSell || order[0][1].action == strSellShort) 
				order[0][1].lmtPrice = m_dLatestAsk;
			order[0][1].auxPrice = 0.0f;
		}
		if (m_bOneTickLimitOrder)	// try and save 1 more tick 
		{
			order[0][1].orderType = "LMT";
			if (order[0][1].action == "BUY") 
				order[0][1].lmtPrice = m_dLatestBid - m_dSymbolTickSize;
			if (order[0][1].action == strSell || order[0][1].action == strSellShort) 
				order[0][1].lmtPrice = m_dLatestAsk + m_dSymbolTickSize;
			order[0][1].auxPrice = 0.0f;
		}
		if (m_bLimitOrder && !m_bStopOrder)	// limit order (limit price must be set)
		{	
			order[0][1].lmtPrice = atof(m_strLmtPrice);
			order[0][1].auxPrice = 0.0f;
		}
		if (m_bStopOrder && !m_bLimitOrder)	// stop order (stop price must be set)
		{
			order[0][1].lmtPrice = 0.0f;
			order[0][1].auxPrice = atof(m_strStpPrice);
		}
		if (m_bStopOrder && m_bLimitOrder)	// Stop-Limit (check IB stop/limit trigger methods)
		{
			order[0][1].lmtPrice = atof(m_strLmtPrice);
			order[0][1].auxPrice = atof(m_strStpPrice);
		}
	}	// end if nOrdNum == 0

	// Now, let's get going...

	// store order numbers in registry  (separated from above for better readability)
	if (nOrdNum == 0)	// main entry/exit order
	{
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
		{
			if (bEntry)	m_lLastOrderId_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			else		m_lLastOrderId_tws2 = 0;
			m_Reg.WriteDword("LastOrderId_tws2", m_lLastOrderId_tws2);
			str.Format(_T("%i"),m_lLastOrderId_tws2); // display main order id
			ListOpenOrder1.SetItemText(1,1,str,Blue,White);
			if (order[0][1].totalQuantity <= 0)
			{
				AddStatusLine("TWS2: Num contracts/shares is incorrect.", statWarn);
				return;
			}
		}
	}

	if (nOrdNum == 1)	// attached stop order 1 (linked to limit order 4)
	{
		if (m_bTrail)	order[1][1].orderType = "TRAIL";
		else			order[1][1].orderType = "STP";
		order[1][1].lmtPrice = 0;
		if (bEntry)
		{	// order id will be incremented in the call, so store current value
			m_lLastStopOrderId1_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id1 TWS2: %i"), m_lLastStopOrderId1_tws2);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws2 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId1_tws2", m_lLastStopOrderId1_tws2);
	}

	if (nOrdNum == 2)	// attached stop order 2
	{
		if (m_bTrail)	order[2][1].orderType = "TRAIL";
		else			order[2][1].orderType = "STP";
		order[2][1].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId2_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id2 TWS2: %i"), m_lLastStopOrderId2_tws2);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId2_tws2 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId2_tws2", m_lLastStopOrderId2_tws2);
	}

	if (nOrdNum == 3)	// attached stop order 3
	{
		if (m_bTrail)	order[3][1].orderType = "TRAIL";
		else			order[3][1].orderType = "STP";
		order[3][1].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId3_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id3 TWS2: %i"), m_lLastStopOrderId3_tws2);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId3_tws2 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId3_tws2", m_lLastStopOrderId3_tws2);
	}
	// end stop orders, now limit orders...

	if (nOrdNum == 4)	// attached limit order 4 (linked to stop order 1)
	{
		order[4][1].auxPrice = 0;
		if (bEntry)
		{	// order id will incremented in the call, so store current value
			m_lLastLimitOrderId1_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id1 TWS2: %i"), m_lLastLimitOrderId1_tws2);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws2 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId1_tws2", m_lLastLimitOrderId1_tws2);
	}

	if (nOrdNum == 5)	// attached limit order 5 (attached to stop 2)
	{
		order[5][1].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId2_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id2 TWS2: %i"), m_lLastLimitOrderId2_tws2);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastLimitOrderId2_tws2 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId2_tws2", m_lLastLimitOrderId2_tws2);
	}

	if (nOrdNum == 6)	// attached limit order 6
	{
		order[6][1].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId3_tws2 = m_lOrderId_tws2;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id3 TWS2: %i"), m_lLastLimitOrderId3_tws2);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastLimitOrderId3_tws2 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId3_tws2", m_lLastLimitOrderId3_tws2);
	}

	if (m_bVerbose)
	{
		CString str;
		str.Format(_T("->id:%i %s %s %i %s %s %.2f %.2f"),
			m_lOrderId_tws2,
			order[nOrdNum][1].ocaGroup,
			order[nOrdNum][1].action,
			order[nOrdNum][1].totalQuantity,
			cont.symbol,
			order[nOrdNum][1].orderType,
			order[nOrdNum][1].lmtPrice,
			order[nOrdNum][1].auxPrice);
		AddToLog(str);
	}	

	if (!m_bPaperTrade)
		m_tws2.placeOrder(
				m_lOrderId_tws2++,		// immediately incremented for next order
				order[nOrdNum][1].action,
				order[nOrdNum][1].totalQuantity,
				cont.symbol,
				cont.secType,
				cont.expiry,
				cont.strike,
				cont.right,
				cont.multiplier,
				cont.exchange,
				cont.primaryExchange,
				cont.currency,
				order[nOrdNum][1].orderType,
				order[nOrdNum][1].lmtPrice,
				order[nOrdNum][1].auxPrice,
				FA[1].faGoodAfterTime,
				FA[1].faGroup,
				FA[1].faMethod,
				FA[1].faPercentage,
				FA[1].faProfile,
				FA[1].faGoodTillDate
				);

	if (!bEntry) m_tws2.SetOca("");		// reset OCA for current TWS

	// get current price to account for slippage - display & record
	if (order[nOrdNum][1].action == "BUY" && order[nOrdNum][1].orderType == "MKT") 
	{
		CString strAsk;
		strAsk.Format(_T("TWS2: %s %i %s MKT Ask:%.3f "),
			order[nOrdNum][1].action, order[nOrdNum][1].totalQuantity, 
			cont.symbol, m_dLatestAsk);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][1].action != "BUY" && order[nOrdNum][1].orderType == "MKT") 
	{
		CString strBid;
		strBid.Format(_T("TWS2: %s %i %s MKT Bid:%.3f "),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, 
			cont.symbol, m_dLatestBid);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid, statInfo);
	}

	if (order[nOrdNum][1].action == "BUY" && order[nOrdNum][1].orderType == "LMT") 
	{
		CString strBid;
		strBid.Format(_T("TWS2: %s %i %s %.3f LMT"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].lmtPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][1].action != "BUY" && order[nOrdNum][1].orderType == "LMT") 
	{
		CString strAsk;
		strAsk.Format(_T("TWS2: %s %i %s %.3f LMT"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].lmtPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][1].action == "BUY" && order[nOrdNum][1].orderType == "MIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS2: %s %i %s %.3f MIT"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][1].action != "BUY" && order[nOrdNum][1].orderType == "MIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS2: %s %i %s %.3f MIT"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][1].action == "BUY" && order[nOrdNum][1].orderType == "LIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS2: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, 
			order[nOrdNum][1].lmtPrice, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][1].action != "BUY" && order[nOrdNum][1].orderType == "LIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS2: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, 
			order[nOrdNum][1].lmtPrice, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][1].action == "BUY" && 
		(order[nOrdNum][1].orderType == "STP" ||
		order[nOrdNum][1].orderType == "TRAIL")) 
	{
		CString strBid;
		strBid.Format(_T("TWS2: %s %i %s %.3f STP"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][1].action != "BUY" && 
		(order[nOrdNum][1].orderType == "STP" ||
		order[nOrdNum][1].orderType == "TRAIL")) 
	{
		CString strAsk;
		strAsk.Format(_T("TWS2: %s %i %s %.3f STP"),
			order[nOrdNum][1].action,order[nOrdNum][1].totalQuantity, cont.symbol, order[nOrdNum][1].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	//  Request OpenOrders on a 5sec timer
	if (order[nOrdNum][1].orderType != "MKT")	
		m_nTimer2 = SetTimer(2, 5000, 0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
void CClient3Dlg::PlaceOrder_tws3(int nOrdNum, BOOL bEntry)	
// differentiates entries (stop loss...) from exits ( order clean up)
{	// order.action is set by the order buttons, which then calls this function
	// this function is also called from the order status event (attached orders)
	m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	m_RegIBDKey = "Software\\IBD" + m_strSessionNo + "\\LastOrders";
	if (m_Reg.SetKey(m_RegIBDKey, TRUE) && (nOrdNum == 0))	
	{
		m_Reg.WriteString("LastAction",order[0][2].action);	// record buy/sell into m_Registry
		m_Reg.WriteBool("EntrySig",bEntry);					// record entry/exit
	}
 
	CString str, strP;
	if (cont.symbol == "")	// local symbol not used in this implementation, so no alternative
	{
		AddStatusLine("No symbol defined: Order setup cancelled", statWarn);
		ResetButtons();
		return;
	}

	if ((order[nOrdNum][0].orderType != "MKT") &&
		(order[nOrdNum][0].auxPrice == 0.0f) &&
		(order[nOrdNum][0].lmtPrice  == 0.0f))
	{
		AddStatusLine("Order is not valid: no price on STP/LMT order.",statWarn);
		if (m_bAutoReturnToMKT == TRUE) 
		{
			m_cbbOrdType.SetCurSel(0);
			OnCbnSelchangeCombo1();
		}
		ResetButtons();
		return;
	}

	m_bLastEntrySig = bEntry;

	if (bEntry)
	{
		if (m_bAutoClose)
		{
			CurrentTime = CTime::GetCurrentTime();
			int h = CurrentTime.GetHour() - m_nTimeOffset;
			int m = CurrentTime.GetMinute();
			if ((h >= m_nEODhour) && (m >= m_nEODmin))
			{
				CString str = "TWS3: Order entry has been filtered on account of time of day";
				AfxMessageBox("Too late to enter a trade...");
				AddToLog(str);
				AddStatusLine(str, statWarn);
				ResetButtons();
				return;
			}
		}
	}
	else	ResetButtons();

	GetAccounts();				// Check for accounts activation

	if (nOrdNum == 0)			// applies to Main Order only. Other orders do not use UI info
	{	
		OnCbnSelchangeCombo1(); // Check order type (MKT, etc)

		if (bEntry)
		{
			// reset attached order ids (if not done yet, but should be)
			m_lLastLimitOrderId1_tws3 = 0;
			m_lLastStopOrderId1_tws3 = 0;
			m_lLastLimitOrderId2_tws3 = 0;
			m_lLastStopOrderId2_tws3 = 0;
			m_lLastLimitOrderId3_tws3 = 0;
			m_lLastStopOrderId3_tws3 = 0;

			CString strId;
			strId.Format(_T("%i"),m_lOrderId_tws3); // OrderId to be used below when order is sent through
			order[0][2].ocaGroup = "Ord" + strId;
			// this OCA group is set for possible conditional orders
			// there is no need for the main order to be part of the stp/lmt group
			m_tws3.SetOca(order[0][2].ocaGroup); // so mostly unused
			if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
				m_Reg.WriteString("LastEntryOCATws3",order[0][2].ocaGroup);
			if (c1.NumShares > 0) 
				order[0][2].totalQuantity = m_nOrdSizeMult * c1.NumShares;
			else
			{
				CString strQ;
				NumContracts.GetWindowText(strQ);
				order[0][2].totalQuantity = atol(strQ) * m_nOrdSizeMult ;	
			}
		}
		else  // exit
		{
			order[0][2].totalQuantity = abs(m_nPosition3);
			//if (m_nPosition1 !=0 || m_nPosition2 !=0 || m_nPosition3 !=0)
			//	if (order[0].ocaGroup != "" && order[0].orderType != "MKT" && !bEntry)
			//	{				
					//AddStatusLine("Please use existing STP/LMT exit orders instead...", statWarn);
					//return;
			//	}
		}

		// set type of order
		if (m_bMarketOrder)		// Market order
		{
			order[0][2].orderType = "MKT";
			order[0][2].lmtPrice = 0.0f;
			order[0][2].auxPrice = 0.0f;
		}
		if (m_bBidAskLimitOrder)	// Bid/Ask Limit (no slippage)
		{
			order[0][2].orderType = "LMT";
			if (order[0][2].action == "BUY") 
				order[0][2].lmtPrice = m_dLatestBid;
			if (order[0][2].action == strSell || order[0][2].action == strSellShort) 
				order[0][2].lmtPrice = m_dLatestAsk;
			order[0][2].auxPrice = 0.0f;
		}
		if (m_bOneTickLimitOrder)	// try and save 1 more tick 
		{
			order[0][2].orderType = "LMT";
			if (order[0][2].action == "BUY") 
				order[0][2].lmtPrice = m_dLatestBid - m_dSymbolTickSize;
			if (order[0][2].action == strSell || order[0][2].action == strSellShort) 
				order[0][2].lmtPrice = m_dLatestAsk + m_dSymbolTickSize;
			order[0][2].auxPrice = 0.0f;
		}
		if (m_bLimitOrder && !m_bStopOrder)	// limit order (limit price must be set)
		{	
			order[0][2].lmtPrice = atof(m_strLmtPrice);
			order[0][2].auxPrice = 0.0f;
		}
		if (m_bStopOrder && !m_bLimitOrder)	// stop order (stop price must be set)
		{
			order[0][2].lmtPrice = 0.0f;
			order[0][2].auxPrice = atof(m_strStpPrice);
		}
		if (m_bStopOrder && m_bLimitOrder)	// Stop-Limit (check IB stop/limit trigger methods)
		{
			order[0][2].lmtPrice = atof(m_strLmtPrice);
			order[0][2].auxPrice = atof(m_strStpPrice);
		}
	}	// end if nOrdNum == 0

	// Now, let's get going...

	// store order numbers in registry  (separated from above for better readability)
	if (nOrdNum == 0)	// main entry/exit order
	{
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
		{
			if (bEntry)	m_lLastOrderId_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			else		m_lLastOrderId_tws3 = 0;
			m_Reg.WriteDword("LastOrderId_tws3", m_lLastOrderId_tws3);
			str.Format(_T("%i"),m_lLastOrderId_tws3); // display main order id
			ListOpenOrder1.SetItemText(2,1,str,Blue,White);
			if (order[0][2].totalQuantity <= 0)
			{
				AddStatusLine("TWS3: Num contracts/shares is incorrect.", statWarn);
				return;
			}
		}
	}

	if (nOrdNum == 1)	// attached stop order 1 (linked to limit order 4)
	{
		if (m_bTrail)	order[1][2].orderType = "TRAIL";
		else			order[1][2].orderType = "STP";
		order[1][2].lmtPrice = 0;
		if (bEntry)
		{	// order id will be incremented in the call, so store current value
			m_lLastStopOrderId1_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id1 TWS3: %i"), m_lLastStopOrderId1_tws2);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws3 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId1_tws3", m_lLastStopOrderId1_tws3);
	}

	if (nOrdNum == 2)	// attached stop order 2
	{
		if (m_bTrail)	order[2][2].orderType = "TRAIL";
		else			order[2][2].orderType = "STP";
		order[2][2].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId2_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id2 TWS3: %i"), m_lLastStopOrderId2_tws3);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId2_tws3 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId2_tws3", m_lLastStopOrderId2_tws3);
	}

	if (nOrdNum == 3)	// attached stop order 3
	{
		if (m_bTrail)	order[3][2].orderType = "TRAIL";
		else			order[3][2].orderType = "STP";
		order[3][2].lmtPrice = 0;
		if (bEntry) 
		{
			m_lLastStopOrderId3_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Stop Order Id3 TWS3: %i"), m_lLastStopOrderId3_tws3);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastStopOrderId3_tws3 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastStopOrderId3_tws3", m_lLastStopOrderId3_tws3);
	}
	// end stop orders, now limit orders...

	if (nOrdNum == 4)	// attached limit order 4 (linked to stop order 1)
	{
		order[4][2].auxPrice = 0;
		if (bEntry)
		{	// order id will incremented in the call, so store current value
			m_lLastLimitOrderId1_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id1 TWS3: %i"), m_lLastLimitOrderId1_tws3);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastStopOrderId1_tws3 = 0;	// reset (to avoid confusion at startup check for pending orders
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId1_tws3", m_lLastLimitOrderId1_tws3);
	}

	if (nOrdNum == 5)	// attached limit order 5 (attached to stop 2)
	{
		order[5][2].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId2_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id2 TWS3: %i"), m_lLastLimitOrderId2_tws3);
			AddStatusLine(str,statInfo);
		}
		else 		m_lLastLimitOrderId2_tws3 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId2_tws3", m_lLastLimitOrderId2_tws3);
	}

	if (nOrdNum == 6)	// attached limit order 6
	{
		order[6][2].auxPrice = 0;
		if (bEntry) 
		{
			m_lLastLimitOrderId3_tws3 = m_lOrderId_tws3;		// stored for mod/cancel
			CString str;
			str.Format(_T("Limit Order Id3 TWS3: %i"), m_lLastLimitOrderId3_tws3);
			AddStatusLine(str,statInfo);
		}
		else 	m_lLastLimitOrderId3_tws3 = 0;				
		if (m_Reg.SetKey(m_RegIBDKey, TRUE))	
			m_Reg.WriteDword("LastLimitOrderId3_tws3", m_lLastLimitOrderId3_tws3);
	}

	if (m_bVerbose)
	{
		CString str;
		str.Format(_T("->id:%i %s %s %i %s %s %.2f %.2f"),
			m_lOrderId_tws3,
			order[nOrdNum][2].ocaGroup,
			order[nOrdNum][2].action,
			order[nOrdNum][2].totalQuantity,
			cont.symbol,
			order[nOrdNum][2].orderType,
			order[nOrdNum][2].lmtPrice,
			order[nOrdNum][2].auxPrice);
		AddToLog(str);
	}	

	if (!m_bPaperTrade)
		m_tws3.placeOrder(
				m_lOrderId_tws3++,		// immediately incremented for next order
				order[nOrdNum][2].action,
				order[nOrdNum][2].totalQuantity,
				cont.symbol,
				cont.secType,
				cont.expiry,
				cont.strike,
				cont.right,
				cont.multiplier,
				cont.exchange,
				cont.primaryExchange,
				cont.currency,
				order[nOrdNum][2].orderType,
				order[nOrdNum][2].lmtPrice,
				order[nOrdNum][2].auxPrice,
				FA[2].faGoodAfterTime,
				FA[2].faGroup,
				FA[2].faMethod,
				FA[2].faPercentage,
				FA[2].faProfile,
				FA[2].faGoodTillDate
				);

	if (!bEntry) m_tws3.SetOca("");		// reset OCA for current TWS

	// get current price to account for slippage - display & record
	if (order[nOrdNum][2].action == "BUY" && order[nOrdNum][2].orderType == "MKT") 
	{
		CString strAsk;
		strAsk.Format(_T("TWS3: %s %i %s MKT Ask:%.3f "),
			order[nOrdNum][2].action, order[nOrdNum][2].totalQuantity, 
			cont.symbol, m_dLatestAsk);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][2].action != "BUY" && order[nOrdNum][2].orderType == "MKT") 
	{
		CString strBid;
		strBid.Format(_T("TWS3: %s %i %s MKT Bid:%.3f "),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, 
			cont.symbol, m_dLatestBid);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid, statInfo);
	}

	if (order[nOrdNum][2].action == "BUY" && order[nOrdNum][2].orderType == "LMT") 
	{
		CString strBid;
		strBid.Format(_T("TWS3: %s %i %s %.3f LMT"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].lmtPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][2].action != "BUY" && order[nOrdNum][2].orderType == "LMT") 
	{
		CString strAsk;
		strAsk.Format(_T("TWS3: %s %i %s %.3f LMT"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].lmtPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}


	if (order[nOrdNum][2].action == "BUY" && order[nOrdNum][2].orderType == "MIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS3: %s %i %s %.3f MIT"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][2].action != "BUY" && order[nOrdNum][2].orderType == "MIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS3: %s %i %s %.3f MIT"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	if (order[nOrdNum][2].action == "BUY" && order[nOrdNum][2].orderType == "LIT") // buy lmt
	{
		CString strBid;
		strBid.Format(_T("TWS3: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, 
			order[nOrdNum][2].lmtPrice, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][2].action != "BUY" && order[nOrdNum][2].orderType == "LIT") // sell lmt
	{
		CString strAsk;
		strAsk.Format(_T("TWS3: %s %i %s %.3f LIT %.3f"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, 
			order[nOrdNum][2].lmtPrice, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}


	if (order[nOrdNum][2].action == "BUY" && 
		(order[nOrdNum][2].orderType == "STP" ||
		order[nOrdNum][2].orderType == "TRAIL")) 
	{
		CString strBid;
		strBid.Format(_T("TWS3: %s %i %s %.3f STP"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strBid += " (paper trade)";
		AddToLog(strBid);
		AddToTradeLog(strBid);
		AddStatusLine(strBid,statInfo);
	}

	if (order[nOrdNum][2].action != "BUY" && 
		(order[nOrdNum][2].orderType == "STP" ||
		order[nOrdNum][2].orderType == "TRAIL")) 
	{
		CString strAsk;
		strAsk.Format(_T("TWS3: %s %i %s %.3f LMT"),
			order[nOrdNum][2].action,order[nOrdNum][2].totalQuantity, cont.symbol, order[nOrdNum][2].auxPrice);
		if (m_bPaperTrade) strAsk += " (paper trade)";
		AddToLog(strAsk);
		AddToTradeLog(strAsk);
		AddStatusLine(strAsk, statInfo);
	}

	//  Request OpenOrders on a 5sec timer
	if (order[nOrdNum][2].orderType != "MKT")	
		m_nTimer3 = SetTimer(3, 5000, 0);
}

void CClient3Dlg::OnTimer(UINT nIDEvent)
{
	// a bit silly since the returned timer id is also the event no
	if (nIDEvent == 1)
	{
		OnreqOpenOrders();	// wait for 2secs to request open orders
		KillTimer(m_nTimer1);
	}
	if (nIDEvent == 2)
	{
		OnreqOpenOrders();	// wait for 2secs to request open orders
		KillTimer(m_nTimer2);
	}
	if (nIDEvent == 3)
	{
		OnreqOpenOrders();	// wait for 2secs to request open orders
		KillTimer(m_nTimer3);
	}

	if (nIDEvent == 10)		// timer for ticker activity
	{
		if ((m_dLatestTrade > 0) &&
			(m_dLatestAsk > 0) &&
			(m_dLatestBid > 0) &&
			(m_dSymbolTickSize > 0))
		{
			OnBnClickedMktdepth();
			KillTimer(m_nTimerTicker);
		}		
	}

	if (nIDEvent == 11)		// timer for openorder
	{
		if ((m_nPosition1 == 0) && (m_nPosition2 == 0) && (m_nPosition3 == 0))
		{
			CWinApp *pApp= AfxGetApp();
			GetWindowRect(m_dlgRect);
			pApp->m_pMainWnd->MoveWindow(
				m_dlgRect.left,
				m_dlgRect.top,
				m_dlgRect.Width(),
				m_nRectHeight - nHeightDiff,
				TRUE);
			ResetButtons();
			KillTimer(11);
		}
	}

	/*
	if (nIDEvent == 100)
	{
		srand( (unsigned)time( NULL ) );
		double r1 = (double)rand()/32768;    // random decimal
		int r2 = rand()/2;
		int position = (r1  * 5) / 5;
		long side = (r1> 0.5 ? 1:0);

		//OnupdateMktDepthTwsctrl1(m_lTickerId,position,1,side,price,r2);
	}
	*/

	CDialog::OnTimer(nIDEvent);
}

// check if TWS account is activated
void CClient3Dlg::GetAccounts(void)
{
	for (int i=0; i<m_lNumIB; i++)
	{
		m_bTwsChecked1[i] = ListOpenOrder1.GetCheckbox(i,0);
		//m_bTwsChecked2[i] = ListOpenOrder2.GetCheckbox(i,0);
	}

	if (m_bTwsChecked1[0] == FALSE) 
	{
		MessageBox("Caution: Some IB events depend exclusively on TWS1 being operational (check documentation).","IB_Direct");
	}
}

// Log section (display and file)
// The following code should be made thread safe to allow the PlaceOrder routines 
// to run on separate threads
void CClient3Dlg::SetLogFile(void)
{
	CFileSystem fs;
	if (!fs.IsDirectoryExist(m_strLogPath))			fs.MakeDirectory(m_strLogPath);
	if (!fs.IsDirectoryExist(m_strTradeLogPath))	fs.MakeDirectory(m_strTradeLogPath);

	CurrentTime = CTime::GetCurrentTime();
	m_strLog = "IB_Log_" + m_strSessionNo + CurrentTime.Format("_%d%m%y") + ".txt";

	AddToLog("Log file: " + m_strLog);	// just 1 header line
	AddStatusLine("Log file: " +  m_strLog, statInfo);
}

// Add a new line into log file
void CClient3Dlg::AddToLog(CString strLine)
{	// simplistic for the time being
	CString strTime;
	CurrentTime = CTime::GetCurrentTime();
	strTime = CurrentTime.Format("%H:%M:%S ");
	::ofstream f;
	f.open(m_strLogPath+m_strLog,std::ios::app);
	f << strTime << strLine << endl;
	f.close();
}

// Add a new line into log file
void CClient3Dlg::AddToTradeLog(CString strLine)
{	// simplistic for the time being
	CString strTime;
	CurrentTime = CTime::GetCurrentTime();
	strTime = CurrentTime.Format("%H:%M:%S ");
	::ofstream f;
	f.open(m_strTradeLogPath+m_strLog,std::ios::app);
	f << strTime << strLine << endl;
	f.close();
}

// Add a line to the Status ListBox
void CClient3Dlg::AddStatusLine(CString strLine, int statType)
{
	static CString strLast;
	if (mlInfo)
	{
		if (m_bPopupStatus) mlInfo->ShowWindow(SW_SHOW);
	}
	else
		return;
	
	if (statType == statError)
	{
		if (strLine == strLast) return;
		strLast = strLine;
		if (mlInfo) mlInfo->ListStatus.InsertItem(0,strLine,White,DarkRed);
		//Beep(100,250);
		ResetButtons();
	}
	else if	(statType == statWarn)
		{
			if (mlInfo) mlInfo->ListStatus.InsertItem(0,strLine,White,DarkGreen);
			//Beep(250,150);
			//ResetButtons();
		}
		else	// statInfo
		{
			if (mlInfo) mlInfo->ListStatus.InsertItem(0,strLine,White,DarkBlue);
		}

	if (mlInfo)
	{
		CRect rect;
		LONG lw;
		mlInfo->ListStatus.GetClientRect(&rect);
		lw = rect.right - rect.left;
		int ic = mlInfo->ListStatus.GetItemCount();
		if (ic > 13)
			mlInfo->ListStatus.SetColumnWidth(0,lw-6);
		else
			mlInfo->ListStatus.SetColumnWidth(0,lw-3);
	}
}
// end log section

///////////////////////////////////////////////////////////////

// Dialog setup
void CClient3Dlg::SetupListCtrls(void)
{
	COLORREF	crBkColor = Colour;
	RECT rect;

	m_lstFAAccounts.InsertString(0,"1");
	m_lstFAAccounts.InsertString(1,"2");
	m_lstFAAccounts.InsertString(2,"3");
	
	m_lstFAAccounts.SetCurSel(-1);

	m_lstEntry.SetExtendedStyle(LVS_EX_GRIDLINES );
	m_lstEntry.GetClientRect(&rect);
	int lw = rect.right - rect.left;
	m_lstEntry.SetBkColor(crBkColor);
	m_lstEntry.InsertColumn(0, "Entry", LVCFMT_CENTER, lw, -1 );
	m_lstEntry.InsertItem(0,"Conservative");
	m_lstEntry.InsertItem(1,"Balanced");
	m_lstEntry.InsertItem(2,"Aggressive");
	m_lstEntry.InsertItem(3,"Very aggressive");
	
	m_lstEntry.SetCurSel(0);
	m_nOrdSizeMult = 1;

	ListOpenOrder1.SetExtendedStyle(
		LVS_OWNERDRAWFIXED |
		LVS_EX_GRIDLINES | 
		LVS_EX_CHECKBOXES);
	ListOpenOrder1.GetClientRect(&rect);
	lw = rect.right - rect.left;
	ListOpenOrder1.SetBkColor(crBkColor);

	ListOpenOrder1.InsertColumn(0, "Tws", LVCFMT_LEFT, lw/8, -1 );
	ListOpenOrder1.InsertColumn(1, "Id", LVCFMT_LEFT, lw/12, -1 );
	//ListOpenOrder1.InsertColumn(2, "Symbol", LVCFMT_CENTER, lw/12, -1 );
	ListOpenOrder1.InsertColumn(2, "Action", LVCFMT_CENTER, lw/12, -1 );
	ListOpenOrder1.InsertColumn(3, "Qty", LVCFMT_CENTER, lw/12, -1 );
	ListOpenOrder1.InsertColumn(4, "Type", LVCFMT_CENTER, lw/6, -1 );
	int nLastItemWidth = lw - (lw/8) - (lw/6) - 3 * (lw/12);
	ListOpenOrder1.InsertColumn(5, "StpP", LVCFMT_CENTER, nLastItemWidth/4, -1 );
	ListOpenOrder1.InsertColumn(6, "LmtP1", LVCFMT_CENTER, nLastItemWidth/4, -1 );
	ListOpenOrder1.InsertColumn(7, "LmtP2", LVCFMT_CENTER, nLastItemWidth/4, -1 );
	ListOpenOrder1.InsertColumn(8, "LmtP3", LVCFMT_CENTER, nLastItemWidth/4, -1 );

	ListOpenOrder1.InsertItem(0,"Acc1");//,Black,crBkColor);
	ListOpenOrder1.SetCheckbox(0,0,TRUE);
	if (m_lNumIB>1) 
	{
		ListOpenOrder1.InsertItem(1,"Acc2");//,Black,crBkColor);
		ListOpenOrder1.SetCheckbox(1,0,TRUE);
	}
	if (m_lNumIB>2) 
	{
		ListOpenOrder1.InsertItem(2,"Acc3");//,Black,crBkColor);
		ListOpenOrder1.SetCheckbox(2,0,TRUE);
	}

	// Add a checkbox in list header
	VERIFY(ListOpenOrder1.m_cImageList.Create(IDB_CHECKBOXES, 16, 3, RGB(255, 0, 255)));
	ListOpenOrder1.m_HeaderCtrl.SetImageList(&ListOpenOrder1.m_cImageList);

	HDITEM hditem;
	for (int i = 0; i < ListOpenOrder1.m_HeaderCtrl.GetItemCount(); i++)
	{
		hditem.mask = HDI_IMAGE | HDI_FORMAT;
		ListOpenOrder1.m_HeaderCtrl.GetItem(i, &hditem);
		hditem.fmt |=  HDF_IMAGE;
		hditem.iImage = (i==0?XHEADERCTRL_CHECKED_IMAGE:XHEADERCTRL_NO_IMAGE);
		//if (i == 0)
		//	hditem.iImage = XHEADERCTRL_CHECKED_IMAGE;
		//else
		//	hditem.iImage = XHEADERCTRL_NO_IMAGE;

		ListOpenOrder1.m_HeaderCtrl.SetItem(i, &hditem);
	}

	ListOpenOrder2.SetExtendedStyle(
		LVS_OWNERDRAWFIXED |
		LVS_EX_GRIDLINES | 
		LVS_EX_CHECKBOXES);
		
	ListOpenOrder2.GetClientRect(&rect);
	lw = rect.right - rect.left;
	ListOpenOrder2.SetBkColor(crBkColor);
	ListOpenOrder2.InsertColumn(0, "Tws", LVCFMT_LEFT, lw/12, -1 );
	ListOpenOrder2.InsertColumn(1, "Id/Pos", LVCFMT_LEFT, lw/8, -1 );
	ListOpenOrder2.InsertColumn(2, "Status", LVCFMT_LEFT, lw/3, -1 );
	ListOpenOrder2.InsertColumn(3, "Filled", LVCFMT_RIGHT, lw/8, -1 );
	ListOpenOrder2.InsertColumn(4, "Remaining", LVCFMT_RIGHT, lw/8, -1 );
	ListOpenOrder2.InsertColumn(5, "LastFill", LVCFMT_RIGHT, lw/8, -1 );
	nLastItemWidth = lw - (lw/12) - 4*(lw/8) - lw/3;
	ListOpenOrder2.InsertColumn(6, "Avg.Fill", LVCFMT_RIGHT, nLastItemWidth, -1 );
	ListOpenOrder2.InsertItem(0,"Acc1");
	//ListOpenOrder2.SetCheckbox(0,0,TRUE);
	if (m_lNumIB>1) 
	{
		ListOpenOrder2.InsertItem(1,"Acc2");
		//ListOpenOrder2.SetCheckbox(1,0,TRUE);
	}
	if (m_lNumIB>2) 
	{
		ListOpenOrder2.InsertItem(2,"Acc3");
		//ListOpenOrder2.SetCheckbox(2,0,TRUE);
	}

	// Add a checkbox in list header (1st col)
	VERIFY(ListOpenOrder2.m_cImageList.Create(IDB_CHECKBOXES, 16, 3, RGB(255, 0, 255)));
	ListOpenOrder2.m_HeaderCtrl.SetImageList(&ListOpenOrder2.m_cImageList);

	for (int i = 0; i < ListOpenOrder2.m_HeaderCtrl.GetItemCount(); i++)
	{
		hditem.mask = HDI_IMAGE | HDI_FORMAT;
		ListOpenOrder2.m_HeaderCtrl.GetItem(i, &hditem);
		hditem.fmt |=  HDF_IMAGE;
		//if (i == 0)
		//	hditem.iImage = XHEADERCTRL_CHECKED_IMAGE;
		//else
			hditem.iImage = XHEADERCTRL_NO_IMAGE;
		ListOpenOrder2.m_HeaderCtrl.SetItem(i, &hditem);
	}

	ListBidAsk.SetBkColor(crBkColor);
	ListBidAsk.SetExtendedStyle(LVS_EX_GRIDLINES);
	ListBidAsk.GetClientRect(&rect);
	lw = rect.right - rect.left;

	ListBidAsk.InsertColumn(0,"", LVCFMT_CENTER, 0, -1 );
	ListBidAsk.InsertColumn(1,"1Tick dn", LVCFMT_CENTER, lw/5, -1 );
	ListBidAsk.InsertColumn(2,"Bid", LVCFMT_CENTER, lw/5, -1 );
	ListBidAsk.InsertColumn(3,"Last", LVCFMT_CENTER, lw/5, -1 );
	ListBidAsk.InsertColumn(4,"Ask", LVCFMT_CENTER, lw/5, -1 );
	nLastItemWidth = lw - 4 * (lw/5);
	ListBidAsk.InsertColumn(5,"1Tick up", LVCFMT_CENTER, nLastItemWidth , -1 );
	ListBidAsk.InsertItem(0,"P",Blue,Colour);//,Black,crBkColor);
	ListBidAsk.InsertItem(1,"S",Blue,Colour);//,Black,crBkColor);

	CRect lprect;
	int nLines = 6;
	m_cbbOrdType.GetWindowRect( &lprect ); 
	lprect.bottom = lprect.top + nLines * m_cbbOrdType.GetItemHeight( -1 ) + lprect.Height();
	m_cbbOrdType.SetWindowPos(NULL, 0, 0, lprect.Width(), lprect.Height(), SWP_NOMOVE | SWP_NOZORDER );
	m_cbbOrdType.InsertString(0,"MKT");
	m_cbbOrdType.InsertString(1,"Bid/Ask LMT");
	m_cbbOrdType.InsertString(2,"1 Tick LMT");
	m_cbbOrdType.InsertString(3,"LMT");
	m_cbbOrdType.InsertString(4,"LIT");
	m_cbbOrdType.InsertString(5,"MIT");
	//m_cbbOrdType.InsertString(6,"STP/TRAIL");
	//m_cbbOrdType.InsertString(7,"STP LMT");
	//m_cbbOrdType.InsertString(8,"REL");

	m_cbbOrdType.SetCurSel(0);
}

void CClient3Dlg::OnInitButtons(BOOL bDisplayIcon) 
{
	// Calculate a color effect for hilighting the button
	short crBtnColor = 30;

	m_btnFA.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnFA.SetTooltipText(_T("Financial Advisor Info"));

	m_btnRefresh.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnRefresh.SetTooltipText(_T("Request open order status"));

	m_btnFAaccts.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnFAaccts.SetTooltipText(_T("Financial Advisor Info"));

	m_btnAllocation.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnAllocation.SetTooltipText(_T("Allocation across FA sub-accounts"));

	m_btnMktDepth.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnMktDepth.SetTooltipText(_T("Display Market Depth"));

	m_btnSLExits.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnSLExits.SetTooltipText(_T("Adjust Stop/Limit Exit prices"));

	m_btnSLEntry.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnSLEntry.SetTooltipText(_T("Adjust Stop/Limit Entry prices"));

	m_btnConnect.SetIcon(IDI_LOGON);
	m_btnConnect.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnConnect.SetTooltipText(_T("Connect to IB WorkStation"));

	m_btnDisconnect.SetIcon(IDI_EXIT);
	m_btnDisconnect.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnDisconnect.SetTooltipText(_T("Disconnect from IB WorkStation"));

	m_btnSettings.SetIcon(IDI_SETTINGS);
	m_btnSettings.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnSettings.SetTooltipText(_T("Ticker & Order settings"));

	m_btnStatus.SetIcon(IDI_EXEC);
	m_btnStatus.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnStatus.SetTooltipText(_T("Status"));

	m_btnCancelOrders.SetIcon(IDI_X);
	m_btnCancelOrders.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnCancelOrders.SetTooltipText(_T("Cancel pending stop/limit primary order"));

	m_btnClose.SetIcon(IDI_RUN);
	m_btnClose.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnClose.SetTooltipText(_T("Shutdown system"));

	if (bDisplayIcon)	m_btnLE.SetIcon(IDI_LE);
	else				m_btnLE.SetIcon(IDI_LE1);
	m_btnLE.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnLE.SetTooltipText(_T("Long Entry"));
	
	if (bDisplayIcon)	m_btnSE.SetIcon(IDI_SE);
	else				m_btnSE.SetIcon(IDI_SE1);
	m_btnSE.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnSE.SetTooltipText(_T("Short Entry"));

	if (bDisplayIcon)	m_btnLX.SetIcon(IDI_LX);
	else				m_btnLX.SetIcon(IDI_LX1);
	m_btnLX.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnLX.SetTooltipText(_T("Long Exit"));

	if (bDisplayIcon)	m_btnSX.SetIcon(IDI_SX);
	else				m_btnSX.SetIcon(IDI_SX1);
	m_btnSX.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnSX.SetTooltipText(_T("Short Exit"));

	if (bDisplayIcon)	m_btnRL.SetIcon(IDI_RL);
	else				m_btnRL.SetIcon(IDI_RL1);
	m_btnRL.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnRL.SetTooltipText(_T("Reverse Long"));

	if (bDisplayIcon)	m_btnRS.SetIcon(IDI_RS);
	else				m_btnRS.SetIcon(IDI_RS1);
	m_btnRS.OffsetColor(CButtonST::BTNST_COLOR_BK_IN, crBtnColor);
	m_btnRS.SetTooltipText(_T("Reverse Short"));
}
//  end dialog setup

/////////////////////////////////////////////////////////////////

//  Dialog events (some are still to be tested)

void CClient3Dlg::OnLvnItemchangedListopen1(NMHDR *pNMHDR, LRESULT *pResult)
{	// To eventually assign orders to specific IB accounts
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CString str;
	BOOL bChecked;
	UINT state = pNMLV->uNewState;

	bChecked = (state == 8192) ? TRUE : FALSE; // state = 4096 otherwise
	m_bTwsChecked1[pNMLV->iItem] = bChecked;

	for (int i=0;i<m_lNumIB;i++)
		if ((m_bTwsChecked1[i] == FALSE) && (m_bTwsConnected[i] == TRUE))
		{
			str.Format(_T("Caution: Tws%i deactivated (1)"),i);
			AddStatusLine(str, statWarn);
		}	
	*pResult = 0;
}

void CClient3Dlg::OnLvnItemchangedListopen2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CString str;
	BOOL bChecked;
	UINT state = pNMLV->uNewState;
	
	bChecked = (state == 8192) ? TRUE : FALSE; // state = 4096 otherwise
/*	m_bTwsChecked2[pNMLV->iItem] = bChecked;

	for (int i=0;i<m_lNumIB;i++)
		if ((m_bTwsChecked2[i] == FALSE) && (m_bTwsConnected[i] == TRUE))
		{
			str.Format("Caution: Tws%i deactivated (2)",i);
			AddStatusLine(str, statWarn);
		}
*/
	*pResult = 0;
}

void CClient3Dlg::OnNMClickOpen1(NMHDR *pNMHDR, LRESULT *pResult)
{
	GetAccounts(); // get checkboxes status
	OnBnClickedClearexec(); // clear lists first
	if (m_bTwsChecked1[0] == TRUE)
		m_tws1.reqOpenOrders();

	if (m_lNumIB>1 && m_bTwsChecked1[1] == TRUE)
		m_tws2.reqOpenOrders();

	if (m_lNumIB>2 && m_bTwsChecked1[2] == TRUE)
		m_tws3.reqOpenOrders();	
	*pResult = 0;
}

//  Custom Draw Section
// does not work (must probably change messaging to MESSAGE_REFLECT)
void CClient3Dlg::OnNMCustomdrawList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVCUSTOMDRAW  lplvcd = (LPNMLVCUSTOMDRAW)pNMHDR;
	int iRow, iCol=0;
	switch(lplvcd->nmcd.dwDrawStage)
	{
		case CDDS_PREPAINT:
			*pResult = CDRF_NOTIFYITEMDRAW;	// ask for item notifications.
			break;

		case CDDS_ITEMPREPAINT:
			*pResult = CDRF_DODEFAULT;
			iCol = lplvcd->iSubItem;
			iRow = lplvcd->nmcd.dwItemSpec;
			if (iCol % 2 == 0)
			{
				lplvcd->clrTextBk = DarkBlue;
				lplvcd->clrText = White;
			}
			else
			{
				lplvcd->clrTextBk = DarkRed;
				lplvcd->clrText = White;
			}
			*pResult = CDRF_NEWFONT;
			break;
		default:
			*pResult = CDRF_DODEFAULT;
	}}

// Clicking on bid/ask ticker selects order type and price
void CClient3Dlg::OnNMClickBidaskticker(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	int nItem = -1;
	int nSubItem = -1;
	if (pNMIA)
	{
		nItem = pNMIA->iItem;
		nSubItem = pNMIA->iSubItem;
	}
	
	switch (nSubItem)
	{
		case 1:	// clicked on the Bid - 1tick
			m_cbbOrdType.SetCurSel(2);
			break;
		case 2:	// clicked on the Bid
			m_cbbOrdType.SetCurSel(1);
			break;
		default:
		case 3: // clicked on the Last
			m_cbbOrdType.SetCurSel(0);
			break;
		case 4: // clicked on the Ask
			m_cbbOrdType.SetCurSel(1);
			break;
		case 5: // clicked on the Ask + 1Tick
			m_cbbOrdType.SetCurSel(2);
			break;
	}
	OnCbnSelchangeCombo1();

	*pResult = 0;
}

void CClient3Dlg::OnLvnColumnclickBidaskticker(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	int nItem = -1;
	int nSubItem = -1;
	if (pNMIA)
	{
		nItem = pNMIA->iItem;
		nSubItem = pNMIA->iSubItem;
	}
	
	switch (nSubItem)
	{
		case 1:	// clicked on the Bid - 1tick
			m_cbbOrdType.SetCurSel(2);
			break;
		case 2:	// clicked on the Bid
			m_cbbOrdType.SetCurSel(1);
			break;
		default:
		case 3: // clicked on the Last
			m_cbbOrdType.SetCurSel(0);
			break;
		case 4: // clicked on the Ask
			m_cbbOrdType.SetCurSel(1);
			break;
		case 5: // clicked on the Ask + 1Tick
			m_cbbOrdType.SetCurSel(2);
			break;
	}
	OnCbnSelchangeCombo1();

	*pResult = 0;
}

//  function below not enabled (custom menu)
void CClient3Dlg::OnNMRclickBidaskticker(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	return;  /// deactivated for the time being
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_MENU1));
	m_mOrderPopup = menu.GetSubMenu(0);
	ASSERT(m_mOrderPopup != NULL);

	int nItem = pNMIA->iItem ;
	//int nSubItem = pNMIA->iSubItem;
	m_nBidAsk = pNMIA->iSubItem;

	RECT Rect;
	ListBidAsk.GetWindowRect(&Rect);
	int x = Rect.left + pNMIA->ptAction.x;
	int y = Rect.top + pNMIA->ptAction.y;

	CString strP = ListBidAsk.GetItemText(0,m_nBidAsk);
	CString strMenuItem1 = "Buy " + strP + " Stop";
	CString strMenuItem2 = "Buy " + strP + " Limit";
	CString strMenuItem3 = "Sell " + strP + " Stop";
	CString strMenuItem4 = "Sell " + strP + " Limit";
	
	m_mOrderPopup->ModifyMenu(0,MF_BYPOSITION,MF_STRING,strMenuItem1);
	m_mOrderPopup->ModifyMenu(1,MF_BYPOSITION,MF_STRING,strMenuItem2);
	m_mOrderPopup->ModifyMenu(2,MF_BYPOSITION,MF_STRING,strMenuItem3);
	m_mOrderPopup->ModifyMenu(3,MF_BYPOSITION,MF_STRING,strMenuItem4);


	// following is an attempt to track menu items...
	// does not work in dialogs (only doc/view)

	CWnd *pWnd = AfxGetMainWnd();
	//CmdRouteMenu(pWnd,pPopup);

	//POINT pp;
	//GetCursorPos(&pp);
	DWORD dwSelectionMade = m_mOrderPopup->TrackPopupMenu(
		TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_NONOTIFY | TPM_RETURNCMD,
		//pp.x,pp.y,this);
		x,y,pWnd);

	//DWORD dwSelectionMade= m_mOrderPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON,x,y,pWnd);


//	m_mOrderPopup->TrackPopupMenu(TPM_RETURNCMD | TPM_LEFTALIGN | TPM_LEFTBUTTON, x, y, pWnd);

//	CPoint ptClient;
//	ptClient.x = x;
//	ptClient.y = y;
//	ScreenToClient(&ptClient);
//	m_ptRClick = ptClient;

	*pResult = 0;
}

void CClient3Dlg::OnNMHoverBidaskticker(NMHDR *pNMHDR, LRESULT *pResult) // not used yet
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	int nItem = pNMIA->iItem ;
	int nSubItem = pNMIA->iSubItem;

	*pResult = 0;
}

//  Careful: this is only valid for FA clients (advisors/institutional)
// this has not been tested...
void CClient3Dlg::OnNMRclickId(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	int nItem = pNMIA->iItem ;

	switch (nItem)
	{
		case 0:
			m_tws1.reqManagedAccts();
			break;
		case 1:
			m_tws2.reqManagedAccts();
			break;
		case 2:
			m_tws3.reqManagedAccts();
			break;
		default:
			break;
	}
	*pResult = 0;
}


void CClient3Dlg::OnNMRclickOpen1(NMHDR *pNMHDR, LRESULT *pResult)
{	// Add option to cancel order
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	int nItem = pNMIA->iItem ;	// does not return line number?
	int nSubItem = pNMIA->iSubItem;
	
	for (int i=0; i<ListOpenOrder1.GetItemCount();i++)
	{
		CString strOrdId_C = ListOpenOrder1.GetItemText(i,1);
		if ((strOrdId_C == "") || (strOrdId_C = "OK")) return;
		int nOrdId = atoi(strOrdId_C);

		if (nOrdId == 0) return;
        
		CString stri, msg, attribute = "?";
		// admittedly pretty inefficient...
		if (i==0)
		{
			stri = "1";
			if (nOrdId == m_lLastOrderId_tws1)		attribute = "Main";
			if (nOrdId == m_lLastStopOrderId1_tws1)	attribute = "Stop1";
			if (nOrdId == m_lLastStopOrderId2_tws1)	attribute = "Stop2";
			if (nOrdId == m_lLastStopOrderId3_tws1)	attribute = "Stop3";
			if (nOrdId == m_lLastLimitOrderId1_tws1)attribute = "Limit1";
			if (nOrdId == m_lLastLimitOrderId2_tws1)attribute = "Limit2";
			if (nOrdId == m_lLastLimitOrderId3_tws1)attribute = "Limit3";
		}
		if (i==1)
		{
			stri = "2";
			if (nOrdId == m_lLastOrderId_tws2)		attribute = "Main";
			if (nOrdId == m_lLastStopOrderId1_tws2)	attribute = "Stop1";
			if (nOrdId == m_lLastStopOrderId2_tws2)	attribute = "Stop2";
			if (nOrdId == m_lLastStopOrderId3_tws2)	attribute = "Stop3";
			if (nOrdId == m_lLastLimitOrderId1_tws2)attribute = "Limit1";
			if (nOrdId == m_lLastLimitOrderId2_tws2)attribute = "Limit2";
			if (nOrdId == m_lLastLimitOrderId3_tws2)attribute = "Limit3";
		}
		if (i==2)
		{
			stri = "3";
			if (nOrdId == m_lLastOrderId_tws3)		attribute = "Main";
			if (nOrdId == m_lLastStopOrderId1_tws3)	attribute = "Stop1";
			if (nOrdId == m_lLastStopOrderId2_tws3)	attribute = "Stop2";
			if (nOrdId == m_lLastStopOrderId3_tws3)	attribute = "Stop3";
			if (nOrdId == m_lLastLimitOrderId1_tws3)attribute = "Limit1";
			if (nOrdId == m_lLastLimitOrderId2_tws3)attribute = "Limit2";
			if (nOrdId == m_lLastLimitOrderId3_tws3)attribute = "Limit3";
		}
		msg.Format(_T("TWS%s: Cancel %s Order No: %s"), stri, attribute, strOrdId_C);
		int retval = MessageBox(msg,"Cancellation",MB_YESNO);
		if (retval == 6 && nOrdId > 0)
		{
			if (i == 0 && m_bTwsChecked1[0] == TRUE) 
			{
				m_tws1.cancelOrder(nOrdId);
				if (nOrdId == m_lLastOrderId_tws1)		m_lLastOrderId_tws1 = 0;
				if (nOrdId == m_lLastStopOrderId1_tws1)	m_lLastStopOrderId1_tws1 = 0;
				if (nOrdId == m_lLastStopOrderId2_tws1)	m_lLastStopOrderId2_tws1 = 0;
				if (nOrdId == m_lLastStopOrderId3_tws1)	m_lLastStopOrderId3_tws1 = 0;
				if (nOrdId == m_lLastLimitOrderId1_tws1)m_lLastLimitOrderId1_tws1 = 0;
				if (nOrdId == m_lLastLimitOrderId2_tws1)m_lLastLimitOrderId2_tws1 = 0;
				if (nOrdId == m_lLastLimitOrderId3_tws1)m_lLastLimitOrderId3_tws1 = 0;
			}
			if (i == 1 && m_bTwsChecked1[1] == TRUE) 
			{
				m_tws2.cancelOrder(nOrdId);
				if (nOrdId == m_lLastOrderId_tws2)		m_lLastOrderId_tws2 = 0;
				if (nOrdId == m_lLastStopOrderId1_tws2)	m_lLastStopOrderId1_tws2 = 0;
				if (nOrdId == m_lLastStopOrderId2_tws2)	m_lLastStopOrderId2_tws2 = 0;
				if (nOrdId == m_lLastStopOrderId3_tws2)	m_lLastStopOrderId3_tws2 = 0;
				if (nOrdId == m_lLastLimitOrderId1_tws2)m_lLastLimitOrderId1_tws2 = 0;
				if (nOrdId == m_lLastLimitOrderId2_tws2)m_lLastLimitOrderId2_tws2 = 0;
				if (nOrdId == m_lLastLimitOrderId3_tws2)m_lLastLimitOrderId3_tws2 = 0;
			}
			if (i == 2 && m_bTwsChecked1[2] == TRUE) 
			{
				m_tws3.cancelOrder(nOrdId);
				if (nOrdId == m_lLastOrderId_tws3)		m_lLastOrderId_tws3 = 0;
				if (nOrdId == m_lLastStopOrderId1_tws3)	m_lLastStopOrderId1_tws3 = 0;
				if (nOrdId == m_lLastStopOrderId2_tws3)	m_lLastStopOrderId2_tws3 = 0;
				if (nOrdId == m_lLastStopOrderId3_tws3)	m_lLastStopOrderId3_tws3 = 0;
				if (nOrdId == m_lLastLimitOrderId1_tws3)m_lLastLimitOrderId1_tws3 = 0;
				if (nOrdId == m_lLastLimitOrderId2_tws3)m_lLastLimitOrderId2_tws3 = 0;
				if (nOrdId == m_lLastLimitOrderId3_tws3)m_lLastLimitOrderId3_tws3 = 0;
			}
		}
		OnreqOpenOrders() ;
	}
	*pResult = 0;
}


void CClient3Dlg::OnNMDblclkOpen2(NMHDR *pNMHDR, LRESULT *pResult)
{	// double click List2
	OnBnClickedClearexec();
	*pResult = 0;
}

void CClient3Dlg::OnNMRclickOpen2(NMHDR *pNMHDR, LRESULT *pResult)
{	// right click List2 item
	OnReqExecutions();
	*pResult = 0;
}

void CClient3Dlg::OnNMDblclkOpen1(NMHDR *pNMHDR, LRESULT *pResult)
{	// double click List1 item
	OnBnClickedClearexec();
	*pResult = 0;
}

void CClient3Dlg::OnNMDblclkId(NMHDR *pNMHDR, LRESULT *pResult)
{
	ReqIBPosition(1);
	ReqIBPosition(2);
	ReqIBPosition(3);
	*pResult = 0;
}

// this function below is called from the modeless form
void CClient3Dlg::CommitNewStop() // commit new stops
{
	CString strMsg;  // log string

	//m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\LastOrders";
	//m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	//order[1].totalQuantity = m_Reg.ReadDword("NumFilled",0);

	if (m_dStopPrice <= 0) return;	// wrong price

	// set new order details before sending it through
	for (int twsn=0;twsn<3;twsn++)
	{
		if (order[0][twsn].action == "BUY")	
		{
			order[3][twsn].action = order[2][twsn].action = order[1][twsn].action = "SELL";
		}
		else		
		{
			order[3][twsn].action = order[2][twsn].action = order[1][twsn].action = "BUY";
		}
		if (m_bTrail)
			order[3][twsn].orderType = order[2][twsn].orderType = order[1][twsn].orderType = "TRAIL";
		else
			order[3][twsn].orderType = order[2][twsn].orderType = order[1][twsn].orderType = "STP";
		order[3][twsn].lmtPrice = order[2][twsn].lmtPrice = order[1][twsn].lmtPrice = 0.0;
		order[3][twsn].auxPrice = order[2][twsn].auxPrice = order[1][twsn].auxPrice = m_dStopPrice;
	}

	// TWS1
	if (m_bTwsConnected[0] == TRUE && m_bTwsChecked1[0] == TRUE)
	{
		//if (c1.NumShares > 0) order[1].totalQuantity = c1.NumShares;
		//else	order[1].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastStopOrderId1_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastStopOrderId1_tws1,
					order[1][0].action,
					order[1][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[1][0].orderType,
					order[1][0].lmtPrice,
					order[1][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New stop1: %.2f points from AvgFill (%.2f)"),
					fabs(order[1][0].auxPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId2_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastStopOrderId2_tws1,
					order[2][0].action,
					order[2][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[2][0].orderType,
					order[2][0].lmtPrice,
					order[2][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New stop2: %.2f points from AvgFill (%.2f)"),
					fabs(order[2][0].auxPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId3_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastStopOrderId3_tws1,
					order[3][0].action,
					order[3][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[3][0].orderType,
					order[3][0].lmtPrice,
					order[3][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New stop3: %.2f points from AvgFill (%.2f)"),
					fabs(order[3][0].auxPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	// TWS2
	if (m_bTwsConnected[1] == TRUE && m_bTwsChecked1[1] == TRUE)
	{
		//if (c1.NumShares > 0) order[1].totalQuantity = c1.NumShares;
		//else	order[1].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastStopOrderId1_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastStopOrderId1_tws2,
					order[1][1].action,
					order[1][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[1][1].orderType,
					order[1][1].lmtPrice,
					order[1][1].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New stop1: %.2f points from AvgFill (%.2f)"),
					fabs(order[1][1].auxPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId2_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastStopOrderId2_tws2,
					order[2][1].action,
					order[2][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[2][1].orderType,
					order[2][1].lmtPrice,
					order[2][1].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New stop2: %.2f points from AvgFill (%.2f)"),
					fabs(order[2][1].auxPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId3_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastStopOrderId3_tws2,
					order[3][1].action,
					order[3][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[3][1].orderType,
					order[3][1].lmtPrice,
					order[3][1].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New stop3: %.2f points from AvgFill (%.2f)"),
					fabs(order[3][1].auxPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	// TWS3
	if (m_bTwsConnected[2] == TRUE && m_bTwsChecked1[2] == TRUE)
	{
		//if (c1.NumShares > 0) order[1].totalQuantity = c1.NumShares;
		//else	order[1].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastStopOrderId1_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastStopOrderId1_tws3,
					order[1][2].action,
					order[1][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[1][2].orderType,
					order[1][2].lmtPrice,
					order[1][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
			strMsg.Format(_T("(Tws3) New stop1: %.2f points from AvgFill (%.2f)"),
					fabs(order[1][2].auxPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId2_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastStopOrderId2_tws1,
					order[2][2].action,
					order[2][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[2][2].orderType,
					order[2][2].lmtPrice,
					order[2][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
			strMsg.Format(_T("(Tws3) New stop2: %.2f points from AvgFill (%.2f)"),
					fabs(order[2][2].auxPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
		if (m_lLastStopOrderId3_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastStopOrderId3_tws3,
					order[3][2].action,
					order[3][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[3][2].orderType,
					order[3][2].lmtPrice,
					order[3][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
			strMsg.Format(_T("(Tws3) New stop3: %.2f points from AvgFill (%.2f)"),
					fabs(order[3][2].auxPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}
	// end commit new stops
	OnreqOpenOrders();
}

// called from modeless dialog
void CClient3Dlg::CommitNewLimit1() // commit new limit 1 (order 4)
{
	CString strMsg;

	//m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\LastOrders";
	//m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	//order[2].totalQuantity = m_Reg.ReadDword("NumFilled",0);

	if (m_dLimitTarget <= 0) return;

	for (int twsn=0;twsn<3;twsn++)
	{
		if (order[0][twsn].action == "BUY")	order[4][twsn].action = "SELL";
		else								order[4][twsn].action = "BUY";
		order[4][twsn].orderType = "LMT";
		order[4][twsn].lmtPrice = m_dLimitTarget; // from modeless form
		order[4][twsn].auxPrice = 0.0;
	}

	if (m_bTwsConnected[0] == TRUE && m_bTwsChecked1[0] == TRUE)
	{
		//if (c1.NumShares > 0) order[2].totalQuantity = c1.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId1_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastLimitOrderId1_tws1,
					order[4][0].action,
					order[4][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[4][0].orderType,
					order[4][0].lmtPrice,
					order[4][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New limit1: %.2f points from AvgFill (%.2f)"),
				fabs(order[4][0].lmtPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[1] == TRUE && m_bTwsChecked1[1] == TRUE)
	{
		//if (c2.NumShares > 0) order[2].totalQuantity = c2.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId1_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastLimitOrderId1_tws2,
					order[4][1].action,
					order[4][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[4][1].orderType,
					order[4][1].lmtPrice,
					order[4][1].auxPrice,
					FA[1].faGoodAfterTime,
					FA[1].faGroup,
					FA[1].faMethod,
					FA[1].faPercentage,
					FA[1].faProfile,
					FA[1].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New limit1: %.2f points from AvgFill (%.2f)"),
				fabs(order[4][1].lmtPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[2] == TRUE && m_bTwsChecked1[2] == TRUE)
	{
		//if (c3.NumShares > 0) order[2].totalQuantity = c3.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId1_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastLimitOrderId1_tws3,
					order[4][2].action,
					order[4][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[4][2].orderType,
					order[4][2].lmtPrice,
					order[4][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
				strMsg.Format(_T("(Tws3) New limit1: %.2f points from AvgFill (%.2f)"),
					fabs(order[4][2].lmtPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
				AddStatusLine(strMsg,statInfo);
				AddToLog(strMsg);
		}
	}
	OnreqOpenOrders(); 
}

void CClient3Dlg::CommitNewLimit2() // commit new limit 2 (order 5)
{
	CString strMsg;

	//m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\LastOrders";
	//m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	//order[2].totalQuantity = m_Reg.ReadDword("NumFilled",0);

	for (int twsn=0;twsn<3;twsn++)
	{
		if (order[0][twsn].action == "BUY")	order[5][twsn].action = "SELL";
		else								order[5][twsn].action = "BUY";
		order[5][twsn].orderType = "LMT";
		order[5][twsn].lmtPrice = m_dLimitTarget2; // from modeless form
		order[5][twsn].auxPrice = 0.0;
	}

	if (m_bTwsConnected[0] == TRUE && m_bTwsChecked1[0] == TRUE)
	{
		//if (c1.NumShares > 0) order[2].totalQuantity = c1.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId2_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastLimitOrderId2_tws1,
					order[5][0].action,
					order[5][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[5][0].orderType,
					order[5][0].lmtPrice,
					order[5][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New limit2: %.2f points from AvgFill (%.2f)"),
				fabs(order[5][0].lmtPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[1] == TRUE && m_bTwsChecked1[1] == TRUE)
	{
		//if (c2.NumShares > 0) order[2].totalQuantity = c2.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId2_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastLimitOrderId2_tws2,
					order[5][1].action,
					order[5][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[5][1].orderType,
					order[5][1].lmtPrice,
					order[5][1].auxPrice,
					FA[1].faGoodAfterTime,
					FA[1].faGroup,
					FA[1].faMethod,
					FA[1].faPercentage,
					FA[1].faProfile,
					FA[1].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New limit2: %.2f points from AvgFill (%.2f)"),
				fabs(order[5][1].lmtPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[2] == TRUE && m_bTwsChecked1[2] == TRUE)
	{
		//if (c3.NumShares > 0) order[2].totalQuantity = c3.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId2_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastLimitOrderId2_tws3,
					order[5][2].action,
					order[5][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[5][2].orderType,
					order[5][2].lmtPrice,
					order[5][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
				strMsg.Format(_T("(Tws3) New limit2: %.2f points from AvgFill (%.2f)"),
					fabs(order[5][2].lmtPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
				AddStatusLine(strMsg,statInfo);
				AddToLog(strMsg);
		}
	}
	OnreqOpenOrders(); 
}

void CClient3Dlg::CommitNewLimit3() // commit new limit 1
{
	CString strMsg;

	//m_RegIBDKey = "Software\\IBD"+m_strSessionNo+"\\LastOrders";
	//m_Reg.SetRootKey(HKEY_LOCAL_MACHINE);
	//order[2].totalQuantity = m_Reg.ReadDword("NumFilled",0);

	for (int twsn=0;twsn<3;twsn++)
	{
		if (order[0][twsn].action == "BUY")	order[6][twsn].action = "SELL";
		else								order[6][twsn].action = "BUY";
		order[6][twsn].orderType = "LMT";
		order[6][twsn].lmtPrice = m_dLimitTarget3; // from modeless form
		order[6][twsn].auxPrice = 0.0;
	}

	if (m_bTwsConnected[0] == TRUE && m_bTwsChecked1[0] == TRUE)
	{
		//if (c1.NumShares > 0) order[2].totalQuantity = c1.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId1_tws1 != 0)
		{
			if (!m_bPaperTrade)
				m_tws1.placeOrder(
					m_lLastLimitOrderId3_tws1,
					order[6][0].action,
					order[6][0].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[6][0].orderType,
					order[6][0].lmtPrice,
					order[6][0].auxPrice,
					FA[0].faGoodAfterTime,
					FA[0].faGroup,
					FA[0].faMethod,
					FA[0].faPercentage,
					FA[0].faProfile,
					FA[0].faGoodTillDate);
			strMsg.Format(_T("(Tws1) New limit3: %.2f points from AvgFill (%.2f)"),
				fabs(order[6][0].lmtPrice - m_dAvgFillPrice1), m_dAvgFillPrice1);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[1] == TRUE && m_bTwsChecked1[1] == TRUE)
	{
		//if (c2.NumShares > 0) order[2].totalQuantity = c2.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId3_tws2 != 0)
		{
			if (!m_bPaperTrade)
				m_tws2.placeOrder(
					m_lLastLimitOrderId3_tws2,
					order[6][1].action,
					order[6][1].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[6][1].orderType,
					order[6][1].lmtPrice,
					order[6][1].auxPrice,
					FA[1].faGoodAfterTime,
					FA[1].faGroup,
					FA[1].faMethod,
					FA[1].faPercentage,
					FA[1].faProfile,
					FA[1].faGoodTillDate);
			strMsg.Format(_T("(Tws2) New limit3: %.2f points from AvgFill (%.2f)"),
				fabs(order[6][1].lmtPrice - m_dAvgFillPrice2), m_dAvgFillPrice2);
			AddStatusLine(strMsg,statInfo);
			AddToLog(strMsg);
		}
	}

	if (m_bTwsConnected[2] == TRUE && m_bTwsChecked1[2] == TRUE)
	{
		//if (c3.NumShares > 0) order[2].totalQuantity = c3.NumShares;
		//else	order[2].totalQuantity = m_lDefaultOrderSize;
		if (m_lLastLimitOrderId1_tws3 != 0)
		{
			if (!m_bPaperTrade)
				m_tws3.placeOrder(
					m_lLastLimitOrderId3_tws3,
					order[6][2].action,
					order[6][2].totalQuantity,
					cont.symbol,
					cont.secType,
					cont.expiry,
					cont.strike,
					cont.right,
					cont.multiplier,
					cont.exchange,
					cont.primaryExchange,
					cont.currency,
					order[6][2].orderType,
					order[6][2].lmtPrice,
					order[6][2].auxPrice,
					FA[2].faGoodAfterTime,
					FA[2].faGroup,
					FA[2].faMethod,
					FA[2].faPercentage,
					FA[2].faProfile,
					FA[2].faGoodTillDate);
				strMsg.Format(_T("(Tws3) New limit3: %.2f points from AvgFill (%.2f)"),
					fabs(order[6][2].lmtPrice - m_dAvgFillPrice3), m_dAvgFillPrice3);
				AddStatusLine(strMsg,statInfo);
				AddToLog(strMsg);
		}
	}
	OnreqOpenOrders(); 
}

// Click ListOpen2 to request executions to be displayed in Status listbox
void CClient3Dlg::OnNMClickOpen2(NMHDR *pNMHDR, LRESULT *pResult)
{
	//call execution reports are downloaded to the client via the openOrder1(), 
	// openOrder2() and orderStatus() events.
	GetAccounts();
	OnBnClickedClearexec(); // clear lists first
	m_tws1.SetSymbolFilter(cont.symbol);	// other filters are available
	m_tws2.SetSymbolFilter(cont.symbol);
	m_tws3.SetSymbolFilter(cont.symbol);
	/*if (m_bTwsChecked2[0] == TRUE)*/ m_tws1.reqExecutions();	
	if (m_lNumIB>1 /*&& (m_bTwsChecked2[1] == TRUE)*/) m_tws2.reqExecutions();	
	if (m_lNumIB>2 /*&& (m_bTwsChecked2[2] == TRUE)*/) m_tws3.reqExecutions();
	*pResult = 0;
}

void CClient3Dlg::OnNMDblclkBidaskticker(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (!m_bTickerActive) OnBnClickedOrdersettings();
	*pResult = 0;
}

// order size multiplier
void CClient3Dlg::OnNMClickList4(NMHDR *pNMHDR, LRESULT *pResult)
{	
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	int nItem = pNMIA->iItem ;	// does not return line number?
	int nSubItem = pNMIA->iSubItem;


	if (m_nOrdSizeMult != nItem + 1)
		if ((m_nPosition1 == 0) && (m_nPosition2 == 0) && (m_nPosition3 == 0))
		{
			CString str;
			m_nOrdSizeMult = nItem + 1;
			str = m_lstEntry.GetItemText(nItem,0);
			AddStatusLine("Trading Mode set to: " + str, statInfo);
			str.Format(_T("%i"),m_nOrdSizeMult);
			OrdMult.SetWindowText(str);
		}
		else
			AddStatusLine("Cannot change trading mode while in position", statWarn);

	*pResult = 0;
}

void CClient3Dlg::OnBnClickedButton13()  // FA Button
{
	int i = m_lstFAAccounts.GetCurSel();
	if (i == -1) 
	{
		AddStatusLine("Please select a FA account first", statWarn);
		return;
	}
	switch (m_nFAAcctNo)
	{
		default:
		case 1:
				OnFinancialAdvisor1();
				break;
		case 2:
				OnFinancialAdvisor2();
				break;
		case 3:
				OnFinancialAdvisor3();
				break;
	}
}

void CClient3Dlg::OnBnClickedButton14() // Managed Accounts (FA)
{
	int i = m_lstFAAccounts.GetCurSel();
	if (i == -1) 
	{
		AddStatusLine("Please select a FA account first", statWarn);
		return;
	}

	switch (m_nFAAcctNo)
	{
		default:
		case 0:
			m_tws1.reqManagedAccts();
			break;
		case 1:
			m_tws2.reqManagedAccts();
			break;
		case 2:
			m_tws3.reqManagedAccts();
			break;
	}
}

void CClient3Dlg::OnBnClickedButton15()  // FA Allocations
{
}

void CClient3Dlg::OnBnClickedRefresh()
{
	CWinApp *pApp= AfxGetApp();
	OnBnClickedClearexec(); // clear lists first
	if (m_bTwsChecked1[0] == TRUE)
		m_tws1.reqAllOpenOrders();

	if (m_lNumIB>1 && m_bTwsChecked1[1] == TRUE)
		m_tws2.reqAllOpenOrders();

	if (m_lNumIB>2 && m_bTwsChecked1[2] == TRUE)
		m_tws3.reqAllOpenOrders();

	GetWindowRect(m_dlgRect);
	pApp->m_pMainWnd->MoveWindow(
		m_dlgRect.left,
		m_dlgRect.top,
		m_dlgRect.Width(),
		m_nRectHeight ,
		TRUE);

	SetTimer(11,2000,0);
}

void CClient3Dlg::CancelAttachedOrders_tws1(void)
{
	if (m_lLastLimitOrderId1_tws1 != 0)
	{
		AddStatusLine("TWS1: Limit Order 1 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastLimitOrderId1_tws1);
		m_lLastLimitOrderId1_tws1 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId1_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId1_tws1 != 0)
	{
		AddStatusLine("TWS1: Stop Order 1 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastStopOrderId1_tws1);
		m_lLastStopOrderId1_tws1 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId1_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId2_tws1 != 0)
	{
		AddStatusLine("TWS1: Limit Order 2 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastLimitOrderId2_tws1);
		m_lLastLimitOrderId2_tws1 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId2_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId2_tws1 != 0)
	{
		AddStatusLine("TWS1: Stop Order 2 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastStopOrderId2_tws1);
		m_lLastStopOrderId2_tws1 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId2_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId3_tws1 != 0)
	{
		AddStatusLine("TWS1: Limit Order 3 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastLimitOrderId3_tws1);
		m_lLastLimitOrderId3_tws1 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId3_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId3_tws1 != 0)
	{
		AddStatusLine("TWS1: Stop Order 3 being cancelled",statInfo);
		m_tws1.cancelOrder(m_lLastStopOrderId3_tws1);
		m_lLastStopOrderId3_tws1 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId3_tws1",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}

void CClient3Dlg::CancelAttachedOrders_tws2(void)
{
	if (m_lLastLimitOrderId1_tws2 != 0)
	{
		AddStatusLine("TWS2: Limit Order 1 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastLimitOrderId1_tws2);
		m_lLastLimitOrderId1_tws2 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId1_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId1_tws2 != 0)
	{
		AddStatusLine("TWS2: Stop Order 1 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastStopOrderId1_tws2);
		m_lLastStopOrderId1_tws2 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId1_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId2_tws2 != 0)
	{
		AddStatusLine("TWS2: Limit Order 2 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastLimitOrderId2_tws2);
		m_lLastLimitOrderId2_tws2 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId2_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId2_tws2 != 0)
	{
		AddStatusLine("TWS2: Stop Order 2 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastStopOrderId2_tws2);
		m_lLastStopOrderId2_tws2 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId2_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId3_tws2 != 0)
	{
		AddStatusLine("TWS2: Limit Order 3 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastLimitOrderId3_tws2);
		m_lLastLimitOrderId3_tws2 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId3_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId3_tws2 != 0)
	{
		AddStatusLine("TWS2: Stop Order 3 being cancelled",statInfo);
		m_tws2.cancelOrder(m_lLastStopOrderId3_tws2);
		m_lLastStopOrderId3_tws2 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId3_tws2",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}

void CClient3Dlg::CancelAttachedOrders_tws3(void)
{
	if (m_lLastLimitOrderId1_tws3 != 0)
	{
		AddStatusLine("TWS3: Limit Order 1 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastLimitOrderId1_tws3);
		m_lLastLimitOrderId1_tws3 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId1_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId1_tws3 != 0)
	{
		AddStatusLine("TWS3: Stop Order 1 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastStopOrderId1_tws3);
		m_lLastStopOrderId1_tws3 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId1_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId2_tws3 != 0)
	{
		AddStatusLine("TWS3: Limit Order 2 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastLimitOrderId2_tws3);
		m_lLastLimitOrderId2_tws3 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId2_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId2_tws3 != 0)
	{
		AddStatusLine("TWS3: Stop Order 2 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastStopOrderId2_tws3);
		m_lLastStopOrderId2_tws3 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId2_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastLimitOrderId3_tws3 != 0)
	{
		AddStatusLine("TWS3: Limit Order 3 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastLimitOrderId3_tws3);
		m_lLastLimitOrderId3_tws3 = 0;
		int ret = m_Reg.WriteDword("LastLimitOrderId3_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
	if (m_lLastStopOrderId3_tws3 != 0)
	{
		AddStatusLine("TWS3: Stop Order 3 being cancelled",statInfo);
		m_tws3.cancelOrder(m_lLastStopOrderId3_tws3);
		m_lLastStopOrderId3_tws3 = 0;
		int ret = m_Reg.WriteDword("LastStopOrderId3_tws3",0);
		if (ret != 1) AddStatusLine("Windows registry error", statWarn);
	}
}


void CClient3Dlg::OnLvnColumnclickOpen1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	GetAccounts();
	*pResult = 0;
}

void CClient3Dlg::OnScannerParametersTwsctrl1(LPCTSTR xml)
{
}

void CClient3Dlg::OnScannerDataTwsctrl1(long reqId, long rank, LPCTSTR symbol, LPCTSTR secType,
								LPCTSTR expiry, double strike, LPCTSTR right, LPCTSTR exchange,
								LPCTSTR currency, LPCTSTR localSymbol, LPCTSTR marketName,
								LPCTSTR tradingClass, LPCTSTR distance, LPCTSTR benchmark, LPCTSTR projection)
{
}


void CClient3Dlg::OntickOptionComputationTwsctrl1(long tickerId, long tickType, double impliedVol, double delta, double modelPrice, double pvDividend) 
{
}

void CClient3Dlg::OntickGenericTwsctrl1(long id, long tickType, double value) 
{
}

void CClient3Dlg::OntickStringTwsctrl1(long id, long tickType, LPCTSTR value) 
{
}